<?php

// File Security Check
if (!defined('ABSPATH')) die('-1');

/*
Register Qodux shortcode.
*/

class WPBakeryShortCode_QODX_pricing_table extends WPBakeryShortCode {
	
	private $qodx_sc;
	
	public function __construct($settings) {
        parent::__construct($settings);
		$this->qodx_sc = new QODX_VCSC_SHORTCODE;
	}
				
	protected function content($atts, $content = null) {
		
		// Get and extract shortcode attributes
		$atts = vc_map_get_attributes( $this->getShortcode(), $atts );
		extract( $atts );
		
		if ($style_table == '1') {
			$style_table_css = ' pricing-block-style-1';
		}elseif ($style_table == '2') {
			$style_table_css = ' pricing-block-style-2';
		}elseif ($style_table == '3') {
			$style_table_css = ' wide-block';
		}else {
			$style_table_css = '';
		}
		$sc_class = 'qodx_pricing_box_sc';	
					
		$id = mt_rand(9999, 99999);
		if (trim($el_id) != false) {
			$el_id = esc_attr( trim($el_id) );
		} else {
			$el_id = $sc_class . '-' . $id;
		}		
		
		$icon_style = '';
		$featured_table_text_out = '';
				
		// Service Icon Output				
		if ( $icon_background != '' ) {
			$icon_background = 'background: ' . $icon_background . ';';
		}
			
		if ( $icon_color != '' ) {
			$icon_color = 'color: ' . $icon_color . ';';
		}
		
		if ( $icon_background != '' || $icon_color != '' ) {
			$icon_style = ' style="'. $icon_color . $icon_background .'"';
		}
		
		$icon        = esc_html( $icon );
		$plan        = esc_html( $plan );
		$currency    = esc_html( $currency );
		$sub_title   = esc_html( $sub_title );
		//$cost        = esc_html( $cost );
		$per         = esc_html( $per );
		$button_text = esc_html( $button_text );
		
		if ($featured_table == 'true') {
			$featured_table = ' qodx_pricing_featured';
			if (!empty($featured_table_text)) {
				$featured_table_text_out = "\n\t" . '<div class="ribbon-block ribbon-block-style-2">'; 
					$featured_table_text_out .= $featured_table_text;
				$featured_table_text_out .= "\n\t" . '</div>';
			}
			if ($style_table != '1') {
				$btn_class = ' btn-black';
			} else {
			$btn_class = ' btn-theme';
			}
		} else {
			$featured_table = '';
			$btn_class = ' btn-theme';
		}	
		
		if ( $icon != '' ) {
			$icon_out = '<span><i class="'.$icon.'"'.$icon_style.'></i></span>';
			$has_icon = ' qodx_price_has_icon'; 
		} else {
			$icon_out = ''; 
			$has_icon = ''; 
		}	
			
		if ( $plan != ''  || $sub_title != '') {
			$plan_out = '<div class="pricing-block-title">';	
			$plan_out .= '<h5 class="h5-lg">'. $plan .'</h5>';	
			$plan_out .= '<p>'. $sub_title .'</p>';									
			$plan_out .= '</div>';
				
			//$plan_out .= $cost_and_per;
		} else {
			$plan_out = ''; 
		}
		
		if ( $currency != '' || $cost != '' || $per != '' ) {
			$cost_and_per = '<div class="pricing-block-price">';
			
				if ( $currency != '' ) {
					$currency = '<sup class="currency">'.$currency.'</sup>';
				}
			
				if ( $promo_cost != '' ) {
					$cost_and_per .= '<h4 class="custom-font old-price">';					
					$cost_and_per .= $currency;
					$cost_and_per .= '<span class="amount">'.$promo_cost.'</span>';
						if ( $per != '' ) {
							$per = '<span class="duration main-color">'.$per.'</span>';
						}
						$cost_and_per .= $per;	
					$cost_and_per .= '</h4>';
				}
				
				$cost_and_per .= '<h4 class="custom-font">';				
				$cost_and_per .= $currency;				
				$cost_and_per .= '<span class="amount">'.$cost.'</span>';				
					if ( $per != '' ) {
						$per = '<span class="duration main-color">'.$per.'</span>';
					}
					$cost_and_per .= $per;					
				$cost_and_per .= '</h4>';
				
				if ( $expires != '' ) {
					$cost_and_per .= '<p>'.$expires.'</p>';
				}
				
			$cost_and_per .= '</div>';
		} else {
			$cost_and_per = '';
		}
		
		if ( $button_text != '' ) {
			
			// parse button link		
			$button_link = ($button_link=='||') ? '' : $button_link;
			$button_link = vc_build_link($button_link);
			$button_url = esc_url($button_link['url']);
			
			$button_title = $button_link['title'];
			$button_title_out = ($button_title!='') ? ' title="' . esc_attr( $button_title ) .'"' : '';	
			
			$button_target = $button_link['target'];
			$button_target_out = ($button_target!='') ? ' target="' . $button_target .'"' : '';	
			
			$button_class = ($button_class!='') ? ' ' . $button_class : '';	
			
			if ( $button_url != '' ) {		
				$button_out = '<a class="btn'.$btn_class.$button_class.' wave-effect" href="'.$button_url.'"' . $button_title_out . $button_target_out .'>'.$button_text.'</a>';
			} else {
				$button_out = '<a class="btn'.$btn_class.$button_class.' wave-effect" href="#">'.$button_text.'</a>';
			}
		} else {
			$button_out = ''; 
		}
		$sc_class .= $featured_table.$has_icon.$style_table_css;				
		$el_class = esc_attr( $this->getExtraClass($el_class) );
		$css_class = apply_filters(VC_SHORTCODE_CUSTOM_CSS_FILTER_TAG, $sc_class.$el_class.vc_shortcode_custom_css_class($css, ' '), $this->settings['base']);	
		$css_class .= $this->qodx_sc->getWTCSSAnimationClass($css_animation,$anim_type);
		$anim_data = $this->qodx_sc->getWTCSSAnimationData($css_animation,$anim_delay);
		
		$content = wpb_js_remove_wpautop($content, true); // fix unclosed/unwanted paragraph tags in $content	
		$output = '<div id="'.$el_id.'" class="'.$css_class.'"'.$anim_data.'>';	
			$output .= '<div class="pricing-block-container">';		
				$output .= $featured_table_text_out;
				if ( $icon_out != '' ) {
					$output .= "\n\t" . '<div class="pricing-block-icon qodx_icon">'; 
						$output .= $icon_out;
					$output .= "\n\t" . '</div>';
				}
				if ( $plan_out != '' ) {
					$output .= "\n\t" . $plan_out;
				}	
				if ( $cost_and_per != '' ) {
					$output .= "\n\t" . $cost_and_per;
				}		
				
				if ( $content != '' ) {
					$output .= "\n\t" . '<div class="pricing-block-features">';
						$output .= "\n\t\t" . $content;
					$output .= "\n\t" . '</div>';
				}
				
				if ( $button_out != '' ) {
					$output .= "\n\t" . '<div class="pricing-block-button">'; 
						$output .= "\n\t\t" .  $button_out;
					$output .= "\n\t" . '</div>';
				}	
				
			$output .= '</div>';
		$output .= '</div>';
		
        return $output;
								
    }
	
}
	
/*
Register Qodux shortcode within Visual Composer interface.
*/

if (function_exists('vc_map')) {

	$add_qodx_sc_func             = new QODX_VCSC_SHORTCODE;
	$add_qodx_extra_id            = $add_qodx_sc_func->getWTExtraId();
	$add_qodx_extra_class         = $add_qodx_sc_func->getWTExtraClass();
	$add_qodx_css_animation       = $add_qodx_sc_func->getWTAnimations();
	$add_qodx_css_animation_type  = $add_qodx_sc_func->getWTAnimationsType();
	$add_qodx_css_animation_delay = $add_qodx_sc_func->getWTAnimationsDelay();
	
	vc_map( array(
		'name'          => esc_html__( 'Pricing Table', 'qodux_fw' ),
		'base'          => 'qodx_pricing_table',
		'icon'          => 'qodx-icon-pricing_table fa fa-usd',
		'class'         => 'qodx_vc_sc_pricing_table',
		'category'      => esc_html__( 'by Qodux', 'qodux_fw' ),
		'description'   => esc_html__( 'Build a pricing table', 'qodux_fw' ),
		'params'        => array(
			array(
				'type'        => 'dropdown',
				'heading'     => esc_html__( 'Style Table', 'qodux_fw' ),
				'param_name'  => 'style_table',
				'value'       => array( 
					esc_html__( 'Style 1', 'qodux_fw' )  => '1',
					esc_html__( 'Style 2', 'qodux_fw' ) => '2',
					esc_html__( 'Style 3', 'qodux_fw' ) => '3',
				),
				'std'           => '1',
				'description' => esc_html__( 'Choose a style for this table.', 'qodux_fw' )
			),
			array(
				'type'        => 'dropdown',
				'heading'     => esc_html__( 'Featured Table', 'qodux_fw' ),
				'param_name'  => 'featured_table',
				'value'       => array( 
					esc_html__( 'No', 'qodux_fw' )  => 'false',
					esc_html__( 'Yes', 'qodux_fw' ) => 'true',
				),
				'description' => esc_html__( 'Select \'Yes\' if you want this table to be featured.', 'qodux_fw' )
			),
			array(
				'type'               => 'textfield',
				'heading'            => esc_html__( 'Featured Table Text', 'qodux_fw' ),
				'param_name'         => 'featured_table_text',
				'value'              => 'Best Value',
				'param_holder_class' => 'border_box qodx_dependency',
				'dependency'	     => Array(
					'element'	=> 'featured_table',
					'value'		=> 'true'
				),
				'description'        => esc_html__( 'Enter a custom text for the feature table.', 'qodux_fw' )
			),
			array(
				'type'        => 'textfield',
				'heading'     => esc_html__( 'Icon', 'qodux_fw' ),
				'param_name'  => 'icon',
				'description' => '<a href="http://fortawesome.github.io/Font-Awesome/icons/" target="_blank">Font Awesome</a>, <a href="http://entypo.com/" target="_blank">Entypo</a> or <a href="http://glyphicons.com/" target="_blank">Glyphicons</a> accepted. (use "fa fa-", "entypo-" or "glyphicon-" prefix - for example "<strong>fa fa-adjust, entypo-flag or glyphicon-leaf</strong>"'
			),
			array(
				'type'          => 'colorpicker',
				'heading'       => esc_html__( 'Icon background', 'qodux_fw' ),
				'param_name'    => 'icon_background',
				'description'   => esc_html__( 'Select icon background.', 'qodux_fw' )
			),
			array(
				'type'          => 'colorpicker',
				'heading'       => esc_html__( 'Icon color', 'qodux_fw' ),
				'param_name'    => 'icon_color',
				'description'   => esc_html__( 'Select icon color.', 'qodux_fw' )
			),
			array(
				"type"        => "textfield",
				"heading"     => esc_html__( "Plan", 'qodux_fw' ),
				"param_name"  => "plan",
				"admin_label" => true,
				"value"       => "Basic"
			),
			array(
				"type"        => "textfield",
				"heading"     => esc_html__( "Sub Plan text", 'qodux_fw' ),
				"param_name"  => "sub_title",
				"admin_label" => true,
				"value"       => ""
			),
			array(
				"type"        => "textfield",
				"heading"     => esc_html__( "Currency", 'qodux_fw' ),
				"param_name"  => "currency",
				"admin_label" => true,
				"value"       => "$"
			),
			array(
				"type"        => "textfield",
				"heading"     => esc_html__( "Cost", 'qodux_fw' ),
				"param_name"  => "cost",
				"admin_label" => true,
				"value"       => "29"
			),
			array(
				"type"        => "textfield",
				"heading"     => esc_html__( "Promo Cost", 'qodux_fw' ),
				"param_name"  => "promo_cost",
				"admin_label" => true,
				"value"       => "39"
			),
			array(
				"type"        => "textfield",
				"heading"     => esc_html__( "Expires Promo Cost", 'qodux_fw' ),
				"param_name"  => "expires",
				"admin_label" => true,
				"value"       => ""
			),
			array(
				"type"		  => "textfield",
				"heading"     => esc_html__( "Per (optional)", 'qodux_fw' ),
				"param_name"  => "per",
				"value"       => "/MO"
			),
			array(
				"type"		  => "textarea_html",
				"heading"     => esc_html__( "Features", 'qodux_fw' ),
				"param_name"  => "content",
				"value"       => "<ul>
								      <li>20GB Storage</li>
									  <li>512MB Ram</li>
									  <li>2 Core Processor</li>
									  <li>25GB Bandwidth</li>
									  <li>24/7 Free Support</li>
								  </ul>",
			),
			array(
				"type"		  => "textfield",
				"heading"	  => esc_html__( "Button: Text", 'qodux_fw' ),
				"param_name"  => "button_text",
				"value"		  => "Button Text",
				"description" => esc_html__( "Type button text here.", 'qodux_fw' )
			),
			array(
				'type'        => 'vc_link',
				'heading'     => esc_html__( 'Button: Link', 'qodux_fw' ),
				'param_name'  => 'button_link',
				'value'       => '',
				'description' => esc_html__( 'Type button link here.', 'qodux_fw' )
			),
			array(
				'type'        => 'dropdown',
				'heading'     => esc_html__( 'Button Extra Class', 'qodux_fw' ),
				'param_name'  => 'button_class',
				'value'       => array( 
					esc_html__( 'Default', 'qodux_fw' )      => '',
					esc_html__( 'Small Button', 'qodux_fw' ) => 'btn-qodx-sm',
					esc_html__( 'Large Button', 'qodux_fw' ) => 'btn-qodx-lg',
				),
				'description' => esc_html__( 'Choose extra button style class.', 'qodux_fw' )
			),
			
			$add_qodx_extra_id,
			$add_qodx_extra_class,
			$add_qodx_css_animation,
			$add_qodx_css_animation_type,
			$add_qodx_css_animation_delay,
			
			array(
				'type'          => 'css_editor',
				'heading'       => esc_html__( 'Css', 'qodux_fw' ),
				'param_name'    => 'css',
				'group'         => esc_html__( 'Design options', 'qodux_fw' )
			)
		)
	));	
	
}