<?php

// File Security Check
if (!defined('ABSPATH')) die('-1');

/*
Register Qodux shortcode.
*/

class WPBakeryShortCode_QODX_testimonial_slider extends WPBakeryShortCode {
	
	private $qodx_sc;
	
	public function __construct($settings) {
        parent::__construct($settings);
		$this->qodx_sc = new QODX_VCSC_SHORTCODE;
	}
		
	protected function content($atts, $content = null) {
		
		// Get and extract shortcode attributes
		$atts = vc_map_get_attributes( $this->getShortcode(), $atts );
		extract( $atts );
		
		$sc_class = 'qodx_testimonial_slider_sc';	
					
		$id = mt_rand(9999, 99999);
		if (trim($el_id) != false) {
			$el_id = esc_attr( trim($el_id) );
		} else {
			$el_id = $sc_class . '-' . $id;
		}
		$slide_items_md = '';
		$slide_items_sm = '';
		$slide_items_xs = '';
		$style          = '';
		$img_size  		= '';
		$border_color   = '';
		$name           = '';
		$company        = '';
		
		$auto_slide     = (int)$auto_slide;		
		$slide_items_md = (int)$slide_items_md;	
		$slide_items_sm = (int)$slide_items_sm;	
		$slide_items_xs = (int)$slide_items_xs;	
				
		
		wp_enqueue_style('qodx-extend-swiper-slider');
		wp_enqueue_script('qodx-extend-swiper-slider');
		
				
		$style = ($style!='') ? $style : '';
		$el_style = '';		
		
		if ($style_testim == '1') {
			$style_testim_css = 'testimonials-block-style-1';
		}
		elseif ($style_testim == '2') {
			$style_testim_css = 'testimonials-block-style-2';
		}
		elseif ($style_testim == '3') {
			$style_testim_css = 'testimonials-block-style-3';
		}
		elseif ($style_testim == '4') {
			$style_testim_css = 'testimonials-block-style-4';
		}
		elseif ($style_testim == '5') {
			$style_testim_css = 'testimonials-block-style-5';
		}
		elseif ($style_testim == '6') {
			$style_testim_css = 'testimonials-block-style-6';
		}
		elseif ($style_testim == '7') {
			$style_testim_css = 'testimonials-block-style-7';
		}
		else {
			$style_testim_css = '';
		}
		
		$img_size = esc_html($img_size);
		
		if ( $border_color != '' ) {
			if ($style == 'vc_box_border' || $style == 'vc_box_border_circle' ) {
				$el_style = 'background-color:' . esc_attr( $border_color ) . ';';
			}
			if ($style == 'vc_box_outline' || $style == 'vc_box_outline_circle' ) {
				$el_style = 'border-color:' . esc_attr( $border_color ) . ';';
			}
		}
			
		$link_to = '';
		
		trim($name) == false ? $name = $name : '';
		trim($company) == false ? $company = $company : '';
		
		$el_class = esc_attr( $this->getExtraClass($el_class) );
		$css_class = apply_filters(VC_SHORTCODE_CUSTOM_CSS_FILTER_TAG, $sc_class.$el_class.vc_shortcode_custom_css_class($css, ' '), $this->settings['base']);	
		$css_class .= $this->qodx_sc->getWTCSSAnimationClass($css_animation,$anim_type);
		$anim_data = $this->qodx_sc->getWTCSSAnimationData($css_animation,$anim_delay);
	
		// Start testimonial section	
		$output = '<section id="'.$el_id.'" class="qodx_testimonial_wrapper_slider '.$css_class.'">';	
		
		// Testimonial with slider	
			
			$direction = $direction == 'vertical' ? ' vertical-swiper-slider' : '';
			
			switch($effect){
				case 'fade':
					$effect = ' fade-swiper-slider';
					break;
				case 'coverflow':
					$effect = ' coverflow-swiper-slider';
					break;
				case 'fade':
				default:
					$effect = '';
			}
			
			$centered_slides = $centered_slides == 'true' ? ' center-swiper-slider' : '';			
			$output .= '<div id="qodx-swiper-slider-'.$id.'" class="qodx-swiper-slider'.$direction.$effect.$centered_slides.'" data-swiper-items="1" data-swiper-md-items="1" data-swiper-sm-items="1" data-swiper-xs-items="1" data-swiper-autoplay="'.$auto_slide.'" data-swiper-grab-cursor="'.$grab_cursor.'" data-swiper-simulate-touch="'.$simulate_touch.'">';
		$output .= '<div class="swiper-wrapper">';	
			
		for($i = 1; $i <= $slide_count; $i++) {
			$item_content = $image_string = $name_string = $company_string = $title_string = $name_link = $a_name_href = $a_name_title_output = $a_name_target_output = '';			
			
			isset($atts["name_link_" . $i]) && $atts["name_link_" . $i] != "||" ? $name_link = $atts["name_link_" . $i] : '';
			// parse name link
			if ($name_link != '') {
				$name_link = vc_build_link($name_link);
				$a_name_href = esc_url( $name_link['url'] );
				
				$a_name_title = $name_link['title'];
				$a_name_title_output = ($a_name_title!='') ? ' title="' . esc_attr( $a_name_title ) .'"' : '';
				
				$a_name_target = $name_link['target'];
				$a_name_target_output = ($a_name_target!='') ? ' target="' . $a_name_target .'"' : '';
			}
											
			isset($atts["content_" . $i]) && $atts["content_" . $i] != "" ? $item_content = $atts["content_" . $i] : '';
			if ($item_content != '') {
				
				$item_content = rawurldecode(base64_decode(strip_tags($item_content)));
				
			}			
						
			if ( $atts["image_" . $i] != NULL ) {				
				$image = $atts["image_" . $i];
				$img_id = preg_replace('/[^\d]/', '', $image);
		
				if ( $border_color != '' && ($style == 'vc_box_border' || $style == 'vc_box_border_circle' || $style == 'vc_box_outline' || $style == 'vc_box_outline_circle') ) {
					$img = qodx_wpb_getImageBySize(array( 'attach_id' => $img_id, 'thumb_size' => $img_size, 'class' => $style, 'style' => $el_style ));
				} else {
					$img = wpb_getImageBySize(array( 'attach_id' => $img_id, 'thumb_size' => $img_size, 'class' => $style ));
				}
				
				if ( !empty($link_to) && !preg_match('/^(https?\:\/\/|\/\/)/', $link_to) ) $link_to = 'http://'.$link_to;
				$img_output = ($style=='vc_box_shadow_3d') ? '<span class="vc_box_shadow_3d_wrap">' . $img['thumbnail'] . '</span>' : $img['thumbnail'];
				$image_string .= "\n\t\t".'<div class="image-block"><div class="image-block-container">';
					$image_string .= "\n\t\t\t" . $img_output;					
				$image_string .= "\n\t\t".'</div></div>';
			}
			
			/*if ($atts["image_" . $i] != NULL) {
				$output .= "\n\t\t".'<div class="image-block"><div class="image-block-container">';
					$output .= "\n\t\t\t" . $image_string;
				$output .= "\n\t\t".'</div></div>';			
			}*/
			
			if ( $atts["name_" . $i] != NULL ) {
				$name = $atts["name_" . $i];	
				$name_string = $name;
			}
			
			if ( $atts["company_" . $i] != NULL ) {
				$company = $atts["company_" . $i];				
				$company_string = !empty($a_name_href) ? ' <a href="'.$a_name_href.'"' . $a_name_title_output . $a_name_target_output .'>'.$company.'</a>' : ' ' . $company;
			}
			
			if ( $atts["name_" . $i] != NULL || $atts["company_" . $i] != NULL ) {
				$title_string .= "\n\t\t" . '<div class="testimonials-block-title">';			
					if ( $comp_new_line ) {
						if ( $comp_heading) { // if heading for company
							$title_string .= "\n\t\t\t" . '<h4>' . $name_string . '</h4>';
							$title_string .= "\n\t\t\t" . '<h5>' . $company_string . '</h5>';
						} else {
							$title_string .= "\n\t\t\t" . '<h4>' . $name_string . '<br><small>' . $company_string . '</small></h4>';
						}
					}  else {
						if ( $comp_heading) { // if heading for company
							$title_string .= "\n\t\t\t" . '<h4>' . $name_string . $company_string . '</h4>';
						} else {
							$title_string .= "\n\t\t\t" . '<h4>' . $name_string . '<small>' . $company_string . '</small></h4>';
						}
					}					 
				$title_string .= "\n\t\t" . '</div>'; 
			}
			
			$output .= '<div class="swiper-slide">';	
				$output .= '<div class="swiper-slide-container">';	
					$output .= "\n\t".'<div class="'.$class_slides.' testimonials-block '.$style_testim_css.'">';
						$output .= "\n\t".'<div class="testimonials-block-container clearfix">';
						
							// image output && title output
							if ( $img_title_content ) {
								$output .= $image_string;
								$output .= $style_testim != '7' ? $title_string : '';
							} elseif ( $img_content_title ) { // image output only
								$output .= $image_string;
							} else {
								$output .= '';
							}
							
							// description output
							$output .= "\n\t".'<div class="testimonials-block-desc">';
								$output .= "\n\t\t" . $item_content;
								if ($style_testim == '7') {
									$output .= $title_string;
								}
							$output .= "\n\t".'</div>';
																						
							// image output && title output
							if ($img_title_content) {
								$output .= '';
							} elseif ( $img_content_title ) {  // title output only
								$output .= $style_testim != '7' ? $title_string : '';
							} else {
								$output .= $image_string;
								$output .= $style_testim != '7' ? $title_string : '';
							}	
														
						$output .= "\n\t".'</div>'; // End "testimonial-block-container"				
					$output .= "\n\t".'</div>'; // End "testimonial-block"
		
				$output .= '</div>'; // End "swiper-slide-container"
			$output .= '</div>'; // End "swiper-slide"
    	} // end for
        $output .= '</div>'; // End "swiper-wrapper"
		
		// Build Pagination
		if ($slider_pag == "true") {
			$pag_lowest = $pag_lowest ? ' pag-lowest' : '';
			$output .= '<div class="swiper-pagination' . $pag_lowest . '"></div>';
		}
		
		// Build Navigation
		if ($slider_nav == "true") {
			$output .= '<div class="swiper-button-prev">
							<i class="fa fa-angle-left"></i>
						</div>
						<div class="swiper-button-next">
							<i class="fa fa-angle-right"></i>
						</div>';
		}
		
        $output .= '</div>'; // End "qodx-swiper-slider"
		
		// End testimonial section
		$output .= '</section>';
		
        return $output;
    }
	
}
	
/*
Register Qodux shortcode within Visual Composer interface.
*/

if (function_exists('vc_map')) {

	$add_qodx_sc_func             = new QODX_VCSC_SHORTCODE;
	$add_qodx_extra_id            = $add_qodx_sc_func->getWTExtraId();
	$add_qodx_extra_class         = $add_qodx_sc_func->getWTExtraClass();
	$add_qodx_css_animation       = $add_qodx_sc_func->getWTAnimations();
	$add_qodx_css_animation_type  = $add_qodx_sc_func->getWTAnimationsType();
	$add_qodx_css_animation_delay = $add_qodx_sc_func->getWTAnimationsDelay();
	
	vc_map( array(
		'name'          => esc_html__( 'Testimonial Slider', 'qodux_fw' ),
		'base'          => 'qodx_testimonial_slider',
		'icon'          => 'qodx-icon-testimonial_slider fa fa-comments-o',
		'class'         => 'qodx_vc_sc_testimonial',
		'category'      => esc_html__( 'by Qodux', 'qodux_fw' ),
		'description'   => esc_html__( 'Static testimonial', 'qodux_fw' ),
		'params'        => array(
			array(
				'type'        => 'dropdown',
				'heading'     => esc_html__( 'Testimonial style', 'qodux_fw' ),
				'param_name'  => 'style_testim',
				'value'       => array( 
					esc_html__( 'Style 1', 'qodux_fw' ) => '1',
					esc_html__( 'Style 2', 'qodux_fw' ) => '2',
					esc_html__( 'Style 3', 'qodux_fw' ) => '3',
					esc_html__( 'Style 4', 'qodux_fw' ) => '4',
					esc_html__( 'Style 5', 'qodux_fw' ) => '5',
					esc_html__( 'Style 6', 'qodux_fw' ) => '6',
					esc_html__( 'Style 7', 'qodux_fw' ) => '7',
				),				
				'std'           => '1',
				'description' => esc_html__( 'Choose a style for this testimonial.', 'qodux_fw' )
			),
			array(
				'type'          => 'checkbox',
				'heading'       => esc_html__( 'New line for company?', 'qodux_fw' ),
				'param_name'    => 'comp_new_line',
				'value'         => Array(esc_html__( 'Yes, please', 'qodux_fw' ) => 'yes'),
				'description'   => esc_html__( 'If selected, company name will be diplayed below title.', 'qodux_fw' )
			),
			array(
				'type'          => 'checkbox',
				'heading'       => esc_html__( 'Heading for company?', 'qodux_fw' ),
				'param_name'    => 'comp_heading',
				'value'         => Array(esc_html__( 'Yes, please', 'qodux_fw' ) => 'yes'),
				'description'   => esc_html__( 'If selected, company name will be wrapped by a heading tag.', 'qodux_fw' ),
				//'param_holder_class' => 'border_box qodx_dependency',
				//'dependency'    => array( 'element' => 'comp_new_line', 'not_empty' => true ),
			),
			array(
				'type'          => 'checkbox',
				'heading'       => esc_html__( 'Image - title - content?', 'qodux_fw' ),
				'param_name'    => 'img_title_content',
				'value'         => Array(esc_html__( 'Yes, please', 'qodux_fw' ) => 'yes'),
				'description'   => esc_html__( 'If selected, this will be the testimonial order.', 'qodux_fw' )
			),
			array(
				'type'          => 'checkbox',
				'heading'       => esc_html__( 'Image - content - title?', 'qodux_fw' ),
				'param_name'    => 'img_content_title',
				'value'         => Array(esc_html__( 'Yes, please', 'qodux_fw' ) => 'yes'),
				'description'   => esc_html__( 'If selected, this will be the testimonial order.', 'qodux_fw' )
			),
			
			array(
				'type'          => 'dropdown',
				'heading'       => esc_html__( 'Number Of Items.', 'qodux_fw' ),
				'param_name'    => 'slide_count',
				'value'         => array( 
					1  => '1', 
					2  => '2', 
					3  => '3', 
					4  => '4', 
					5  => '5', 
					6  => '6', 
					7  => '7', 
					8  => '8', 
					9  => '9',
					10 => '10', 
					11 => '11',
					12 => '12',
					13 => '13',
					14 => '14',
					15 => '15'
				),
				'description'   => esc_html__( 'Specify the number of slide items.', 'qodux_fw' ) .' <strong>' . esc_html__( 'Maximum allowed is \'15\' items', 'qodux_fw' ) .'</strong>.'
			),	
				
				// Testimonial item #1
				array(
					'type'		  => 'qodx_separator',
					'heading'	  => '',
					"param_name"  => sprintf('separator_%d',1),
					'separator'	  => sprintf(esc_html__( 'Testimonial item #%d', 'qodux_fw' ),1),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count',
						'value'   => array('1','2','3','4','5','6','7','8','9','10','11','12','13','14','15')
					)
				),				
				array(
					'type'          => 'textfield',
					'heading'       => sprintf(esc_html__( "Testimonial Name %d", 'qodux_fw' ),1),
					'param_name'    => sprintf("name_%d",1),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'	     => Array(
						'element'	=> 'slide_count',
						'value'   => array('1','2','3','4','5','6','7','8','9','10','11','12','13','14','15')
					),
					'description'        => esc_html__( 'Set testimonial author name.', 'qodux_fw' )
				),
				array(
					'type'          => 'textfield',
					'heading'       => sprintf(esc_html__( "Testimonial Company %d", 'qodux_fw' ),1),
					'param_name'    => sprintf("company_%d",1),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'	     => Array(
						'element'	=> 'slide_count',
						'value'   => array('1','2','3','4','5','6','7','8','9','10','11','12','13','14','15')
					),
					'description'        => esc_html__( 'Set testimonial author function.', 'qodux_fw' )
				),
				array(
					'type'          => 'vc_link',
					'heading'       => sprintf(esc_html__( "Testimonial Item URL (Link) %d", 'qodux_fw' ),1),
					'param_name'    => sprintf("name_link_%d",1),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('1','2','3','4','5','6','7','8','9','10','11','12','13','14','15')
					),
					'description'   => esc_html__( 'Select URL if you want to have a link on author function.', 'qodux_fw' )
				),			
				array(
					'type'               => 'textarea_raw_html',
					'heading'            => sprintf(esc_html__( "Testimonial Content %d", 'qodux_fw' ),1),
					'param_name'         => sprintf("content_%d",1),
					'param_holder_class' => 'wtcode border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('1','2','3','4','5','6','7','8','9','10','11','12','13','14','15')
					)
				),		
				
				array(
					'type'               => 'attach_image',
					'heading'            => sprintf(esc_html__( 'Testimonial Image %d', 'qodux_fw' ),1),
					'param_name'         => sprintf('image_%d',1),
					'param_holder_class' => 'border_box qodx_dependency',
					'description'        => esc_html__( 'If you want to use an image you can upload it here.', 'qodux_fw' ),
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('1','2','3','4','5','6','7','8','9','10','11','12','13','14','15')
					)
				),	
				
				// Testimonial item #2
				array(
					'type'		  => 'qodx_separator',
					'heading'	  => '',
					"param_name"  => sprintf('separator_%d',2),
					'separator'	  => sprintf(esc_html__( 'Testimonial item #%d', 'qodux_fw' ),2),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count',
						'value'   => array('2','3','4','5','6','7','8','9','10','11','12','13','14','15')
					)
				),		
				array(
					'type'          => 'textfield',
					'heading'       => sprintf(esc_html__( "Testimonial Name %d", 'qodux_fw' ),2),
					'param_name'    => sprintf("name_%d",2),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'	     => Array(
						'element'	=> 'slide_count',
						'value'   => array('2','3','4','5','6','7','8','9','10','11','12','13','14','15')
					),
					'description'        => esc_html__( 'Set testimonial author name.', 'qodux_fw' )
				),
				array(
					'type'          => 'textfield',
					'heading'       => sprintf(esc_html__( "Testimonial Company %d", 'qodux_fw' ),2),
					'param_name'    => sprintf("company_%d",2),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'	     => Array(
						'element'	=> 'slide_count',
						'value'   => array('2','3','4','5','6','7','8','9','10','11','12','13','14','15')
					),
					'description'        => esc_html__( 'Set testimonial author function.', 'qodux_fw' )
				),
				array(
					'type'          => 'vc_link',
					'heading'       => sprintf(esc_html__( "Testimonial URL (Link) %d", 'qodux_fw' ),2),
					'param_name'    => sprintf("name_link_%d",2),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('2','3','4','5','6','7','8','9','10','11','12','13','14','15')
					),
					'description'   => esc_html__( 'Select URL if you want to have a link on author function.', 'qodux_fw' )
				),	
				array(
					'type'               => 'textarea_raw_html',
					'heading'            => sprintf(esc_html__( "Testimonial Content %d", 'qodux_fw' ),2),
					'param_name'         => sprintf("content_%d",2),
					'param_holder_class' => 'wtcode border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('2','3','4','5','6','7','8','9','10','11','12','13','14','15')
					)
				),		
				array(
					'type'               => 'attach_image',
					'heading'            => sprintf(esc_html__( 'Testimonial Image %d', 'qodux_fw' ),2),
					'param_name'         => sprintf('image_%d',2),
					'param_holder_class' => 'border_box qodx_dependency',
					'description'        => esc_html__( 'If you want to use an image you can upload it here.', 'qodux_fw' ),
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('2','3','4','5','6','7','8','9','10','11','12','13','14','15')
					)
				),	
				
				// Testimonial item #3
				array(
					'type'		  => 'qodx_separator',
					'heading'	  => '',
					"param_name"  => sprintf('separator_%d',3),
					'separator'	  => sprintf(esc_html__( 'Testimonial item #%d', 'qodux_fw' ),3),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count',
						'value'   => array('3','4','5','6','7','8','9','10','11','12','13','14','15')
					)
				),	
				array(
					'type'          => 'textfield',
					'heading'       => sprintf(esc_html__( "Testimonial Name %d", 'qodux_fw' ),3),
					'param_name'    => sprintf("name_%d",3),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'	     => Array(
						'element'	=> 'slide_count',
						'value'   => array('3','4','5','6','7','8','9','10','11','12','13','14','15')
					),
					'description'        => esc_html__( 'Set testimonial author name.', 'qodux_fw' )
				),
				array(
					'type'          => 'textfield',
					'heading'       => sprintf(esc_html__( "Testimonial Company %d", 'qodux_fw' ),3),
					'param_name'    => sprintf("company_%d",3),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'	     => Array(
						'element'	=> 'slide_count',
						'value'   => array('3','4','5','6','7','8','9','10','11','12','13','14','15')
					),
					'description'        => esc_html__( 'Set testimonial author function.', 'qodux_fw' )
				),
				array(
					'type'          => 'vc_link',
					'heading'       => sprintf(esc_html__( "Testimonial URL (Link) %d", 'qodux_fw' ),3),
					'param_name'    => sprintf("name_link_%d",3),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('3','4','5','6','7','8','9','10','11','12','13','14','15')
					),
					'description'   => esc_html__( 'Select URL if you want to have a link on author function.', 'qodux_fw' )
				),		
				array(
					'type'               => 'textarea_raw_html',
					'heading'            => sprintf(esc_html__( "Testimonial Content %d", 'qodux_fw' ),3),
					'param_name'         => sprintf("content_%d",3),
					'param_holder_class' => 'wtcode border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('3','4','5','6','7','8','9','10','11','12','13','14','15')
					)
				),
				array(
					'type'               => 'attach_image',
					'heading'            => sprintf(esc_html__( "Testimonial Image %d", 'qodux_fw' ),3),
					'param_name'         => sprintf("image_%d",3),
					'param_holder_class' => 'border_box qodx_dependency',
					'description'        => esc_html__( 'If you want to use an image for this testimonial you can upload it here.', 'qodux_fw' ),
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('3','4','5','6','7','8','9','10','11','12','13','14','15')
					)
				),
				
				// Testimonial item #4
				array(
					'type'		  => 'qodx_separator',
					'heading'	  => '',
					"param_name"  => sprintf('separator_%d',4),
					'separator'	  => sprintf(esc_html__( 'Testimonial item #%d', 'qodux_fw' ),4),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count',
						'value'   => array('4','5','6','7','8','9','10','11','12','13','14','15')
					)
				),	
				array(
					'type'          => 'textfield',
					'heading'       => sprintf(esc_html__( "Testimonial Name %d", 'qodux_fw' ),4),
					'param_name'    => sprintf("name_%d",4),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'	     => Array(
						'element'	=> 'slide_count',
						'value'   => array('4','5','6','7','8','9','10','11','12','13','14','15')
					),
					'description'        => esc_html__( 'Set testimonial author name.', 'qodux_fw' )
				),
				array(
					'type'          => 'textfield',
					'heading'       => sprintf(esc_html__( "Testimonial Company %d", 'qodux_fw' ),4),
					'param_name'    => sprintf("company_%d",4),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'	     => Array(
						'element'	=> 'slide_count',
						'value'   => array('4','5','6','7','8','9','10','11','12','13','14','15')
					),
					'description'        => esc_html__( 'Set testimonial author function.', 'qodux_fw' )
				),
				array(
					'type'          => 'vc_link',
					'heading'       => sprintf(esc_html__( "Testimonial URL (Link) %d", 'qodux_fw' ),4),
					'param_name'    => sprintf("name_link_%d",4),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('4','5','6','7','8','9','10','11','12','13','14','15')
					),
					'description'   => esc_html__( 'Select URL if you want to have a link on author function.', 'qodux_fw' )
				),		
				array(
					'type'               => 'textarea_raw_html',
					'heading'            => sprintf(esc_html__( "Testimonial Content %d", 'qodux_fw' ),4),
					'param_name'         => sprintf("content_%d",4),
					'param_holder_class' => 'wtcode border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('4','5','6','7','8','9','10','11','12','13','14','15')
					)
				),
				array(
					'type'               => 'attach_image',
					'heading'            => sprintf(esc_html__( "Testimonial Image %d", 'qodux_fw' ),4),
					'param_name'         => sprintf("image_%d",4),
					'param_holder_class' => 'border_box qodx_dependency',
					'description'        => esc_html__( 'If you want to use an image for this testimonial you can upload it here.', 'qodux_fw' ),
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('4','5','6','7','8','9','10','11','12','13','14','15')
					)
				),
				
				// Testimonial item #5
				array(
					'type'		  => 'qodx_separator',
					'heading'	  => '',
					"param_name"  => sprintf('separator_%d',5),
					'separator'	  => sprintf(esc_html__( 'Testimonial item #%d', 'qodux_fw' ),5),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count',
						'value'   => array('5','6','7','8','9','10','11','12','13','14','15')
					)
				),	
				array(
					'type'          => 'textfield',
					'heading'       => sprintf(esc_html__( "Testimonial Name %d", 'qodux_fw' ),5),
					'param_name'    => sprintf("name_%d",5),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'	     => Array(
						'element'	=> 'slide_count',
						'value'   => array('5','6','7','8','9','10','11','12','13','14','15')
					),
					'description'        => esc_html__( 'Set testimonial author name.', 'qodux_fw' )
				),
				array(
					'type'          => 'textfield',
					'heading'       => sprintf(esc_html__( "Testimonial Company %d", 'qodux_fw' ),5),
					'param_name'    => sprintf("company_%d",5),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'	     => Array(
						'element'	=> 'slide_count',
						'value'   => array('5','6','7','8','9','10','11','12','13','14','15')
					),
					'description'        => esc_html__( 'Set testimonial author function.', 'qodux_fw' )
				),
				array(
					'type'          => 'vc_link',
					'heading'       => sprintf(esc_html__( "Testimonial URL (Link) %d", 'qodux_fw' ),5),
					'param_name'    => sprintf("name_link_%d",5),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('5','6','7','8','9','10','11','12','13','14','15')
					),
					'description'   => esc_html__( 'Select URL if you want to have a link on author function.', 'qodux_fw' )
				),		
				array(
					'type'               => 'textarea_raw_html',
					'heading'            => sprintf(esc_html__( "Testimonial Content %d", 'qodux_fw' ),5),
					'param_name'         => sprintf("content_%d",5),
					'param_holder_class' => 'wtcode border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('5','6','7','8','9','10','11','12','13','14','15')
					)
				),
				array(
					'type'               => 'attach_image',
					'heading'            => sprintf(esc_html__( "Testimonial Image %d", 'qodux_fw' ),5),
					'param_name'         => sprintf("image_%d",5),
					'param_holder_class' => 'border_box qodx_dependency',
					'description'        => esc_html__( 'If you want to use an image for this testimonial you can upload it here.', 'qodux_fw' ),
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('5','6','7','8','9','10','11','12','13','14','15')
					)
				),
				
				// Testimonial item #6
				array(
					'type'		  => 'qodx_separator',
					'heading'	  => '',
					"param_name"  => sprintf('separator_%d',6),
					'separator'	  => sprintf(esc_html__( 'Testimonial item #%d', 'qodux_fw' ),6),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count',
						'value'   => array('6','7','8','9','10','11','12','13','14','15')
					)
				),	
				array(
					'type'          => 'textfield',
					'heading'       => sprintf(esc_html__( "Testimonial Name %d", 'qodux_fw' ),6),
					'param_name'    => sprintf("name_%d",6),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'	     => Array(
						'element'	=> 'slide_count',
						'value'   => array('6','7','8','9','10','11','12','13','14','15')
					),
					'description'        => esc_html__( 'Set testimonial author name.', 'qodux_fw' )
				),
				array(
					'type'          => 'textfield',
					'heading'       => sprintf(esc_html__( "Testimonial Company %d", 'qodux_fw' ),6),
					'param_name'    => sprintf("company_%d",6),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'	     => Array(
						'element'	=> 'slide_count',
						'value'   => array('6','7','8','9','10','11','12','13','14','15')
					),
					'description'        => esc_html__( 'Set testimonial author function.', 'qodux_fw' )
				),
				array(
					'type'          => 'vc_link',
					'heading'       => sprintf(esc_html__( "Testimonial URL (Link) %d", 'qodux_fw' ),6),
					'param_name'    => sprintf("name_link_%d",6),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('6','7','8','9','10','11','12','13','14','15')
					),
					'description'   => esc_html__( 'Select URL if you want to have a link on author function.', 'qodux_fw' )
				),		
				array(
					'type'               => 'textarea_raw_html',
					'heading'            => sprintf(esc_html__( "Testimonial Content %d", 'qodux_fw' ),6),
					'param_name'         => sprintf("content_%d",6),
					'param_holder_class' => 'wtcode border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('6','7','8','9','10','11','12','13','14','15')
					)
				),
				array(
					'type'               => 'attach_image',
					'heading'            => sprintf(esc_html__( "Testimonial Image %d", 'qodux_fw' ),6),
					'param_name'         => sprintf("image_%d",6),
					'param_holder_class' => 'border_box qodx_dependency',
					'description'        => esc_html__( 'If you want to use an image for this testimonial you can upload it here.', 'qodux_fw' ),
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('6','7','8','9','10','11','12','13','14','15')
					)
				),
				
				// Testimonial item #7
				array(
					'type'		  => 'qodx_separator',
					'heading'	  => '',
					"param_name"  => sprintf('separator_%d',7),
					'separator'	  => sprintf(esc_html__( 'Testimonial item #%d', 'qodux_fw' ),7),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count',
						'value'   => array('7','8','9','10','11','12','13','14','15')
					)
				),	
				array(
					'type'          => 'textfield',
					'heading'       => sprintf(esc_html__( "Testimonial Name %d", 'qodux_fw' ),7),
					'param_name'    => sprintf("name_%d",7),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'	     => Array(
						'element'	=> 'slide_count',
						'value'   => array('7','8','9','10','11','12','13','14','15')
					),
					'description'        => esc_html__( 'Set testimonial author name.', 'qodux_fw' )
				),
				array(
					'type'          => 'textfield',
					'heading'       => sprintf(esc_html__( "Testimonial Company %d", 'qodux_fw' ),7),
					'param_name'    => sprintf("company_%d",7),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'	     => Array(
						'element'	=> 'slide_count',
						'value'   => array('7','8','9','10','11','12','13','14','15')
					),
					'description'        => esc_html__( 'Set testimonial author function.', 'qodux_fw' )
				),
				array(
					'type'          => 'vc_link',
					'heading'       => sprintf(esc_html__( "Testimonial URL (Link) %d", 'qodux_fw' ),7),
					'param_name'    => sprintf("name_link_%d",7),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('7','8','9','10','11','12','13','14','15')
					),
					'description'   => esc_html__( 'Select URL if you want to have a link on author function.', 'qodux_fw' )
				),		
				array(
					'type'               => 'textarea_raw_html',
					'heading'            => sprintf(esc_html__( "Testimonial Content %d", 'qodux_fw' ),7),
					'param_name'         => sprintf("content_%d",7),
					'param_holder_class' => 'wtcode border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('7','8','9','10','11','12','13','14','15')
					)
				),
				array(
					'type'               => 'attach_image',
					'heading'            => sprintf(esc_html__( "Testimonial Image %d", 'qodux_fw' ),7),
					'param_name'         => sprintf("image_%d",7),
					'param_holder_class' => 'border_box qodx_dependency',
					'description'        => esc_html__( 'If you want to use an image for this testimonial you can upload it here.', 'qodux_fw' ),
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('7','8','9','10','11','12','13','14','15')
					)
				),
				
				// Testimonial item #8
				array(
					'type'		  => 'qodx_separator',
					'heading'	  => '',
					"param_name"  => sprintf('separator_%d',8),
					'separator'	  => sprintf(esc_html__( 'Testimonial item #%d', 'qodux_fw' ),8),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count',
						'value'   => array('8','9','10','11','12','13','14','15')
					)
				),	
				array(
					'type'          => 'textfield',
					'heading'       => sprintf(esc_html__( "Testimonial Name %d", 'qodux_fw' ),8),
					'param_name'    => sprintf("name_%d",8),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'	     => Array(
						'element'	=> 'slide_count',
						'value'   => array('8','9','10','11','12','13','14','15')
					),
					'description'        => esc_html__( 'Set testimonial author name.', 'qodux_fw' )
				),
				array(
					'type'          => 'textfield',
					'heading'       => sprintf(esc_html__( "Testimonial Company %d", 'qodux_fw' ),8),
					'param_name'    => sprintf("company_%d",8),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'	     => Array(
						'element'	=> 'slide_count',
						'value'   => array('8','9','10','11','12','13','14','15')
					),
					'description'        => esc_html__( 'Set testimonial author function.', 'qodux_fw' )
				),
				array(
					'type'          => 'vc_link',
					'heading'       => sprintf(esc_html__( "Testimonial URL (Link) %d", 'qodux_fw' ),8),
					'param_name'    => sprintf("name_link_%d",8),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('8','9','10','11','12','13','14','15')
					),
					'description'   => esc_html__( 'Select URL if you want to have a link on author function.', 'qodux_fw' )
				),		
				array(
					'type'               => 'textarea_raw_html',
					'heading'            => sprintf(esc_html__( "Testimonial Content %d", 'qodux_fw' ),8),
					'param_name'         => sprintf("content_%d",8),
					'param_holder_class' => 'wtcode border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('8','9','10','11','12','13','14','15')
					)
				),
				array(
					'type'               => 'attach_image',
					'heading'            => sprintf(esc_html__( "Testimonial Image %d", 'qodux_fw' ),8),
					'param_name'         => sprintf("image_%d",8),
					'param_holder_class' => 'border_box qodx_dependency',
					'description'        => esc_html__( 'If you want to use an image for this testimonial you can upload it here.', 'qodux_fw' ),
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('8','9','10','11','12','13','14','15')
					)
				),
				
				// Testimonial item #9
				array(
					'type'		  => 'qodx_separator',
					'heading'	  => '',
					"param_name"  => sprintf('separator_%d',9),
					'separator'	  => sprintf(esc_html__( 'Testimonial item #%d', 'qodux_fw' ),9),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count',
						'value'   => array('9','10','11','12','13','14','15')
					)
				),	
				array(
					'type'          => 'textfield',
					'heading'       => sprintf(esc_html__( "Testimonial Name %d", 'qodux_fw' ),9),
					'param_name'    => sprintf("name_%d",9),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'	     => Array(
						'element'	=> 'slide_count',
						'value'   => array('9','10','11','12','13','14','15')
					),
					'description'        => esc_html__( 'Set testimonial author name.', 'qodux_fw' )
				),
				array(
					'type'          => 'textfield',
					'heading'       => sprintf(esc_html__( "Testimonial Company %d", 'qodux_fw' ),9),
					'param_name'    => sprintf("company_%d",9),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'	     => Array(
						'element'	=> 'slide_count',
						'value'   => array('9','10','11','12','13','14','15')
					),
					'description'        => esc_html__( 'Set testimonial author function.', 'qodux_fw' )
				),
				array(
					'type'          => 'vc_link',
					'heading'       => sprintf(esc_html__( "Testimonial URL (Link) %d", 'qodux_fw' ),9),
					'param_name'    => sprintf("name_link_%d",9),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('9','10','11','12','13','14','15')
					),
					'description'   => esc_html__( 'Select URL if you want to have a link on author function.', 'qodux_fw' )
				),		
				array(
					'type'               => 'textarea_raw_html',
					'heading'            => sprintf(esc_html__( "Testimonial Content %d", 'qodux_fw' ),9),
					'param_name'         => sprintf("content_%d",9),
					'param_holder_class' => 'wtcode border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('9','10','11','12','13','14','15')
					)
				),
				array(
					'type'               => 'attach_image',
					'heading'            => sprintf(esc_html__( "Testimonial Image %d", 'qodux_fw' ),9),
					'param_name'         => sprintf("image_%d",9),
					'param_holder_class' => 'border_box qodx_dependency',
					'description'        => esc_html__( 'If you want to use an image for this testimonial you can upload it here.', 'qodux_fw' ),
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('9','10','11','12','13','14','15')
					)
				),
				
				// Testimonial item #10
				array(
					'type'		  => 'qodx_separator',
					'heading'	  => '',
					"param_name"  => sprintf('separator_%d',10),
					'separator'	  => sprintf(esc_html__( 'Testimonial item #%d', 'qodux_fw' ),10),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count',
						'value'   => array('10','11','12','13','14','15')
					)
				),	
				array(
					'type'          => 'textfield',
					'heading'       => sprintf(esc_html__( "Testimonial Name %d", 'qodux_fw' ),10),
					'param_name'    => sprintf("name_%d",10),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'	     => Array(
						'element'	=> 'slide_count',
						'value'   => array('10','11','12','13','14','15')
					),
					'description'        => esc_html__( 'Set testimonial author name.', 'qodux_fw' )
				),
				array(
					'type'          => 'textfield',
					'heading'       => sprintf(esc_html__( "Testimonial Company %d", 'qodux_fw' ),10),
					'param_name'    => sprintf("company_%d",10),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'	     => Array(
						'element'	=> 'slide_count',
						'value'   => array('10','11','12','13','14','15')
					),
					'description'        => esc_html__( 'Set testimonial author function.', 'qodux_fw' )
				),
				array(
					'type'          => 'vc_link',
					'heading'       => sprintf(esc_html__( "Testimonial URL (Link) %d", 'qodux_fw' ),10),
					'param_name'    => sprintf("name_link_%d",10),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('10','11','12','13','14','15')
					),
					'description'   => esc_html__( 'Select URL if you want to have a link on author function.', 'qodux_fw' )
				),		
				array(
					'type'               => 'textarea_raw_html',
					'heading'            => sprintf(esc_html__( "Testimonial Content %d", 'qodux_fw' ),10),
					'param_name'         => sprintf("content_%d",10),
					'param_holder_class' => 'wtcode border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('10','11','12','13','14','15')
					)
				),
				array(
					'type'               => 'attach_image',
					'heading'            => sprintf(esc_html__( "Testimonial Image %d", 'qodux_fw' ),10),
					'param_name'         => sprintf("image_%d",10),
					'param_holder_class' => 'border_box qodx_dependency',
					'description'        => esc_html__( 'If you want to use an image for this testimonial you can upload it here.', 'qodux_fw' ),
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('10','11','12','13','14','15')
					)
				),
				
				// Testimonial item #11
				array(
					'type'		  => 'qodx_separator',
					'heading'	  => '',
					"param_name"  => sprintf('separator_%d',11),
					'separator'	  => sprintf(esc_html__( 'Testimonial item #%d', 'qodux_fw' ),11),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count',
						'value'   => array('11','12','13','14','15')
					)
				),	
				array(
					'type'          => 'textfield',
					'heading'       => sprintf(esc_html__( "Testimonial Name %d", 'qodux_fw' ),11),
					'param_name'    => sprintf("name_%d",11),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'	     => Array(
						'element'	=> 'slide_count',
						'value'   => array('11','12','13','14','15')
					),
					'description'        => esc_html__( 'Set testimonial author name.', 'qodux_fw' )
				),
				array(
					'type'          => 'textfield',
					'heading'       => sprintf(esc_html__( "Testimonial Company %d", 'qodux_fw' ),11),
					'param_name'    => sprintf("company_%d",11),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'	     => Array(
						'element'	=> 'slide_count',
						'value'   => array('11','12','13','14','15')
					),
					'description'        => esc_html__( 'Set testimonial author function.', 'qodux_fw' )
				),
				array(
					'type'          => 'vc_link',
					'heading'       => sprintf(esc_html__( "Testimonial URL (Link) %d", 'qodux_fw' ),11),
					'param_name'    => sprintf("name_link_%d",11),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('11','12','13','14','15')
					),
					'description'   => esc_html__( 'Select URL if you want to have a link on author function.', 'qodux_fw' )
				),		
				array(
					'type'               => 'textarea_raw_html',
					'heading'            => sprintf(esc_html__( "Testimonial Content %d", 'qodux_fw' ),11),
					'param_name'         => sprintf("content_%d",11),
					'param_holder_class' => 'wtcode border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('11','12','13','14','15')
					)
				),
				array(
					'type'               => 'attach_image',
					'heading'            => sprintf(esc_html__( "Testimonial Image %d", 'qodux_fw' ),11),
					'param_name'         => sprintf("image_%d",11),
					'param_holder_class' => 'border_box qodx_dependency',
					'description'        => esc_html__( 'If you want to use an image for this testimonial you can upload it here.', 'qodux_fw' ),
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('11','12','13','14','15')
					)
				),
				
				// Testimonial item #12
				array(
					'type'		  => 'qodx_separator',
					'heading'	  => '',
					"param_name"  => sprintf('separator_%d',12),
					'separator'	  => sprintf(esc_html__( 'Testimonial item #%d', 'qodux_fw' ),12),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count',
						'value'   => array('12','13','14','15')
					)
				),	
				array(
					'type'          => 'textfield',
					'heading'       => sprintf(esc_html__( "Testimonial Name %d", 'qodux_fw' ),12),
					'param_name'    => sprintf("name_%d",12),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'	     => Array(
						'element'	=> 'slide_count',
						'value'   => array('12','13','14','15')
					),
					'description'        => esc_html__( 'Set testimonial author name.', 'qodux_fw' )
				),
				array(
					'type'          => 'textfield',
					'heading'       => sprintf(esc_html__( "Testimonial Company %d", 'qodux_fw' ),12),
					'param_name'    => sprintf("company_%d",12),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'	     => Array(
						'element'	=> 'slide_count',
						'value'   => array('12','13','14','15')
					),
					'description'        => esc_html__( 'Set testimonial author function.', 'qodux_fw' )
				),
				array(
					'type'          => 'vc_link',
					'heading'       => sprintf(esc_html__( "Testimonial URL (Link) %d", 'qodux_fw' ),12),
					'param_name'    => sprintf("name_link_%d",12),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('12','13','14','15')
					),
					'description'   => esc_html__( 'Select URL if you want to have a link on author function.', 'qodux_fw' )
				),		
				array(
					'type'               => 'textarea_raw_html',
					'heading'            => sprintf(esc_html__( "Testimonial Content %d", 'qodux_fw' ),12),
					'param_name'         => sprintf("content_%d",12),
					'param_holder_class' => 'wtcode border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('12','13','14','15')
					)
				),
				array(
					'type'               => 'attach_image',
					'heading'            => sprintf(esc_html__( "Testimonial Image %d", 'qodux_fw' ),12),
					'param_name'         => sprintf("image_%d",12),
					'param_holder_class' => 'border_box qodx_dependency',
					'description'        => esc_html__( 'If you want to use an image for this testimonial you can upload it here.', 'qodux_fw' ),
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('12','13','14','15')
					)
				),
				
				// Testimonial item #13
				array(
					'type'		  => 'qodx_separator',
					'heading'	  => '',
					"param_name"  => sprintf('separator_%d',13),
					'separator'	  => sprintf(esc_html__( 'Testimonial item #%d', 'qodux_fw' ),13),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count',
						'value'   => array('13','14','15')
					)
				),	
				array(
					'type'          => 'textfield',
					'heading'       => sprintf(esc_html__( "Testimonial Name %d", 'qodux_fw' ),13),
					'param_name'    => sprintf("name_%d",13),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'	     => Array(
						'element'	=> 'slide_count',
						'value'   => array('13','14','15')
					),
					'description'        => esc_html__( 'Set testimonial author name.', 'qodux_fw' )
				),
				array(
					'type'          => 'textfield',
					'heading'       => sprintf(esc_html__( "Testimonial Company %d", 'qodux_fw' ),13),
					'param_name'    => sprintf("company_%d",13),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'	     => Array(
						'element'	=> 'slide_count',
						'value'   => array('13','14','15')
					),
					'description'        => esc_html__( 'Set testimonial author function.', 'qodux_fw' )
				),
				array(
					'type'          => 'vc_link',
					'heading'       => sprintf(esc_html__( "Testimonial URL (Link) %d", 'qodux_fw' ),13),
					'param_name'    => sprintf("name_link_%d",13),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('13','14','15')
					),
					'description'   => esc_html__( 'Select URL if you want to have a link on author function.', 'qodux_fw' )
				),		
				array(
					'type'               => 'textarea_raw_html',
					'heading'            => sprintf(esc_html__( "Testimonial Content %d", 'qodux_fw' ),13),
					'param_name'         => sprintf("content_%d",13),
					'param_holder_class' => 'wtcode border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('13','14','15')
					)
				),
				array(
					'type'               => 'attach_image',
					'heading'            => sprintf(esc_html__( "Testimonial Image %d", 'qodux_fw' ),13),
					'param_name'         => sprintf("image_%d",13),
					'param_holder_class' => 'border_box qodx_dependency',
					'description'        => esc_html__( 'If you want to use an image for this testimonial you can upload it here.', 'qodux_fw' ),
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('13','14','15')
					)
				),
				
				// Testimonial item #14
				array(
					'type'		  => 'qodx_separator',
					'heading'	  => '',
					"param_name"  => sprintf('separator_%d',14),
					'separator'	  => sprintf(esc_html__( 'Testimonial item #%d', 'qodux_fw' ),14),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count',
						'value'   => array('14','15')
					)
				),	
				array(
					'type'          => 'textfield',
					'heading'       => sprintf(esc_html__( "Testimonial Name %d", 'qodux_fw' ),14),
					'param_name'    => sprintf("name_%d",14),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'	     => Array(
						'element'	=> 'slide_count',
						'value'   => array('14','15')
					),
					'description'        => esc_html__( 'Set testimonial author name.', 'qodux_fw' )
				),
				array(
					'type'          => 'textfield',
					'heading'       => sprintf(esc_html__( "Testimonial Company %d", 'qodux_fw' ),14),
					'param_name'    => sprintf("company_%d",14),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'	     => Array(
						'element'	=> 'slide_count',
						'value'   => array('14','15')
					),
					'description'        => esc_html__( 'Set testimonial author function.', 'qodux_fw' )
				),
				array(
					'type'          => 'vc_link',
					'heading'       => sprintf(esc_html__( "Testimonial URL (Link) %d", 'qodux_fw' ),14),
					'param_name'    => sprintf("name_link_%d",14),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('14','15')
					),
					'description'   => esc_html__( 'Select URL if you want to have a link on author function.', 'qodux_fw' )
				),		
				array(
					'type'               => 'textarea_raw_html',
					'heading'            => sprintf(esc_html__( "Testimonial Content %d", 'qodux_fw' ),14),
					'param_name'         => sprintf("content_%d",14),
					'param_holder_class' => 'wtcode border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('14','15')
					)
				),
				array(
					'type'               => 'attach_image',
					'heading'            => sprintf(esc_html__( "Testimonial Image %d", 'qodux_fw' ),14),
					'param_name'         => sprintf("image_%d",14),
					'param_holder_class' => 'border_box qodx_dependency',
					'description'        => esc_html__( 'If you want to use an image for this testimonial you can upload it here.', 'qodux_fw' ),
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('14','15')
					)
				),
				
				// Testimonial item #15
				array(
					'type'		  => 'qodx_separator',
					'heading'	  => '',
					"param_name"  => sprintf('separator_%d',15),
					'separator'	  => sprintf(esc_html__( 'Testimonial item #%d', 'qodux_fw' ),15),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count',
						'value'   => array('15')
					)
				),	
				array(
					'type'          => 'textfield',
					'heading'       => sprintf(esc_html__( "Testimonial Name %d", 'qodux_fw' ),15),
					'param_name'    => sprintf("name_%d",15),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'	     => Array(
						'element'	=> 'slide_count',
						'value'   => array('15')
					),
					'description'        => esc_html__( 'Set testimonial author name.', 'qodux_fw' )
				),
				array(
					'type'          => 'textfield',
					'heading'       => sprintf(esc_html__( "Testimonial Company %d", 'qodux_fw' ),15),
					'param_name'    => sprintf("company_%d",15),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'	     => Array(
						'element'	=> 'slide_count',
						'value'   => array('15')
					),
					'description'        => esc_html__( 'Set testimonial author function.', 'qodux_fw' )
				),
				array(
					'type'          => 'vc_link',
					'heading'       => sprintf(esc_html__( "Testimonial URL (Link) %d", 'qodux_fw' ),15),
					'param_name'    => sprintf("name_link_%d",15),
					'param_holder_class' => 'border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('15')
					),
					'description'   => esc_html__( 'Select URL if you want to have a link on author function.', 'qodux_fw' )
				),		
				array(
					'type'               => 'textarea_raw_html',
					'heading'            => sprintf(esc_html__( "Testimonial Content %d", 'qodux_fw' ),15),
					'param_name'         => sprintf("content_%d",15),
					'param_holder_class' => 'wtcode border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('15')
					)
				),
				array(
					'type'               => 'attach_image',
					'heading'            => sprintf(esc_html__( "Testimonial Image %d", 'qodux_fw' ),15),
					'param_name'         => sprintf("image_%d",15),
					'param_holder_class' => 'border_box qodx_dependency',
					'description'        => esc_html__( 'If you want to use an image for this testimonial you can upload it here.', 'qodux_fw' ),
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('15')
					)
				),
				
			// Slider Settings				
			array(
				'type'               => 'textfield',
				'heading'            => esc_html__( 'Extra class for slides', 'qodux_fw' ),
				'param_name'         => 'class_slides',
				'value'              => 'col-md-12',
				'description'   => esc_html__( 'Add extra class for testimonial slides.', 'qodux_fw' ),
				'group' => esc_html__( 'Slider', 'qodux_fw' )
			),			
			array(
				'type'               => 'textfield',
				'heading'            => esc_html__( 'Autoplay', 'qodux_fw' ),
				'param_name'         => 'auto_slide',
				'value'              => '5000',
				'description'   => esc_html__( 'Enables autoplay and define the time interval (in miliseconds - Ex: 3000, 4000, 5000 etc) between transitions. Set it "0" to disable autoplay.', 'qodux_fw' ),
				'group' => esc_html__( 'Slider', 'qodux_fw' )
			),
			array(
				'type'               => 'dropdown',
				'heading'            => esc_html__( 'Direction', 'qodux_fw' ),
				'param_name'         => 'direction',
				'value' 			 => array( 
					esc_html__( 'Horizontal', 'qodux_fw' ) => 'horizontal',
					esc_html__( 'Vertical', 'qodux_fw' )   => 'vertical',
				),
				'description'   => esc_html__( 'Define slider direction ( horizontal / vertical ).', 'qodux_fw' ),
				'group' => esc_html__( 'Slider', 'qodux_fw' )
			),
			array(
				'type'               => 'dropdown',
				'heading'            => esc_html__( 'Effect', 'qodux_fw' ),
				'param_name'         => 'effect',
				'value' 			 => array( 
					esc_html__( 'Slide', 'qodux_fw' )     => 'slide',
					esc_html__( 'Fade', 'qodux_fw' )      => 'fade',
					esc_html__( 'Coverflow', 'qodux_fw' ) => 'coverflow',
				),
				'description'   => esc_html__( 'Define slider animation effect.', 'qodux_fw' ),
				'group' => esc_html__( 'Slider', 'qodux_fw' )
			),
			array(
				'type'               => 'dropdown',
				'heading'            => esc_html__( 'Centered Slides', 'qodux_fw' ),
				'param_name'         => 'centered_slides',
				'value' 			 => array( 
					esc_html__( 'No', 'qodux_fw' )    => 'false',
					esc_html__( 'Yes', 'qodux_fw' )   => 'true',
				),
				'description'   => esc_html__( 'If true, then active slide will be centered, not always on the left side.', 'qodux_fw' ),
				'group' => esc_html__( 'Slider', 'qodux_fw' )
			),	
			array(
				'type'               => 'dropdown',
				'heading'            => esc_html__( 'Grab Cursor', 'qodux_fw' ),
				'param_name'         => 'grab_cursor',
				'value' 			 => array( 
					esc_html__( 'Yes', 'qodux_fw' )   => 'true',
					esc_html__( 'No', 'qodux_fw' )    => 'false',
				),
				'description'   => esc_html__( 'This option may a little improve desktop usability. If true, user will see the "grab" cursor when hover on Swiper.', 'qodux_fw' ),
				'group' => esc_html__( 'Slider', 'qodux_fw' )
			),	
			array(
				'type'               => 'dropdown',
				'heading'            => esc_html__( 'Simulate Touch', 'qodux_fw' ),
				'param_name'         => 'simulate_touch',
				'value' 			 => array( 
					esc_html__( 'Yes', 'qodux_fw' )   => 'true',
					esc_html__( 'No', 'qodux_fw' )    => 'false',
				),
				'description'   => esc_html__( 'If true, Swiper will accept mouse events like touch events (click and drag to change slides).', 'qodux_fw' ),
				'group' => esc_html__( 'Slider', 'qodux_fw' )
			),	
			array(
				'type'               => 'dropdown',
				'heading'            => esc_html__( 'Slider Pagination', 'qodux_fw' ),
				'param_name'         => 'slider_pag',
				'value' 			 => array( 
					esc_html__( 'No', 'qodux_fw' )    => 'false',
					esc_html__( 'Yes', 'qodux_fw' )   => 'true',
				),
				'description'   => esc_html__( 'Enables slider pagination.', 'qodux_fw' ),
				'group' => esc_html__( 'Slider', 'qodux_fw' )
			),		
			array(
				'type'			     => 'checkbox',
				'heading'		     => esc_html__( 'Slider Pagination Lowest?', 'qodux_fw' ),
				'param_name'	     => 'pag_lowest',
				'value'			     => Array( esc_html__( 'Yes please.', 'qodux_fw' ) => 'yes' ),
				'description'        => esc_html__( 'Check this option to display pagination in the lowest position.', 'qodux_fw' ),
				'param_holder_class' => 'border_box qodx_dependency',
				'dependency' 	     => array(
					'element' => 'slider_pag',
					'value'   => 'true'
				),
				'group'              => esc_html__( 'Slider', 'qodux_fw' )
			),
			array(
				'type'               => 'dropdown',
				'heading'            => esc_html__( 'Slider Navigation', 'qodux_fw' ),
				'param_name'         => 'slider_nav',
				'value' 			 => array( 
					esc_html__( 'No', 'qodux_fw' )    => 'false',
					esc_html__( 'Yes', 'qodux_fw' )   => 'true',
				),
				'description'   => esc_html__( 'Enables slider navigation ( prev / next buttons ).', 'qodux_fw' ),
				'group' => esc_html__( 'Slider', 'qodux_fw' )
			),	
			
			$add_qodx_extra_id,
			$add_qodx_extra_class,
			$add_qodx_css_animation,
			$add_qodx_css_animation_type,
			$add_qodx_css_animation_delay,
			
			array(
				'type'          => 'css_editor',
				'heading'       => esc_html__( 'Css', 'qodux_fw' ),
				'param_name'    => 'css',
				'group'         => esc_html__( 'Design options', 'qodux_fw' )
			)
		)
	));
	
}