<?php

// File Security Check
if (!defined('ABSPATH')) die('-1');

/*
Register Qodux shortcode.
*/

class WPBakeryShortCode_QODX_portfolio extends WPBakeryShortCode {
	
	private $qodx_sc;
	
	public function __construct($settings) {
        parent::__construct($settings);
		$this->qodx_sc = new QODX_VCSC_SHORTCODE;
	}
			
	protected function content($atts, $content = null) {
		
		// Get and extract shortcode attributes
		$atts = vc_map_get_attributes( $this->getShortcode(), $atts );
		extract( $atts );
				
		$sc_class = 'qodx_portfolio_sc';
		
		$id = mt_rand(9999, 99999);
		if (trim($el_id) != false) {
			$el_id = esc_attr( trim($el_id) );
		} else {
			$el_id = $sc_class . '-' . $id;
		}
		
		$el_class = esc_attr( $this->getExtraClass($el_class) );		
		$css_class = apply_filters(VC_SHORTCODE_CUSTOM_CSS_FILTER_TAG, $sc_class.$el_class.vc_shortcode_custom_css_class($css, ' '), $this->settings['base']);		
		
		$columns        = (int)$columns;
		$max            = (int)$max;			
		$excerpt_length = (int)$excerpt_length;				
		$read_more_text = esc_html($read_more_text);	
		$auto_slide     = (int)$auto_slide;	
		$slide_items_md = (int)$slide_items_md;	
		$slide_items_sm = (int)$slide_items_sm;	
		$slide_items_xs = (int)$slide_items_xs;
		
		if ($slider == "true") {
			//wp_enqueue_style('qodx-extend-swiper-slider');
			wp_enqueue_script('qodx-extend-swiper-slider');
		}
						
		$atts = array(
			'columns'            => $columns,
			'max'                => $max,
			'style'              => $style,
			'img_width'          => $img_width,
			'img_height'         => $img_height,
			'single_settings'    => $single_settings,
			'img_link'           => $img_link,
			'grid_spaces'        => $grid_spaces,
			'slider'             => $slider,
			'title'              => $title,
			'title_linkable'     => $title_linkable,
			'excerpt'            => $excerpt,
			'excerpt_length'     => $excerpt_length,
			'full'               => $full,
			'category'           => $category,
			'read_more'          => $read_more,
			'read_more_text'     => $read_more_text,
			'group'              => $group,	
			'ids'                => $ids,	
			'cat'           	 => $cat,
			'cat__not'           => $cat__not,
			'order'              => $order,
			'orderby'            => $orderby,			
			
			'pagination'         => $pagination,
			'pagination_align'   => $pagination_align,
			'sortable'           => $sortable,
			'filter'             => $filter,
			'isotope_grid'       => $isotope_grid,			
			
			'slider'             => $slider,
			'auto_slide'         => $auto_slide,
			'direction'          => $direction,
			'equal_height'       => $equal_height,
			'effect'             => $effect,
			'centered_slides'    => $centered_slides,
			'slide_items_md'     => $slide_items_md,
			'slide_items_sm'     => $slide_items_sm,
			'slide_items_xs'     => $slide_items_xs,
			'grab_cursor'        => $grab_cursor,
			'simulate_touch'     => $simulate_touch,
			'slider_pag'         => $slider_pag,
			'pag_lowest'         => $pag_lowest,
			'slider_nav'         => $slider_nav
		);
				
		$output = '';
		
		// Automatically disable sortable or pagination if they all are true by mistake
		if ($slider == "true") { 
			$sortable   = 'false';
			$pagination = 'false';
		}
		if ($sortable == "true") {
			$pagination = 'false';		
		}
		
		// if portfolio with sortable links	- build the sortableLinks first			
		if ($sortable == "true") {
			$output .= '<div class="filter-section-wrapper gallery-filter">'; // Start filter section wrapper				
			wp_enqueue_script('qodx-extend-isotope');
			
			$terms = array();
			if ($cat != '') {
				foreach(explode(',', $cat) as $term_slug) {
					$terms[] = get_term_by('slug', $term_slug, 'portfolio_category');
					
					//$output .= ' ' . implode(' ', $terms_slug) . '">';
				}
			} else {
				$terms = get_terms('portfolio_category', 'orderby=id', 'hide_empty=1');
			}
			
			if ( $filter == 'filter_links' ) {	
				/* Sortable links Start */
				$output .= '<div class="sortableLinks btn-toolbar text-center m-bottom-30"><div class="btn-group">';
				// $output .= '<span>'.esc_html__( 'Show:','qodx_front')).'</span>';
				$output .= '<a class="btn active selected" data-filter="*" href="#">'.__('All Projects','qodx_front').'</a>';
				
				foreach($terms as $term) {
					// Show categories links which are not excluded
					if (strpos($cat__not, $term->slug) === FALSE) {
						$output .= '<a class="btn" data-filter=".' . $term->slug . '" href="#">' . $term->name . '</a>';					
					}
				}
							
				$output .= '</div></div>';
				/* Sortable links End */
			} else {					
				/* Sortable select options Start */			
				wp_enqueue_script('qodx-extend-qodx-select');
				
				$output .= '<div class="filter-block">';
					$output .= '<div class="filter-block-container">';
						$output .= '<div class="col-md-3">';
							$output .= '<div class="filter-group" data-filter-group="*">';
								$output .= '<select class="qodx-select">';
									$output .= '<option selected data-filter="*">'.__('All Projects','qodx_front').'</option>';				
									
									foreach($terms as $term) {
										// Show categories links which are not excluded
										if (strpos($cat__not, $term->slug) === FALSE) {
											$output .= '<option data-filter=".' . $term->slug . '">' . $term->name . '</option>';					
										}
									}
									
								$output .= '</select>';
								$output .= '<label>Choose Category</label>';
							$output .= '</div>';
						$output .= '</div>';
					$output .= '</div>';
				$output .= '</div>';
				/* Sortable select options End */	
			}
		}
				
		// Output for portfolio section		
		$output .= '<section id="'.$el_id.'" class="qodx-portfolio-wrapper'; // Start portfolio section	
									
			/* Portfolio with slider	*/
			if ( $slider == "true" ) {
				$output .= '-slider '.$css_class.'">';
				
				$equal_height = $direction == 'horizontal' && $equal_height == 'true' ? ' swiper-equal-height' : '';
				
				$direction = $direction == 'vertical' ? ' vertical-swiper-slider' : '';
			
				switch($effect){
					case 'fade':
						$effect = ' fade-swiper-slider';
						break;
					case 'coverflow':
						$effect = ' coverflow-swiper-slider';
						break;
					case 'fade':
					default:
						$effect = '';
				}
				
				$centered_slides = $centered_slides == 'true' ? ' center-swiper-slider' : '';			
															
				$output .= '<div id="qodx-swiper-slider-'.$id.'" class="qodx-swiper-slider'.$direction.$equal_height.$effect.$centered_slides.'" data-swiper-items="'.$columns.'" data-swiper-md-items="'.$slide_items_md.'" data-swiper-sm-items="'.$slide_items_sm.'" data-swiper-xs-items="'.$slide_items_xs.'" data-swiper-autoplay="'.$auto_slide.'" data-swiper-grab-cursor="'.$grab_cursor.'" data-swiper-simulate-touch="'.$simulate_touch.'">';
					$output .= '<div class="swiper-wrapper">';	
			
			/* Portfolio sortable or (fallback) if pagination, sortable and slider are all false */
			} elseif ( $sortable == "true" || ($pagination == "false" && $sortable == "false" && $slider == "false" && $isotope_grid) ) {
				wp_enqueue_script('qodx-extend-isotope');
				$output .= '-isotope filter-items-wrapper qodx_portfolio_' . $columns . ' '.$css_class.'">';
				
			/* Portfolio with pagination */	
			} else {
				$output .= ' qodx_portfolio_' . $columns . ' '.$css_class.'">';
			}		
					
				// Portfolio articles content goes here
				$output .= $this->QODX_VCSC_PortfolioList($atts, $id);
								
		return $output;			
	
	}
	
	protected function QODX_VCSC_PortfolioList($atts, $id) {
		
		extract($atts);	
		
		global $wp_filter;
		$the_content_filter_backup = $wp_filter['the_content'];
			
		$output = '';
		
		$rel_group = 'portfolio_'.$id; // for lightbox group
		if($group == 'true'){
			$rel =  ' data-fancybox-group="' . $rel_group . '"';
		} else {
			$rel = '';
		}
		
		if ( $style == 'style_1' ){
			$style_class = ' portfolio-block-style-1';
		} else if ( $style == 'style_2' ){
			$style_class = ' portfolio-block-style-2';
		} else if ( $style == 'style_3' ){
			$style_class = ' portfolio-block-style-3';
		} else {
			$style_class = '';
		}
		
		$grid_spaces = $grid_spaces == "true" ? '' : ' wide-block';
		
		if ( $read_more == 'true' ){
			$read_more = true;
		} else {
			$read_more = false;
		}
				
		// Automatically disable sortable or pagination if they all are true by mistake
		if ($slider == "true") { 
			$sortable   = 'false';
			$pagination = 'false';
		}
		if ($sortable == "true") {
			$pagination = 'false';		
		} 
		
		if ($pagination == "true") {
			global $wp_version;
			if(is_front_page() && version_compare($wp_version, "3.1", '>=')){ //fix wordpress 3.1 paged query
				$paged = (get_query_var('paged')) ? get_query_var('paged') : ((get_query_var('page')) ? get_query_var('page') : 1);
			}else{
				$paged = (get_query_var('paged')) ? get_query_var('paged') : 1;
			}
		} else {
			$paged = NULL;
		}	
		
		// Display only selected portfolios		
		if ( $ids ) {
			$portfolio_ids = explode(',',$ids);
		} else {
			$portfolio_ids = NULL;
		}	
				
		// Include categories
		if ( ! empty( $cat ) ) {
			$include_categories = array(
				'taxonomy'	=> 'portfolio_category',
				'field'		=> 'slug',
				'terms'		=> explode(',', $cat),
				'operator'	=> 'IN',
			);
		} else {
			$include_categories = '';
		}
		
		// Exclude categories
		if ( ! empty( $cat__not ) ) {
			$exclude_categories = array(
				'taxonomy'	=> 'portfolio_category',
				'field'		=> 'slug',
				'terms'		=> explode(',', $cat__not),
				'operator'	=> 'NOT IN',
			);
		} else {
			$exclude_categories = '';
		}	
		
		$qodx_query = new WP_Query(
			array(
				'post_type'			=> 'portfolio',
				'posts_per_page'	=> $max,
				'paged'				=> $paged,
				'order'				=> $order,
				'orderby'			=> $orderby,
				'post__in'			=> $portfolio_ids,
				'tax_query'			=> array(
					'relation'		=> 'AND',
					$include_categories,
					$exclude_categories,
				),
			)
		);
		
		$i     = 1;				
		$order = 0;
		
		$col_class     = '';
		$width_inline  = '';
		$height_inline = '';
		$_img_width    = '';
		$_img_height   = '';
						
		switch($columns){
			case 1:
				$col_class = 'col-md-12 ';
				break;
			case 2:
				$col_class = 'col-md-6 col-sm-6 col-xs-6 m-bottom-20 m-bottom-20 m-bottom-20 ';
				break;
			case 3:
				$col_class = 'col-md-4 col-sm-6 col-xs-6 m-bottom-20 ';
				break;
			case 6:
				$col_class = 'col-md-2 col-sm-6 col-xs-6 ';
				break;
			case 4:
			default:
				$col_class = 'col-md-3 col-sm-6 col-xs-6 ';
		}
		
		if ( $slider == 'true' ) {
			$col_class = 'col-md-12 ';
		}
		
		$isotope_css = '';			
		if ( ($pagination == "false" && $sortable == "false" && $slider == "false" && $isotope_grid) || $sortable == "true" ) { 
			$isotope_css = ' isotope-item';
		}
				
		while($qodx_query->have_posts()) {
			$order++;
			$qodx_query->the_post();
			$terms = get_the_terms(get_the_id(), 'portfolio_category');
			$terms_slug = array();
			if (is_array($terms)) {
				foreach($terms as $term) {
					$terms_slug[] = $term->slug;
				}
			}
			$col_css = $_item_css = $icon = $contentOutput = $thumbOutput = $imgOutput = $mainLink_start = $mainLink_end  = $lightbox_start = $lightbox_end = $thumb_width = $thumb_height = '';
			
			/* Content output Start	*/
			if ($title == 'true' || $excerpt == 'true' || $category == 'true' || $read_more == true){				
				$contentOutput .= "\n\t\t" . '<div class="qodx-portofolio-details"><div class="overlay-content">';
			}
	
				// If portfolio title
				if ( $title == 'true' ){
					if ( $title_linkable == 'true' ) {
						$contentOutput .= '<h4 class="qodx_portfolio_title"><a href="'.get_permalink().'" title="'.get_the_title().'">' . get_the_title() . '</a></h4>';
					} else {
						$contentOutput .= '<h4 class="qodx_portfolio_title">' . get_the_title() . '</h4>';
					}
				}
				
				// if NOT style #1 or #2 - display category, excerpt or read more button
				if ( $style != 'style_1' || $style != 'style_2' ) {
					//  If excerpt, category or read_more then build "qodx_portofolio_det" wrapper
					if ($excerpt == 'true' || $category == 'true' || $read_more == true){			
						$contentOutput .= '<div class="qodx_portofolio_det">';	
					}					
						
						// if category is set to Yes	
						if ($category == 'true'){		
							$contentOutput .= '<p class="qodx_portfolioCategory">'.$term->name.'</p>';
						}
						
						// if excerpt is set to Yes	
						if ($excerpt == 'true'){
							
							/* Display all post content or post excerpt */						
							if ( $full == 'true' ){
								$read_more = false;
								$content = get_the_content();
								$content = apply_filters('the_content', $content);
								$content = str_replace(']]>', ']]&gt;', $content);
								$contentOutput .= $content;
							} else {
								$content = QODX_VCSC_Excerpt( $excerpt_length, false, $read_more_text );
								$contentOutput .= '<div class="qodx_portfolio_excerpt">'.$content.'</div>';
							}						
							
						}
					
						// if read_more is set to Yes					
						if ( $read_more == true ) {	
							$more_link = focus_wp_get_superlink(get_post_meta(get_the_id(), '_portfolio_link', true), get_permalink());						
							$more_link_target = get_post_meta(get_the_ID(), '_portfolio_link_target', true);
							$more_link_target = $more_link_target ? $more_link_target : '_self';
								
							$readmore_link = '<p class="qodx_portf_readmore"><a href="' .$more_link. '" target="'.$more_link_target.'" title="' .$read_more_text. '" rel="bookmark" class="btn btn-qodx btn-qodx-sm wave-effect">' .$read_more_text. '</a></p>';
							
							$contentOutput .= apply_filters( 'qodx_readmore_link', $readmore_link );
						}
					
					if($excerpt == 'true' || $category == 'true' || $read_more == true){
						$contentOutput .= '</div>'; // End div - "qodx_portofolio_det"
					}
				} // End - if ( $style == 'style_1' || $style == 'style_2' )
				
			if ($title == 'true' || $excerpt == 'true' || $category == 'true' || $read_more == true){
				$contentOutput .= '</div></div>'; // End div - "qodx-portofolio-details"
			}
			/* Content output End */	
			
			/* Image output Start - if has_post_thumbnail() */
			if (has_post_thumbnail()) {
				$image_id = get_post_thumbnail_id(get_the_id());
				$image = wp_get_attachment_image_src($image_id, 'full', true);								
				
				$type = get_post_meta(get_the_id(), '_portfolio_type', true);
				$iframe = '';
				$video_width = $video_height = '';				
				
				if ( $single_settings ) {
					$_img_width  = get_post_meta(get_the_id(), '_img_width', true);
					$_img_height = get_post_meta(get_the_id(), '_img_height', true);
				}
							
				// image output
				wp_enqueue_script( 'fancybox' );
																
				// if portfolio type - video
				if ($type == 'video'){
					
					wp_enqueue_script( 'fancybox-media' );
					
					// if no video link is set then get the featured image
					$href =  get_post_meta(get_the_id(), '_video', true);
					if(empty($href)){
						$href = $image[0];
					}
										
					$icon = ' fancybox-' . $type;
					
				// if portfolio type - link
				} elseif ($type == 'link'){
					
					$link = get_post_meta(get_the_ID(), '_portfolio_link', true);
					$href = focus_wp_get_superlink($link);
					$link_target = get_post_meta(get_the_ID(), '_portfolio_link_target', true);					
					$link_target = $link_target ? $link_target : '_self';
					
					$icon = ' fancybox-' . $type;
										
				// if portfolio type - document
				}  elseif ($type == 'doc'){
					
					$href = get_permalink();
					$link_target = get_post_meta(get_the_ID(), '_doc_target', true);
					$link_target = $link_target ? $link_target : '_self';
					
					$icon = ' fancybox-' . $type;
									
				// if portfolio type - image (default)	
				} else {
					
					// if no large image link is set then get the featured image
					$href =  get_post_meta(get_the_id(), '_image', true);
					if(empty($href)){
						$href = $image[0];
					}					
				}					
				
				$cropped_img = focus_wp_get_image_src($image[0]); // fallback if aq_resize script doesn't exist
				if( function_exists( 'aq_resize' ) ) {
					$thumb_hard_crop = ( '9999' == $img_height ) ? false : true;
					
					// portfolio item width or height will override the shortcode settings
					$thumb_width  = $_img_width ? $_img_width : $img_width;
					$thumb_height = $_img_height ? $_img_height : $img_height;
					
					$cropped_img = aq_resize( focus_wp_get_image_src($image[0]), $thumb_width, $thumb_height, $thumb_hard_crop );
				}				
								
				$lightbox_start = '<a class="fancybox' . $icon . '" ' . (isset($link_target)?'target="'.$link_target.'" ':'') . ' href="' . $href . $video_width . $video_height . '" title="' . get_the_title() . '"' . $rel . '>';
				$lightbox_end   = '</a>';	
				
				$mainLink_start = '<a href="' . get_permalink() . '" title="' . get_the_title() . '" class="main-link">';
				$mainLink_end   = '</a>';			
				
				$imgOutput      = '<img src="'. $cropped_img .'" alt="' . get_the_title() . '" '.$width_inline.' '.$height_inline.' />';
				
				if ( $style == 'style_1' || $style == 'style_2' ) {
					// fancybox
					$thumbOutput .= $lightbox_start . $lightbox_end;
					// Start - Main Link
					$thumbOutput .= $mainLink_start;
				}
				
				$thumbOutput .= "\n\t\t" . '<figure class="image-block">';
					$thumbOutput .= '<div class="image-block-container">';
					
						if ( ($style == 'default' && $img_link == '') || $style == 'style_1' || $style == 'style_2' ){	
							$thumbOutput .= $imgOutput;
						} elseif ( $style == 'default' && $img_link == 'post' ){				
							$thumbOutput .= $mainLink_start . $imgOutput . $mainLink_end;
						} else {			
							$thumbOutput .= $lightbox_start . $imgOutput . $lightbox_end;
						}					
						
					$thumbOutput .= '</div>';
				$thumbOutput .= '</figure>';
				
				// Add content after featured image				
				if ( $style == 'style_1' || $style == 'style_2' ) {
					$thumbOutput .= $contentOutput;
					$thumbOutput .= $mainLink_end; // End - Main Link
				} else {
					$thumbOutput .= $contentOutput;
				}	
			} 
			/* Image output End - if (has_post_thumbnail() */
			
			if ( $single_settings ) {
				$_item_css = get_post_meta(get_the_id(), '_item_css', true);
			}
			$col_css = $_item_css ? $_item_css . ' ' : $col_class;
			
			if ( $slider == 'true' ) {
				$output .= '<div class="swiper-slide">';	
					$output .= '<div class="swiper-slide-container">';	
			}
						
			$output .= "\n\t" . '<article data-order="'.$order.'" id="post-' . get_the_ID() . '" class="' . $col_css . 'qodx-portofolio-item portfolio-block' . $style_class . $grid_spaces . $isotope_css;
			$output .= ' ' . implode(' ', $terms_slug) . '">';
				$output .= '<div class="portfolio-block-container">';	
					if (has_post_thumbnail()) {									
						$output .= $thumbOutput;   // display portfolio with featured image + content	
					} else {
						$output .= $contentOutput; // display portfolio content only	
					}
				$output .= '</div>'; // End div - "portfolio-block-container"				
			$output .= '</article>'; // End portfolio article
			
			if ($slider == 'true') {
					$output .= '</div>'; // End "swiper-slide-container"
				$output .= '</div>'; // End "swiper-slide"
			}
			
		} // End "while"
		
		/* Portfolio section ending */				
			if ($slider == 'true') {
					$output .= '</div>'; // End "swiper-wrapper"
					
					// Build Pagination
					if ($slider_pag == "true") {
						$pag_lowest = $pag_lowest ? ' pag-lowest' : '';
						$output .= '<div class="swiper-pagination' . $pag_lowest . '"></div>';
					}
					
					// Build Navigation
					if ($slider_nav == "true") {
						$output .= '<div class="swiper-button-prev">
										<i class="fa fa-angle-left"></i>
									</div>
									<div class="swiper-button-next">
										<i class="fa fa-angle-right"></i>
									</div>';
					}
					
				$output .= '</div>'; // End "qodx-swiper-slider"				
			}
		
		$output .= '</section>'; // End portfolio section		
		
		if ($sortable == "true") {
			$output .= '</div>'; // End filter section wrapper
		}
				
		if ($pagination == "true" && $sortable == "false" && $slider == "false") {
			ob_start();
			QODX_VCSC_PortfolioPageNavi('', '', $qodx_query, $paged, $pagination_align);
			$output .= ob_get_clean();
		}
				
		wp_reset_postdata();
		$wp_filter['the_content'] = $the_content_filter_backup; 
		
		return $output;
		
	}
	
}

/*
Register Qodux shortcode within Visual Composer interface.
*/

if (function_exists('vc_map')) {

	$add_qodx_sc_func             = new QODX_VCSC_SHORTCODE;	
	$add_qodx_extra_id            = $add_qodx_sc_func->getWTExtraId();
	$add_qodx_extra_class         = $add_qodx_sc_func->getWTExtraClass();
	
	vc_map( array(
		'name' => esc_html__( 'Portfolio', 'qodux_fw' ),
		'base' => 'qodx_portfolio',
		'icon' => 'qodx-icon-portfolio fa fa-folder-open',
		'class' => 'qodx_vc_sc_portfolio',
		'category' => esc_html__( 'by Qodux', 'qodux_fw' ),
		'description' => esc_html__( 'Recent portfolio posts', 'qodux_fw' ),
		'params' => array(
			array(
				'type'			=> 'dropdown',
				'class'			=> '',
				'heading'		=> esc_html__( 'Columns', 'qodux_fw' ),
				'param_name'	=> 'columns',
				'admin_label'	=> true,
				'value' 		=> array(
					//esc_html__( 'One', 'qodux_fw' )		=> '1',
					esc_html__( 'Two', 'qodux_fw' )		=> '2',
					esc_html__( 'Three', 'qodux_fw' )	    => '3',
					esc_html__( 'Four', 'qodux_fw' )	    => '4',
					esc_html__( 'Five', 'qodux_fw' )	    => '5',
					esc_html__( 'Six', 'qodux_fw' )	    => '6',
				),
				'std'	        => '4',
				'description'	=> esc_html__( 'How many columns? Only \'1, 2, 3, 4, 6\' are accepted.', 'qodux_fw' ),
			),
			array(
				'type'          => 'textfield',
				'heading'       => esc_html__( 'Max (posts number)', 'qodux_fw' ),
				'param_name'    => 'max',
				'value'         => '-1',
				'description'   => esc_html__( 'How many items do you wish to show? Set -1 to display all.', 'qodux_fw' )
			),
			array(
				'type'          => 'dropdown',
				'heading'       => esc_html__( 'Portfolio Styles', 'qodux_fw' ),
				'param_name'    => 'style',
				'value' => array( 
					esc_html__( 'Default', 'qodux_fw' )    => 'default',
					esc_html__( 'Style #1', 'qodux_fw' )   => 'style_1',
					esc_html__( 'Style #2', 'qodux_fw' )   => 'style_2',
					esc_html__( 'Style #3', 'qodux_fw' )   => 'style_3',
				),
				'description'   => esc_html__( 'Select portfolio styles.', 'qodux_fw' )
			),
			array(
				'type'          => 'dropdown',
				'heading'       => esc_html__( 'Link featured image', 'qodux_fw' ),
				'param_name'    => 'img_link',
				'value' => array( 
					esc_html__( 'No link', 'qodux_fw' )     => '',
					esc_html__( 'Large image', 'qodux_fw' ) => 'fancybox',
					esc_html__( 'Post', 'qodux_fw' )        => 'post',
				),
				'param_holder_class' => 'border_box qodx_dependency',
				'dependency'	     => Array(
					'element'	     => 'style',
					'value'		     => 'default'
				),
				'description'   => esc_html__( 'If selected, the featured image will be linked to the portfolio item post.', 'qodux_fw' )
			),			
			array(
				'type'			=> 'textfield',
				'heading'		=> esc_html__( 'Featured image width', 'qodux_fw' ),
				'param_name'	=> 'img_width',
				'value'			=> '9999',
				'description'	=> esc_html__( 'Enter the width in pixels.', 'qodux_fw' ),
			),
			array(
				'type'			=> 'textfield',
				'heading'		=> esc_html__( 'Featured image height', 'qodux_fw' ),
				'param_name'	=> 'img_height',
				'value'			=> '9999',
				"description"	=> esc_html__( 'Enter the height in pixels. Set to "9999" to disable vertical cropping and keep image proportions.', 'qodux_fw' ),
			),
			array(
				'type'			=> 'checkbox',
				'heading'		=> esc_html__( 'Keep single portfolio settings?', 'qodux_fw' ),
				'param_name'	=> 'single_settings',
				'value'			=> Array( esc_html__( 'Yes please.', 'qodux_fw' ) => 'yes' ),
				'description'   => esc_html__( 'Check this option to override above featured image sizes, and also to enable custom css class, with the optional ones specified for every single portfolio item. Useful for masonry portfolio shortcode.', 'qodux_fw' ),
			),
			array(
				'type'          => 'dropdown',
				'heading'       => esc_html__( 'Portfolio Grid Spaces', 'qodux_fw' ),
				'param_name'    => 'grid_spaces',
				'value' => array( 
					esc_html__( 'No', 'qodux_fw' )    => 'false',
					esc_html__( 'Yes', 'qodux_fw' )   => 'true',
				),
				'description'   => esc_html__( 'If selected, portfolio articles will have spaces around.', 'qodux_fw' )
			),
			array(
				'type'          => 'dropdown',
				'heading'       => esc_html__( 'Title', 'qodux_fw' ),
				'param_name'    => 'title',
				'value' => array( 
					esc_html__( 'Yes', 'qodux_fw' )   => 'true',
					esc_html__( 'No', 'qodux_fw' )    => 'false',
				),
				'std'           => 'false',
				'description'   => esc_html__( 'Display post title?', 'qodux_fw' )
			),
			array(
				'type'               => 'dropdown',
				'heading'            => esc_html__( 'Title linkable', 'qodux_fw' ),
				'param_name'         => 'title_linkable',
				'value'              => array( 
					esc_html__( 'Yes', 'qodux_fw' )   => 'true',
					esc_html__( 'No', 'qodux_fw' )    => 'false',
				),
				'std'           => 'false',
				'param_holder_class' => 'border_box qodx_dependency',
				'dependency'	     => Array(
					'element'	=> 'title',
					'value'		=> 'true'
				),
				'description'   => esc_html__( 'Link on title?', 'qodux_fw' )
			),
			array(
				'type'          => 'dropdown',
				'heading'       => esc_html__( 'Excerpt (post content)', 'qodux_fw' ),
				'param_name'    => 'excerpt',
				'value' => array( 
					esc_html__( 'Yes', 'qodux_fw' )   => 'true',
					esc_html__( 'No', 'qodux_fw' )    => 'false',
				),
				'std'           => 'false',
				'description'   => esc_html__( 'Display post excerpt / content?', 'qodux_fw' )
			),
			array(
				'type'               => 'textfield',
				'heading'            => esc_html__( 'Excerpt (post content) length', 'qodux_fw' ),
				'param_name'         => 'excerpt_length',
				'value'              => '15',
				'param_holder_class' => 'border_box qodx_dependency',
				'dependency'	     => Array(
					'element'	=> 'excerpt',
					'value'		=> 'true'
				),
				'description'        => esc_html__( 'Enter a custom excerpt length. Will trim the excerpt by this number of words.', 'qodux_fw' )
			),
			array(
				'type'               => 'dropdown',
				'heading'            => esc_html__( 'Display full post?', 'qodux_fw' ),
				'param_name'         => 'full',
				'value'              => array( 
					esc_html__( 'No', 'qodux_fw' )    => 'false',
					esc_html__( 'Yes', 'qodux_fw' )   => 'true',
				),
				'param_holder_class' => 'border_box qodx_dependency',
				'dependency'	     => Array(
					'element'	=> 'excerpt',
					'value'		=> 'true'
				),
				'description'        => esc_html__( 'Display all posts content instead of the auto excerpt. Excerpt option above should be \'YES\'.', 'qodux_fw' )
			),
			array(
				'type'          => 'dropdown',
				'heading'       => esc_html__( 'Category', 'qodux_fw' ),
				'param_name'    => 'category',
				'value' => array( 
					esc_html__( 'Yes', 'qodux_fw' )   => 'true',
					esc_html__( 'No', 'qodux_fw' )    => 'false',
				),
				'std'           => 'false',
				'description'   => esc_html__( 'Display portfolio post category.', 'qodux_fw' )
			),	
			array(
				'type'			=> 'dropdown',
				'class'			=> '',
				'heading'		=> esc_html__( 'Read More', 'qodux_fw' ),
				'param_name'	=> 'read_more',
				'value'			=> array(
					esc_html__( 'Yes', 'qodux_fw' )   => 'true',
					esc_html__( 'No', 'qodux_fw' )	=> 'false',
				),
				'std'           => 'false',
				'description'	=> esc_html__( 'Display post readmore button after excerpt?', 'qodux_fw' ),
			),
			array(
				'type'			     => 'textfield',
				'class'			     => '',
				'heading'		     => esc_html__( 'Read More Text', 'qodux_fw' ),
				'param_name'	     => 'read_more_text',
				'value'			     => esc_html__( 'Read more', 'qodux_fw' ),
				'description'	     => esc_html__( 'Enter your custom text for the read more button.', 'qodux_fw' ),
				'param_holder_class' => 'border_box qodx_dependency',
				'dependency'	     => Array(
					'element'	=> 'read_more',
					'value'		=> 'true'
				),
			),
			array(
				'type'          => 'dropdown',
				'heading'       => esc_html__( 'Group', 'qodux_fw' ),
				'param_name'    => 'group',
				'value' => array( 
					esc_html__( 'Yes', 'qodux_fw' )   => 'true',
					esc_html__( 'No', 'qodux_fw' )    => 'false',
				),
				'description'   => esc_html__( 'Portfolio item tuhmbnails (featured images) will be grouped in the lightbox.', 'qodux_fw' )
			),			
			array(
				'type'          => 'qodx_multidropdown',
				'heading'       => esc_html__( 'Display specific portfolio items (optional)', 'qodux_fw' ),
				'param_name'    => 'ids',
				'value'         => '',
				'target'        => 'portfolio',
				'description'   => esc_html__( 'Display only specific / selected portfolio items.', 'qodux_fw' ) .'<b>' . esc_html__( 'Hold the \'Ctrl\' or \'Shift\' keys while clicking to select multiple items', 'qodux_fw' ).'</b>.'
			),
			array(
				'type'          => 'qodx_multidropdown',
				'heading'       => esc_html__( 'Display from category (optional)', 'qodux_fw' ),
				'param_name'    => 'cat',
				'value'         => '',
				'target'        => 'portfolio_category',
				'description'   => esc_html__( 'Display portfolio items from selected categories.', 'qodux_fw' ) .'<b>' . esc_html__( 'Hold the \'Ctrl\' or \'Shift\' keys while clicking to select multiple items', 'qodux_fw' ).'</b>.'
			),	
			array(
				'type'          => 'qodx_multidropdown',
				'heading'       => esc_html__( 'Exclude selected categories (optional)', 'qodux_fw' ),
				'param_name'    => 'cat__not',
				'value'         => '',
				'target'        => 'portfolio_category',
				'description'   => esc_html__( 'Display portfolio items and exclude selected categories.', 'qodux_fw' ) .'<b>' . esc_html__( 'Hold the \'Ctrl\' or \'Shift\' keys while clicking to select multiple items', 'qodux_fw' ).'</b>.'
			),		
			array(
				'type'			=> 'dropdown',
				'class'			=> '',
				'heading'		=> esc_html__( 'Order', 'qodux_fw' ),
				'param_name'	=> 'order',
				'description'	=> sprintf( esc_html__( 'Designates the ascending or descending order. More at %s.', 'qodux_fw' ), '<a href="http://codex.wordpress.org/Class_Reference/WP_Query#Order_.26_Orderby_Parameters" target="_blank">WordPress codex</a>' ),
				'value'			=> array(
					 esc_html__( 'DESC', 'qodux_fw' )	=> 'DESC',
					 esc_html__( 'ASC', 'qodux_fw' )	=> 'ASC',
				),
			),
			array(
				'type'			=> 'dropdown',
				'class'			=> '',
				'heading'		=> esc_html__( 'Order By', 'qodux_fw' ),
				'param_name'	=> 'orderby',
				'description'	=> sprintf( esc_html__( 'Select how to sort retrieved posts. More at %s.', 'qodux_fw' ), '<a href="http://codex.wordpress.org/Class_Reference/WP_Query#Order_.26_Orderby_Parameters" target="_blank">WordPress codex</a>' ),
				'value'			=> array(					
					esc_html__( 'None', 'qodux_fw' )			=> 'none',
					esc_html__( 'Id', 'qodux_fw' )			    => 'ID',
					esc_html__( 'Author', 'qodux_fw' )			=> 'author',
					esc_html__( 'Title', 'qodux_fw' )		    => 'title',
					esc_html__( 'Date', 'qodux_fw' )			=> 'date',
					esc_html__( 'Modified', 'qodux_fw' )		=> 'modified',
					esc_html__( 'Parent', 'qodux_fw' )			=> 'parent',
					esc_html__( 'Random', 'qodux_fw' )			=> 'rand',
					esc_html__( 'Comment Count', 'qodux_fw' )	=> 'comment_count',
					esc_html__( 'Menu Order', 'qodux_fw' )	    => 'menu_order',
				),
				'std'	        => 'date',
			),
			
			array(
				'type'          => 'dropdown',
				'heading'       => esc_html__( 'Pagination', 'qodux_fw' ),
				'param_name'    => 'pagination',
				'value' => array( 
					esc_html__( 'No', 'qodux_fw' )    => 'false',
					esc_html__( 'Yes', 'qodux_fw' )   => 'true',
				),
				'description'   => esc_html__( 'Display pagination.', 'qodux_fw' )
			),		
			array(
				'type'          => 'dropdown',
				'heading'       => esc_html__( 'Pagination alignment', 'qodux_fw' ),
				'param_name'    => 'pagination_align',
				'value'         => array( esc_html__( 'Align left', 'qodux_fw' ) => 'left', esc_html__( 'Align right', 'qodux_fw' ) => 'right', esc_html__( 'Align center', 'qodux_fw' ) => 'center'),
				'std'           => 'center',
				'param_holder_class' => 'border_box qodx_dependency',
				'dependency'	     => Array(
					'element'	     => 'pagination',
					'value'		     => 'true'
				),
				'description'   => esc_html__( 'Aligns pagination links to left / center / right.', 'qodux_fw' )
			),
			array(
				'type'          => 'dropdown',
				'heading'       => esc_html__( 'Sortable', 'qodux_fw' ),
				'param_name'    => 'sortable',
				'value'         => array( 
					esc_html__( 'No', 'qodux_fw' )    => 'false',
					esc_html__( 'Yes', 'qodux_fw' )   => 'true',
				),
				'description'   => esc_html__( 'Display sortable portfolio. Posts will be sorted and grouped by category. This will disable "Pagination" above option.', 'qodux_fw' )
			),
			array(
				'type'          => 'dropdown',
				'heading'       => esc_html__( 'Filter', 'qodux_fw' ),
				'param_name'    => 'filter',
				'value'         => array( 
					esc_html__( 'Filter links', 'qodux_fw' )   => 'filter_links', 
					esc_html__( 'Filter options', 'qodux_fw' ) => 'filter_options'
				),
				'param_holder_class' => 'border_box qodx_dependency',
				'dependency'	     => Array(
					'element'	     => 'sortable',
					'value'		     => 'true'
				),
				'description'   => esc_html__( 'Select portfolio filter method (simple links or select field options)', 'qodux_fw' )
			),
			array(
				'type'			=> 'checkbox',
				'heading'		=> esc_html__( 'Keep simple isotope grid?', 'qodux_fw' ),
				'param_name'	=> 'isotope_grid',
				'value'			=> Array( esc_html__( 'Yes please.', 'qodux_fw' ) => 'yes' ),
				'description'   => esc_html__( 'Check this option to enable simple isotope grid without filter options/links if pagination, sortable or slider options are disabled.', 'qodux_fw' ),
			),
			
			array(
				'type'          => 'dropdown',
				'heading'       => esc_html__( 'Enable', 'qodux_fw' ),
				'param_name'    => 'slider',
				'value'         => array( 
					esc_html__( 'No', 'qodux_fw' )    => 'false',
					esc_html__( 'Yes', 'qodux_fw' )   => 'true',
				),
				'description'   => esc_html__( 'Enables slider for displaying team members.', 'qodux_fw' ),
				'group' => esc_html__( 'Slider', 'qodux_fw' )
			),
			
			// Slider Settings			
			array(
				'type'		  => 'qodx_separator',
				'heading'	  => '',
				"param_name"  => 'separator',
				'value'	      => '',
				'separator'	  => 'Slider Settings',
				'dependency'	     => Array(
					'element'	     => 'slider',
					'value'		     => 'true'
				),
				'description' => esc_html__( 'Below you can edit default slider settings.', 'qodux_fw' ),
				'group' => esc_html__( 'Slider', 'qodux_fw' )
			),			
			array(
				'type'               => 'textfield',
				'heading'            => esc_html__( 'Autoplay', 'qodux_fw' ),
				'param_name'         => 'auto_slide',
				'value'              => '5000',
				'dependency'	     => Array(
					'element'	     => 'slider',
					'value'		     => 'true'
				),
				'description'   => esc_html__( 'Enables autoplay and define the time interval (in miliseconds - Ex: 3000, 4000, 5000 etc) between transitions. Set it "0" to disable autoplay.', 'qodux_fw' ),
				'group' => esc_html__( 'Slider', 'qodux_fw' )
			),
			array(
				'type'               => 'dropdown',
				'heading'            => esc_html__( 'Direction', 'qodux_fw' ),
				'param_name'         => 'direction',
				'value' 			 => array( 
					esc_html__( 'Horizontal', 'qodux_fw' ) => 'horizontal',
					esc_html__( 'Vertical', 'qodux_fw' )   => 'vertical',
				),
				'dependency'	     => Array(
					'element'	     => 'slider',
					'value'		     => 'true'
				),
				'description'   => esc_html__( 'Define slider direction ( horizontal / vertical ).', 'qodux_fw' ),
				'group' => esc_html__( 'Slider', 'qodux_fw' )
			),
			array(
				'type'               => 'dropdown',
				'heading'            => esc_html__( 'Equal height for horizontal sliders?', 'qodux_fw' ),
				'param_name'         => 'equal_height',
				'value' 			 => array( 
					esc_html__( 'Yes', 'qodux_fw' )   => 'true',
					esc_html__( 'No', 'qodux_fw' )    => 'false',
				),
				'param_holder_class' => 'border_box qodx_dependency',
				'dependency'	     => Array(
					'element'	     => 'slider',
					'value'		     => 'true'
				),
				'description'   => esc_html__( 'Set equal height for horizontal sliders. Slider will have the highest slide item size.', 'qodux_fw' ),
				'group' => esc_html__( 'Slider', 'qodux_fw' )
			),
			array(
				'type'               => 'dropdown',
				'heading'            => esc_html__( 'Effect', 'qodux_fw' ),
				'param_name'         => 'effect',
				'value' 			 => array( 
					esc_html__( 'Slide', 'qodux_fw' )     => 'slide',
					esc_html__( 'Fade', 'qodux_fw' )      => 'fade',
					esc_html__( 'Coverflow', 'qodux_fw' ) => 'coverflow',
				),
				'dependency'	     => Array(
					'element'	     => 'slider',
					'value'		     => 'true'
				),
				'description'   => esc_html__( 'Define slider animation effect.', 'qodux_fw' ),
				'group' => esc_html__( 'Slider', 'qodux_fw' )
			),
			array(
				'type'               => 'qodx_range',
				'heading'            => esc_html__( 'Items visible on Small Desktop', 'qodux_fw' ),
				'param_name'         => 'slide_items_md',
				'value'              => 2,
				'min'                => 1,
				'max'                => 4,
				'step'               => 1,
				'dependency'	     => Array(
					'element'	     => 'slider',
					'value'		     => 'true'
				),
				'description'        => esc_html__( 'Define maximum amount of items to be visible on small desktops.', 'qodux_fw' ),
				'group' => esc_html__( 'Slider', 'qodux_fw' )
			),
			array(
				'type'               => 'qodx_range',
				'heading'            => esc_html__( 'Items visible on Tablet', 'qodux_fw' ),
				'param_name'         => 'slide_items_sm',
				'value'              => 2,
				'min'                => 1,
				'max'                => 4,
				'step'               => 1,
				'dependency'	     => Array(
					'element'	     => 'slider',
					'value'		     => 'true'
				),
				'description'        => esc_html__( 'Define maximum amount of items to be visible on tablets.', 'qodux_fw' ),
				'group' => esc_html__( 'Slider', 'qodux_fw' )
			),
			array(
				'type'               => 'qodx_range',
				'heading'            => esc_html__( 'Items visible on Mobile', 'qodux_fw' ),
				'param_name'         => 'slide_items_xs',
				'value'              => 1,
				'min'                => 1,
				'max'                => 3,
				'step'               => 1,
				'dependency'	     => Array(
					'element'	     => 'slider',
					'value'		     => 'true'
				),
				'description'        => esc_html__( 'Define maximum amount of items to be visible on mobiles.', 'qodux_fw' ),
				'group' => esc_html__( 'Slider', 'qodux_fw' )
			),
			array(
				'type'               => 'dropdown',
				'heading'            => esc_html__( 'Centered Slides', 'qodux_fw' ),
				'param_name'         => 'centered_slides',
				'value' 			 => array( 
					esc_html__( 'No', 'qodux_fw' )    => 'false',
					esc_html__( 'Yes', 'qodux_fw' )   => 'true',
				),
				'dependency'	     => Array(
					'element'	     => 'slider',
					'value'		     => 'true'
				),
				'description'   => esc_html__( 'If true, then active slide will be centered, not always on the left side.', 'qodux_fw' ),
				'group' => esc_html__( 'Slider', 'qodux_fw' )
			),	
			array(
				'type'               => 'dropdown',
				'heading'            => esc_html__( 'Grab Cursor', 'qodux_fw' ),
				'param_name'         => 'grab_cursor',
				'value' 			 => array( 
					esc_html__( 'Yes', 'qodux_fw' )   => 'true',
					esc_html__( 'No', 'qodux_fw' )    => 'false',
				),
				'dependency'	     => Array(
					'element'	     => 'slider',
					'value'		     => 'true'
				),
				'description'   => esc_html__( 'This option may a little improve desktop usability. If true, user will see the "grab" cursor when hover on Swiper.', 'qodux_fw' ),
				'group' => esc_html__( 'Slider', 'qodux_fw' )
			),	
			array(
				'type'               => 'dropdown',
				'heading'            => esc_html__( 'Simulate Touch', 'qodux_fw' ),
				'param_name'         => 'simulate_touch',
				'value' 			 => array( 
					esc_html__( 'Yes', 'qodux_fw' )   => 'true',
					esc_html__( 'No', 'qodux_fw' )    => 'false',
				),
				'dependency'	     => Array(
					'element'	     => 'slider',
					'value'		     => 'true'
				),
				'description'   => esc_html__( 'If true, Swiper will accept mouse events like touch events (click and drag to change slides).', 'qodux_fw' ),
				'group' => esc_html__( 'Slider', 'qodux_fw' )
			),	
			array(
				'type'               => 'dropdown',
				'heading'            => esc_html__( 'Slider Pagination', 'qodux_fw' ),
				'param_name'         => 'slider_pag',
				'value' 			 => array( 
					esc_html__( 'No', 'qodux_fw' )    => 'false',
					esc_html__( 'Yes', 'qodux_fw' )   => 'true',
				),
				'dependency'	     => Array(
					'element'	     => 'slider',
					'value'		     => 'true'
				),
				'description'   => esc_html__( 'Enables slider pagination.', 'qodux_fw' ),
				'group' => esc_html__( 'Slider', 'qodux_fw' )
			),	
			array(
				'type'			     => 'checkbox',
				'heading'		     => esc_html__( 'Slider Pagination Lowest?', 'qodux_fw' ),
				'param_name'	     => 'pag_lowest',
				'value'			     => Array( esc_html__( 'Yes please.', 'qodux_fw' ) => 'yes' ),
				'description'        => esc_html__( 'Check this option to display pagination in the lowest position.', 'qodux_fw' ),
				'param_holder_class' => 'border_box qodx_dependency',
				'dependency' 	     => array(
					'element' => 'slider_pag',
					'value'   => 'true'
				),
				'group'              => esc_html__( 'Slider', 'qodux_fw' )
			),			
			array(
				'type'               => 'dropdown',
				'heading'            => esc_html__( 'Slider Navigation', 'qodux_fw' ),
				'param_name'         => 'slider_nav',
				'value' 			 => array( 
					esc_html__( 'No', 'qodux_fw' )    => 'false',
					esc_html__( 'Yes', 'qodux_fw' )   => 'true',
				),
				'dependency'	     => Array(
					'element'	     => 'slider',
					'value'		     => 'true'
				),
				'description'   => esc_html__( 'Enables slider navigation ( prev / next buttons ).', 'qodux_fw' ),
				'group' => esc_html__( 'Slider', 'qodux_fw' )
			),
			
			$add_qodx_extra_id,
			$add_qodx_extra_class,
			
			array(
				'type' => 'css_editor',
				'heading' => esc_html__( 'Css', 'qodux_fw' ),
				'param_name' => 'css',
				'group' => esc_html__( 'Design options', 'qodux_fw' )
			)
		)
	));
	
}