<?php

if (!defined('ABSPATH')) exit;

// Check for Visual Composer
// -------------------------
if (!defined('__VC_EXTENSIONS__')){
	define('__VC_EXTENSIONS__', QODX_FW_DIR);
}


// Main Class for Visual Composer Extensions
// -----------------------------------------

if (!class_exists('QODX_VC_EXTENSIONS')) {
	
	// Create Plugin Class
	// -------------------
	class QODX_VC_EXTENSIONS {
		
		public $QODX_VCSC_Elements = array(
			"WT Blog"				                => array("setting" => "Blog",                     "file" => "blog",     	       "type" => "internal",		"active" => "true"),
			"WT Contact Form"					    => array("setting" => "ContactForm",              "file" => "contact_form",        "type" => "internal",		"active" => "true"),
			"WT Swipe Slider"					    => array("setting" => "SwipeSlider",              "file" => "swipe_slider",        "type" => "internal",		"active" => "true"),
			"WT Bx Rotator"					        => array("setting" => "BxRotator",                "file" => "bx_rotator",     	   "type" => "internal",		"active" => "true"),
			"WT Clients"					        => array("setting" => "Clients",                  "file" => "clients",             "type" => "internal",		"active" => "true"),
			"WT Testimonial"					    => array("setting" => "Testimonial",              "file" => "testimonial",     	   "type" => "internal",		"active" => "true"),
			"WT Testimonials Slider"				=> array("setting" => "TestimonialsSlider",       "file" => "testimonials_slider", "type" => "internal",		"active" => "true"),
			"WT Service Box"					    => array("setting" => "ServiceBox",               "file" => "service_box",         "type" => "internal",		"active" => "true"),
			"WT Services"					        => array("setting" => "Services",                 "file" => "services",            "type" => "internal",		"active" => "true"),
			"WT Services Slider"					=> array("setting" => "ServicesSlider",           "file" => "services_slider",     "type" => "internal",		"active" => "true"),
			"WT Counter"					        => array("setting" => "Counter",                  "file" => "counter",     	       "type" => "internal",		"active" => "true"),
			"WT Pie Chart"					        => array("setting" => "PieChart",                 "file" => "pie_chart",           "type" => "internal",		"active" => "true"),
			"WT Timeline"					        => array("setting" => "Timeline",                 "file" => "timeline",            "type" => "internal",		"active" => "true"),
			"WT Social Networks"					=> array("setting" => "SocialNetworks",           "file" => "social_networks",     "type" => "internal",		"active" => "true"),
			"WT Twitter"					        => array("setting" => "Twitter",                  "file" => "twitter",     	        "type" => "internal",		"active" => "true"),
			"WT Tag"					            => array("setting" => "Tag",                      "file" => "tag",     	           "type" => "internal",		"active" => "true"),
			"WT Spacer"					            => array("setting" => "Spacer",                   "file" => "spacer",              "type" => "internal",		"active" => "true"),
			"WT Pricing Table"					    => array("setting" => "PricingTable",             "file" => "pricing_table",       "type" => "internal",		"active" => "true"),
			"WT Custom Heading"					    => array("setting" => "CustomHeading",            "file" => "custom_heading",      "type" => "internal",		"active" => "true"),
			"WT Section Headings"				    => array("setting" => "SectionHeadings",          "file" => "section_headings",    "type" => "internal",		"active" => "true"),
			"WT Galler Grid"				        => array("setting" => "GalleryGrid",              "file" => "gallery_grid",        "type" => "internal",		"active" => "true"),
			"WT Google Map"				            => array("setting" => "GoogleMap",                "file" => "gmap",                "type" => "internal",		"active" => "true"),
			
			// External Plugins
			"WT Portfolio"				            => array("setting" => "Portfolio",                "file" => "portfolio",           "type" => "external",		"active" => "false"),
			"WT Team"				                => array("setting" => "Team",                     "file" => "team",                "type" => "external",		"active" => "false"),
		);
		
		function __construct() {
			
			// Get default theme options for Qodux Framework Plugin
			if ( get_option('qodx_fw_options') !== false ) {
				$fw_options = get_option('qodx_fw_options');
			}
			
			// Adding Qodux classes to standard VC shortcodes
			// --------------------------------------------
			add_filter('vc_shortcodes_css_class',       array($this, 'QODX_VCSC_Extensions_Css_Classes'), 10, 2);			
			
			// Load External Files on Back-End
			// -------------------------------------------
			add_action('admin_enqueue_scripts', 		array($this, 	'QODX_VCSC_Extensions_Admin'));
			
			// Load External Files on Front-End
			// --------------------------------------------
			add_action('wp_enqueue_scripts', 			array($this, 	'QODX_VCSC_Extensions_Front'), 		999999999999999999999999999);
										
			// Load Composer Elements ( Maps + Shortcodes Output )
			// --------------------------------------------
			foreach ($this->QODX_VCSC_Elements as $ElementName => $element) {
					
					// Set custom plugin shortcodes active state true, depending on theme options
					if( get_option('qodx_fw_options') !== false ){						
						if( 'portfolio' == $element['file'] && '1' == $fw_options['portfolio_post_type'] ){
							$element['active'] = 'true';
						}
						if( 'team' == $element['file'] && '1' == $fw_options['team_post_type'] ){
							$element['active'] = 'true';
						}
					}
				
					if ($element['active'] == "true") {
						if ($element['type'] == 'internal') {
							//require_once($this->shortcode_dir.'/qodx_vcsc_' . $element['file'] . '.php');
							require_once(QODX_FW_DIR . 'shortcodes/elements/qodx_vcsc_' . $element['file'] . '.php');
						} else if ($element['type'] == 'external') {
							// Initialize external plugins
							require_once(QODX_FW_DIR . 'shortcodes/plugins/qodx_vcsc_' . $element['file'] . '.php');
						}
					}
				}
																			
			// Load Extended Composer Elements
			// --------------------------------------------
			add_action('init', 							array($this, 'QODX_VCSC_RegisterWithComposer'), 999999999);
			
			// Load Helper Functions
			// --------------------------------------------
			add_action('init', 							array($this, 'QODX_VCSC_HelperFunctions'));
			
		}
				
		// ! Generate param type "qodx_separator"
		// --------------------------------------------		
		function qodx_separator_settings_field($settings, $value) {
			$dependency = function_exists('vc_generate_dependencies_attributes') ? vc_generate_dependencies_attributes($settings) : '';
			$param_name  = isset($settings['param_name']) ? $settings['param_name'] : '';
			$type        = isset($settings['type']) ? $settings['type'].'_field' : '';
            $separator	 = isset($settings['separator']) ? $settings['separator'] : '';	
			
			$output      = '';			
			$output .= '<div class="wpb_vc_param_value ' . $param_name . ' ' . $type . '" name="' . $param_name . '" style="border-bottom: 2px solid #DEDEDE; margin-bottom: 10px; margin-top: 10px; padding-bottom: 10px; font-size: 18px; color: #BEBEBE;" ' . $dependency . '>' . $separator . '</div>';
			return $output;
		}
		
		// ! Generate param type "qodx_multiselect"
		// --------------------------------------------	
		function qodx_multiselect_settings_field($settings, $value){
			$param_name   = isset($settings['param_name']) ? $settings['param_name'] : '';
			$param_option = isset($settings['options']) ? $settings['options'] : '';
			
			$output = '';			
			$output .= '<input type="hidden" name="' . $param_name . '" id="' . $param_name . '" class="wpb_vc_param_value ' . $param_name . '" value="' . $value . '"/>';
			
			$output .= '<select multiple id="' . $param_name . '_select2" name="' . $param_name . '_select2" class="multi-select">';
			if ($param_option != '' && is_array($param_option)) {
				foreach ($param_option as $text_val => $val) {
					if (is_numeric($text_val) && (is_string($val) || is_numeric($val))) {
						$text_val = $val;
					}
					$output .= '<option id="' . $val . '" value="' . $val . '">' . htmlspecialchars($text_val) . '</option>';
				}
			}
			$output .= '</select>';
						
			$output .= '<script type="text/javascript">
						jQuery(document).ready(function($){
		
							$("#' . $param_name . '_select2").selectize();
							
							/*
							var order = $("#' . $param_name . '").val();
							if (order != "") {
								order = order.split(",");
								var choices = [];
								for (var i = 0; i < order.length; i++) {
									var option = $("#' . $param_name . '_select2 option[value="+ order[i]  + "]");
									if (option.length > 0) {
										choices[i] = {id:order[i], text:option[0].label, element: option};
									}
								}
								$("#' . $param_name . '_select2").select2("data", choices);
							}
		
							$("#' . $param_name . '_select2").on("select2-selecting", function(e) {
								var ids = $("#' . $param_name . '").val();
								if (ids != "") {
									ids +=",";
								}
								ids += e.val;
								$("#' . $param_name . '").val(ids);
								console.log($("#' . $param_name . '_select2").select2("data"));
							}).on("select2-removed", function(e) {
								  var ids = $("#' . $param_name . '").val();
								  var arr_ids = ids.split(",");
								  var newIds = "";
								  for(var i = 0 ; i < arr_ids.length; i++) {
									if (arr_ids[i] != e.val){
										if (newIds != "") {
											newIds +=",";
										}
										newIds += arr_ids[i];
									}
								  }
								  $("#' . $param_name . '").val(newIds);
							 });
							 */
						});
						</script>';
						
			return $output;
		}
				 
		// ! Generate param type "qodx_multidropdown"
		// --------------------------------------------				 
		function qodx_multidropdown_settings_field($settings, $value) {
			$css_option   = vc_get_dropdown_option($settings, $value);
			$dependency = function_exists('vc_generate_dependencies_attributes') ? vc_generate_dependencies_attributes($settings) : '';	
			$param_name   = isset($settings['param_name']) ? $settings['param_name'] : '';
			$type         = isset($settings['type']) ? $settings['type'].'_dropdown_field' : '';	
			
			$output = '';		
			$output .= '<input type="hidden" name="' . $param_name . '" id="' . $param_name . '" class="wpb_vc_param_value ' . $param_name . '" value="' . $value . '"/>';						
			
			$output .= '<select  id="' . $param_name . '_dropdown" name="'
					   . $param_name . '_dropdown'
					   . '" class="wpb_vc_param_value wpb-input wpb-select '
					   . $param_name . '_dropdown'
					   . ' ' . $type
					   . '" data-option="' . $css_option
					   . '" ' . 'multiple'
					   . ' ' . $dependency . '">';				
			
			$current_value = explode(",", $value);
			
			// if exists $settings['target'] then auto fill the options for multidropdown related to target value
			isset($settings['target']) ? $target = 'true' : $target = 'false';
			
			if ( $target == 'false' ) {
				$values = is_array($settings['value']) ? $settings['value'] : array();
			} else {
				$values = QODX_VCSC_GetSelectTargetOptions($settings['target']);
			}
			
			if ($values != '' && is_array($values)) {
				foreach ( $values as $text_val => $val ) {
					if ( is_numeric($text_val) && (is_string($val) || is_numeric($val)) ) {
						$text_val = $val;
					}				
					$text_val = htmlspecialchars( $text_val );		
					$selected = is_array($current_value) && in_array($val, $current_value) ? ' selected="selected"' : '';
					
					$output .= '<option value="' . $val . '"'.$selected.'>'.$text_val.'</option>';
				}
			}
			$output .= '</select>';
			
			$output .= '<script type="text/javascript">
						jQuery(document).ready(function($){	
							$("#' . $param_name . '_dropdown").change(function() {							
								var values    = $(this).val(),
									strValues = "";
									
								if (values != null) {
									strValues = values.toString();
								}																								
								$("#' . $param_name . '").val(strValues);
								
								//console.log(values);
								//console.log(strValues);
							});
						});
						</script>';
			return $output; 
		}
		
		// ! Generate param type "qodx_range"
		// --------------------------------------------	
		function qodx_range_settings_field($settings, $value) {
			$dependency = function_exists('vc_generate_dependencies_attributes') ? vc_generate_dependencies_attributes($settings) : '';
			$param_name  = isset($settings['param_name']) ? $settings['param_name'] : '';
			$type        = isset($settings['type']) ? $settings['type'].'_field' : '';
			
			$min         = isset($settings['min']) ? $settings['min'] : '';
			$max         = isset($settings['max']) ? $settings['max'] : '';
			$step        = isset($settings['step']) ? $settings['step'] : '';
			$unit        = isset($settings['unit']) ? $settings['unit'] : '';
			
			$unit_margin = $unit != '' ? '20px' : '10px';
			
			$output      = '';			
			$output     .= '<div class="qodx_range_block clearfix">';
			$output 	.= '<input style="width: 60px; float: left; margin-left: 0; margin-right: 5px; text-align: center; padding: 6px;" name="' . $param_name . '"  class="qodx-range-serial nouislider-input-selector nouislider-input-composer wpb_vc_param_value ' . $param_name . ' ' . $type . '" type="text" value="' . $value . '"/>';
			$output     .= '<span style="float: left; margin-right: '.$unit_margin.'; margin-top: 8px;" class="unit">' . $unit . '</span>';
			$output 	.= '<div class="qodx-range-input-element" data-value="' . $value . '" data-min="' . $min . '" data-max="' . $max . '" data-step="' . $step . '" style="width: 200px; float: left; margin-top: 8px;"></div>';
			$output 	.= '</div>';			
			return $output;
		}		
		
		// ! Generate param type "qodx_loadfile"
		// --------------------------------------------	
		function qodx_loadfile_settings_field($settings, $value){
			$dependency = function_exists('vc_generate_dependencies_attributes') ? vc_generate_dependencies_attributes($settings) : '';
			$param_name = isset($settings['param_name']) ? $settings['param_name'] : '';
			$type       = isset($settings['type']) ? $settings['type'].'_field' : '';
			
			$file_path  = isset($settings['file_path']) ? $settings['file_path'] : '';
			//$url        = plugin_dir_url( __FILE__ );
			$url        = QODX_FW_URL . 'shortcodes/assets/';
			
			$output     = '';
			if (!empty($file_path)) {
				$output .= '<script type="text/javascript" src="' . $url.$file_path . '"></script>';
			}
			return $output;
		}
		
		// ! Generate param type "qodx_markers"
		// --------------------------------------------	
		function qodx_markers_settings_field($settings, $value) {
			$dependency = function_exists('vc_generate_dependencies_attributes') ? vc_generate_dependencies_attributes($settings) : '';
			?>
			<script type="text/javascript">
				jQuery(document).ready(function( $ ) {
		
					// recreate from settings - textarea content
					var textarea_val = $('#vc_ui-panel-edit-element .marker_data').html();
					if(textarea_val != '') {
						// check if value is a valid json
						if (/^[\],:{}\s]*$/.test(textarea_val.replace(/\\["\\\/bfnrtu]/g, '@').replace(/"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g, ']').replace(/(?:^|:|,)(?:\s*\[)+/g, ''))) {
							var obj = $.parseJSON(textarea_val);
							// loop trough the object
							Object.keys(obj).forEach(function(key) {
								var obj_data = {
									'm_address'   : obj[key].m_address,
									'm_link'      : obj[key].m_link,
									'm_title'     : obj[key].m_title,
									'm_desc'      : obj[key].m_desc,
									'm_image_id'  : obj[key].m_image_id,
									'm_image_url' : obj[key].m_image_url,
									'm_icon_id'   : obj[key].m_icon_id,
									'm_icon_url'  : obj[key].m_icon_url,
									'm_img_text'  : obj[key].m_img_text
								},
								marker = qodx_marker_item_panel(obj_data);
								$('.qodx_markers_wrapper').append(marker);
							});
						}
					}
				});
			</script>
			<?php
			return  '<div class="qodx_markers_wrapper"></div>'
					.'<a href="#" class="new_marker">Add marker</a>';
		}
				
		// ! Load Composer Elements + Add Custom Parameters
		// --------------------------------------------	
		function QODX_VCSC_RegisterWithComposer() {
			if (function_exists('vc_is_inline')){
				if ((vc_is_inline()) || (is_admin())) {
					$this->QODX_VCSC_AddParametersToComposer();
					$this->QODX_VCSC_AddElementsToComposer();
				} else {
					$this->QODX_VCSC_LoadClassElements();
				}
			} else if (is_admin()) {
				$this->QODX_VCSC_AddParametersToComposer();
				$this->QODX_VCSC_AddElementsToComposer();
			} else {
				$this->QODX_VCSC_LoadClassElements();
			}
		}
		
		// ! Add Extended Custom Parameters
		// --------------------------------------------	
		function QODX_VCSC_AddParametersToComposer() {
			if (function_exists('vc_add_shortcode_param')) {
									
				// Generate param type "qodx_separator"
				vc_add_shortcode_param('qodx_separator',        	array($this, 'qodx_separator_settings_field'));
				
				// Generate param type "qodx_multidropdown"
				vc_add_shortcode_param('qodx_multidropdown',      array($this, 'qodx_multidropdown_settings_field'));
				
				// Generate param type "qodx_multiselect"
				//vc_add_shortcode_param('qodx_multiselect',        array($this, 'qodx_multiselect_settings_field'));
				
				// Generate param type "qodx_range"
				vc_add_shortcode_param('qodx_range',              array($this, 'qodx_range_settings_field'));
								
				// Generate param type "qodx_loadfile"
				vc_add_shortcode_param('qodx_loadfile',           array($this, 'qodx_loadfile_settings_field'));
				
				// Generate param type "qodx_markers"
				vc_add_shortcode_param('qodx_gmap_markers',       array($this, 'qodx_markers_settings_field'));
								
			}
		}
		// ! Load Extended Composer Elements
		// --------------------------------------------
		function QODX_VCSC_AddElementsToComposer() {			
			
			$extend_QODX_VCSC_Rows   = false;
			$extend_QODX_VCSC_Cols   = false;
			$extend_QODX_VCSC_Params = false;
			
			// Load Extended Row Settings
			if ( $extend_QODX_VCSC_Rows ) {
				//require_once($this->shortcode_dir . '/qodx_vcsc_extend_row.php');
				require_once(QODX_FW_DIR . 'shortcodes/elements/qodx_vcsc_extend_row.php');
			}
			// Load Extended Column Settings
			if ( $extend_QODX_VCSC_Cols ) {
				//require_once($this->shortcode_dir . '/qodx_vcsc_extend_column.php');
				require_once(QODX_FW_DIR . 'shortcodes/elements/qodx_vcsc_extend_column.php');
			}
			// Load Extended Params for Specific VC Shortcode
			if ( $extend_QODX_VCSC_Params ) {
				//require_once($this->shortcode_dir . '/qodx_vcsc_extend_params.php');
				require_once(QODX_FW_DIR . 'shortcodes/elements/qodx_vcsc_extend_params.php');
			}
				//require_once(QODX_FW_DIR . 'shortcodes/elements/qodx_vcsc_extend_icon.php');
		}
		
		function QODX_VCSC_LoadClassElements() {			
			// Load Custom Post Types
		}
		
		// ! Load extended plugin Back-End css and javascript files when Editing
		// --------------------------------------------			
		function QODX_VCSC_Extensions_Admin() {
			global $pagenow, $typenow;
			$screen = get_current_screen();
			if (empty($typenow) && !empty($_GET['post'])) {
				$post 		= get_post($_GET['post']);
				$typenow 	= $post->post_type;
			}
			$url = plugin_dir_url( __FILE__ );
			
			if (QODX_VCSC_IsEditPagePost()) {
				wp_enqueue_style( 'qodx-visual-composer-extensions-admin', QODX_FW_URL . 'shortcodes/assets/qodx-visual-composer-extensions-admin.css', null, false, 'all' );
			  
				// If you need any javascript files on back end, here is how you can load them.		
				
				wp_enqueue_style( 'qodx-extend-nouislider',                            QODX_FW_URL . 'shortcodes/assets/lib/css/admin/jquery.nouislider.css',                null, false, 'all' );
				wp_enqueue_script( 'qodx-extend-nouislider',                           QODX_FW_URL . 'shortcodes/assets/lib/js/admin/jquery.nouislider.min.js',             array('jquery'), null, true );	
				
				/* Select2 Plugin
				------------------------------------------- */
				wp_enqueue_script( 'qodx-extend-selectize',                            QODX_FW_URL . 'shortcodes/assets/lib/js/admin/selectize.min.js',    array('jquery'), null, true );
				
				/* Google Map Admin Scripts
				------------------------------------------- */
				wp_enqueue_media();
				
				$qodx_google_maps_api = focus_wp_get_option('api','qodx_google_maps_api');
				if ( !empty( $qodx_google_maps_api ) ) {
                	wp_register_script( 'qodx-extend-gmap-api', 'https://maps.google.com/maps/api/js?key=' . focus_wp_get_option('api','qodx_google_maps_api') );
				} else {
					wp_register_script( 'qodx-extend-gmap-api', 'https://maps.google.com/maps/api/js' );
				}
				
				//wp_register_script( 'qodx-extend-gmap',                                $url . 'assets/lib/js/admin/qodx-gmap-settings.js', array('jquery'), null, true );
				wp_enqueue_script( 'qodx-extend-gmap',                                 QODX_FW_URL . 'shortcodes/assets/lib/js/admin/qodx-gmap-settings.js',         array('jquery'), null, true );
				/* End Google Map Admin Scripts
				------------------------------------------- */
				
				wp_enqueue_style( 'themify',                            QODX_FW_URL . 'shortcodes/assets/lib/css/admin/themify/themify.css',                null, false, 'all' );
			}
		}
		
		// ! Load extended plugin Front-End css and javascript files
		// --------------------------------------------		
		function QODX_VCSC_Extensions_Front() {
			global $post;
			$url = plugin_dir_url( __FILE__ );
			
				wp_deregister_script( 'waypoints' ); // deregister VC old script and replace it with a newer version
				wp_register_script( 'waypoints',                                     QODX_FW_URL . 'shortcodes/assets/lib/js/waypoints/jquery.waypoints.min.js', array('jquery'), null, true );
				
				wp_register_script( 'jquery-sticky',                                 QODX_FW_URL . 'shortcodes/assets/lib/js/waypoints/jquery.sticky.min.js',    array('jquery'), null, true );
								
				wp_enqueue_style( 'theme-fancybox',                                  QODX_FW_URL . 'shortcodes/assets/lib/js/fancybox/jquery.fancybox.min.css',   null, false, 'all' );
	
				wp_register_script( 'fancybox',                                      QODX_FW_URL . 'shortcodes/assets/lib/js/fancybox/jquery.fancybox.pack.js',   array('jquery'), null, true);
				
				wp_register_script( 'fancybox-media',                                QODX_FW_URL . 'shortcodes/assets/lib/js/fancybox/jquery.fancybox-media.min.js',array('jquery','fancybox'), null, true);	
				
				wp_enqueue_style( 'qodx-extend-bx-slider',                             QODX_FW_URL . 'shortcodes/assets/lib/css/jquery.bxslider.css',               null, false, 'all' );

				wp_register_script( 'qodx-extend-bx-slider',                           QODX_FW_URL . 'shortcodes/assets/lib/js/jquery.bxslider.js',                array('jquery'), null, true );					

				wp_register_script( 'qodx-extend-isotope',                             QODX_FW_URL . 'shortcodes/assets/lib/js/isotope/isotope.pkgd.min.js',       array('jquery'), null, true );
				
				wp_register_script( 'qodx-extend-qodx-select',                        QODX_FW_URL . 'shortcodes/assets/lib/js/qodxSelect/qodxSelect.min.js',       array('jquery'), null, true );			
				
				wp_enqueue_style( 'qodx-extend-swiper-slider',                         QODX_FW_URL . 'shortcodes/assets/lib/css/swiper/swiper.min.css',             null, false, 'all' );

				wp_register_script( 'qodx-extend-swiper-slider',                       QODX_FW_URL . 'shortcodes/assets/lib/js/swiper/swiper.min.js',              array('jquery'), null, true );				
				
				wp_register_style( 'qodx-extend-youtube-player',                       QODX_FW_URL . 'shortcodes/assets/lib/css/YTPlayer.css',                        null, false, 'all' );

				wp_register_script( 'qodx-extend-youtube-player',                      QODX_FW_URL . 'shortcodes/assets/lib/js/jquery.mb.YTPlayer.js',               array('jquery'), null, true );
				
				wp_register_script( 'qodx-extend-easypiechart',                        QODX_FW_URL . 'shortcodes/assets/lib/js/jquery.easypiechart.min.js',          array('jquery'), null, true );	
				
				$qodx_google_maps_api = focus_wp_get_option('api','qodx_google_maps_api');
				if ( !empty( $qodx_google_maps_api ) ) {
                	wp_register_script( 'qodx-extend-gmap-api', 'https://maps.google.com/maps/api/js?key=' . focus_wp_get_option('api','qodx_google_maps_api') );
				} else {
					wp_register_script( 'qodx-extend-gmap-api', 'https://maps.google.com/maps/api/js' );
				}
				
				wp_register_script( 'qodx-extend-gmap-markerclusterer',                QODX_FW_URL . 'shortcodes/assets/lib/js/markerclusterer.js',                  array('jquery'), null, true );
				
				wp_register_script( 'qodx-extend-gmap',                                QODX_FW_URL . 'shortcodes/assets/lib/js/qodx-gmap.js',                          array('jquery'), null, true );	
				
				wp_register_script( 'qodx-extend-gmap-infobox',                        QODX_FW_URL . 'shortcodes/assets/lib/js/infobox/infobox_packed.js',         array('jquery'), null, true );
				
				wp_register_script( 'qodx-extend-tweetie',                             QODX_FW_URL . 'shortcodes/includes/tweetie/tweetie.min.js',                array('jquery'), null, true );
					
		}
		
		// ! Adding Qodux classes to standard VC shortcodes
		// --------------------------------------------		
		function QODX_VCSC_Extensions_Css_Classes($qodx_class, $tag) {
			if ( in_array( $tag, array('vc_tabs', 'vc_accordion', 'vc_toggle', 'vc_pie', 'TS-VCSC-Pricing-Table', 'TS-VCSC-Countdown') ) ) {
				$qodx_class .= ' qodx_vcsc_style';
			}
			return $qodx_class;
		}		
				
		// ! Load Helper Functions
		// --------------------------------------------	
		function QODX_VCSC_HelperFunctions() {			
			//require_once($this->includes_dir.'/qodx_vcsc_functions.php');
			require_once(QODX_FW_DIR . 'shortcodes/includes/qodx_vcsc_functions.php');
			
			//require_once($this->includes_dir.'/aq-resizer.php');
			require_once(QODX_FW_DIR . 'shortcodes/includes/aq-resizer.php');
		}
	}
			
}

if (class_exists('QODX_VC_EXTENSIONS')) {
	$QODX_VC_EXTENSIONS = new QODX_VC_EXTENSIONS;
}

// ! Add QODX_VCSC_SHORTCODE Class
// --------------------------------------------	
class QODX_VCSC_SHORTCODE {
			
    public function getWTExtraId() {
		$output = '';
		$output = array(
			'type'        => 'textfield',
			'heading'     => esc_html__( 'Extra Unique ID name', 'qodux_fw' ),
			'param_name'  => 'el_id',
			'description' => esc_html__( 'If you wish to style particular content element differently, then use this field to add a UNIQUE ID name and then refer to it in your css file.', 'qodux_fw' ),
			'group'       => esc_html__( 'Extra settings', 'qodux_fw' )
		);		
		return $output;
	}	
	
    public function getWTExtraClass() {
		$output = '';
		$output = array(
			'type'        => 'textfield',
			'heading'     => esc_html__( 'Extra class name', 'qodux_fw' ),
			'param_name'  => 'el_class',
			'description' => esc_html__( 'If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.', 'qodux_fw' ),
			'group'       => esc_html__( 'Extra settings', 'qodux_fw' )
		);		
		return $output;
	}
	
    public function getWTAnimations() {
		$output = '';
		$output = array(
			"type"        => "dropdown",
			"heading"     => esc_html__( "CSS WT Animation", 'qodux_fw' ),
			"param_name"  => "css_animation",
			"value" => array( esc_html__( "No", 'qodux_fw' ) => '', esc_html__( "Hinge", 'qodux_fw' ) => "hinge", esc_html__( "Flash", 'qodux_fw' ) => "flash", esc_html__( "Shake", 'qodux_fw' ) => "shake", esc_html__( "Bounce", 'qodux_fw' ) => "bounce", esc_html__( "Tada", 'qodux_fw' ) => "tada", esc_html__( "Swing", 'qodux_fw' ) => "swing", esc_html__( "Wobble", 'qodux_fw' ) => "wobble", esc_html__( "Pulse", 'qodux_fw' ) => "pulse", esc_html__( "Flip", 'qodux_fw' ) => "flip", esc_html__( "FlipInX", 'qodux_fw' ) => "flipInX", esc_html__( "FlipOutX", 'qodux_fw' ) => "flipOutX", esc_html__( "FlipInY", 'qodux_fw' ) => "flipInY", esc_html__( "FlipOutY", 'qodux_fw' ) => "flipOutY", esc_html__( "FadeIn", 'qodux_fw' ) => "fadeIn", esc_html__( "FadeInUp", 'qodux_fw' ) => "fadeInUp", esc_html__( "FadeInDown", 'qodux_fw' ) => "fadeInDown", esc_html__( "FadeInLeft", 'qodux_fw' ) => "fadeInLeft", esc_html__( "FadeInRight", 'qodux_fw' ) => "fadeInRight", esc_html__( "FadeInUpBig", 'qodux_fw' ) => "fadeInUpBig", esc_html__( "FadeInDownBig", 'qodux_fw' ) => "fadeInDownBig", esc_html__( "FadeInLeftBig", 'qodux_fw' ) => "fadeInLeftBig", esc_html__( "FadeInRightBig", 'qodux_fw' ) => "fadeInRightBig", esc_html__( "FadeOut", 'qodux_fw' ) => "fadeOut", esc_html__( "FadeOutUp", 'qodux_fw' ) => "fadeOutUp", esc_html__( "FadeOutDown", 'qodux_fw' ) => "fadeOutDown", esc_html__( "FadeOutLeft", 'qodux_fw' ) => "fadeOutLeft", esc_html__( "FadeOutRight", 'qodux_fw' ) => "fadeOutRight", esc_html__( "fadeOutUpBig", 'qodux_fw' ) => "fadeOutUpBig", esc_html__( "FadeOutDownBig", 'qodux_fw' ) => "fadeOutDownBig", esc_html__( "FadeOutLeftBig", 'qodux_fw' ) => "fadeOutLeftBig", esc_html__( "FadeOutRightBig", 'qodux_fw' ) => "fadeOutRightBig", esc_html__( "BounceIn", 'qodux_fw' ) => "bounceIn", esc_html__( "BounceInUp", 'qodux_fw' ) => "bounceInUp", esc_html__( "BounceInDown", 'qodux_fw' ) => "bounceInDown", esc_html__( "BounceInLeft", 'qodux_fw' ) => "bounceInLeft", esc_html__( "BounceInRight", 'qodux_fw' ) => "bounceInRight", esc_html__( "BounceOut", 'qodux_fw' ) => "bounceOut", esc_html__( "BounceOutUp", 'qodux_fw' ) => "bounceOutUp", esc_html__( "BounceOutDown", 'qodux_fw' ) => "bounceOutDown", esc_html__( "BounceOutLeft", 'qodux_fw' ) => "bounceOutLeft", esc_html__( "BounceOutRight", 'qodux_fw' ) => "bounceOutRight", esc_html__( "RotateIn", 'qodux_fw' ) => "rotateIn", esc_html__( "RotateInUpLeft", 'qodux_fw' ) => "rotateInUpLeft", esc_html__( "RotateInDownLeft", 'qodux_fw' ) => "rotateInDownLeft", esc_html__( "RotateInUpRight", 'qodux_fw' ) => "rotateInUpRight", esc_html__( "RotateInDownRight", 'qodux_fw' ) => "rotateInDownRight", esc_html__( "RotateOut", 'qodux_fw' ) => "rotateOut", esc_html__( "RotateOutUpLeft", 'qodux_fw' ) => "rotateOutUpLeft", esc_html__( "RotateOutDownLeft", 'qodux_fw' ) => "rotateOutDownLeft", esc_html__( "RotateOutUpRight", 'qodux_fw' ) => "rotateOutUpRight", esc_html__( "RotateOutDownRight", 'qodux_fw' ) => "rotateOutDownRight", esc_html__( "RollIn", 'qodux_fw' ) => "rollIn", esc_html__( "RollOut", 'qodux_fw' ) => "rollOut", esc_html__( "LightSpeedIn", 'qodux_fw' ) => "lightSpeedIn", esc_html__( "LightSpeedOut", 'qodux_fw' ) => "lightSpeedOut" ),
			"description" => esc_html__( "Select type of animation if you want this element to be animated when it enters into the browsers viewport. Note: Works only in modern browsers.", 'qodux_fw' ),
			'group'       => esc_html__( 'Extra settings', 'qodux_fw' )
		);		
		return $output;
	}
	
    public function getWTAnimationsType() {
		$output = '';
		$output = array(
			"type"        => "dropdown",
			"heading"     => esc_html__( "WT Animation Visible Type", 'qodux_fw' ),
			"param_name"  => "anim_type",
			"value"       => array( esc_html__( "Animate when element is visible", 'qodux_fw' ) => 'qodx_animate_if_visible', esc_html__( "Animate if element is almost visible", 'qodux_fw' ) => "qodx_animate_if_almost_visible" ),
			"description" => esc_html__( "Select when the type of animation should start for this element.", 'qodux_fw' ),
			'group'       => esc_html__( 'Extra settings', 'qodux_fw' )
		);		
		return $output;
	}
	
    public function getWTAnimationsDelay() {
		$output = '';
		$output = array(
			"type"        => "textfield",
			"heading"     => esc_html__( "WT Animation Delay", 'qodux_fw' ),
			"param_name"  => "anim_delay",
			"description" => esc_html__( "Here you can set a specific delay for the animation (miliseconds). Example: '100', '500', '1000'.", 'qodux_fw' ),
			'group'       => esc_html__( 'Extra settings', 'qodux_fw' )
		);		
		return $output;
	}

	public function getWTCSSAnimationClass($css_animation,$anim_type) {
		$output = '';
		if ( $css_animation != '' ) {
			wp_enqueue_script( 'waypoints' ); // VC file
			//wp_enqueue_script( 'qodx-extend-waypoints' );
			if ($anim_type == false) {
				$output = ' qodx_animate' ;
			} else {
				$output = ' qodx_animate ' . $anim_type ;
			}
		}
		return $output;
	}
	
	public function getWTCSSAnimationData($css_animation,$anim_delay) {
		$output = '';
		if ( $css_animation != '' ) {
			$output = ' data-animation="'.$css_animation.'"';
			if ( $anim_delay != '' ) {
				$output .= ' data-animation-delay="'.absint( $anim_delay ).'"';
			}
		}
		return $output;
	}
	
	public function getWTElementStyle($el_style) {
		$output = '';
		if ( trim($el_style) != '' ) {
			$output = ' style="'.$el_style.'"';
		}
		return $output;
	}
	
}

/*** Qodux Visual Composer Content elements refresh ***/
class QODX_VCSC_SharedLibrary {
	// Here we will store plugin wise (shared) settings. sizes, sizes etc...

	public static $sizes = array(
		'Mini'   => 'xs',
		'Small'  => 'sm',
		'Normal' => 'md',
		'Large'  => 'lg'
	);
	
	public static $text_align = array(
		'Left'    => 'left',
		'Right'   => 'right',
		'Center'  => 'center',
		'Justify' => 'justify'
	);
	
	public static $sep_styles = array(
		'Border' => '',
		'Dashed' => 'dashed',
		'Dotted' => 'dotted',
		'Double' => 'double'
	);
	
	public static $box_styles = array(
		'Default'                => '',
		'Rounded'                => 'vc_box_rounded',
		'Border'                 => 'vc_box_border',
		'Outline'                => 'vc_box_outline',
		'Shadow'                 => 'vc_box_shadow',
		'Bordered shadow'        => 'vc_box_shadow_border',
		'3D Shadow'              => 'vc_box_shadow_3d',
		'Circle'                 => 'vc_box_circle', //new
		'Circle Border'          => 'vc_box_border_circle', //new
		'Circle Outline'         => 'vc_box_outline_circle', //new
		'Circle Shadow'          => 'vc_box_shadow_circle', //new
		'Circle Border Shadow'   => 'vc_box_shadow_border_circle' //new
	);
	
	public static function getSizes() {
		return self::$sizes;
	}
	
	public static function getTextAlign() {
		return self::$text_align;
	}
	
	public static function getSeparatorStyles() {
		return self::$sep_styles;
	}

	public static function getBoxStyles() {
		return self::$box_styles;
	}
}

function QODX_VCSC_getShared( $asset = '' ) {
	switch ( $asset ) {
		
		case 'sizes':
			return QODX_VCSC_SharedLibrary::getSizes();
			break;
		
		case 'text align':
			return QODX_VCSC_SharedLibrary::getTextAlign();
			break;
		
		case 'separator styles':
			return QODX_VCSC_SharedLibrary::getSeparatorStyles();
			break;

		case 'single image styles':
			return QODX_VCSC_SharedLibrary::getBoxStyles();
			break;

		default:
			# code...
			break;
			
	}
}
?>