<?php
$config = array(
	'title' => sprintf( esc_html__( 'Page Bg Options', 'qodux_fw' ),QODUX_FRAME_NAME),
	'id' => 'page_bg',
	'pages' => array('page','post'),
	'callback' => '',
	'context' => 'normal',
	'priority' => 'low',
);
$options = array(
	array(
		"class" => "nav-tab-wrapper",
		"default" => '',
		"options" => array(
			"header" => esc_html__( 'Header', 'qodux_fw' ),
			"breadcrumbs" => esc_html__( 'Breadcrumbs', 'qodux_fw' ),
			"page" => esc_html__( 'Page', 'qodux_fw' ),
			"footer" => esc_html__( 'Footer', 'qodux_fw' ),
		),
		"type" => "qodx_navigation",
	),	
	array(
		"type" => "qodx_option_group_start",
		"group_id" => "page",
	),
		array(
			"name" => esc_html__( "Page Background Image", 'qodux_fw' ),
			"desc" => esc_html__( "You can paste the full URL of the image (including ", 'qodux_fw' ) . "<code>http://</code>" . esc_html__( "), to be used as a background image, or you can simply upload it using the button.", 'qodux_fw' ),
			"id" => "_page_bg",
			"default" => "",
			"type" => "qodx_upload"
		),
		array(
			"name" => esc_html__( "Page Background Position", 'qodux_fw' ),
			"desc" => "Choose the background image position.",
			"id" => "_page_position_x",
			"default" => 'center',
			"options" => array(
				"left" => esc_html__( 'Left', 'qodux_fw' ),
				"center" => esc_html__( 'Center', 'qodux_fw' ),
				"right" => esc_html__( 'Right', 'qodux_fw' ),
			),
			"type" => "qodx_select",
		),
		array(
			"name" => esc_html__( "Page Background Repeat", 'qodux_fw' ),
			"desc" => "Choose the background image repeat style.",
			"id" => "_page_repeat",
			"default" => 'no-repeat',
			"options" => array(
				"no-repeat" => esc_html__( 'No Repeat', 'qodux_fw' ),
				"repeat" => esc_html__( 'Repeat', 'qodux_fw' ),
				"repeat-x" => esc_html__( 'Repeat Horizontally', 'qodux_fw' ),
				"repeat-y" => esc_html__( 'Repeat Vertically', 'qodux_fw' ),
			),
			"type" => "qodx_select",
		),
		array(
			"name" => esc_html__( "Page Background Color", 'qodux_fw' ),
			"desc" => esc_html__( "Here you can choose a specific page background color. Set it to transparent in order to disable this.", 'qodux_fw' ),
			"id" => "_page_bg_color",
			"default" => "",
			"type" => "qodx_color"		
		),
	array(
		"type" => "qodx_group_end",
	),
	
	array(
		"type" => "qodx_option_group_start",
		"group_id" => "header",
	),
		array(
			"name" => esc_html__( "Header Background Image", 'qodux_fw' ),
			"desc" => esc_html__( "You can paste the full URL of the image (including ", 'qodux_fw' ) . "<code>http://</code>" . esc_html__( "), to be used as a background image, or you can simply upload it using the button.", 'qodux_fw' ),
			"id" => "_header_bg",
			"default" => "",
			"type" => "qodx_upload"
		),
		array(
			"name" => esc_html__( "Header Background Position", 'qodux_fw' ),
			"desc" => "Choose the background image position.",
			"id" => "_header_position_x",
			"default" => 'center',
			"options" => array(
				"left" => esc_html__( 'Left', 'qodux_fw' ),
				"center" => esc_html__( 'Center', 'qodux_fw' ),
				"right" => esc_html__( 'Right', 'qodux_fw' ),
			),
			"type" => "qodx_select",
		),
		array(
			"name" => esc_html__( "Header Background Repeat", 'qodux_fw' ),
			"desc" => "Choose the background image repeat style.",
			"id" => "_header_repeat",
			"default" => 'no-repeat',
			"options" => array(
				"no-repeat" => esc_html__( 'No Repeat', 'qodux_fw' ),
				"repeat" => esc_html__( 'Repeat', 'qodux_fw' ),
				"repeat-x" => esc_html__( 'Repeat Horizontally', 'qodux_fw' ),
				"repeat-y" => esc_html__( 'Repeat Vertically', 'qodux_fw' ),
			),
			"type" => "qodx_select",
		),
		array(
			"name" => esc_html__( "Header Background Color", 'qodux_fw' ),
			"desc" => esc_html__( "Here you can choose a specific page background color. Set it to transparent in order to disable this.", 'qodux_fw' ),
			"id" => "_header_bg_color",
			"default" => "",
			"type" => "qodx_color"		
		),
		
	array(
		"type" => "qodx_group_end",
	),
	
	array(
		"type" => "qodx_option_group_start",
		"group_id" => "breadcrumbs",
	),	
		array(
			"name" => esc_html__( "Breadcrumbs Background Image", 'qodux_fw' ),
			"desc" => esc_html__( "You can paste the full URL of the image (including ", 'qodux_fw' ) . "<code>http://</code>" . esc_html__( "), to be used as a background image, or you can simply upload it using the button.", 'qodux_fw' ),
			"id" => "_breadcrumbs_bg",
			"default" => "",
			"type" => "qodx_upload"
		),
		array(
			"name" => esc_html__( "Breadcrumbs Background Position", 'qodux_fw' ),
			"desc" => "Choose the background image position.",
			"id" => "_breadcrumbs_position_x",
			"default" => 'center',
			"options" => array(
				"left" => esc_html__( 'Left', 'qodux_fw' ),
				"center" => esc_html__( 'Center', 'qodux_fw' ),
				"right" => esc_html__( 'Right', 'qodux_fw' ),
			),
			"type" => "qodx_select",
		),
		array(
			"name" => esc_html__( "Breadcrumbs Background Repeat", 'qodux_fw' ),
			"desc" => "Choose the background image repeat style.",
			"id" => "_breadcrumbs_repeat",
			"default" => 'no-repeat',
			"options" => array(
				"no-repeat" => esc_html__( 'No Repeat', 'qodux_fw' ),
				"repeat" => esc_html__( 'Repeat', 'qodux_fw' ),
				"repeat-x" => esc_html__( 'Repeat Horizontally', 'qodux_fw' ),
				"repeat-y" => esc_html__( 'Repeat Vertically', 'qodux_fw' ),
			),
			"type" => "qodx_select",
		),
		array(
			"name" => esc_html__( "Breadcrumbs Background Color", 'qodux_fw' ),
			"desc" => esc_html__( "Here you can choose a specific intro background color. Set it to transparent in order to disable this.", 'qodux_fw' ),
			"id" => "_breadcrumbs_bg_color",
			"default" => "",
			"type" => "qodx_color"		
		),
		array(
			"name" => esc_html__( "Breadcrumbs Text Color", 'qodux_fw' ),
			"desc" => esc_html__( "Here you can choose a specific text color.", 'qodux_fw' ),
			"id" => "_breadcrumbs_text_color",
			"default" => "",
			"type" => "qodx_color"		
		),
	array(
		"type" => "qodx_group_end",
	),
	
	array(
		"type" => "qodx_option_group_start",
		"group_id" => "intro",
	),	
		array(
			"name" => esc_html__( "Intro Background Image", 'qodux_fw' ),
			"desc" => esc_html__( "You can paste the full URL of the image (including ", 'qodux_fw' ) . "<code>http://</code>" . esc_html__( "), to be used as a background image, or you can simply upload it using the button.", 'qodux_fw' ),
			"id" => "_intro_bg",
			"default" => "",
			"type" => "qodx_upload"
		),
		array(
			"name" => esc_html__( "Intro Background Position", 'qodux_fw' ),
			"desc" => "Choose the background image position.",
			"id" => "_intro_position_x",
			"default" => 'center',
			"options" => array(
				"left" => esc_html__( 'Left', 'qodux_fw' ),
				"center" => esc_html__( 'Center', 'qodux_fw' ),
				"right" => esc_html__( 'Right', 'qodux_fw' ),
			),
			"type" => "qodx_select",
		),
		array(
			"name" => esc_html__( "Intro Background Repeat", 'qodux_fw' ),
			"desc" => "Choose the background image repeat style.",
			"id" => "_intro_repeat",
			"default" => 'no-repeat',
			"options" => array(
				"no-repeat" => esc_html__( 'No Repeat', 'qodux_fw' ),
				"repeat" => esc_html__( 'Repeat', 'qodux_fw' ),
				"repeat-x" => esc_html__( 'Repeat Horizontally', 'qodux_fw' ),
				"repeat-y" => esc_html__( 'Repeat Vertically', 'qodux_fw' ),
			),
			"type" => "qodx_select",
		),
		array(
			"name" => esc_html__( "Intro Background Color", 'qodux_fw' ),
			"desc" => esc_html__( "Here you can choose a specific intro background color. Set it to transparent in order to disable this.", 'qodux_fw' ),
			"id" => "_intro_bg_color",
			"default" => "",
			"type" => "qodx_color"		
		),
		array(
			"name" => esc_html__( "Intro Text Color", 'qodux_fw' ),
			"desc" => esc_html__( "Here you can choose a specific intro text color.", 'qodux_fw' ),
			"id" => "_intro_text_color",
			"default" => "",
			"type" => "qodx_color"		
		),
	array(
		"type" => "qodx_group_end",
	),
	
	array(
		"type" => "qodx_option_group_start",
		"group_id" => "container",
	),	
		array(
			"name" => esc_html__( "Container Background Image", 'qodux_fw' ),
			"desc" => esc_html__( "You can paste the full URL of the image (including ", 'qodux_fw' ) . "<code>http://</code>" . esc_html__( "), to be used as a background image, or you can simply upload it using the button.", 'qodux_fw' ),
			"id" => "_container_bg",
			"default" => "",
			"type" => "qodx_upload"
		),
		array(
			"name" => esc_html__( "Container Background Position", 'qodux_fw' ),
			"desc" => "Choose the background image position.",
			"id" => "_container_position_x",
			"default" => 'center',
			"options" => array(
				"left" => esc_html__( 'Left', 'qodux_fw' ),
				"center" => esc_html__( 'Center', 'qodux_fw' ),
				"right" => esc_html__( 'Right', 'qodux_fw' ),
			),
			"type" => "qodx_select",
		),
		array(
			"name" => esc_html__( "Container Background Repeat", 'qodux_fw' ),
			"desc" => "Choose the background image repeat style.",
			"id" => "_container_repeat",
			"default" => 'no-repeat',
			"options" => array(
				"no-repeat" => esc_html__( 'No Repeat', 'qodux_fw' ),
				"repeat" => esc_html__( 'Repeat', 'qodux_fw' ),
				"repeat-x" => esc_html__( 'Repeat Horizontally', 'qodux_fw' ),
				"repeat-y" => esc_html__( 'Repeat Vertically', 'qodux_fw' ),
			),
			"type" => "qodx_select",
		),
		array(
			"name" => esc_html__( "Container Background Color", 'qodux_fw' ),
			"desc" => esc_html__( "Here you can choose a specific intro background color. Set it to transparent in order to disable this.", 'qodux_fw' ),
			"id" => "_container_bg_color",
			"default" => "",
			"type" => "qodx_color"		
		),
	array(
		"type" => "qodx_group_end",
	),
	
	array(
		"type" => "qodx_option_group_start",
		"group_id" => "content",
	),	
		array(
			"name" => esc_html__( "Content Background Image", 'qodux_fw' ),
			"desc" => esc_html__( "You can paste the full URL of the image (including ", 'qodux_fw' ) . "<code>http://</code>" . esc_html__( "), to be used as a background image, or you can simply upload it using the button.", 'qodux_fw' ),
			"id" => "_content_bg",
			"default" => "",
			"type" => "qodx_upload"
		),
		array(
			"name" => esc_html__( "Content Background Position", 'qodux_fw' ),
			"desc" => "Choose the background image position.",
			"id" => "_content_position_x",
			"default" => 'center',
			"options" => array(
				"left" => esc_html__( 'Left', 'qodux_fw' ),
				"center" => esc_html__( 'Center', 'qodux_fw' ),
				"right" => esc_html__( 'Right', 'qodux_fw' ),
			),
			"type" => "qodx_select",
		),
		array(
			"name" => esc_html__( "Content Background Repeat", 'qodux_fw' ),
			"desc" => "Choose the background image repeat style.",
			"id" => "_content_repeat",
			"default" => 'no-repeat',
			"options" => array(
				"no-repeat" => esc_html__( 'No Repeat', 'qodux_fw' ),
				"repeat" => esc_html__( 'Repeat', 'qodux_fw' ),
				"repeat-x" => esc_html__( 'Repeat Horizontally', 'qodux_fw' ),
				"repeat-y" => esc_html__( 'Repeat Vertically', 'qodux_fw' ),
			),
			"type" => "qodx_select",
		),
		array(
			"name" => esc_html__( "Content Background Color", 'qodux_fw' ),
			"desc" => esc_html__( "Here you can choose a specific intro background color. Set it to transparent in order to disable this.", 'qodux_fw' ),
			"id" => "_content_bg_color",
			"default" => "",
			"type" => "qodx_color"		
		),
	array(
		"type" => "qodx_group_end",
	),
	
	array(
		"type" => "qodx_option_group_start",
		"group_id" => "footer",
	),
		array(
			"name" => esc_html__( "Footer Top", 'qodux_fw' ),
			"type" => "focus_wp_title",
		),
		array(
			"name" => esc_html__( "Footer Top Background Image", 'qodux_fw' ),
			"desc" => esc_html__( "You can paste the full URL of the image (including ", 'qodux_fw' ) . "<code>http://</code>" . esc_html__( "), to be used as a background image, or you can simply upload it using the button.", 'qodux_fw' ),
			"id" => "_footer_top_bg",
			"default" => "",
			"type" => "qodx_upload"
		),
		array(
			"name" => esc_html__( "Footer Position", 'qodux_fw' ),
			"desc" => "Choose the background image position.",
			"id" => "_footer_top_position_x",
			"default" => 'center',
			"options" => array(
				"left" => esc_html__( 'Left', 'qodux_fw' ),
				"center" => esc_html__( 'Center', 'qodux_fw' ),
				"right" => esc_html__( 'Right', 'qodux_fw' ),
			),
			"type" => "qodx_select",
		),
		array(
			"name" => esc_html__( "Footer Repeat", 'qodux_fw' ),
			"desc" => "Choose the background image repeat style.",
			"id" => "_footer_top_repeat",
			"default" => 'no-repeat',
			"options" => array(
				"no-repeat" => esc_html__( 'No Repeat', 'qodux_fw' ),
				"repeat" => esc_html__( 'Repeat', 'qodux_fw' ),
				"repeat-x" => esc_html__( 'Repeat Horizontally', 'qodux_fw' ),
				"repeat-y" => esc_html__( 'Repeat Vertically', 'qodux_fw' ),
			),
			"type" => "qodx_select",
		),
		array(
			"name" => esc_html__( "Footer Top Background Color", 'qodux_fw' ),
			"desc" => esc_html__( "Here you can choose a specific page background color. Set it to transparent in order to disable this.", 'qodux_fw' ),
			"id" => "_footer_top_color",
			"default" => "",
			"type" => "qodx_color"		
		),
		
		array(
			"name" => esc_html__( "Footer Middle", 'qodux_fw' ),
			"type" => "focus_wp_title",
		),
		array(
			"name" => esc_html__( "Footer Background Image", 'qodux_fw' ),
			"desc" => esc_html__( "You can paste the full URL of the image (including ", 'qodux_fw' ) . "<code>http://</code>" . esc_html__( "), to be used as a background image, or you can simply upload it using the button.", 'qodux_fw' ),
			"id" => "_footer_bg",
			"default" => "",
			"type" => "qodx_upload"
		),
		array(
			"name" => esc_html__( "Footer Position", 'qodux_fw' ),
			"desc" => "Choose the background image position.",
			"id" => "_footer_position_x",
			"default" => 'center',
			"options" => array(
				"left" => esc_html__( 'Left', 'qodux_fw' ),
				"center" => esc_html__( 'Center', 'qodux_fw' ),
				"right" => esc_html__( 'Right', 'qodux_fw' ),
			),
			"type" => "qodx_select",
		),
		array(
			"name" => esc_html__( "Footer Repeat", 'qodux_fw' ),
			"desc" => "Choose the background image repeat style.",
			"id" => "_footer_repeat",
			"default" => 'no-repeat',
			"options" => array(
				"no-repeat" => esc_html__( 'No Repeat', 'qodux_fw' ),
				"repeat" => esc_html__( 'Repeat', 'qodux_fw' ),
				"repeat-x" => esc_html__( 'Repeat Horizontally', 'qodux_fw' ),
				"repeat-y" => esc_html__( 'Repeat Vertically', 'qodux_fw' ),
			),
			"type" => "qodx_select",
		),
		array(
			"name" => esc_html__( "Footer Background Color", 'qodux_fw' ),
			"desc" => esc_html__( "If you specify a color below, this option will override the global configuration. Set it to transparent in order to disable this.", 'qodux_fw' ),
			"id" => "_footer_bg_color",
			"default" => "",
			"type" => "qodx_color"		
		),
		
		
		array(
			"name" => esc_html__( "Footer Bottom", 'qodux_fw' ),
			"type" => "focus_wp_title",
		),
		array(
			"name" => esc_html__( "Footer Bottom Background Image", 'qodux_fw' ),
			"desc" => esc_html__( "You can paste the full URL of the image (including ", 'qodux_fw' ) . "<code>http://</code>" . esc_html__( "), to be used as a background image, or you can simply upload it using the button.", 'qodux_fw' ),
			"id" => "_footer_bottom_bg",
			"default" => "",
			"type" => "qodx_upload"
		),
		array(
			"name" => esc_html__( "Footer Position", 'qodux_fw' ),
			"desc" => "Choose the background image position.",
			"id" => "_footer_bottom_position_x",
			"default" => 'center',
			"options" => array(
				"left" => esc_html__( 'Left', 'qodux_fw' ),
				"center" => esc_html__( 'Center', 'qodux_fw' ),
				"right" => esc_html__( 'Right', 'qodux_fw' ),
			),
			"type" => "qodx_select",
		),
		array(
			"name" => esc_html__( "Footer Repeat", 'qodux_fw' ),
			"desc" => "Choose the background image repeat style.",
			"id" => "_footer_bottom_repeat",
			"default" => 'no-repeat',
			"options" => array(
				"no-repeat" => esc_html__( 'No Repeat', 'qodux_fw' ),
				"repeat" => esc_html__( 'Repeat', 'qodux_fw' ),
				"repeat-x" => esc_html__( 'Repeat Horizontally', 'qodux_fw' ),
				"repeat-y" => esc_html__( 'Repeat Vertically', 'qodux_fw' ),
			),
			"type" => "qodx_select",
		),
		array(
			"name" => esc_html__( "Footer Bottom Background Color", 'qodux_fw' ),
			"desc" => esc_html__( "Here you can choose a specific page background color. Set it to transparent in order to disable this.", 'qodux_fw' ),
			"id" => "_footer_bottom_color",
			"default" => "",
			"type" => "qodx_color"		
		),
	array(
		"type" => "qodx_group_end",
	),	
);

new focus_wp_metaboxes($config,$options);