<?php

$qodx_options = array(
	array(
		"class" => "nav-tab-wrapper",
		"default" => '',
		"options" => array(
			"blog_settings" => esc_html__( 'Blog', 'qodux_fw' ),
			"single_post_settings" => esc_html__( 'Single Post', 'qodux_fw' ),
			"meta_information_settings" => esc_html__( 'Meta Informations', 'qodux_fw' ),
			"featured_entry_settings" => esc_html__( 'Featured Entry', 'qodux_fw' ),
		),
		"type" => "qodx_navigation",
	),
	array(
		"type" => "qodx_group_start",
		"group_id" => "blog_settings",
	),	
		array(
			"name" => esc_html__( "Blog Settings", 'qodux_fw' ),
			"type" => "qodx_open"
		),
			array(
				"name" => esc_html__( "Layout", 'qodux_fw' ),
				"desc" => "Here you can set the layout of the blog page.",
				"id" => "layout",
				"default" => 'right',
				"options" => array(
					"full" => esc_html__( 'Full Width', 'qodux_fw' ),
					"right" => esc_html__( 'Right Sidebar', 'qodux_fw' ),
					"left" => esc_html__( 'Left Sidebar', 'qodux_fw' ),
				),
				"type" => "qodx_select",
			),
			/*array(
				"name" => esc_html__( "Featured Post Entry Type", 'qodux_fw' ),
				"desc" => "The style in which the post entry will be displayed. This could be an image/slideshow/mp3/video (youtube, vimeo, daylimotion, metacafe, google, .flv, .f4v, .mp4)",
				"id" => "featured_image_type",
				"default" => 'full',
				"options" => array(
					"full" => esc_html__( 'Full Width', 'qodux_fw' ),
					"left" => esc_html__( 'Left Float', 'qodux_fw' ),
				),
				"type" => "qodx_select",
			),*/
			array(
				"name" => esc_html__( "Display Full Blog Posts", 'qodux_fw' ),
				"desc" => esc_html__( "If the option is set to ON, the blog postswill be full displayed on the index page.", 'qodux_fw' ),
				"id" => "display_full",
				"default" => false,
				"type" => "qodx_toggle"
			),
			array(
				"name" => esc_html__( "Exclude Categories", 'qodux_fw' ),
				"desc" => esc_html__( "ff you don't want to display custom categories in the blog pages, you can set them here. Also you can exclude multiple categories.", 'qodux_fw' ),
				"id" => "exclude_categorys",
				"default" => array(),
				"target" => "cat",
				"prompt" => esc_html__( "Choose category...", 'qodux_fw' ),
				"chosen" => "true",
				"type" => "qodx_multiselect",
				//"type" => "multidropdown"
			),
			array(
				"name" => esc_html__( "Gap Between Posts", 'qodux_fw' ),
				"desc" => "Here you can set the distance between the blog posts.",
				"id" => "posts_gap",
				"min" => "0",
				"max" => "200",
				"step" => "1",
				"unit" => 'px',
				"default" => "50",
				"type" => "qodx_range"
			),
			array(
				"type" => "qodx_close"
			),
		array(
			"type" => "qodx_reset"
		),
	array(
		"type" => "qodx_group_end",
	),
	array(
		"type" => "qodx_group_start",
		"group_id" => "single_post_settings",
	),		
		array(
			"name" => esc_html__( "Single Post Settings", 'qodux_fw' ),
			"type" => "qodx_open"
		),
			array(
				"name" => esc_html__( "Layout", 'qodux_fw' ),
				"desc" => "Here you can set the layout of the blog posts.",
				"id" => "single_layout",
				"default" => 'right',
				"options" => array(
					"full" => esc_html__( 'Full Width', 'qodux_fw' ),
					"right" => esc_html__( 'Right Sidebar', 'qodux_fw' ),
					"left" => esc_html__( 'Left Sidebar', 'qodux_fw' ),
				),
				"type" => "qodx_select",
			),
			array(
				"name" => esc_html__( "Featured Post Entry", 'qodux_fw' ),
				"desc" => esc_html__( "If the button is set to ON then the Featured Image/Slideshow/Mp3/Video will be displayed on the Single Blog post.", 'qodux_fw' ),
				"id" => "featured_image",
				"default" => true,
				"type" => "qodx_toggle"
			),
			/*array(
				"name" => esc_html__( "Featured Post Entry Type", 'qodux_fw' ),
				"desc" => "The style in which the post entry will be displayed on Single Blog post. This could be an image/slideshow/mp3/video (youtube, vimeo, daylimotion, metacafe, google, .flv, .f4v, .mp4). ",
				"id" => "single_featured_image_type",
				"default" => 'full',
				"options" => array(
					"full" => esc_html__( 'Full Width', 'qodux_fw' ),
					"left" => esc_html__( 'Left Float', 'qodux_fw' ),
				),
				"type" => "qodx_select",
			),*/
			array(
				"name" => esc_html__( "Featured Image for Lightbox", 'qodux_fw' ),
				"desc" => esc_html__( "If the button is set to ON then the full image will be opened in the lightbox when you click on Featured Image of the Blog Single Post page.", 'qodux_fw' ),
				"id" => "featured_image_lightbox",
				"default" => false,
				"type" => "qodx_toggle"
			),
			/*array(
				"name" => esc_html__( "About Author Box", 'qodux_fw' ),
				"desc" => "If the button is set to ON then the About Author Box will be displayed in the Blog Single Post page.",
				"id" => "author",
				"default" => false,
				"type" => "qodx_toggle"
			),*/
			array(
				"name" => esc_html__( "Previous & Next Navigation", 'qodux_fw' ),
				"desc" => "Display pagination for the posts.",
				"id" => "entry_navigation",
				"default" => true,
				"type" => "qodx_toggle"
			),
			array(
				"name" => esc_html__( "Display Share On", 'qodux_fw' ),
				"desc" => "Display share on facebook, google and twitter for the posts.",
				"id" => "share_on",
				"default" => true,
				"type" => "qodx_toggle"
			),
			array(
				"name" => esc_html__( "Disqus comments", 'qodux_fw' ),
				"desc" => "Display disqus comments. This option will disable the default comments.",
				"id" => "disqus",
				"default" => false,
				"type" => "qodx_toggle"
			),
		array(
			"type" => "qodx_close"
		),
		array(
			"type" => "qodx_reset"
		),
	array(
		"type" => "qodx_group_end",
	),
	array(
		"type" => "qodx_group_start",
		"group_id" => "meta_information_settings",
	),
		array(
			"name" => esc_html__( "Meta Informations", 'qodux_fw' ),
			"type" => "qodx_open"
		),
			array(
				"name" => esc_html__( "Date", 'qodux_fw' ),
				"desc" => "Display date in Meta Informations box.",
				"id" => "meta_date",
				"default" => true,
				"type" => "qodx_toggle"
			),
			array(
				"name" => esc_html__( "Author", 'qodux_fw' ),
				"desc" => "Display author in Meta Informations box.",
				"id" => "meta_author",
				"default" => false,
				"type" => "qodx_toggle"
			),
			array(
				"name" => esc_html__( "Author Link Type", 'qodux_fw' ),
				"desc" => "Select the link type for the author ( website link which is set in the user profile page, author's posts page or none ).",
				"id" => "author_link_type",
				"default" => 'archive',
				"options" => array(
					"website" => esc_html__( 'Website', 'qodux_fw' ),
					"archive" => esc_html__( 'Author archive', 'qodux_fw' ),
					""        => esc_html__( 'None', 'qodux_fw' ),
				),
				"type" => "qodx_select",
			),
			array(
				"name" => esc_html__( "Categories", 'qodux_fw' ),
				"desc" => "Display categories in Meta Informations box.",
				"id" => "meta_category",
				"default" => true,
				"type" => "qodx_toggle"
			),
			/*array(
				"name" => esc_html__( "Tags", 'qodux_fw' ),
				"desc" => "Display tags in Meta Informations box.",
				"id" => "meta_tags",
				"default" => false,
				"type" => "qodx_toggle"
			),*/
			array(
				"name" => esc_html__( "Views", 'qodux_fw' ),
				"desc" => "Display number of views in Meta Informations box.",
				"id" => "meta_views",
				"default" => true,
				"type" => "qodx_toggle"
			),
			array(
				"name" => esc_html__( "Comments", 'qodux_fw' ),
				"desc" => "Display comments number in Meta Informations box.",
				"id" => "meta_comment",
				"default" => true,
				"type" => "qodx_toggle"
			),
		array(
			"type" => "qodx_close"
		),
		array(
			"type" => "qodx_reset"
		),
		array(
			"name" => esc_html__( "Meta Informations Single Post", 'qodux_fw' ),
			"type" => "qodx_open"
		),
			array(
				"name" => esc_html__( "Date", 'qodux_fw' ),
				"desc" => "Display date in Meta Informations box.",
				"id" => "single_meta_date",
				"default" => true,
				"type" => "qodx_toggle"
			),
			array(
				"name" => esc_html__( "Author", 'qodux_fw' ),
				"desc" => "Display author in Meta Informations box.",
				"id" => "single_meta_author",
				"default" => false,
				"type" => "qodx_toggle"
			),
			array(
				"name" => esc_html__( "Categories", 'qodux_fw' ),
				"desc" => "Display categories in Meta Informations box.",
				"id" => "single_meta_category",
				"default" => true,
				"type" => "qodx_toggle"
			),
			array(
				"name" => esc_html__( "Tags", 'qodux_fw' ),
				"desc" => "Display tags in Meta Informations box.",
				"id" => "single_meta_tags",
				"default" => true,
				"type" => "qodx_toggle"
			),
			array(
				"name" => esc_html__( "Views", 'qodux_fw' ),
				"desc" => "Display number of views in Meta Informations box.",
				"id" => "single_meta_views",
				"default" => true,
				"type" => "qodx_toggle"
			),
			array(
				"name" => esc_html__( "Comments", 'qodux_fw' ),
				"desc" => "Display comments number in Meta Informations box.",
				"id" => "single_meta_comment",
				"default" => true,
				"type" => "qodx_toggle"
			),
		array(
			"type" => "qodx_close"
		),
		array(
			"type" => "qodx_reset"
		),
	array(
		"type" => "qodx_group_end",
	),
	array(
		"type" => "qodx_group_start",
		"group_id" => "featured_entry_settings",
	),
		array(
			"name" => esc_html__( "Full Width Featured Post Entry", 'qodux_fw' ),
			"type" => "qodx_open"
		),
			array(
				"name" => esc_html__( "Blog Adaptive Height", 'qodux_fw' ),
				"desc" => esc_html__( "If the button is set to ON then the Featured Image height depends on the original image.", 'qodux_fw' ),
				"id" => "adaptive_height",
				"default" => false,
				"type" => "qodx_toggle"
			),
			array(
				"name" => esc_html__( "Single Adaptive Height", 'qodux_fw' ),
				"desc" => esc_html__( "If the button is set to ON then the Featured Image height depends on the original image.", 'qodux_fw' ),
				"id" => "single_adaptive_height",
				"default" => false,
				"type" => "qodx_toggle"
			),
			array(
				"name" => esc_html__( "\"Full Layout\" - Featured Image Height", 'qodux_fw' ),
				"desc" => esc_html__( "You can set the Featured Image Entry height for full width layouts. ( Adaptive height option above should be OFF ).  Default height is 550px.", 'qodux_fw' ),
				"id" => "image_height",
				"min" => "1",
				"max" => "640",
				"step" => "1",
				"unit" => 'px',
				"default" => "550",
				"type" => "qodx_range"
			),
			array(
				"name" => esc_html__( "\"Full Layout\" - Featured Slide Height", 'qodux_fw' ),
				"desc" => esc_html__( "You can set the Featured Slide Entry height for full width layouts. Default height is 550px.", 'qodux_fw' ),
				"id" => "slide_height",
				"min" => "1",
				"max" => "640",
				"step" => "1",
				"unit" => 'px',
				"default" => "550",
				"type" => "qodx_range"
			),
			array(
				"name" => esc_html__( "\"Sidebar Layout\" - Featured Image Height", 'qodux_fw' ),
				"desc" => esc_html__( "You can set the Featured Image Entry height for layouts with sidebar. ( Adaptive height option above should be OFF ). Default height is 250px.", 'qodux_fw' ),
				"id" => "sidebar_image_height",
				"min" => "1",
				"max" => "640",
				"step" => "1",
				"unit" => 'px',
				"default" => "429",
				"type" => "qodx_range"
			),
			array(
				"name" => esc_html__( "\"Sidebar Layout\" - Featured Slide Height", 'qodux_fw' ),
				"desc" => esc_html__( "You can set the Featured Slide Entry height for layouts with sidebar. Default height is 400px.", 'qodux_fw' ),
				"id" => "sidebar_slide_height",
				"min" => "1",
				"max" => "640",
				"step" => "1",
				"unit" => 'px',
				"default" => "429",
				"type" => "qodx_range"
			),
		array(
			"type" => "qodx_close"
		),
		array(
			"type" => "qodx_reset"
		),
		array(
			"name" => esc_html__( "Left Float Featured Post Entry", 'qodux_fw' ),
			"type" => "qodx_open"
		),
			array(
				"name" => esc_html__( "\"Full Layout\" - Width", 'qodux_fw' ),
				"desc" => esc_html__( "You can set the width of the left floated entry wrapper for Full Layouts. Original image width is 720px because on smaller screens it will be displayed at full size. Default width is 460px.", 'qodux_fw' ),
				"id" => "left_width",
				"min" => "1",
				"max" => "640",
				"step" => "1",
				"unit" => 'px',
				"default" => "460",
				"type" => "qodx_range"
			),
			array(
				"name" => esc_html__( "\"Full Layout\" - Featured Image Height", 'qodux_fw' ),
				"desc" => esc_html__( "You can set the height of the left floated Image Entry for Full Layouts. This is the height for smaller screens where the image will be displayed in full size. On larger screens the image height will be resized to fit in left image wrapper. Default height is 405px.", 'qodux_fw' ),
				"id" => "left_image_height",
				"min" => "1",
				"max" => "640",
				"step" => "1",
				"unit" => 'px',
				"default" => "405",
				"type" => "qodx_range"
			),
			array(
				"name" => esc_html__( "\"Full Layout\" - Featured Slide Height", 'qodux_fw' ),
				"desc" => esc_html__( "You can set the height of the left floated Slide Entry for Full Layouts. This is the height for smaller screens where the image will be displayed in full size. On larger screens the image height will be resized to fit in left image wrapper. Default height is 405px.", 'qodux_fw' ),
				"id" => "left_slide_height",
				"min" => "1",
				"max" => "640",
				"step" => "1",
				"unit" => 'px',
				"default" => "405",
				"type" => "qodx_range"
			),
			array(
				"name" => esc_html__( "\"Sidebar Layout\" - Width", 'qodux_fw' ),
				"desc" => esc_html__( "You can set the width of the left floated entry wrapper for Layouts With Sidebar. Original image width is 720px because on smaller screens it will be displayed at full size. Default width is 380px.", 'qodux_fw' ),
				"id" => "sidebar_left_width",
				"min" => "1",
				"max" => "460",
				"step" => "1",
				"unit" => 'px',
				"default" => "380",
				"type" => "qodx_range"
			),
			array(
				"name" => esc_html__( "\"Sidebar Layout\" - Featured Image Height", 'qodux_fw' ),
				"desc" => esc_html__( "You can set the height of the left floated Image Entry for Layouts With Sidebar. This is the height for smaller screens where the image will be displayed in full size. On larger screens the image height will be resized to fit in left image wrapper. Default height is 405px.", 'qodux_fw' ),
				"id" => "sidebar_left_image_height",
				"min" => "1",
				"max" => "460",
				"step" => "1",
				"unit" => 'px',
				"default" => "405",
				"type" => "qodx_range"
			),
			array(
				"name" => esc_html__( "\"Sidebar Layout\" - Featured Slide Height", 'qodux_fw' ),
				"desc" => esc_html__( "You can set the height of the left floated Slide Entry for Layouts With Sidebar. This is the height for smaller screens where the image will be displayed in full size. On larger screens the image height will be resized to fit in left image wrapper.  Default height is 405px.", 'qodux_fw' ),
				"id" => "sidebar_left_slide_height",
				"min" => "1",
				"max" => "460",
				"step" => "1",
				"unit" => 'px',
				"default" => "405",
				"type" => "qodx_range"
			),
		array(
			"type" => "qodx_close"
		),
		array(
			"type" => "qodx_reset"
		),
	array(
		"type" => "qodx_group_end",
	),
);
return array(
	'auto' => true,
	'name' => 'blog',
	'options' => $qodx_options
);