/* global jQuery:false, document, window, waypoint, grecaptcha, google, InfoBox, Photostack, Cookies, smoothScroll */

/**
 * Qodux Extend WPBakery Visual Composer Shortcodes
 *
 */
  
(function($) {
    "use strict";
	
	var disable_autoplay;
	
	/* ----- Settings ----- */
	
	// Enable or disable Swiper Slide autoplay ( true / false )
	disable_autoplay = false;
	
    $(document).ready(function() {
		if($.fn.tooltip) {
			$('.qodx_social_networks_sc').tooltip({ selector: "a[data-toggle=tooltip]"});
		}
        qodx_extended_vc_shortcode_scripts();	
    });

	$(window).load(function() {
		// Initialize after images are loaded
        qodx_extended_vc_shortcode_scripts_on_load();			
	});
	
	function qodx_extended_vc_shortcode_scripts_on_load(container) {			
		if(typeof container == 'undefined'){ container = 'body';}
		var win     = $(window);
				
		if($.fn.qodx_sc_portfolio)
		$('.qodx-portfolio-wrapper-isotope', container).qodx_sc_portfolio();			
		
		win.on("smartresize", function() {
			swiperSliderHeightfn();
		});
		swiperSliderHeightfn();
	}

	function qodx_extended_vc_shortcode_scripts(container) {
		if(typeof container == 'undefined'){ container = 'body';}
		var win     = $(window),
			wrapper = $('html');
		
		// activates css animations once the elements appear into viewport but only if animations are enabled
		if($().waypoint && $.fn.qodx_waypoints) {
			$('.qodx_animate_if_visible', container).qodx_waypoints();
			$('.qodx_animate_if_almost_visible', container).qodx_waypoints({ offset: '75%'});
		}
		// prevents hidden elements if switch from small screen to large screen
		win.smartresize(function(){
			if($().waypoint && $.fn.qodx_waypoints) {
				$('.qodx_animate_if_visible', container).qodx_waypoints();
				$('.qodx_animate_if_almost_visible', container).qodx_waypoints({ offset: '75%'});
			}
		});		
		
		// Css Animations			
		if($.fn.qodx_sc_animations)
		$('.qodx_animations .qodx_animate', container).qodx_sc_animations();
		
		// Contact Forms Validation
		if($.fn.qodx_forms_validate)
		$(".qodx_contact_form_sc", container).qodx_forms_validate();
				
		// Progress Bars animations			
		if($.fn.qodx_sc_progress_bars)
		$('.vc_single_bar', container).qodx_sc_progress_bars();	
		
		// Bx Slider			
		if($.fn.qodx_sc_bx_slider)
		$('.qodx_bxslider', container).qodx_sc_bx_slider();	
		
		// Counters			
		if($.fn.qodx_sc_counters)
		$('.qodx_counter_sc', container).qodx_sc_counters();
		
		// Pie Charts			
		if($.fn.qodx_sc_pie_charts)
		$('.qodx_pie_chart_sc', container).qodx_sc_pie_charts();
		
		// Owl Carousel			
		if($.fn.qodx_sc_owl_carousel)
		$('.qodx_owl_carousel', container).qodx_sc_owl_carousel();
		
		// Parallax			
		if($.fn.qodx_sc_parallax)
		$('.qodx-background-parallax', container).qodx_sc_parallax();
		
		// Tooltip		
		if ($.fn.tooltip)
		$("[data-toggle='tooltip']").tooltip({ animation: true }); // This works with twitter bootstrap tooltip scipt
		
		if ($.fn.mb_YTPlayer) {			
			if (!wrapper.hasClass('qodx_mobile')) {
				/* show player and hide mobile bg on desktops */
				$(".qodx_youtube_player").mb_YTPlayer();
				$('.qodx_row_bg_video_mobile').hide();
			} else {
				/* hide player and video volume button on mobiles */
				$(".qodx_youtube_player").hide();
			}
		}
		
		
		/* LUNE THEME FUNCTIONS
		   --------------------------------------------------------- */	
		
		/* ----- Swiper Slider ----- */	
		if($.fn.qodx_sc_swiper_slider)
		$('.qodx-swiper-slider', container).qodx_sc_swiper_slider();
				
		swipToSlidefn();
		
		if ($('select.qodx-select').length) { qodxSelectfn();	}
		
		qodxMatchHeightfn();
		
		/* ----- Popover Team Block ----- */	
		$('a.team-popover').popover({
			html: true,
			container: 'body',
			template: '<div class="popover team-popover" role="tooltip"><div class="arrow"></div><h3 class="popover-title"></h3><div class="popover-content"></div></div>'
		});
		
		/* ----- Contact Form ----- */	
		if($.fn.qodx_contact_form)
		$(".qodx_contact_form_sc", container).qodx_contact_form();
		
		$('body').on('click', '.form-message-block button', function () {
			dismissFormMessagefn();
		});
		
		/* ----- Form Elements - Input ----- */
		$('.form-control').each(function () {
			$(this).on({
				focus: function () {
					$(this).addClass('input-filled');
				},
				focusout: function () {
					if ($(this).val() === '') {
						$(this).removeClass('input-filled');
					}
				}
			});
		});
		
		/* ----- Form Elements - Checkbox ----- */
		if ($('input[type="checkbox"].form-control').length) {
			$('input[type="checkbox"].form-control').each(function (index) {
				$(this).attr('id', 'qodx-checkbox-' + index);
				$(this).next('label').attr('for', 'qodx-checkbox-' + index);
			});
		}
			
		/* ----- Button Ripple Animation ----- */
		$('body').on('click', '.wave-effect', function (e) {
			if (e.button === 2) {
				return false;
			}
	
			$('.qodx-ripple-animation').removeClass('qodx-ripple-animation');
			$(this).addClass('qodx-ripple-animation');
			qodxRippleAnimationfn(e.pageX, e.pageY);
		});		
		
		/* ----- Twitter feed ----- */	
		if($.fn.qodx_sc_twitter)
		$('.twitter-feed-block', container).qodx_sc_twitter();
		
	}
	
	/* Qodux Portfolio
	   --------------------------------------------------------- */	
			
	$.fn.qodx_sc_portfolio = function() {
		return this.each(function() {
			var container       = $(this),
				containerParent = container.parent(), // .filter-section-wrapper
				win             = $(window),
				
				// Isotope filter portfolio
				qodx_iso_filter   = function() {					
					
					containerParent.on('click', '[data-filter]', function () {			
						var el                = $(this),
							filterGroupValue  = '',
							filterValue 	  = el.attr('data-filter');			
						
						if (! el.closest('.sortableLinks').length ) {
							// Select options filter
							el.parents('.filter-group').attr('data-filter-group', filterValue);
							el.parents('.filter-block').find('.filter-group').each(function () {
								filterGroupValue += $(this).attr('data-filter-group');
							});
							
							container.isotope({ filter: filterGroupValue });
						} else { 
							// Sortable links filter
							if (el.hasClass('selected')) {
								return false;
							} else {				
								$('.sortableLinks .selected').removeClass('selected');
								container.isotope({ filter: filterValue });
								el.addClass('selected');
								return false;			
							}
						}												
					});				
				},
				
				// Isotope portfolio
				qodx_portfolio    = function() {										
					var qodx_portf = function() { 
						container.isotope({
							layoutMode   : 'masonry',
							itemSelector : '.isotope-item'
						});
					}
					
					win.on("smartresize", qodx_portf);
					qodx_portf();					
				};
			
			if ( $.isFunction($.fn.isotope) && containerParent.length ) { // if isotope scripts are called and portfolio is isotope type
				qodx_iso_filter();		
				qodx_portfolio();
			}
		});
	};
	
	/* Css Animations
	   --------------------------------------------------------- */	
	
	$.fn.qodx_sc_animations = function() {
		return this.each(function() {
			var win            = $(window),
				container      = $(this),
				animation      = container.data('animation'),
				animationDelay = container.data('animation-delay'),
				
				qodx_animations  = function() {
					var isSmallScreen  = $('html').hasClass('is_smallScreen');	
									
					if (!isSmallScreen && $().waypoint) {
						
						container.on('qodx_start_animation', function() {
							if (animationDelay) {
								setTimeout(function(){
									container.addClass( animation + ' animated').css('visibility', 'visible'); 
								}, animationDelay);
							} else {
								container.addClass( animation + ' animated').css('visibility', 'visible'); 
							}
						});
					}
				};				
			
			win.on("smartresize", qodx_animations);
			qodx_animations();
		});
	};
	
	/* Contact Forms Validation
	   --------------------------------------------------------- */	
	   
	$.fn.qodx_forms_validate = function() {
		return this.each(function(){
			var form = $(this),
				validator = form.validate();
			form.submit(function(e) {
				if (!e.isDefaultPrevented()) {
					var $id = form.find('input[name="contact_widget_id"]').val(),
						success = form.siblings('.success');
					$.post(this.action,{
						'to'      : $('input[name="contact_to_'+$id+'"]').val().replace("(at)", "@"),
						'name'    : $('input[name="contact_name_'+$id+'"]').val(),
						'email'   : $('input[name="contact_email_'+$id+'"]').val(),
						'subject' : $('input[name="contact_subject_'+$id+'"]').val(),
						'phone'   : $('input[name="contact_phone_'+$id+'"]').val(),
						'website' : $('input[name="contact_website_'+$id+'"]').val(),
						'country' : $('input[name="contact_country_'+$id+'"]').val(),
						'city'    : $('input[name="contact_city_'+$id+'"]').val(),
						'company' : $('input[name="contact_company_'+$id+'"]').val(),
						'sitename' : $('input[name="contact_sitename_'+$id+'"]').val(),
						'siteurl' : $('input[name="contact_siteurl_'+$id+'"]').val(),
						'content' : $('textarea[name="contact_content_'+$id+'"]').val()
					},function(){
						form.fadeOut('fast', function() {
							success.show();
						});
						success.children('button').on('click', function() {
							success.clone().insertBefore(form).hide();
							form.find('input[type="text"], input[type="email"], input[type="tel"], input[type="url"], textarea').val('');
							setTimeout(function(){
								form.fadeIn('fast');
							}, 800);	
						});
					});
					e.preventDefault();
				}
			});
			form.find( '.reset-form' ).on( 'click' ,function(e) {
				e.preventDefault();		
				form.find('input[type="text"], input[type="email"], input[type="tel"], input[type="url"], textarea').val('');
				validator.resetForm();
			});
		});
	};
	
	$.fn.qodx_contact_form = function() {
		return this.each(function(){
			var form = $(this);
			
			if (form.length) {
				
				form.submit(function(e) {
					if (!e.isDefaultPrevented()) {
							
						var formValues = form.serialize();
						
						form.find('button').addClass('add-spin');
							
						$.post(this.action, formValues.replace("(at)", "@"), function (response) {
							
							/* Form Message
							--------------------------------------------------------- */
							if (!$('.form-message-block').length) {
								$('body').append('<div class="form-message-block"><div class="form-message-container"></div><button type="button" class="form-message-close-button"><i class="fa fa-times"></i></button></div>');
							}
							$('.form-message-container').html(response);
							$('.form-message-block').fadeIn(100).css({bottom: '24px'});
		
							/* Handle Errors
							--------------------------------------------------------- */
							
							/* ----- Name ----- */
							if (response.match('error-name') !== null) {
								form.find('.contact-name').next().addClass('error');
								form.find('button').removeClass('add-spin');
							}
												
							/* ----- Email ----- */
							if (response.match('error-email') !== null) {
								form.find('.contact-email').next().addClass('error');
								form.find('button').removeClass('add-spin');
							}
		
							/* ----- Subject ----- */
							if (response.match('error-subject') !== null) {
								form.find('.contact-subject').next().addClass('error');
								form.find('button').removeClass('add-spin');
							}
							
							/* ----- Phone ----- */
							if (response.match('error-phone') !== null) {
								form.find('.contact-phone').next().addClass('error');
								form.find('button').removeClass('add-spin');
							}
							
							/* ----- Website ----- */
							if (response.match('error-website') !== null) {
								form.find('.contact-website').next().addClass('error');
								form.find('button').removeClass('add-spin');
							}
							
							/* ----- Country ----- */
							if (response.match('error-country') !== null) {
								form.find('.contact-country').next().addClass('error');
								form.find('button').removeClass('add-spin');
							}
							
							/* ----- City ----- */
							if (response.match('error-city') !== null) {
								form.find('.contact-city').next().addClass('error');
								form.find('button').removeClass('add-spin');
							}
							
							/* ----- Company ----- */
							if (response.match('error-company') !== null) {
								form.find('.contact-company').next().addClass('error');
								form.find('button').removeClass('add-spin');
							}
		
							/* ----- Message ----- */
							if (response.match('error-message') !== null) {
								form.find('.contact-message').next().addClass('error');
								form.find('button').removeClass('add-spin');
							}	
							
							/* Terms
							----------------------------------------------------- */
							if (response.match('error-terms') !== null) {
								form.find('.contact-terms').next().addClass('error');
								form.find('button').removeClass('add-spin');
							}	
										
							/* Captcha
							----------------------------------------------------- */
							if (response.match('error-captcha') !== null) {
								form.find('button').removeClass('add-spin');
							}	
									
							/* Success
							--------------------------------------------------------- */
							if (response.match('success-message') !== null) {
				
								form.find('.form-control').val('').removeClass('input-filled');
		
								form.find('button').removeClass('add-spin');
		
								form.find('.contact-terms').attr('checked', false);
								form.find('.contact-terms').attr('value', 'accepted');
								form.find('.contact-terms').next().removeClass('error');
							}
						});
						e.preventDefault();
					}
				});				
		
				form.find('.form-control').on('focus', function () {
					$(this).next().removeClass('error');
					dismissFormMessagefn();
				});
		
			}
			
		});
	};
	
	/* Progress Bars Animations
	   --------------------------------------------------------- */	
	   	
	$.fn.qodx_sc_progress_bars = function() {
		return this.each(function(i) {
			
			var element      = $(this),
				progress_bar = element.find('.vc_bar'),
				percentage   = progress_bar.data('percentage-value'),
				
				qodx_progress_bars = function() {
														
					progress_bar.css({'width':'0%', 'visibility':'visible'});
					setTimeout(function(){ 
						progress_bar.css({
							width: percentage+'%'
						});
					}, i * 200 );
						
				};
				
			if($().waypoint) { // if animations are enabled
				element.on('qodx_start_animation', function() { qodx_progress_bars(); });
			} else {
				qodx_progress_bars();
			}
		});
	};
			
	/* Counters
	   --------------------------------------------------------- */	
	   
	$.fn.qodx_sc_counters = function() {
		return this.each(function() {
			var container = $(this),
				percent   = container.data('percent'),
				target    = container.find('.qodx_stat_count'),			
				
				qodx_counters = function() {
					if ( $().countTo ) {
						target.delay(6000).countTo({
							from: 0,
							to: percent,
							speed: 3000,
							refreshInterval: 50
						});
					}
				};
				
			if($().waypoint) { // if aniamtions are enabled	
				container.on('qodx_start_animation', function() { qodx_counters(); });
			} else {
				qodx_counters();
			}
		});
	};
	
	/* Pie Charts
	   --------------------------------------------------------- */	
	   
	$.fn.qodx_sc_pie_charts = function() {
		return this.each(function() {
			var container   = $(this),
			    animDelay   = container.data('animation-delay'),      
				target      = container.find('.qodx_pie_percentage'),	
				
				//percent     = target.data('percent'),
				//size        = target.data('size'),
				track_color = target.data('track_color'),
				bar_color   = target.data('bar_color'),
				line_width  = target.data('line_width'),
				animate     = target.data('animate'),
				line_cap    = target.data('line_cap'),
				
				qodx_pie_charts = function() {
					if ( $().easyPieChart ) {
						target.easyPieChart({
							barColor    : bar_color,
							trackColor  : track_color,
							size        : 130,
							trackWidth  : line_width,
							lineWidth   : line_width,
							lineCap     : line_cap,
							scaleColor  : false,
							scaleLength : false,
							rotate      : 0,
							animate     : animate,
							// easing      : 'easeOutBounce',
							onStart     : function(from, to) {
								$(this.el).find('.qodx_pie_unit').css('visibility', 'visible');
							},
							onStep      : function(from, to, percent) {
								$(this.el).find('.qodx_pie_percent').text(Math.round(percent));
							}
						});
					}
				};
				
			if($().waypoint) { // if aniamtions are enabled				
				container.on('qodx_start_animation', function() {
					if (animDelay) { 
						setTimeout( function(){ qodx_pie_charts(); }, animDelay );
					} else {
						qodx_pie_charts(); 
					}
				});
			} else {
				qodx_pie_charts();
			}
		});
	};
	
	/* Bx Slider
	   --------------------------------------------------------- */	
		
	$.fn.qodx_sc_bx_slider = function() {
		return this.each(function() {
			var $bxslider = $(this),
				_initBxslider;
		
			if( $bxslider.length ) {
				_initBxslider = function initBxslider( bxsliders ) {
					bxsliders.each(function() {
						var $this  = $(this),
							$customNav = $this.data('bx-customnav');
						function bxslider() {									
							$this.bxSlider({
								adaptiveHeight: true,
								pagerCustom : $customNav ? "#"+$this.data('bxcustomnav') : null,
								auto        : $this.data('bx-autoplay'),
								autoHover   : true,
								pager       : $this.data('bx-pagernav'),
								pause       : $this.data('bx-pause'),
								mode        : $this.data('bx-mode'),
								controls    : $this.data('bx-controlnav'),
								nextText    : '',
								prevText    : '',
								speed       : $this.data('bx-speed'),
								easing      : $this.data('bx-easing')
							});
						}
						
						bxslider();
					});
				};
				_initBxslider( $bxslider );		
			}		
		});
	};
	
	/* Owl Carousel
	   --------------------------------------------------------- */	
	   
	$.fn.qodx_sc_owl_carousel = function() {
		return this.each(function() {
			var $carousel = $(this),
				_initCarousel;
	
			if( $carousel.length ) {
				_initCarousel = function initCarousel( carousels ) {
					carousels.each(function() {
						var $this  = $(this),							
							$transition_style = $this.data('owl-transitionstyle');
						
						function carousel() {									
							$this.owlCarousel({								
								slideSpeed        : $this.data('owl-speed'), 
								paginationSpeed   : $this.data('owl-pagspeed'), 
								autoPlay          : $this.data('owl-autoplay'),
								stopOnHover       : $this.data('owl-stoponhover'),								
								transitionStyle   : $transition_style ? $transition_style : false,
								items             : $this.data('owl-items'),								
								itemsCustom       : [ [0,    $this.data('owl-itemsmobilesmall')],  // under 360px browser width
								                      [360,  $this.data('owl-itemsmobile')],       // beteween 360px and 480px browser width
								                      [480,  $this.data('owl-itemstablet')],       // beteween 480px and 768px browser width
													  [768,  $this.data('owl-itemssmalldesktop')], // beteween 768px and 960px browser width
													  [960,  $this.data('owl-itemsdesktop')],      // beteween 960px and 1170px browser width
													  [1170, $this.data('owl-items')] ],           // above 1170px browser width
													  
								navigation        : $this.data('owl-navigation'),
								pagination        : $this.data('owl-pagination'),
								navigationText    : false								
							});
							
							// Carousel Custom Navigation
							$(".qodx_owl_prev").click(function(){
								$this.trigger('owl.next');
							})
							
							$(".qodx_owl_next").click(function(){
								$this.trigger('owl.next');
							})
						}
						
						carousel();
					});
				};
				_initCarousel( $carousel );		
			}	
		});
	};
	
	/* Parallax
	   --------------------------------------------------------- */	
	   
	$.fn.qodx_sc_parallax = function() {
		return this.each(function() {
			var $parallax = $(this),
				container = $('html');
				
			$(window).bind('load', function () {
				if (!container.hasClass('qodx_mobile')) {	
					$parallax.parallax("50%", "0.5");
				}
			});
			
		});
	};
	
	
	
	// -------------------------------------------------------------------------------------------
	// LUNE THEME FUNCTIONS START
	// -------------------------------------------------------------------------------------------
	
	/* Swiper Slider
	   --------------------------------------------------------- */	
	   
	$.fn.qodx_sc_swiper_slider = function() {
		return this.each(function() {
			var win      = $(window),
				$this    = $(this),
				initSlider;
	
			if( $this.length ) {
				initSlider = function initSlider() {
					
					var winWidth = win.outerWidth(true),
						slideLoop,
						slideAnimationEffect,
						sliderDirection,
                		centeredSlidesItems,
						slideItemsPerView,
						slideItemsMDPerView,
						slideItemsSMPerView,
						slideItemsXSPerView,
						slideItemsPerCol,
						slidePagination,
						slideNavNext,
						slideNavPrev;
						
					 // Slider, Pagination and Arrows IDs
					slidePagination = $this.find('.swiper-pagination');
					slideNavNext    = $this.find('.swiper-button-next');
					slideNavPrev    = $this.find('.swiper-button-prev');
					
					// Thumbs
					if ($this.hasClass('thumbs-swiper-slider')) {
						$this.parent('.qodx_swiper_slider_sc').addClass('custom-swiper-slide');
						$this.find('.swiper-pagination').addClass('swiper-pagination-thumbs').removeClass('swiper-pagination');
						$this.find('.swiper-pagination-thumbs span:first').addClass('active-swiper-slide');
						$this.find('.swiper-pagination-thumbs span').each(function (slidesIndex) {
							$(this).attr('data-qodx-swiper-slide-to', slidesIndex + 1);
						});
						slidePagination = '';
					}					
					
					// Slide Loop	
					slideLoop = $this.data('swiper-loop');
					if (slideLoop === '' || slideLoop === undefined) {
						slideLoop = true; }						
					// console.log( $this.attr('id') + ' = ' + $this.data('swiper-loop') + ' is ' + typeof $this.data('swiper-loop') );										
					// slideLoop = (slideLoop == 'true'); // set string to boolean				
																				
					// Direction			 
					sliderDirection = $this.hasClass('vertical-swiper-slider')
						? 'vertical'
						: 'horizontal';
						
					// Centerd Items
					centeredSlidesItems = $this.hasClass('center-swiper-slider')
						? !0
						: !1;
					
					// Effect ( fade/slide )
					slideAnimationEffect = $this.hasClass('fade-swiper-slider')
						? 'fade'
						: 'slide';
						
					// Effect ( coverflow )	- do not move this block code, it should be before horizontal statement
					if ( $this.hasClass('coverflow-swiper-slider') ) {
						if (winWidth < 1024) {
							$this.removeClass('swiper-container-3d');
							$this.find('.swiper-slide').css({transform: 'rotateY(0)'});
							slideItemsPerView    = 2;
							slideAnimationEffect = 'slide';														
						} else {
							slideAnimationEffect = 'coverflow';
						}
					}
										
					// Slide Items Per View ( on Large screen )		
					slideItemsPerView = $this.data('swiper-items');
					if (slideItemsPerView === '' || slideItemsPerView === undefined) {
						slideItemsPerView = 1; }
					
					// Slide Items Per View ( on small descktops )	
					slideItemsMDPerView = $this.data('swiper-md-items');						
					if (slideItemsMDPerView === '' || slideItemsMDPerView === undefined) {
						slideItemsMDPerView = 2; }
					
					// Slide Items Per View ( on small tablets )		
					slideItemsSMPerView = $this.data('swiper-sm-items');
					if (slideItemsSMPerView === '' || slideItemsSMPerView === undefined) {
						slideItemsSMPerView = 2; }
					
					// Slide Items Per View ( on small mobiles )		
					slideItemsXSPerView = $this.data('swiper-xs-items');
					if (slideItemsXSPerView === '' || slideItemsXSPerView === undefined) {
						slideItemsXSPerView = 1; }						
					
					// Slide Items Per Column		
					slideItemsPerCol = $this.data('swiper-slides-col');
					if (slideItemsPerCol === '' || slideItemsPerCol === undefined) {
						slideItemsPerCol = 1; }	
											
					if (sliderDirection === 'horizontal') {
						if (winWidth < 401) {
							slideItemsPerView = 1;
						} else if (winWidth < 601) {
							slideItemsPerView = slideItemsXSPerView;
						} else if (winWidth < 768) {
							slideItemsPerView = slideItemsSMPerView;
						} else if (winWidth < 1024) {
							slideItemsPerView = slideItemsMDPerView;
						}
					} else {
						slideItemsPerView = 1;
					}					
										
					function slider() {									
						$this.swiper({
							loop                         : slideLoop,
							speed                        : 800,
							coverflow                    : {
								depth   : 120,
								rotate  : -30,
								stretch : 10
							},
							autoplay                     : disable_autoplay ? 0 : $this.data('swiper-autoplay'),
							paginationClickable          : true,
							effect                       : slideAnimationEffect,
							direction                    : sliderDirection,
							slidesPerView                : slideItemsPerView,
							slidesPerColumn              : slideItemsPerCol,
							grabCursor                   : $this.data('swiper-grab-cursor'),
							simulateTouch                : $this.data('swiper-simulate-touch'),
							centeredSlides               : centeredSlidesItems,
							autoplayDisableOnInteraction : false,
                			pagination                   : slidePagination,
							nextButton                   : slideNavNext,
							prevButton                   : slideNavPrev
						});
												
						// Hover
						$this.on({
							mouseenter: function () {
								$(this)[0].swiper.stopAutoplay();
							},
							mouseleave: function () {
								$(this)[0].swiper.startAutoplay();
							}
						});
						
					}
					slider();					
					
					// Equal height for horizontal sliders with overlay content
					/*
					if (sliderDirection === 'horizontal' && $this.hasClass('swiper-equal-height')) {
						$this.css({height: '100%'});
						$this.css({height: $this.find('.swiper-wrapper').outerHeight(true)});
						if ($this.height() === 0 || $this.height() < 21) {
							$this.css({height: '100%'});
						}
					}
					*/
				};
				
				win.on("smartresize", function() {				
					$this[0].swiper.destroy();								
					initSlider();
				});							
				initSlider();
			}	
		});
	};
	
	/* Slider Height Function
    ------------------------------------------------------------------------- */
    function swiperSliderHeightfn() {
        $('.swiper-container-horizontal').each(function () {
            var el = $(this);
			if (el.hasClass('swiper-equal-height')) {
				el.css({height: '100%'});
				el.css({height: el.find('.swiper-wrapper').outerHeight(true)});
				if (el.height() === 0 || el.height() < 21) {
					el.css({height: '100%'});
				}
			}
        });
    }
			
	/* Swipe to Slide Funcrion
    ------------------------------------------------------------------------- */	
    function swipToSlidefn() {
		// if users click on thumbs
        $('> :first-child', '[data-qodx-swiper-slide-to]').on('click', function () {
            var el          = $(this),
                elParent    = el.parent(),
                swipToSlide = elParent.attr('data-qodx-swiper-slide-to'),
                sliderID    = '#' + el.parents('.custom-swiper-slide').find('.qodx-swiper-slider').attr('id');
								
            if ( $(sliderID)[0] !== undefined ) {
                el.parents('.custom-swiper-slide').find('.active-swiper-slide').removeClass('active-swiper-slide');
                elParent.addClass('active-swiper-slide');
                $(sliderID)[0].swiper.slideTo(swipToSlide, 500, false);
            }
        });
		
		// if users drag the slides or click on navigation buttons
        if ($('[data-qodx-swiper-slide-to]').length) {
            $('[data-qodx-swiper-slide-to]').parents('.custom-swiper-slide').find('.qodx-swiper-slider').each(function () {

                var el = $(this),
                    sliderID = '#' + el.attr('id'),
                    elParents = $(sliderID).parents('.custom-swiper-slide');
					
                elParents.find('.active-swiper-slide').removeClass('active-swiper-slide');
                elParents.find('[data-qodx-swiper-slide-to="1"]').addClass('active-swiper-slide');

                $(sliderID)[0].swiper.on('slideChangeStart', function () {

                    var slideIndex = $(sliderID)[0].swiper.activeIndex,
                        swipToSlideLength = elParents.find('[data-qodx-swiper-slide-to]').length;

                    elParents.find('.active-swiper-slide').removeClass('active-swiper-slide');
                    elParents.find('[data-qodx-swiper-slide-to="' + slideIndex + '"]').addClass('active-swiper-slide');

                    if (slideIndex > swipToSlideLength) {
                        elParents.find('[data-qodx-swiper-slide-to="1"]').addClass('active-swiper-slide');
                    }
                    if (slideIndex < 1) {
                        elParents.find('[data-qodx-swiper-slide-to="' + swipToSlideLength + '"]').addClass('active-swiper-slide');
                    }

                });

            });
        }
    };
	
	/* Select
    ------------------------------------------------------------------------- */	
	function qodxSelectfn() {
		$('select.qodx-select').each(function (index) {
			$(this).attr('id', 'qodx-select-' + index);
			$('#qodx-select-' + index).qodxSelect();	
		});
	};
	
	/* Blocks Height
    ------------------------------------------------------------------------- */
	function qodxMatchHeightfn() {
		$('.content-block:not(.content-block-style-2)').each(function () {
            $(this).closest('.equal-height-blocks').find('.content-block-container').matchHeight();
        });
		
		$('.team-block').each(function () {
            //$(this).parent().find('.team-block-container').matchHeight();
        });

        $('.portfolio-block:not(.isotope-item)').each(function () {
            //$(this).parent().find('.portfolio-block-container').matchHeight();
        });
		
		$('.testimonials-block').each(function () {
            $(this).closest('.equal-height-blocks').find('.testimonials-block-container').matchHeight();
        });
		
		$('.pricing-block').each(function () {
            $(this).closest('.pricing-tables-wrapper').find('.pricing-block-container').matchHeight();
        });
		
		$('.contact-block').each(function () {
            $(this).parent().find('.contact-block-container').matchHeight();
        });
    }
	
	/* Dismiss Form Message
    ------------------------------------------------------------------------- */
    function dismissFormMessagefn() {
        $('.form-message-block').css({bottom: '-20%'}).fadeOut(300, function () {
            $(this).remove();
        });
    }
		
		
	/* GFort Ripple Animation
    ------------------------------------------------------------------------- */
	function qodxRippleAnimationfn(xAxes, yAxes) {

        $('.qodx-ripple').remove();

        var rippleTopPosition,
            rippleLeftPosition,
            el = $('.qodx-ripple-animation'),
            elPosTop = el.offset().top,
            elPosLeft = el.offset().left,
            elouterWidth = el.outerWidth(),
            elouterHeight = el.outerHeight();

        el.prepend('<span class="qodx-ripple"></span>');

        if (elouterWidth >= elouterHeight) {
            elouterHeight = elouterWidth;
        } else {
            elouterWidth = elouterHeight;
        }

        rippleLeftPosition = xAxes - elPosLeft - elouterWidth / 2;
        rippleTopPosition = yAxes - elPosTop - elouterHeight / 2;

        $('.qodx-ripple').css({
            width: elouterWidth,
            height: elouterHeight,
            top: rippleTopPosition + 'px',
            left: rippleLeftPosition + 'px'
        }).addClass('ripple-animation');

    }
	
	
    /* -------------------------------------------------------------------------
    Video
    ------------------------------------------------------------------------- */
    /* Background Video
    ------------------------------------------------------------------------- */
    /* Main Function
    ------------------------------------------------------------------------- */
    function backgroundVideofn() {
        $('.background-video-block video').each(function () {

            var elWidth = 16,
                elHeight = 9,
                el = $(this),
                elParent = el.parent(),
                parentWidth = elParent.outerWidth(true),
                parentHeight = elParent.outerHeight(true),
                widthRatio = parentWidth / elWidth,
                heightRatio = parentHeight / elHeight,
                ratio = widthRatio > heightRatio
                    ? widthRatio
                    : heightRatio,
                elNewWidth = ratio * elWidth,
                elNewHeight = ratio * elHeight,
                elMarginLeft = (elNewWidth - parentWidth) / -2,
                elMarginTop = (elNewHeight - parentHeight) / -2;

            el.css({
                width: elNewWidth,
                height: elNewHeight,
                marginTop: elMarginTop,
                marginLeft: elMarginLeft
            });

        });
    }

    /* Resize Window
    ------------------------------------------------------------------------- */
    $(window).resize(function () {
        backgroundVideofn();
    });

    /* Buttons
    ------------------------------------------------------------------------- */
    $('.background-video-block').each(function (index) {

        var el = $(this);
        el.find('video').attr('id', 'qodx-bg-video-' + index);

        if (el.find('video[autoplay]').length) {
            el.find('.video-overlayer').remove();
            el.find('button.play-button').html('<i class="fa fa-pause"></i>');
        } else {
            el.find('button.play-button').html('<i class="fa fa-play"></i>');
        }

        if (el.find('video[muted]').length) {
            el.find('button.mute-button').html('<i class="fa fa-volume-off"></i>');
        } else {
            el.find('button.mute-button').html('<i class="fa fa-volume-up"></i>');
        }

    });

    /* Play, Pause and Mute Buttons
    ------------------------------------------------------------------------- */
    $('.background-video-block button').on('click', function () {

        var el = $(this),
            videoOverlayer = el.parents('.background-video-block').find('.video-overlayer'),
            videoID = $('#' + el.parents('.background-video-block').find('video').attr('id'))[0];

        if (el.hasClass('play-button')) {
            if (videoID.paused) {
                videoID.play();
                videoOverlayer.css({display: 'none'});
                el.html('<i class="fa fa-pause"></i>');
            } else {
                videoID.pause();
                el.html('<i class="fa fa-play"></i>');
            }
        }

        if (el.hasClass('mute-button')) {
            if (videoID.muted) {
                videoID.muted = false;
                el.html('<i class="fa fa-volume-up"></i>');
            } else {
                videoID.muted = true;
                el.html('<i class="fa fa-volume-off"></i>');
            }
        }

    });

    /* Condition
    ------------------------------------------------------------------------- */
    if ($('.background-video-block').length) {
        backgroundVideofn();
    }


    /* Twitter Feed
    ------------------------------------------------------------------------- */
	
	$.fn.qodx_sc_twitter = function() {
		return this.each(function() {
			var $this = $(this);
	
			$this.twittie({
				count      : $this.data('count'),
				dateFormat : '%d %b %Y',
				username   : $this.data('username'),
				loadingText: 'Loading ...',
				apiPath    : qodx_plugin_uri + '/shortcodes/includes/tweetie/api/tweet.php',
				template: '<div class="twitter-avatar"><a href="https://twitter.com/{{user_name}}" title="{{user_name}}" target="_blank">{{avatar}}</a><span><a class="twitter-avatar-link" href="https://twitter.com/{{user_name}}" title="{{user_name}}" target="_blank">@{{user_name}}</a></span></div><div class="twitter-tweet"><p>{{tweet}}</p></div><div class="twitter-date-buttons"><div class="twitter-date"><a href="{{url}}" target="_blank">{{date}}</a></div><div class="twitter-buttons"><a href="https://twitter.com/intent/tweet?in_reply_to={{tweet_id}}" title="Reply" target="_blank"><i class="fa fa-reply"></i><span>Reply</span></a><a href="https://twitter.com/intent/retweet?tweet_id={{tweet_id}}" title="Retweet" target="_blank"><i class="fa fa-retweet"></i><span>Retweet</span></a><a href="https://twitter.com/intent/favorite?tweet_id={{tweet_id}}" title="Favourite" target="_blank"><i class="fa fa-star"></i><span>Favourite</span></a></div></div><div class="twitter-follow"><a href="https://twitter.com/intent/follow?original_referer=&screen_name='+$this.data('username')+'" target="_blank" class="btn btn-qodx wave-effect"><i class="fa fa-twitter"></i><span>Follow</span></a></div>'
			}, function () {
	
				/* Slider
				----------------------------------------------------------------- */
				if ($this.hasClass('twitter-slider')) {
					
					var slidePagination;	
	
					/* Replace ul and li with slider divs
					--------------------------------------------------------- */
					$this.find('ul.qodx-twitter-list').wrap('<div class="swiper-wrapper"/>').contents().unwrap();
					$this.find('li.qodx-twitter-item').each(function () {
						$(this).wrap('<div class="swiper-slide"><div class="qodx-twitter-item"></div></div>').contents().unwrap();
					});

					/* Pagination
					--------------------------------------------------------- */
					$this.append('<div class="swiper-pagination"></div>');
					slidePagination = $this.find('.swiper-pagination');

					/* Slider Configurations
					--------------------------------------------------------- */
					$this.swiper({
						loop: true,
						speed: 800,
						autoplay: 5000,
						effect: 'slide',
						slidesPerView: 1,
						grabCursor: false,
						simulateTouch: false,
						centeredSlides: false,
						direction: 'horizontal',
						paginationClickable: true,
						autoplayDisableOnInteraction: false,
						pagination: slidePagination
					});

					/* Hover
					----------------------------------------------------------------- */
					$this.on({
						mouseenter: function () {
							$(this)[0].swiper.stopAutoplay();
						},
						mouseleave: function () {
							$(this)[0].swiper.startAutoplay();
						}
					});	
	
				}
			});
			
		});
	};
			
	// -------------------------------------------------------------------------------------------
	// LUNE THEME FUNCTIONS END
	// -------------------------------------------------------------------------------------------
	
		
	// -------------------------------------------------------------------------------------------
	// HELPER FUNCTIONS
	// -------------------------------------------------------------------------------------------
	
			
	/* Equal Height Functions
	   --------------------------------------------------------- */	
	$.fn.equalHeight = function() {
		var tallest = 0;
		$(this).each(function(){
			var thisHeight = $(this).height();
			if (thisHeight > tallest) { tallest = thisHeight; }
		});
		$(this).height(tallest);
	};
	
	$.fn.equalHeights = function() {
		$(this).each(function(){
			var currentTallest = 0;
			$(this).children().each(function(){
				if ($(this).outerHeight() > currentTallest) { currentTallest = $(this).outerHeight(); }
			});
			$(this).children().css({'min-height': currentTallest}); 
		});
		return this;
	};
	
	/* Waypoint script when the elements appear into viewport
		( place this function after others animation functions )
	   --------------------------------------------------------- */	
	   
	$.fn.qodx_waypoints = function(opts)	{		
		
		if(!$('html').is('.csstransforms')) return;
		
		var defaults = { offset: 'bottom-in-view'},
			options  = $.extend({}, defaults, opts);
		
		return this.each(function() {			
			
			var element = $(this);
					
			setTimeout(function() {
				element.waypoint(function() {
					// handler option is provided as the first paramter
					element.addClass('qodx_was_animated').trigger('qodx_start_animation');						
					this.disable();	// trigger waypoint only once
				}, options );
		
			},100);
							
		});
	};

})(jQuery); // End