<?php
	if (function_exists('vc_add_param')) {
		
		// Row QODX_VC Extensions
		vc_add_param("vc_row", array(
			'type'              			=> 'qodx_separator',
			'heading'           			=> '',
			'param_name'        			=> 'separator',
			'value'	      					=> '',
			'separator'	  					=> 'Background Extended Settings',
			'description'       			=> '',
			'group' 						=> esc_html__( 'QODX_VC Extensions', 'qodux_fw' ),
		));
		vc_add_param("vc_row", array(
			'type'                          => 'textfield',
			'heading'                       => esc_html__( 'Extra Unique ID name', 'qodux_fw' ),
			'param_name'                    => 'el_id',
			'description'                   => esc_html__( 'If you wish to style particular content element differently, then use this field to add a UNIQUE ID name and then refer to it in your css file.', 'qodux_fw' )
		));
		vc_add_param("vc_row", array(
			'type'                  		=> 'qodx_range',
			'heading'               		=> esc_html__( 'Minimum Height', 'qodux_fw' ),
			'param_name'            		=> 'min_height',
			'value'                 		=> '0',
			'min'                   		=> '0',
			'max'                   		=> '2048',
			'step'                  		=> '1',
			'unit'                  		=> 'px',
			'description'           		=> esc_html__( 'Define the minimum height for this row.', 'qodux_fw' ),
			'group' 						=> esc_html__( 'QODX_VC Extensions', 'qodux_fw' ),
		));
		vc_add_param( "vc_row", array(
			'type'							=> 'checkbox',
			'class'							=> '',
			'heading'						=> esc_html__( 'Center Row Content?', 'qodux_fw' ),
			'param_name'					=> 'center_row',
			'value'							=> Array( esc_html__( 'Yes please.', 'qodux_fw' ) => 'yes'),
			/*'std'                           => 'yes',*/
			'description'           		=> esc_html__( 'Use this option to horizontally center the inner content of this row. <strong>Useful when using pages based on \'Full Screen\' templates.</strong>', 'qodux_fw' ),
			'group' 						=> esc_html__( 'QODX_VC Extensions', 'qodux_fw' )
		));
		vc_add_param( "vc_row", array(
			'type'							=> 'checkbox',
			'class'							=> '',
			'heading'						=> esc_html__( 'Full Screen Width on Mobiles?', 'qodux_fw' ),
			'param_name'					=> 'full_mobile_row',
			'value'							=> Array( esc_html__( 'Yes please.', 'qodux_fw' ) => 'yes'),
			'description'           		=> esc_html__( 'Use this option to keep full width content of this row on mobiles. <strong>Useful when using pages based on \'Full Screen\' templates.</strong>', 'qodux_fw' ),
			'group' 						=> esc_html__( 'QODX_VC Extensions', 'qodux_fw' )
		));
		vc_add_param( "vc_row", array(
			'type'							=> 'checkbox',
			'heading'						=> esc_html__( 'Default Background?', 'qodux_fw' ),
			'param_name'					=> 'default_bg',
			'value'							=> Array( esc_html__( 'Yes please.', 'qodux_fw' ) => 'yes'),
			'description'           		=> esc_html__( 'Check this option to add a default background color.', 'qodux_fw' ),
			'group' 						=> esc_html__( 'QODX_VC Extensions', 'qodux_fw' )
		));	
		vc_add_param( "vc_row", array(
			'type'							=> 'checkbox',
			'heading'						=> esc_html__( 'Default Skin Background?', 'qodux_fw' ),
			'param_name'					=> 'default_skin_bg',
			'value'							=> Array( esc_html__( 'Yes please.', 'qodux_fw' ) => 'yes'),
			'description'           		=> esc_html__( 'Check this option to add a default skin background color.', 'qodux_fw' ),
			'group' 						=> esc_html__( 'QODX_VC Extensions', 'qodux_fw' )
		));	
		vc_add_param( "vc_row", array(
			'type'							=> 'checkbox',
			'heading'						=> esc_html__( 'Default Border?', 'qodux_fw' ),
			'param_name'					=> 'default_border',
			'value'							=> Array( esc_html__( 'Yes please.', 'qodux_fw' ) => 'yes'),
			'description'           		=> esc_html__( 'Check this option to add a default border.', 'qodux_fw' ),
			'group' 						=> esc_html__( 'QODX_VC Extensions', 'qodux_fw' )
		));
		vc_add_param( "vc_row", array(
			'type'							=> 'checkbox',
			'heading'						=> esc_html__( 'Drop Shadow?', 'qodux_fw' ),
			'param_name'					=> 'shadow',
			'value'							=> Array( esc_html__( 'Yes please.', 'qodux_fw' ) => 'yes'),
			'description'           		=> esc_html__( 'Check this option to add a default shadow to this row.', 'qodux_fw' ),
			'group' 						=> esc_html__( 'QODX_VC Extensions', 'qodux_fw' )
		));
		vc_add_param("vc_row", array(
			'type' 							=> 'dropdown',
			'heading' 						=> esc_html__( 'Typography Style', 'qodux_fw' ),
			'param_name' 					=> 'typography',
			'value' 						=> array(
				esc_html__( 'Dark Text', 'qodux_fw' )		=> 'dark',
				esc_html__( 'White Text', 'qodux_fw' )	=> 'light'
			),
			'description' 					=> esc_html__( 'Select typography style.', 'qodux_fw' ),
			'group' 						=> esc_html__( 'QODX_VC Extensions', 'qodux_fw' ),
		));
		vc_add_param("vc_row", array(
			'type'                          => 'colorpicker',
			'heading'                       => esc_html__( 'Background Color', 'qodux_fw' ),
			'param_name'                    => 'bck_color',
			'description'                   => esc_html__( 'Select background color for this row.', 'qodux_fw' ),
			'group' 						=> esc_html__( 'QODX_VC Extensions', 'qodux_fw' )
		));	
		vc_add_param("vc_row", array(
			'type' 							=> 'dropdown',
			'heading' 						=> esc_html__( 'Background Type', 'qodux_fw' ),
			'param_name' 					=> 'bg_type',
			'value' 						=> array(
				esc_html__( 'None', 'qodux_fw' )					=> '',
				esc_html__( 'Simple Image', 'qodux_fw' )			=> 'image',
				esc_html__( 'Fixed Image', 'qodux_fw' )			=> 'fixed',
				esc_html__( 'Parallax Image', 'qodux_fw' )		=> 'parallax',
				esc_html__( 'YouTube Video', 'qodux_fw' )			=> 'youtube',
				esc_html__( 'HTML5 Video', 'qodux_fw' )			=> 'html_video',
			),
			'admin_label' 					=> true,
			'description' 					=> esc_html__( 'Select background type for this row.', 'qodux_fw' ),
			'group' 						=> esc_html__( 'QODX_VC Extensions', 'qodux_fw' ),
		));
		vc_add_param("vc_row", array(
			'type'							=> 'attach_image',
			'heading'						=> esc_html__( 'Background Image', 'qodux_fw' ),
			'param_name'					=> 'bck_image',
			'value'							=> '',
			'description'					=> esc_html__( 'Select the background image for your row.', 'qodux_fw' ),
			'dependency' 					=> array(
				'element' 	=> 'bg_type',
				'value' 	=> array('image', 'fixed', 'parallax')
			),
			'group' 						=> esc_html__( 'QODX_VC Extensions', 'qodux_fw' ),
		));
		vc_add_param("vc_row", array(
			'type'                  		=> 'dropdown',
			'heading'               		=> esc_html__( 'Background Image Size', 'qodux_fw' ),
			'param_name'            		=> 'bg_size',
			'value'                 		=> array(
				esc_html__( 'Full Size Image', 'qodux_fw' )			=> 'full',
				esc_html__( 'Large Size Image', 'qodux_fw' )			=> 'large',
				esc_html__( 'Medium Size Image', 'qodux_fw' )		=> 'medium',
				esc_html__( 'Thumbnail Size Image', 'qodux_fw' )		=> 'thumbnail',
			),
			'description'           		=> esc_html__( 'Select which image size based on WordPress settings should be used.', 'qodux_fw' ),
			'dependency' 					=> array(
				'element' 	=> 'bg_type',
				'value' 	=> array('image', 'fixed', 'parallax')
			),
			'group' 						=> esc_html__( 'QODX_VC Extensions', 'qodux_fw' ),
		));
		vc_add_param("vc_row", array(
			'type' 							=> 'dropdown',
			'heading' 						=> esc_html__( 'Background Position', 'qodux_fw' ),
			'param_name' 					=> 'bg_position',
			'value' 						=> array(
				esc_html__( 'Top', 'qodux_fw' )			=> 'top',
				esc_html__( 'Middle', 'qodux_fw' ) 		=> 'center',
				esc_html__( 'Bottom', 'qodux_fw' ) 		=> 'bottom'
			),
			'description' 					=> '',
			'dependency' 					=> array(
				'element' 	=> 'bg_type',
				'value' 	=> array('image', 'fixed', 'parallax')
			),
			'group' 						=> esc_html__( 'QODX_VC Extensions', 'qodux_fw' ),
		));
		vc_add_param("vc_row", array(
			'type' 							=> 'dropdown',
			'heading' 						=> esc_html__( 'Background Size', 'qodux_fw' ),
			'param_name' 					=> 'bg_size_standard',
			'value' 						=> array(
				esc_html__( 'Cover', 'qodux_fw' ) 		=> 'cover',
				esc_html__( 'Contain', 'qodux_fw' ) 		=> 'contain',
				esc_html__( 'Initial', 'qodux_fw' ) 		=> 'initial',
				esc_html__( 'Auto', 'qodux_fw' ) 		=> 'auto',
			),
			'description' 					=> '',
			'dependency' 					=> array(
				'element' 	=> 'bg_type',
				'value' 	=> array('image', 'fixed', 'parallax')
			),
			'group' 						=> esc_html__( 'QODX_VC Extensions', 'qodux_fw' ),
		));
		vc_add_param("vc_row", array(
			'type' 							=> 'dropdown',
			'heading' 						=> esc_html__( 'Background Repeat', 'qodux_fw' ),
			'param_name' 					=> 'bg_repeat',
			'value' 						=> array(
				esc_html__( 'No Repeat', 'qodux_fw' )	=> 'no-repeat',
				esc_html__( 'Repeat X + Y', 'qodux_fw' )	=> 'repeat',
				esc_html__( 'Repeat X', 'qodux_fw' )		=> 'repeat-x',
				esc_html__( 'Repeat Y', 'qodux_fw' )		=> 'repeat-y'
			),
			'description' 					=> '',
			'dependency' 					=> array(
				'element' 	=> 'bg_type',
				'value' 	=> array('image', 'fixed', 'parallax')
			),
			'group' 						=> esc_html__( 'QODX_VC Extensions', 'qodux_fw' ),
		));
		
		// YouTube Video Background
		vc_add_param("vc_row", array(
			'type'              			=> 'textfield',
			'heading'           			=> esc_html__( 'YouTube Video ID', 'qodux_fw' ),
			'param_name'        			=> 'youtube_video_id',
			'value'             			=> '',
			'description'       			=> esc_html__( 'Enter the YouTube video ID.', 'qodux_fw' ),
			'dependency' 					=> array(
				'element' 	=> 'bg_type',
				'value' 	=> 'youtube'
			),
			'group' 						=> esc_html__( 'QODX_VC Extensions', 'qodux_fw' ),
		));
		vc_add_param( "vc_row", array(
			'type'							=> 'checkbox',
			'heading'						=> esc_html__( 'YouTube Video Controls?', 'qodux_fw' ),
			'param_name'					=> 'yt_video_controls',
			'value'							=> Array( esc_html__( 'Yes please.', 'qodux_fw' ) => 'yes'),
			'description'           		=> esc_html__( 'Check this option to add controls for youtube video.', 'qodux_fw' ),
			'dependency' 					=> array(
				'element' 	=> 'bg_type',
				'value' 	=> 'youtube'
			),
			'group' 						=> esc_html__( 'QODX_VC Extensions', 'qodux_fw' )
		));
		vc_add_param("vc_row", array(
			'type'							=> 'attach_image',
			'heading'						=> esc_html__( 'YouTube Background Image', 'qodux_fw' ),
			'param_name'					=> 'yt_video_bg_img',
			'value'							=> '',
			'description'					=> esc_html__( 'Select the youtube background image for your row. This is a placeholder for mobiles where the video doesn\'t work.', 'qodux_fw' ),
			'dependency' 					=> array(
				'element' 	=> 'bg_type',
				'value' 	=> 'youtube'
			),
			'group' 						=> esc_html__( 'QODX_VC Extensions', 'qodux_fw' ),
		));
		
		// HTML5 Video Background
		vc_add_param("vc_row", array(
			'type'              			=> 'textfield',
			'heading'           			=> esc_html__( 'HTML5 Mp4 Video Link', 'qodux_fw' ),
			'param_name'        			=> 'html_mp4',
			'value'             			=> '',
			'description'       			=> esc_html__( 'Enter the YouTube video ID.', 'qodux_fw' ),
			'dependency' 					=> array(
				'element' 	=> 'bg_type',
				'value' 	=> 'html_video'
			),
			'group' 						=> esc_html__( 'QODX_VC Extensions', 'qodux_fw' ),
		));
		vc_add_param("vc_row", array(
			'type'              			=> 'textfield',
			'heading'           			=> esc_html__( 'HTML5 Webm Video Link', 'qodux_fw' ),
			'param_name'        			=> 'html_wbm',
			'value'             			=> '',
			'description'       			=> esc_html__( 'Enter the YouTube video ID.', 'qodux_fw' ),
			'dependency' 					=> array(
				'element' 	=> 'bg_type',
				'value' 	=> 'html_video'
			),
			'group' 						=> esc_html__( 'QODX_VC Extensions', 'qodux_fw' ),
		));
		vc_add_param("vc_row", array(
			'type'							=> 'attach_image',
			'heading'						=> esc_html__( 'HTML5 Background Image', 'qodux_fw' ),
			'param_name'					=> 'html_video_bg_img',
			'value'							=> '',
			'description'					=> esc_html__( 'Select the youtube background image for your row. This is a placeholder for mobiles where the video doesn\'t work.', 'qodux_fw' ),
			'dependency' 					=> array(
				'element' 	=> 'bg_type',
				'value' 	=> 'html_video'
			),
			'group' 						=> esc_html__( 'QODX_VC Extensions', 'qodux_fw' ),
		));
		
		vc_add_param("vc_row", array(
			'type'                          => 'colorpicker',
			'heading'                       => esc_html__( 'Background Overlay Color', 'qodux_fw' ),
			'param_name'                    => 'bg_color_overlay',
			'description'                   => esc_html__( 'Select overlay color for this element.', 'qodux_fw' ),
			'group' 						=> esc_html__( 'QODX_VC Extensions', 'qodux_fw' )
		));	
		vc_add_param("vc_row", array(
			'type'                  		=> 'dropdown',
			'heading'               		=> esc_html__( 'Background Overlay Pattern', 'qodux_fw' ),
			'param_name'            		=> 'bg_pattern_overlay',
			'value'                 		=> array(
				esc_html__( 'None', 'qodux_fw' )			=> '',
				esc_html__( 'Dotted', 'qodux_fw' )		=> 'dotted',
				esc_html__( 'Dashed', 'qodux_fw' )		=> 'dashed',
			),
			'description'           		=> esc_html__( 'Select overlay pattern type for this element.', 'qodux_fw' ),
			'group' 						=> esc_html__( 'QODX_VC Extensions', 'qodux_fw' ),
		));
		vc_add_param("vc_row", array(
			'type'							=> 'colorpicker',
			'class'							=> '',
			'heading'						=> esc_html__( 'Border Color', 'qodux_fw' ),
			'param_name'					=> 'border_color',
			'value' 						=> '',
			'group' 						=> esc_html__( 'QODX_VC Extensions', 'qodux_fw' )
		));
		
		vc_add_param("vc_row", array(
			'type'							=> 'dropdown',
			'class'							=> '',
			'heading'						=> esc_html__( 'Border Style', 'qodux_fw' ),
			'param_name'					=> 'border_style',
			'value'							=> array(
				esc_html__( 'Solid', 'qodux_fw' )	=> 'solid',
				esc_html__( 'Dotted', 'qodux_fw' )	=> 'dotted',
				esc_html__( 'Dashed', 'qodux_fw' )	=> 'dashed',
			),
			'group' 						=> esc_html__( 'QODX_VC Extensions', 'qodux_fw' )
		));
		
		vc_add_param("vc_row", array(
			'type'							=> 'textfield',
			'class'							=> '',
			'heading'						=> esc_html__( 'Border Width', 'qodux_fw' ),
			'param_name'					=> 'border_width',
			'value'							=> '0px 0px 0px 0px',
			'description'					=> esc_html__( 'Your border width in pixels. Example: <strong>1px 1px 1px 1px</strong> (top, right, bottom, left).', 'qodux_fw' ),
			'group' 						=> esc_html__( 'QODX_VC Extensions', 'qodux_fw' )
		));	
		
		// Paddings & Margins
		vc_add_param("vc_row", array(
			'type'              			=> 'qodx_separator',
			'heading'           			=> '',
			'param_name'        			=> 'separator_2',
			'value'	      					=> '',
			'separator'	  					=> 'Paddings and Margins',
			'description'       			=> '',
			'group' 						=> esc_html__( 'QODX_VC Extensions', 'qodux_fw' ),
		));
		vc_add_param("vc_row", array(
			'type'                  		=> 'qodx_range',
			'heading'               		=> esc_html__( 'Padding: Top', 'qodux_fw' ),
			'param_name'            		=> 'padding_top',
			'value'                 		=> '0',
			'min'                   		=> '0',
			'max'                   		=> '250',
			'step'                  		=> '1',
			'unit'                  		=> 'px',
			'description'           		=> '',
			'group' 						=> esc_html__( 'QODX_VC Extensions', 'qodux_fw' ),
		));
		vc_add_param("vc_row", array(
			'type'                  		=> 'qodx_range',
			'heading'               		=> esc_html__( 'Padding: Bottom', 'qodux_fw' ),
			'param_name'            		=> 'padding_bottom',
			'value'                 		=> '0',
			'min'                   		=> '0',
			'max'                   		=> '250',
			'step'                  		=> '1',
			'unit'                  		=> 'px',
			'description'           		=> '',
			'group' 						=> esc_html__( 'QODX_VC Extensions', 'qodux_fw' ),
		));
		vc_add_param("vc_row", array(
			'type'                  		=> 'qodx_range',
			'heading'               		=> esc_html__( 'Padding: Left', 'qodux_fw' ),
			'param_name'            		=> 'padding_left',
			'value'                 		=> '0',
			'min'                   		=> '0',
			'max'                   		=> '250',
			'step'                  		=> '1',
			'unit'                  		=> 'px',
			'description'           		=> '',
			'group' 						=> esc_html__( 'QODX_VC Extensions', 'qodux_fw' ),
		));
		vc_add_param("vc_row", array(
			'type'                  		=> 'qodx_range',
			'heading'               		=> esc_html__( 'Padding: Right', 'qodux_fw' ),
			'param_name'            		=> 'padding_right',
			'value'                 		=> '0',
			'min'                   		=> '0',
			'max'                   		=> '250',
			'step'                  		=> '1',
			'unit'                  		=> 'px',
			'description'           		=> '',
			'group' 						=> esc_html__( 'QODX_VC Extensions', 'qodux_fw' ),
		));
		vc_add_param("vc_row", array(
			'type'                  		=> 'qodx_range',
			'heading'               		=> esc_html__( 'Margin: Top', 'qodux_fw' ),
			'param_name'            		=> 'margin_top',
			'value'                 		=> '0',
			'min'                   		=> '-250',
			'max'                   		=> '250',
			'step'                  		=> '1',
			'unit'                  		=> 'px',
			'description'           		=> '',
			'group' 						=> esc_html__( 'QODX_VC Extensions', 'qodux_fw' ),
		));
		vc_add_param("vc_row", array(
			'type'                  		=> 'qodx_range',
			'heading'               		=> esc_html__( 'Margin: Bottom', 'qodux_fw' ),
			'param_name'            		=> 'margin_bottom',
			'value'                 		=> '0',
			'min'                   		=> '-250',
			'max'                   		=> '250',
			'step'                  		=> '1',
			'unit'                  		=> 'px',
			'description'           		=> '',
			'group' 						=> esc_html__( 'QODX_VC Extensions', 'qodux_fw' ),
		));
		
		// Animations	
		vc_add_param("vc_row", array(
			'type'              			=> 'qodx_separator',
			'heading'           			=> '',
			'param_name'        			=> 'separator_3',
			'value'	      					=> '',
			'separator'	  					=> 'Animations',
			'description'       			=> '',
			'group' 						=> esc_html__( 'QODX_VC Extensions', 'qodux_fw' ),
		));	
		vc_add_param("vc_row", array(
			"type"                          => "dropdown",
			"heading"                       => esc_html__( "CSS WT Animation", 'qodux_fw' ),
			"param_name"                    => "css_animation",
			"value" => array( esc_html__( "No", 'qodux_fw' ) => '', esc_html__( "Hinge", 'qodux_fw' ) => "hinge", esc_html__( "Flash", 'qodux_fw' ) => "flash", esc_html__( "Shake", 'qodux_fw' ) => "shake", esc_html__( "Bounce", 'qodux_fw' ) => "bounce", esc_html__( "Tada", 'qodux_fw' ) => "tada", esc_html__( "Swing", 'qodux_fw' ) => "swing", esc_html__( "Wobble", 'qodux_fw' ) => "wobble", esc_html__( "Pulse", 'qodux_fw' ) => "pulse", esc_html__( "Flip", 'qodux_fw' ) => "flip", esc_html__( "FlipInX", 'qodux_fw' ) => "flipInX", esc_html__( "FlipOutX", 'qodux_fw' ) => "flipOutX", esc_html__( "FlipInY", 'qodux_fw' ) => "flipInY", esc_html__( "FlipOutY", 'qodux_fw' ) => "flipOutY", esc_html__( "FadeIn", 'qodux_fw' ) => "fadeIn", esc_html__( "FadeInUp", 'qodux_fw' ) => "fadeInUp", esc_html__( "FadeInDown", 'qodux_fw' ) => "fadeInDown", esc_html__( "FadeInLeft", 'qodux_fw' ) => "fadeInLeft", esc_html__( "FadeInRight", 'qodux_fw' ) => "fadeInRight", esc_html__( "FadeInUpBig", 'qodux_fw' ) => "fadeInUpBig", esc_html__( "FadeInDownBig", 'qodux_fw' ) => "fadeInDownBig", esc_html__( "FadeInLeftBig", 'qodux_fw' ) => "fadeInLeftBig", esc_html__( "FadeInRightBig", 'qodux_fw' ) => "fadeInRightBig", esc_html__( "FadeOut", 'qodux_fw' ) => "fadeOut", esc_html__( "FadeOutUp", 'qodux_fw' ) => "fadeOutUp", esc_html__( "FadeOutDown", 'qodux_fw' ) => "fadeOutDown", esc_html__( "FadeOutLeft", 'qodux_fw' ) => "fadeOutLeft", esc_html__( "FadeOutRight", 'qodux_fw' ) => "fadeOutRight", esc_html__( "fadeOutUpBig", 'qodux_fw' ) => "fadeOutUpBig", esc_html__( "FadeOutDownBig", 'qodux_fw' ) => "fadeOutDownBig", esc_html__( "FadeOutLeftBig", 'qodux_fw' ) => "fadeOutLeftBig", esc_html__( "FadeOutRightBig", 'qodux_fw' ) => "fadeOutRightBig", esc_html__( "BounceIn", 'qodux_fw' ) => "bounceIn", esc_html__( "BounceInUp", 'qodux_fw' ) => "bounceInUp", esc_html__( "BounceInDown", 'qodux_fw' ) => "bounceInDown", esc_html__( "BounceInLeft", 'qodux_fw' ) => "bounceInLeft", esc_html__( "BounceInRight", 'qodux_fw' ) => "bounceInRight", esc_html__( "BounceOut", 'qodux_fw' ) => "bounceOut", esc_html__( "BounceOutUp", 'qodux_fw' ) => "bounceOutUp", esc_html__( "BounceOutDown", 'qodux_fw' ) => "bounceOutDown", esc_html__( "BounceOutLeft", 'qodux_fw' ) => "bounceOutLeft", esc_html__( "BounceOutRight", 'qodux_fw' ) => "bounceOutRight", esc_html__( "RotateIn", 'qodux_fw' ) => "rotateIn", esc_html__( "RotateInUpLeft", 'qodux_fw' ) => "rotateInUpLeft", esc_html__( "RotateInDownLeft", 'qodux_fw' ) => "rotateInDownLeft", esc_html__( "RotateInUpRight", 'qodux_fw' ) => "rotateInUpRight", esc_html__( "RotateInDownRight", 'qodux_fw' ) => "rotateInDownRight", esc_html__( "RotateOut", 'qodux_fw' ) => "rotateOut", esc_html__( "RotateOutUpLeft", 'qodux_fw' ) => "rotateOutUpLeft", esc_html__( "RotateOutDownLeft", 'qodux_fw' ) => "rotateOutDownLeft", esc_html__( "RotateOutUpRight", 'qodux_fw' ) => "rotateOutUpRight", esc_html__( "RotateOutDownRight", 'qodux_fw' ) => "rotateOutDownRight", esc_html__( "RollIn", 'qodux_fw' ) => "rollIn", esc_html__( "RollOut", 'qodux_fw' ) => "rollOut", esc_html__( "LightSpeedIn", 'qodux_fw' ) => "lightSpeedIn", esc_html__( "LightSpeedOut", 'qodux_fw' ) => "lightSpeedOut" ),
			'description' => esc_html__( 'Select type of animation if you want this element to be animated when it enters into the browsers viewport. Note: Works only in modern browsers.', 'qodux_fw' ),
			'group' 	                    => esc_html__( 'QODX_VC Extensions', 'qodux_fw' ),
		));
		vc_add_param("vc_row", array(
			"type"                          => "dropdown",
			"heading"                       => esc_html__( "WT Animation Visible Type", 'qodux_fw' ),
			"param_name"                    => "anim_type",
			"value"                         => array( esc_html__( "Animate when element is visible", 'qodux_fw' ) => 'qodx_animate_if_visible', esc_html__( "Animate if element is almost visible", 'qodux_fw' ) => "qodx_animate_if_almost_visible" ),
			"description"                   => esc_html__( "Select when the type of animation should start for this element.", 'qodux_fw' ),
			'group'                         => esc_html__( 'QODX_VC Extensions', 'qodux_fw' )
		));		
		vc_add_param("vc_row", array(
			"type"                          => "textfield",
			"heading"                       => esc_html__( "WT Animation Delay", 'qodux_fw' ),
			"param_name"                    => "anim_delay",
			"description"                   => esc_html__( "Here you can set a specific delay for the animation (miliseconds). Example: '100', '500', '1000'.", 'qodux_fw' ),
			'group'                         => esc_html__( 'QODX_VC Extensions', 'qodux_fw' )
		));	
		
		vc_add_param("vc_row", array(
			'type'                  		=> 'qodx_loadfile',
			'heading'               		=> '',
			'param_name'            		=> 'el_file',
			'value'                 		=> '',
			'file_type'             		=> 'js',
			'file_path'             		=> 'qodx-visual-composer-extend-element.min.js',
			'param_holder_class'            => 'qodx_loadfile_field',
			'description'           		=> '',
			'group' 						=> esc_html__( 'QODX_VC Extensions', 'qodux_fw' ),
		));
	}
?>