<?php

// File Security Check
if (!defined('ABSPATH')) die('-1');

/*
Register Qodux shortcode.
*/

class WPBakeryShortCode_QODX_team extends WPBakeryShortCode {
	
	private $qodx_sc;
	
	public function __construct($settings) {
        parent::__construct($settings);
		$this->qodx_sc = new QODX_VCSC_SHORTCODE;
	}
			
	protected function content($atts, $content = null) {
		
		// Get and extract shortcode attributes
		$atts = vc_map_get_attributes( $this->getShortcode(), $atts );
		extract( $atts );
		
		$sc_class = 'qodx_team_sc';
		
		$id = mt_rand(9999, 99999);
		if (trim($el_id) != false) {
			$el_id = esc_attr( trim($el_id) );
		} else {
			$el_id = $sc_class . '-' . $id;
		}
		
		$el_class = esc_attr( $this->getExtraClass($el_class) );		
		$css_class = apply_filters(VC_SHORTCODE_CUSTOM_CSS_FILTER_TAG, $sc_class.$el_class.vc_shortcode_custom_css_class($css, ' '), $this->settings['base']);		
		
		$columns        = (int)$columns;
		$max            = (int)$max;					
		$excerpt_length = (int)$excerpt_length;		
		$auto_slide     = (int)$auto_slide;		
		$slide_items_md = (int)$slide_items_md;	
		$slide_items_sm = (int)$slide_items_sm;	
		$slide_items_xs = (int)$slide_items_xs;	
				
		if ($slider == "true") {
			//wp_enqueue_style('qodx-extend-swiper-slider');
			wp_enqueue_script('qodx-extend-swiper-slider');
		}
		
		$atts = array(
			'columns'            => $columns,
			'image_container'    => $image_container,
			'image_style'        => $image_style,
			'parallax'           => $parallax,
			'max'                => $max,
			'style'              => '',
			'img_width'          => $img_width,
			'img_height'         => $img_height,
			'single_settings'    => $single_settings,
			'title'              => $title,
			'title_linkable'     => $title_linkable,			
			'position'           => $position,
			'category'           => $category,
			'excerpt'            => $excerpt,
			'excerpt_length'     => $excerpt_length,
			'full'               => $full,
			'contact'            => $contact,
			'socials'            => $socials,
			'popover'            => $popover,
			'ids'                => $ids,	
			'cat'           	 => $cat,
			'cat__not'           => $cat__not,
			'order'              => $order,
			'orderby'            => $orderby,			
						
			'slider'             => $slider,
			'auto_slide'         => $auto_slide,
			'direction'          => $direction,
			'equal_height'       => $equal_height,
			'effect'             => $effect,
			'centered_slides'    => $centered_slides,
			'slide_items_md'     => $slide_items_md,
			'slide_items_sm'     => $slide_items_sm,
			'slide_items_xs'     => $slide_items_xs,
			'grab_cursor'        => $grab_cursor,
			'simulate_touch'     => $simulate_touch,
			'slider_pag'         => $slider_pag,
			'pag_lowest'         => $pag_lowest,
			'slider_nav'         => $slider_nav
		);
						
		$output = '';				
				
		// Start team section	
		$output .= '<section id="'.$el_id.'" class="qodx_team_wrapper';	
		
		// if team with slider
		if ($slider == "true") {
			
			$output .= '_slider '.$css_class.'">';
			
			$equal_height = $direction == 'horizontal' && $equal_height == 'true' ? ' swiper-equal-height' : '';
			
			$direction = $direction == 'vertical' ? ' vertical-swiper-slider' : '';
			
			switch($effect){
				case 'fade':
					$effect = ' fade-swiper-slider';
					break;
				case 'coverflow':
					$effect = ' coverflow-swiper-slider';
					break;
				case 'fade':
				default:
					$effect = '';
			}
			
			$centered_slides = $centered_slides == 'true' ? ' center-swiper-slider' : '';			
														
			$output .= '<div id="qodx-swiper-slider-'.$id.'" class="qodx-swiper-slider'.$direction.$equal_height.$effect.$centered_slides.'" data-swiper-items="'.$columns.'" data-swiper-md-items="'.$slide_items_md.'" data-swiper-sm-items="'.$slide_items_sm.'" data-swiper-xs-items="'.$slide_items_xs.'" data-swiper-autoplay="'.$auto_slide.'" data-swiper-grab-cursor="'.$grab_cursor.'" data-swiper-simulate-touch="'.$simulate_touch.'">';
				$output .= '<div class="swiper-wrapper">';	
		} else {
			// if team with simple grid		
			$output .= ' qodx_team-grid qodx_team_col_' . $columns . ' '.$css_class.'">';
		}
			// the articles content
			$output .= $this->QODX_VCSC_TeamList($atts, $id);
		
		if ($slider == 'true') {
				$output .= '</div>'; // End "swiper-wrapper"
				
				// Build Pagination
				if ($slider_pag == "true") {
					$pag_lowest = $pag_lowest ? ' pag-lowest' : '';
					$output .= '<div class="swiper-pagination' . $pag_lowest . '"></div>';
				}
				
				// Build Navigation
				if ($slider_nav == "true") {
					$output .= '<div class="swiper-button-prev">
									<i class="fa fa-angle-left"></i>
								</div>
								<div class="swiper-button-next">
									<i class="fa fa-angle-right"></i>
								</div>';
				}
				
			$output .= '</div>'; // End "qodx-swiper-slider"				
		}
		
		// End team section
		$output .= '</section>';
				
		return $output;			
	
	}
	
	protected function QODX_VCSC_TeamList($atts, $id) {
		
		extract($atts);	
		
		global $wp_filter;
		$the_content_filter_backup = $wp_filter['the_content'];
		
		$output = '';		
						
		// since there is no pagination option, $paged is null
		$paged = NULL;
		
		// Display only selected team members		
		if ( $ids ) {
			$team_ids = explode(',',$ids);
		} else {
			$team_ids = NULL;
		}	
				
		// Include categories
		if ( ! empty( $cat ) ) {
			$include_categories = array(
				'taxonomy'	=> 'team_category',
				'field'		=> 'slug',
				'terms'		=> explode(',', $cat),
				'operator'	=> 'IN',
			);
		} else {
			$include_categories = '';
		}
		
		// Exclude categories
		if ( ! empty( $cat__not ) ) {
			$exclude_categories = array(
				'taxonomy'	=> 'team_category',
				'field'		=> 'slug',
				'terms'		=> explode(',', $cat__not),
				'operator'	=> 'NOT IN',
			);
		} else {
			$exclude_categories = '';
		}	
		
		$qodx_query = new WP_Query(
			array(
				'post_type'			=> 'team',
				'posts_per_page'	=> $max,
				'paged'				=> $paged,
				'order'				=> $order,
				'orderby'			=> $orderby,
				'post__in'			=> $team_ids,
				'tax_query'			=> array(
					'relation'		=> 'AND',
					$include_categories,
					$exclude_categories,
				),
			)
		);
		
		$i     = 1;				
		$order = 0;		
			
		$col_class = '';
		$width_inline  = '';
		$height_inline = '';
		switch($columns){
			case 1:
				$col_class = 'col-md-6 pull-right ';
				break;
			case 2:
				$col_class = 'col-md-6 ';
				break;
			case 3:
				$col_class = 'col-md-4 col-sm-6 m-bottom-20 ';
				break;
			case 6:
				$col_class = 'col-md-2 col-sm-6 ';
				break;
			case 4:
			default:
				$col_class = 'col-md-3 col-sm-6 ';
		}
		
		if ($slider == 'true' && $columns != 1 ) {
			$col_class = 'col-md-12 ';
		}		
				
		if ($style != '') {
			$style = ' team-block-style-' . $style ;
		}
		
		while($qodx_query->have_posts()) {
			$order++;
			$qodx_query->the_post();
			$terms = get_the_terms(get_the_id(), 'team_category');
			$terms_slug = array();
			if (is_array($terms)) {
				foreach($terms as $term) {
					$terms_slug[] = $term->slug;
				}
			}
	
			$col_css = $_item_css = $contentOutput = $popoverOutput = $thumbOutput = $imgOutput = $imgContainer = $image_container_start = $image_container_end = $parallax_css = '';
			
			if ( $image_style == 'true' && $parallax == 'true' ) {
				$parallax_css = 'qodx_img_parallax ';
			}
			
			$get_position  = get_post_meta(get_the_id(), '_position', true);
			$get_phone     = get_post_meta(get_the_id(), '_phone', true);
			$get_email     = get_post_meta(get_the_id(), '_email', true);
			$get_website   = get_post_meta(get_the_id(), '_website', true);
			$get_facebook  = get_post_meta(get_the_id(), '_facebook', true);
			$get_twitter   = get_post_meta(get_the_id(), '_twitter', true);
			$get_behance   = get_post_meta(get_the_id(), '_behance', true);
			$get_dribbble  = get_post_meta(get_the_id(), '_dribbble', true);
			$get_github    = get_post_meta(get_the_id(), '_github', true);
			$get_instagram = get_post_meta(get_the_id(), '_instagram', true);
			$get_google    = get_post_meta(get_the_id(), '_google', true);
			$get_linkedin  = get_post_meta(get_the_id(), '_linkedin', true);
			$get_skype     = get_post_meta(get_the_id(), '_skype', true);
			
			/* if has_post_thumbnail() */
			if (has_post_thumbnail()) {
				$image_id = get_post_thumbnail_id(get_the_id());
				$image = wp_get_attachment_image_src($image_id, 'full', true);
								
				// link to large featured image
				$href = $image[0];
				
				$cropped_img = focus_wp_get_image_src($image[0]); // fallback if aq_resize script doesn't exist
				if( function_exists( 'aq_resize' ) ) {
					$thumb_hard_crop = ( '9999' == $img_height ) ? false : true;										
					$cropped_img = aq_resize( focus_wp_get_image_src($image[0]), $img_width, $img_height, $thumb_hard_crop );
				}
								
				$imgOutput    = '<img src="'. $cropped_img .'" alt="' . get_the_title() . '" '.$width_inline.' '.$height_inline.' />';
				
				$thumbOutput .= "\n\t\t" . '<figure class="image-block">';
					$thumbOutput .= '<span class="image-block-container">';
						$thumbOutput .= $imgOutput;								
					$thumbOutput .= '</span>';
				$thumbOutput .= '</figure>';
					
			} 
			/* End if (has_post_thumbnail() */
			
			/* Article content output Start	*/
			if ($title == 'true' || $position == 'true' || $category == 'true' || $excerpt == 'true' || $contact == 'true' || $socials == 'true'){				
				$contentOutput .= "\n\t\t" . '<div class="img-block-wrapper-hover"><div class="team-member-data">';
			}
						
				// If team title / position / category
				if ($title == 'true' || $position == 'true' || $category == 'true'){			
					$contentOutput .= '<div class="team-block-title">';				
					$popoverOutput .= '<div class=\'team-block-title\'>';	
				}
					if ($columns == 1) {
						$heading_first = '2';
						$heading_sec   = '4';
					} else {
						$heading_first = '4';
						$heading_sec   = '6';
					}
				
					// If team title is set to Yes
					if($title == 'true'){
						if($title_linkable == 'true'){
							$contentOutput .= '<h'.$heading_first.' class="qodx_team_title"><a href="'.get_permalink().'">' . get_the_title() . '</a></h'.$heading_first.'>';
							$popoverOutput .= '<h'.$heading_first.' class=\'qodx_team_title\'><a href=\''.get_permalink().'\'>' . get_the_title() . '</a></h'.$heading_first.'>';
						} else {
							$contentOutput .= '<h'.$heading_first.' class="qodx_team_title">' . get_the_title() . '</h'.$heading_first.'>';
							$popoverOutput .= '<h'.$heading_first.' class=\'qodx_team_title\'>' . get_the_title() . '</h'.$heading_first.'>';
						}
					}
					
					// if position is set to Yes	
					if ($position == 'true'){						
						if(!empty($get_position)){								
							$contentOutput .= '<h'.$heading_sec.' class="qodx_team_position main-color">'.$get_position.'</h'.$heading_sec.'>';
							$popoverOutput .= '<h'.$heading_sec.' class=\'qodx_team_position main-color\'>'.$get_position.'</h'.$heading_sec.'>';
						}		
					}
					
					// if category is set to Yes	
					if ($category == 'true'){		
						$contentOutput .= '<h'.$heading_sec.' class="qodx_team_category">'.$term->name.'</h'.$heading_sec.'>';
						$popoverOutput .= '<h'.$heading_sec.' class=\'qodx_team_category\'>'.$term->name.'</h'.$heading_sec.'>';
					}
					
				if ($title == 'true' || $position == 'true' || $category == 'true'){			
					$contentOutput .= '</div>'; // End div - "team-block-title"				
					$popoverOutput .= '</div>'; // End div - "team-block-title"	
				}
				
				// if phone, email, website	
				if ($contact == 'true'){
					if( !empty($get_phone) || !empty($get_email) || !empty($get_website) ){								
						$contentOutput .= '<ul class="list-icon">';
					}
						// if phone
						if( !empty($get_phone) ){								
							$contentOutput .= '<li><i class="fa fa-phone"></i><span itemscope="telephone">' . esc_attr($get_phone) . '</span></li>';
						}
						// if email
						if( !empty($get_email) ){								
							$contentOutput .= '<li><i class="fa fa-envelope-o"></i><span itemscope="email">' . '<a href="mailto:' . sanitize_email($get_email) . '">' . $get_email . '</a>' . '</span></li>';
						}
						// if website
						if( !empty($get_website) ){								
							$contentOutput .= '<li><i class="fa fa-external-link"></i><span itemscope="website">' . '<a href="' . esc_url($get_website) . '" target="_blank">' . $get_website . '</a>' . '</span></li>';
						}
					
					if( !empty($get_phone) || !empty($get_email) || !empty($get_website) ){								
						$contentOutput .= '</ul>'; // End list
					}
				}
				
				//  If excerpt, category then build "qodx_team_det" wrapper
				if ($excerpt == 'true'){			
					$contentOutput .= '<div class="qodx_team_det">';	
				}						
					
					// if excerpt is set to Yes	
					if ($excerpt == 'true'){
						
						/* Display all post content or post excerpt */						
						if ( $full == 'true' ){
							$content = get_the_content();
							$content = apply_filters('the_content', $content);
							$content = str_replace(']]>', ']]&gt;', $content);
							$contentOutput .= $content;
						} else {
							$content = QODX_VCSC_Excerpt( $excerpt_length, false, false );
							$contentOutput .= '<div class="qodx_team_excerpt">'.$content.'</div>';
						}						
						
					}
								
				if($excerpt == 'true'){
					$contentOutput .= '</div>'; // End div - "qodx_team_det"
				}
				
				// if social icons
				if ($socials == 'true'){
					
					if( !empty($get_facebook) || !empty($get_twitter) || !empty($get_behance) || !empty($get_dribbble) || !empty($get_github) || !empty($get_instagram) || !empty($get_google) || !empty($get_linkedin) || !empty($get_skype) ){	
						$contentOutput .= '<div class="social-icons">';							
							$contentOutput .= '<ul>';
					}
						// if facebook
						if( !empty($get_facebook) ){								
							$contentOutput .= '<li>' . '<a href="' . esc_url($get_facebook) . '" title="Facebook" target="_blank"><i class="fa fa-facebook"></i></a>' . '</li>';
						}
						// if twitter
						if( !empty($get_twitter) ){						
							$contentOutput .= '<li>' . '<a href="' . esc_url($get_twitter) . '" title="Twitter" target="_blank"><i class="fa fa-twitter"></i></a>' . '</li>';
						}
						// if behance
						if( !empty($get_behance) ){						
							$contentOutput .= '<li>' . '<a href="' . esc_url($get_behance) . '" title="Behance" target="_blank"><i class="fa fa-behance"></i></a>' . '</li>';
						}
						// if dribbble
						if( !empty($get_dribbble) ){						
							$contentOutput .= '<li>' . '<a href="' . esc_url($get_dribbble) . '" title="Dribbble" target="_blank"><i class="fa fa-dribbble"></i></a>' . '</li>';
						}
						// if github
						if( !empty($get_github) ){						
							$contentOutput .= '<li>' . '<a href="' . esc_url($get_github) . '" title="Github" target="_blank"><i class="fa fa-github"></i></a>' . '</li>';
						}
						// if instagram
						if( !empty($get_instagram) ){						
							$contentOutput .= '<li>' . '<a href="' . esc_url($get_instagram) . '" title="Instagram" target="_blank"><i class="fa fa-instagram"></i></a>' . '</li>';
						}
						// if google
						if( !empty($get_google) ){						
							$contentOutput .= '<li>' . '<a href="' . esc_url($get_google) . '" title="Google" target="_blank"><i class="fa fa-google-plus"></i></a>' . '</li>';
						}
						// if linkedin
						if( !empty($get_linkedin) ){						
							$contentOutput .= '<li>' . '<a href="' . esc_url($get_linkedin) . '" title="Linkedin" target="_blank"><i class="fa fa-linkedin"></i></a>' . '</li>';
						}
						// if skype
						if( !empty($get_skype) ){						
							$contentOutput .= '<li>' . '<a href="' . esc_url($get_skype) . '" title="Skype" target="_blank"><i class="fa fa-skype"></i></a>' . '</li>';
						}
					
					if( !empty($get_facebook) || !empty($get_twitter) || !empty($get_behance) || !empty($get_dribbble) || !empty($get_github) || !empty($get_instagram) || !empty($get_google) || !empty($get_linkedin) || !empty($get_skype) ){								
							$contentOutput .= '</ul>'; // End social list							
						$contentOutput .= '</div>';
					}
				} // End if social icons
			
			if ($title == 'true' || $position == 'true' || $category == 'true' || $excerpt == 'true' || $contact == 'true' || $socials == 'true'){
				$contentOutput .= '</div></div>'; // End div - "qodx_team_details"
			}	
			/* Article content output End */
			
			if ($slider == 'true') {
				$output .= '<div class="swiper-slide">';	
					$output .= '<div class="swiper-slide-container">';	
			}
			
			if ($columns == 1) {
				$output .= '<div class="team-section">';
					$output .= '<div class="section-container">';
					
						if ( $image_container == 'true' ) { 
							$image_container_start = '<div class="qodx-50-column">';
							$image_container_end = '</div>';
						}
				
						if ( $image_style == 'true' ) { // if background image
							$imgContainer = ' img-container';
							$output .= $image_container_start;
								$output .= '<div class="' . $parallax_css . 'background-image-block qodx-image">';
									$output .= $imgOutput;
								$output .= '</div>';
							$output .= $image_container_end;
						} else { // if simple image
							$output .= $image_container_start;
								$output .= '<div class="image-block">';
									$output .= '<div class="image-block-container">';
										$output .= $imgOutput;
									$output .= '</div>';
								$output .= '</div>';
							$output .= $image_container_end;
						}
				
						$output .= '<div class="container' . $imgContainer . '">';
							$output .= '<div class="row">';
			}
				
			if ( $single_settings ) {
				$_item_css = get_post_meta(get_the_id(), '_item_css', true);
			}
			$col_css = $_item_css ? $_item_css . ' ' : $col_class;
				
				// Start article
				$output .= "\n\t" . '<article id="post-' . get_the_ID() . '" class="'.$col_css.'team-block' . $style . ' ' . implode(' ', $terms_slug) . '"' . ' data-order="'.$order.'"' . '>';	
				
					$output .= '<div class="team-block-container">';
					
						if ($popover == 'true') { // Start Team popover
							$output .= '<a class="team-popover" tabindex="0" role="button" data-trigger="focus" data-container="body" data-toggle="popover" data-placement="bottom" data-content="'.$popoverOutput.'">'; // End Team popover
						}		
											
						if ($popover == 'true') {
							$output .= '</a>'; // End Team popover
						} else {
							$output .= $contentOutput; // display article content output
						}
					
						if ($columns != 1) {
							$output .= $thumbOutput; // if has_post_thumbnail() and $column is not set to 1 
						}	
					
					$output .= '</div>'; // End div - "team-block-container"
				
				$output .= '</article>';
			    // End  article
				
			if ($columns == 1) {															
							$output .= '</div>'; // End "row"
						$output .= '</div>'; // End "container"
						
					$output .= '</div>'; // End "section-container"
				$output .= '</div>'; // End "team-section"
			}
			
			if ($slider == 'true') {
					$output .= '</div>'; // End "swiper-slide-container"
				$output .= '</div>'; // End "swiper-slide"
			}
		}
						
		wp_reset_postdata();
		$wp_filter['the_content'] = $the_content_filter_backup;
		return $output;
		
	}
	
}

/*
Register Qodux shortcode within Visual Composer interface.
*/

if (function_exists('vc_map')) {

	$add_qodx_sc_func             = new QODX_VCSC_SHORTCODE;	
	$add_qodx_extra_id            = $add_qodx_sc_func->getWTExtraId();
	$add_qodx_extra_class         = $add_qodx_sc_func->getWTExtraClass();
	
	vc_map( array(
		'name' => esc_html__( 'Team', 'qodux_fw' ),
		'base' => 'qodx_team',
		'icon' => 'qodx-icon-team fa fa-users',
		'class' => 'qodx_vc_sc_team',
		'category' => esc_html__( 'by Qodux', 'qodux_fw' ),
		'description' => esc_html__( 'Team members', 'qodux_fw' ),
		'params' => array(		
			array(
				'type'			=> 'dropdown',
				'class'			=> '',
				'heading'		=> esc_html__( 'Columns', 'qodux_fw' ),
				'param_name'	=> 'columns',
				'admin_label'	=> true,
				'value' 		=> array(
					esc_html__( 'One', 'qodux_fw' )		=> '1',
					esc_html__( 'Two', 'qodux_fw' )		=> '2',
					esc_html__( 'Three', 'qodux_fw' )	=> '3',
					esc_html__( 'Four', 'qodux_fw' )	    => '4',
					esc_html__( 'Five', 'qodux_fw' )	    => '5',
					esc_html__( 'Six', 'qodux_fw' )	    => '6',
				),
				'std'	        => '4',
				'description'	=> esc_html__( 'How many columns?', 'qodux_fw' ),
			),
			array(
				'type'               => 'dropdown',
				'heading'            => esc_html__( 'Container for image?', 'qodux_fw' ),
				'param_name'         => 'image_container',
				'value'              => array( 
					esc_html__( 'No', 'qodux_fw' )    => 'false',
					esc_html__( 'Yes', 'qodux_fw' )   => 'true',
				),
				'param_holder_class' => 'border_box qodx_dependency',
				'dependency'	     => Array(
					'element'	=> 'columns',
					'value'		=> '1'
				),
				'description'   => esc_html__( 'Specifically for 1 column style, the image will be wrapped by a separate left aligned container.', 'qodux_fw' )
			),
			array(
				'type'               => 'dropdown',
				'heading'            => esc_html__( 'Background image style?', 'qodux_fw' ),
				'param_name'         => 'image_style',
				'value'              => array( 
					esc_html__( 'Yes', 'qodux_fw' )   => 'true',
					esc_html__( 'No', 'qodux_fw' )    => 'false',
				),
				'param_holder_class' => 'border_box qodx_dependency',
				'dependency'	     => Array(
					'element'	=> 'columns',
					'value'		=> '1'
				),
				'description'   => esc_html__( 'Specifically for 1 column style, you can select image style. A background image or a simple image.', 'qodux_fw' )
			),
			array(
				'type'          => 'dropdown',
				'heading'       => esc_html__( 'Image with parallax effect', 'qodux_fw' ),
				'param_name'    => 'parallax',
				'value' => array( 
					esc_html__( 'No', 'qodux_fw' )    => 'false',
					esc_html__( 'Yes', 'qodux_fw' )   => 'true',
				),
				'param_holder_class' => 'border_box qodx_dependency',
				'description'   => esc_html__( 'Specifically for 1 column with background image style, the image will have a parallax effect when scrolling.', 'qodux_fw' ),
				'dependency' 	=> array(
					'element' => 'columns',
					'value'   => '1'
				),
			),
			array(
				'type'          => 'textfield',
				'heading'       => esc_html__( 'Max (posts number)', 'qodux_fw' ),
				'param_name'    => 'max',
				'value'         => '-1',
				'description'   => esc_html__( 'How many team members do you wish to show? Set -1 to display all.', 'qodux_fw' )
			),
			/*array(
				'type'			=> 'dropdown',
				'class'			=> '',
				'heading'		=> esc_html__( 'Style', 'qodux_fw' ),
				'param_name'	=> 'style',
				'value' 		=> array(
					esc_html__( 'Default', 'qodux_fw' )	=> '',
					esc_html__( 'Style 1', 'qodux_fw' )	=> '1',
					esc_html__( 'Style 2', 'qodux_fw' )	=> '2',
					esc_html__( 'Style 3', 'qodux_fw' )	=> '3',
					esc_html__( 'Style 4', 'qodux_fw' )	=> '4',
					esc_html__( 'Style 5', 'qodux_fw' )	=> '5',
					esc_html__( 'Style 6', 'qodux_fw' )	=> '6',
					esc_html__( 'Style 7', 'qodux_fw' )	=> '7',
					esc_html__( 'Style 8', 'qodux_fw' )	=> '8',
					esc_html__( 'Style 9', 'qodux_fw' )	=> '9',
					esc_html__( 'Style 10', 'qodux_fw' )	=> '10',
					esc_html__( 'Style 11', 'qodux_fw' )	=> '11',
					esc_html__( 'Style 12', 'qodux_fw' )	=> '12',
					esc_html__( 'Style 13', 'qodux_fw' )	=> '13',
					esc_html__( 'Style 14', 'qodux_fw' )	=> '14',
					esc_html__( 'Style 15', 'qodux_fw' ) => '15',
				),
				'std'	        => '',
				'description'	=> esc_html__( 'Choose team style.', 'qodux_fw' ),
			),	*/		
			array(
				'type'			=> 'textfield',
				'heading'		=> esc_html__( 'Featured image width', 'qodux_fw' ),
				'param_name'	=> 'img_width',
				'value'			=> '9999',
				'description'	=> esc_html__( 'Enter the width in pixels.', 'qodux_fw' ),
			),
			array(
				'type'			=> 'textfield',
				'heading'		=> esc_html__( 'Featured image height', 'qodux_fw' ),
				'param_name'	=> 'img_height',
				'value'			=> '9999',
				"description"	=> esc_html__( 'Enter the height in pixels. Set to "9999" to disable vertical cropping and keep image proportions.', 'qodux_fw' ),
			),
			array(
				'type'			=> 'checkbox',
				'heading'		=> esc_html__( 'Keep single team item settings?', 'qodux_fw' ),
				'param_name'	=> 'single_settings',
				'value'			=> Array( esc_html__( 'Yes please.', 'qodux_fw' ) => 'yes' ),
				'description'   => esc_html__( 'Check this option to override team articles classes. Enables custom css class - the optional one specified for every single team item. Useful if you want to change default team articles classes.', 'qodux_fw' ),
			),
			array(
				'type'          => 'dropdown',
				'heading'       => esc_html__( 'Title', 'qodux_fw' ),
				'param_name'    => 'title',
				'value' => array( 
					esc_html__( 'Yes', 'qodux_fw' )   => 'true',
					esc_html__( 'No', 'qodux_fw' )    => 'false',
				),
				'description'   => esc_html__( 'Display post title?', 'qodux_fw' )
			),
			array(
				'type'               => 'dropdown',
				'heading'            => esc_html__( 'Title linkable', 'qodux_fw' ),
				'param_name'         => 'title_linkable',
				'value'              => array( 
					esc_html__( 'Yes', 'qodux_fw' )   => 'true',
					esc_html__( 'No', 'qodux_fw' )    => 'false',
				),
				'param_holder_class' => 'border_box qodx_dependency',
				'dependency'	     => Array(
					'element'	=> 'title',
					'value'		=> 'true'
				),
				'description'   => esc_html__( 'Link on title?', 'qodux_fw' )
			),
			array(
				'type'          => 'dropdown',
				'heading'       => esc_html__( 'Position', 'qodux_fw' ),
				'param_name'    => 'position',
				'value' => array( 
					esc_html__( 'Yes', 'qodux_fw' )   => 'true',
					esc_html__( 'No', 'qodux_fw' )    => 'false',
				),
				'std'           => 'true',
				'description'   => esc_html__( 'Display team member\'s position within the team.', 'qodux_fw' )
			),
			array(
				'type'          => 'dropdown',
				'heading'       => esc_html__( 'Category', 'qodux_fw' ),
				'param_name'    => 'category',
				'value' => array( 
					esc_html__( 'Yes', 'qodux_fw' )   => 'true',
					esc_html__( 'No', 'qodux_fw' )    => 'false',
				),
				'std'           => 'false',
				'description'   => esc_html__( 'Display team member\'s category.', 'qodux_fw' )
			),
			array(
				'type'          => 'dropdown',
				'heading'       => esc_html__( 'Excerpt (post content)', 'qodux_fw' ),
				'param_name'    => 'excerpt',
				'value' => array( 
					esc_html__( 'Yes', 'qodux_fw' )   => 'true',
					esc_html__( 'No', 'qodux_fw' )    => 'false',
				),
				'std'           => 'false',
				'description'   => esc_html__( 'Display post excerpt / content?', 'qodux_fw' )
			),
			array(
				'type'               => 'textfield',
				'heading'            => esc_html__( 'Excerpt (post content) length', 'qodux_fw' ),
				'param_name'         => 'excerpt_length',
				'value'              => '15',
				'param_holder_class' => 'border_box qodx_dependency',
				'dependency'	     => Array(
					'element'	=> 'excerpt',
					'value'		=> 'true'
				),
				'description'        => esc_html__( 'Enter a custom excerpt length. Will trim the excerpt by this number of words.', 'qodux_fw' )
			),
			array(
				'type'               => 'dropdown',
				'heading'            => esc_html__( 'Display full post?', 'qodux_fw' ),
				'param_name'         => 'full',
				'value'              => array( 
					esc_html__( 'No', 'qodux_fw' )    => 'false',
					esc_html__( 'Yes', 'qodux_fw' )   => 'true',
				),
				'param_holder_class' => 'border_box qodx_dependency',
				'dependency'	     => Array(
					'element'	=> 'excerpt',
					'value'		=> 'true'
				),
				'description'        => esc_html__( 'Display all posts content instead of the auto excerpt. Excerpt option above should be \'YES\'.', 'qodux_fw' )
			),	
			array(
				'type'          => 'dropdown',
				'heading'       => esc_html__( 'Contact data', 'qodux_fw' ),
				'param_name'    => 'contact',
				'value' => array( 
					esc_html__( 'Yes', 'qodux_fw' )   => 'true',
					esc_html__( 'No', 'qodux_fw' )    => 'false',
				),
				'std'           => 'false',
				'description'   => esc_html__( 'Display contact data (phone number, email or website)?', 'qodux_fw' )
			),	
			array(
				'type'          => 'dropdown',
				'heading'       => esc_html__( 'Socials', 'qodux_fw' ),
				'param_name'    => 'socials',
				'value' => array( 
					esc_html__( 'Yes', 'qodux_fw' )   => 'true',
					esc_html__( 'No', 'qodux_fw' )    => 'false',
				),
				'std'           => 'false',
				'description'   => esc_html__( 'Display social network links?', 'qodux_fw' )
			),	
			array(
				'type'          => 'dropdown',
				'heading'       => esc_html__( 'Popover Content?', 'qodux_fw' ),
				'param_name'    => 'popover',
				'value' => array( 
					esc_html__( 'Yes', 'qodux_fw' )   => 'true',
					esc_html__( 'No', 'qodux_fw' )    => 'false',
				),
				'std'           => 'false',
				'description'   => esc_html__( 'Enables popover content when user click on team item.', 'qodux_fw' )
			),
			array(
				'type'          => 'qodx_multidropdown',
				'heading'       => esc_html__( 'Display specific team members (optional)', 'qodux_fw' ),
				'param_name'    => 'ids',
				'admin_label'	=> true,
				'value'         => '',
				'target'        => 'team',
				'description'   => esc_html__( 'Display only specific / selected team members.', 'qodux_fw' ) .'<b>' . esc_html__( 'Hold the \'Ctrl\' or \'Shift\' keys while clicking to select multiple items', 'qodux_fw' ).'</b>.'
			),
			array(
				'type'          => 'qodx_multidropdown',
				'heading'       => esc_html__( 'Display from category (optional)', 'qodux_fw' ),
				'param_name'    => 'cat',
				'value'         => '',
				'target'        => 'team_category',
				'description'   => esc_html__( 'Display team members from selected categories.', 'qodux_fw' ) .'<b>' . esc_html__( 'Hold the \'Ctrl\' or \'Shift\' keys while clicking to select multiple items', 'qodux_fw' ).'</b>.'
			),	
			array(
				'type'          => 'qodx_multidropdown',
				'heading'       => esc_html__( 'Exclude selected categories (optional)', 'qodux_fw' ),
				'param_name'    => 'cat__not',
				'value'         => '',
				'target'        => 'team_category',
				'description'   => esc_html__( 'Display team members and exclude selected categories.', 'qodux_fw' ) .'<b>' . esc_html__( 'Hold the \'Ctrl\' or \'Shift\' keys while clicking to select multiple items', 'qodux_fw' ).'</b>.'
			),		
			array(
				'type'			=> 'dropdown',
				'class'			=> '',
				'heading'		=> esc_html__( 'Order', 'qodux_fw' ),
				'param_name'	=> 'order',
				'description'	=> sprintf( esc_html__( 'Designates the ascending or descending order. More at %s.', 'qodux_fw'  ), '<a href="http://codex.wordpress.org/Class_Reference/WP_Query#Order_.26_Orderby_Parameters" target="_blank">WordPress codex</a>' ),
				'value'			=> array(
					 esc_html__( 'DESC', 'qodux_fw' )	=> 'DESC',
					 esc_html__( 'ASC', 'qodux_fw' )	=> 'ASC',
				),
			),
			array(
				'type'			=> 'dropdown',
				'class'			=> '',
				'heading'		=> esc_html__( 'Order By', 'qodux_fw'  ),
				'param_name'	=> 'orderby',
				'description'	=> sprintf( esc_html__( 'Select how to sort retrieved posts. More at %s.', 'qodux_fw'  ), '<a href="http://codex.wordpress.org/Class_Reference/WP_Query#Order_.26_Orderby_Parameters" target="_blank">WordPress codex</a>' ),
				'value'			=> array(					
					esc_html__( 'None', 'qodux_fw' )			 => 'none',
					esc_html__( 'Id', 'qodux_fw' )			 => 'ID',
					esc_html__( 'Author', 'qodux_fw' )		 => 'author',
					esc_html__( 'Title', 'qodux_fw' )		 => 'title',
					esc_html__( 'Date', 'qodux_fw' )		     => 'date',
					esc_html__( 'Modified', 'qodux_fw' )		 => 'modified',
					esc_html__( 'Parent', 'qodux_fw' )		 => 'parent',
					esc_html__( 'Random', 'qodux_fw' )		 => 'rand',
					esc_html__( 'Comment Count', 'qodux_fw' ) => 'comment_count',
					esc_html__( 'Menu Order', 'qodux_fw'  )	 => 'menu_order',
				),
				'std'	        => 'date',
			),			
			
			array(
				'type'          => 'dropdown',
				'heading'       => esc_html__( 'Enable', 'qodux_fw' ),
				'param_name'    => 'slider',
				'value'         => array( 
					esc_html__( 'No', 'qodux_fw' )    => 'false',
					esc_html__( 'Yes', 'qodux_fw' )   => 'true',
				),
				'description'   => esc_html__( 'Enables slider for displaying team members.', 'qodux_fw' ),
				'group' => esc_html__( 'Slider', 'qodux_fw' )
			),
			
			// Slider Settings			
			array(
				'type'		  => 'qodx_separator',
				'heading'	  => '',
				"param_name"  => 'separator',
				'value'	      => '',
				'separator'	  => 'Slider Settings',
				'dependency'	     => Array(
					'element'	     => 'slider',
					'value'		     => 'true'
				),
				'description' => esc_html__( 'Below you can edit default slider settings.', 'qodux_fw' ),
				'group' => esc_html__( 'Slider', 'qodux_fw' )
			),			
			array(
				'type'               => 'textfield',
				'heading'            => esc_html__( 'Autoplay', 'qodux_fw' ),
				'param_name'         => 'auto_slide',
				'value'              => '5000',
				'dependency'	     => Array(
					'element'	     => 'slider',
					'value'		     => 'true'
				),
				'description'   => esc_html__( 'Enables autoplay and define the time interval (in miliseconds - Ex: 3000, 4000, 5000 etc) between transitions. Set it "0" to disable autoplay.', 'qodux_fw' ),
				'group' => esc_html__( 'Slider', 'qodux_fw' )
			),
			array(
				'type'               => 'dropdown',
				'heading'            => esc_html__( 'Direction', 'qodux_fw' ),
				'param_name'         => 'direction',
				'value' 			 => array( 
					esc_html__( 'Horizontal', 'qodux_fw' ) => 'horizontal',
					esc_html__( 'Vertical', 'qodux_fw' )   => 'vertical',
				),
				'dependency'	     => Array(
					'element'	     => 'slider',
					'value'		     => 'true'
				),
				'description'   => esc_html__( 'Define slider direction ( horizontal / vertical ).', 'qodux_fw' ),
				'group' => esc_html__( 'Slider', 'qodux_fw' )
			),
			array(
				'type'               => 'dropdown',
				'heading'            => esc_html__( 'Equal height for horizontal sliders?', 'qodux_fw' ),
				'param_name'         => 'equal_height',
				'value' 			 => array( 
					esc_html__( 'Yes', 'qodux_fw' )   => 'true',
					esc_html__( 'No', 'qodux_fw' )    => 'false',
				),
				'param_holder_class' => 'border_box qodx_dependency',
				'dependency'	     => Array(
					'element'	     => 'slider',
					'value'		     => 'true'
				),
				'description'   => esc_html__( 'Set equal height for horizontal sliders. Slider will have the highest slide item size.', 'qodux_fw' ),
				'group' => esc_html__( 'Slider', 'qodux_fw' )
			),
			array(
				'type'               => 'dropdown',
				'heading'            => esc_html__( 'Effect', 'qodux_fw' ),
				'param_name'         => 'effect',
				'value' 			 => array( 
					esc_html__( 'Slide', 'qodux_fw' )     => 'slide',
					esc_html__( 'Fade', 'qodux_fw' )      => 'fade',
					esc_html__( 'Coverflow', 'qodux_fw' ) => 'coverflow',
				),
				'dependency'	     => Array(
					'element'	     => 'slider',
					'value'		     => 'true'
				),
				'description'   => esc_html__( 'Define slider animation effect.', 'qodux_fw' ),
				'group' => esc_html__( 'Slider', 'qodux_fw' )
			),
			array(
				'type'               => 'qodx_range',
				'heading'            => esc_html__( 'Items visible on Small Desktop', 'qodux_fw' ),
				'param_name'         => 'slide_items_md',
				'value'              => 2,
				'min'                => 1,
				'max'                => 4,
				'step'               => 1,
				'dependency'	     => Array(
					'element'	     => 'slider',
					'value'		     => 'true'
				),
				'description'        => esc_html__( 'Define maximum amount of items to be visible on small desktops.', 'qodux_fw' ),
				'group' => esc_html__( 'Slider', 'qodux_fw' )
			),
			array(
				'type'               => 'qodx_range',
				'heading'            => esc_html__( 'Items visible on Tablet', 'qodux_fw' ),
				'param_name'         => 'slide_items_sm',
				'value'              => 2,
				'min'                => 1,
				'max'                => 4,
				'step'               => 1,
				'dependency'	     => Array(
					'element'	     => 'slider',
					'value'		     => 'true'
				),
				'description'        => esc_html__( 'Define maximum amount of items to be visible on tablets.', 'qodux_fw' ),
				'group' => esc_html__( 'Slider', 'qodux_fw' )
			),
			array(
				'type'               => 'qodx_range',
				'heading'            => esc_html__( 'Items visible on Mobile', 'qodux_fw' ),
				'param_name'         => 'slide_items_xs',
				'value'              => 1,
				'min'                => 1,
				'max'                => 3,
				'step'               => 1,
				'dependency'	     => Array(
					'element'	     => 'slider',
					'value'		     => 'true'
				),
				'description'        => esc_html__( 'Define maximum amount of items to be visible on mobiles.', 'qodux_fw' ),
				'group' => esc_html__( 'Slider', 'qodux_fw' )
			),
			array(
				'type'               => 'dropdown',
				'heading'            => esc_html__( 'Centered Slides', 'qodux_fw' ),
				'param_name'         => 'centered_slides',
				'value' 			 => array( 
					esc_html__( 'No', 'qodux_fw' )    => 'false',
					esc_html__( 'Yes', 'qodux_fw' )   => 'true',
				),
				'dependency'	     => Array(
					'element'	     => 'slider',
					'value'		     => 'true'
				),
				'description'   => esc_html__( 'If true, then active slide will be centered, not always on the left side.', 'qodux_fw' ),
				'group' => esc_html__( 'Slider', 'qodux_fw' )
			),	
			array(
				'type'               => 'dropdown',
				'heading'            => esc_html__( 'Grab Cursor', 'qodux_fw' ),
				'param_name'         => 'grab_cursor',
				'value' 			 => array( 
					esc_html__( 'Yes', 'qodux_fw' )   => 'true',
					esc_html__( 'No', 'qodux_fw' )    => 'false',
				),
				'dependency'	     => Array(
					'element'	     => 'slider',
					'value'		     => 'true'
				),
				'description'   => esc_html__( 'This option may a little improve desktop usability. If true, user will see the "grab" cursor when hover on Swiper.', 'qodux_fw' ),
				'group' => esc_html__( 'Slider', 'qodux_fw' )
			),	
			array(
				'type'               => 'dropdown',
				'heading'            => esc_html__( 'Simulate Touch', 'qodux_fw' ),
				'param_name'         => 'simulate_touch',
				'value' 			 => array( 
					esc_html__( 'Yes', 'qodux_fw' )   => 'true',
					esc_html__( 'No', 'qodux_fw' )    => 'false',
				),
				'dependency'	     => Array(
					'element'	     => 'slider',
					'value'		     => 'true'
				),
				'description'   => esc_html__( 'If true, Swiper will accept mouse events like touch events (click and drag to change slides).', 'qodux_fw' ),
				'group' => esc_html__( 'Slider', 'qodux_fw' )
			),	
			array(
				'type'               => 'dropdown',
				'heading'            => esc_html__( 'Slider Pagination', 'qodux_fw' ),
				'param_name'         => 'slider_pag',
				'value' 			 => array( 
					esc_html__( 'No', 'qodux_fw' )    => 'false',
					esc_html__( 'Yes', 'qodux_fw' )   => 'true',
				),
				'dependency'	     => Array(
					'element'	     => 'slider',
					'value'		     => 'true'
				),
				'description'   => esc_html__( 'Enables slider pagination.', 'qodux_fw' ),
				'group' => esc_html__( 'Slider', 'qodux_fw' )
			),	
			array(
				'type'			     => 'checkbox',
				'heading'		     => esc_html__( 'Slider Pagination Lowest?', 'qodux_fw' ),
				'param_name'	     => 'pag_lowest',
				'value'			     => Array( esc_html__( 'Yes please.', 'qodux_fw' ) => 'yes' ),
				'description'        => esc_html__( 'Check this option to display pagination in the lowest position.', 'qodux_fw' ),
				'param_holder_class' => 'border_box qodx_dependency',
				'dependency' 	     => array(
					'element' => 'slider_pag',
					'value'   => 'true'
				),
				'group'              => esc_html__( 'Slider', 'qodux_fw' )
			),		
			array(
				'type'               => 'dropdown',
				'heading'            => esc_html__( 'Slider Navigation', 'qodux_fw' ),
				'param_name'         => 'slider_nav',
				'value' 			 => array( 
					esc_html__( 'No', 'qodux_fw' )    => 'false',
					esc_html__( 'Yes', 'qodux_fw' )   => 'true',
				),
				'dependency'	     => Array(
					'element'	     => 'slider',
					'value'		     => 'true'
				),
				'description'   => esc_html__( 'Enables slider navigation ( prev / next buttons ).', 'qodux_fw' ),
				'group' => esc_html__( 'Slider', 'qodux_fw' )
			),	
			
			$add_qodx_extra_id,
			$add_qodx_extra_class,
			
			array(
				'type' => 'css_editor',
				'heading' => esc_html__( 'Css', 'qodux_fw' ),
				'param_name' => 'css',
				'group' => esc_html__( 'Design options', 'qodux_fw' )
			),
			
			// Load Custom CSS/JS File
			array(
				'type'               => 'qodx_loadfile',
				'heading'            => '',
				'param_name'         => 'el_file',
				'value'              => '',
				'file_path'          => 'qodx-visual-composer-extend-element.min.js',
				'param_holder_class' => 'qodx_loadfile_field',
				'description'        => ''
			),
		)
	));
	
}