<?php
/**
 * Facebook Widget Class
 */
 
// File Security Check
if (!defined('ABSPATH')) die('-1');
 
// Start widget class
class Focus_WP_Widget_Facebook extends WP_Widget {

	function __construct() {
		$widget_ops = array('classname' => 'facebook-widget-block', 'description' => esc_html__( 'Facebook Page', 'qodux_fw' ));
		parent::__construct('facebook', QODUX_FRAME_NAME.' - '.esc_html__( 'Facebook', 'qodux_fw' ), $widget_ops);
	}
	
	function widget( $args, $instance ) {	
		// Set vars for widget usage	
		extract( $args );					
		$title        = isset( $instance['title'] ) ? apply_filters( 'widget_title', $instance['title'] ) : '';
		
		$facebook_url = isset( $instance['facebook_url'] ) ? $instance['facebook_url'] : '';
										
		echo balanceTags( $before_widget );
		
		// Display title if defined
		if ( $title) {
			echo balanceTags( $before_title . $title . $after_title );
		} ?>
        
		<?php
		// Not show in customizer to not slow things down
		if ( function_exists( 'is_customize_preview' ) && is_customize_preview() ) :

			esc_html_e( 'Facebook widget does not display in the Customizer because it can slow things down.', 'qodux_fw' );

		elseif ( $facebook_url ) : ?>

			<div class="fb-page" data-href="<?php echo esc_url( $facebook_url ); ?>" data-small-header="false" data-width="500" data-adapt-container-width="true" data-hide-cover="false" data-show-facepile="true" data-show-posts="false"></div>

			<div id="fb-root"></div>
			<?php focus_wp_inline_fb(); ?>
		<?php endif; ?>
        
		<?php
		echo balanceTags( $after_widget );
	}
	
	function update( $new_instance, $old_instance ) {
		// Get instanc
		$instance                 = $old_instance;
		$instance['title']        = ( ! empty( $new_instance['title'] ) ) ? strip_tags( $new_instance['title'] ) : '';
		$instance['facebook_url'] = ( ! empty( $new_instance['facebook_url'] ) ) ? esc_url( $new_instance['facebook_url'] ) : '';			
		return $instance;
	}

	function form( $instance ) {
		
		extract( wp_parse_args( ( array ) $instance, array(
			'title'        => esc_html__( 'Find Us On Facebook', 'qodux_fw' ),
			'facebook_url' => '',
		) ) ); ?>
        		
		<p><label for="<?php echo esc_attr( $this->get_field_id('title') ); ?>"><?php esc_html_e( 'Title:', 'qodux_fw' ); ?></label>
		<input class="widefat" id="<?php echo esc_attr( $this->get_field_id('title') ); ?>" name="<?php echo esc_attr( $this->get_field_name('title') ); ?>" type="text" value="<?php echo esc_attr( $title ); ?>" /></p>
        
		<p><label for="<?php echo esc_attr( $this->get_field_id('facebook_url') ); ?>"><?php esc_html_e( 'Facebook Page URL:', 'qodux_fw' ); ?></label>
		<input class="widefat" id="<?php echo esc_attr( $this->get_field_id('facebook_url') ); ?>" name="<?php echo esc_attr( $this->get_field_name('facebook_url') ); ?>" type="text" value="<?php echo esc_attr( $facebook_url ); ?>" /></p>		
<?php
	}
	
}