<?php
class Focus_WP_themeFeatures {
	function focus_wp_menu(){
		 wp_nav_menu( array( 
			 'theme_location' => 'primary-menu',
			 'container'      => false,
			 'menu_class'     => 'nav navbar-nav navbar-right',
			 'walker'         => new Focus_WP_walker ,
		 ));
	}
	function focus_wp_menu_one_page(){
		 wp_nav_menu( array( 
			 'theme_location' => 'primary-menu',
			 'container'      => false,
			 'menu_class'     => 'nav navbar-nav navbar-right',
			 'walker'         => new Focus_WP_description_walker ,
		 ));
	}
	function focus_wp_home_menu(){
		global $focus_wp_home_menu;
		focus_wp_qodx_home($focus_wp_home_menu);
	}
	function focus_wp_sidebar($post_id = NULL){
		focus_wp_sidebar_generator('focus_wp_get_sidebar',$post_id);
	}
	function focus_wp_footer_sidebar(){
		focus_wp_sidebar_generator('focus_wp_get_footer_sidebar');
	}
	function focus_wp_top_widget(){
		focus_wp_sidebar_generator('focus_wp_get_top_widget');
	}	
	function wp_link_pages(){
		 wp_link_pages( array());
	}
	function comment_form(){
	}
	function search(){
		global $search;
		focus_wp_search($search);
	}	
	function focus_wp_headerWrapper($post_id = NULL) {
		echo '<div id="qodx_headerWrapper" role="banner" class="clearfix">';
	}
	function focus_wp_header($post_id = NULL) {
		$focus_wp_stickyHeader  = focus_wp_get_option('general', 'sticky_header');
		$menu_position = focus_wp_get_option('general','menu_position');
		$focus_wp_responsiveNav = focus_wp_get_option('general', 'responsive_nav');
		if (focus_wp_is_blog()){
			$focus_wp_blog_page_id = focus_wp_get_option('blog','blog_page');
			$post_id = get_object_id($focus_wp_blog_page_id,'page');
		}
		$color = focus_wp_check_input(get_post_meta($post_id, '_header_bg_color', true));
		$bg = focus_wp_check_input(get_post_meta($post_id, '_header_bg', true));
		$bg_position = get_post_meta($post_id, '_header_position_x', true);
		$bg_repeat = get_post_meta($post_id, '_header_repeat', true);
		if(!empty($color) && $color != "transparent"){
			$color = 'background-color:'.$color.';';
		}else{
			$color = '';
		}
		if(!empty($bg)){
			$bg = 'background-image:url('.$bg.');background-position:top '.$bg_position.';background-repeat:'.$bg_repeat.'';
		}else{
			$bg = '';
		}
		if($focus_wp_stickyHeader) {
			$navbar = ' navbar-fixed-top';
		}else{
			$navbar = ' navbar-static-top';
		}
		$focus_wp_responsiveNav = 'qodx_resp_nav_under_' . $focus_wp_responsiveNav . ' ';
		$focus_wp_header_column = focus_wp_get_option('header','header_style');
		if(is_numeric($focus_wp_header_column)) {
			switch ( $focus_wp_header_column ):
				case 2:
					echo '<header id="header-section-2" class="header-section header-style-2"';
					break;
				case 1:
				default:
					echo '<header id="header-section-1" class="header-section header-style-1"';
					break;
			endswitch;
		}
		if(!empty($color) || !empty($bg)){
			echo' style="'.$color.''.$bg.'"';
		}
		echo '>';
	}
	function focus_wp_intro($post_id = NULL) {
		if (focus_wp_is_blog()){
			$focus_wp_blog_page_id = focus_wp_get_option('blog','blog_page');
			$post_id = get_object_id($focus_wp_blog_page_id,'page');
		}
		$color = focus_wp_check_input(get_post_meta($post_id, '_intro_bg_color', true));
		$textcolor = focus_wp_check_input(get_post_meta($post_id, '_intro_text_color', true));
		$bg = focus_wp_check_input(get_post_meta($post_id, '_intro_bg', true));
		$bg_position = get_post_meta($post_id, '_intro_position_x', true);
		$bg_repeat = get_post_meta($post_id, '_intro_repeat', true);
		if(!empty($color) && $color != "transparent"){
			$color = 'background-color:'.$color.';';
		}else{
			$color = '';
		}
		if(!empty($textcolor) && $textcolor != "transparent"){
			$textcolor = 'color:'.$textcolor.';';
		}else{
			$textcolor = '';
		}
		if(!empty($bg)){
			$bg = 'background-image:url('.$bg.');background-position:top '.$bg_position.';background-repeat:'.$bg_repeat.'';
		}else{
			$bg = '';
		}
		echo '<header id="qodx_intro"';
		if(!empty($color) || !empty($bg)){
			echo' style="'.$color.''.$textcolor.''.$bg.'"';
		}
		echo ' class="clearfix">';
	}
	function focus_wp_containerWrapp($post_id = NULL) {
		if (focus_wp_is_blog()){
			$focus_wp_blog_page_id = focus_wp_get_option('blog','blog_page');
			$post_id = get_object_id($focus_wp_blog_page_id,'page');
		}
		$color = focus_wp_check_input(get_post_meta($post_id, '_container_bg_color', true));
		$bg = focus_wp_check_input(get_post_meta($post_id, '_container_bg', true));
		$bg_position = get_post_meta($post_id, '_container_position_x', true);
		$bg_repeat = get_post_meta($post_id, '_container_repeat', true);
		if(!empty($color) && $color != "transparent"){
			$color = 'background-color:'.$color.';';
		}else{
			$color = '';
		}
		if(!empty($bg)){
			$bg = 'background-image:url('.$bg.');background-position:top '.$bg_position.';background-repeat:'.$bg_repeat.'';
		}else{
			$bg = '';
		}
		echo '<div id="qodx_containerWrapp"';
		if(!empty($color) || !empty($bg)){
			echo' style="'.$color.''.$bg.'"';
		}
		if(is_single()){
			echo ' class="qodx_section clearfix">';
		}
		else {
			echo ' class="clearfix">';
		}
	}
	function focus_wp_content($post_id = NULL) {
		if (focus_wp_is_blog()){
			$focus_wp_blog_page_id = focus_wp_get_option('blog','blog_page');
			$post_id = get_object_id($focus_wp_blog_page_id,'page');
		}
		$color = focus_wp_check_input(get_post_meta($post_id, '_content_bg_color', true));
		$bg = focus_wp_check_input(get_post_meta($post_id, '_content_bg', true));
		$bg_position = get_post_meta($post_id, '_content_position_x', true);
		$bg_repeat = get_post_meta($post_id, '_content_repeat', true);
		if(!empty($color) && $color != "transparent"){
			$color = 'background-color:'.$color.';';
		}else{
			$color = '';
		}
		if(!empty($bg)){
			$bg = 'background-image:url('.$bg.');background-position:top '.$bg_position.';background-repeat:'.$bg_repeat.'';
		}else{
			$bg = '';
		}
		
		echo '<div id="qodx_content"';
		if(!empty($color) || !empty($bg)){
			echo' style="'.$color.''.$bg.'"';
		}
		echo ' class="clearfix"';
		if ( is_page_template('template_fullwidth.php') || is_page_template('gallery-4-columns.php') || is_page_template('gallery-3-columns.php') || is_page_template('gallery-2-columns.php') || is_page_template('galleria.php') ) { 
			echo ' role="main"';
		}
		echo '>';
	}
	function focus_wp_footerWrapper($post_id = NULL) {
		echo ' <div id="qodx_footerWrapper" class="clearfix">';
	}
	function focus_wp_footer($post_id = NULL) {
		if (focus_wp_is_blog()){
			$focus_wp_blog_page_id = focus_wp_get_option('blog','blog_page');
			$post_id = get_object_id($focus_wp_blog_page_id,'page');
		}
		$color = focus_wp_check_input(get_post_meta($post_id, '_footer_bg_color', true));
		$bg = focus_wp_check_input(get_post_meta($post_id, '_footer_bg', true));
		$bg_position = get_post_meta($post_id, '_footer_position_x', true);
		$bg_repeat = get_post_meta($post_id, '_footer_repeat', true);
		
		if(!empty($color) && $color != "transparent"){
			$color = 'background-color:'.$color.';';
		}else{
			$color = '';
		}
		if(!empty($bg)){
			$bg = 'background-image:url('.$bg.');background-position:top '.$bg_position.';background-repeat:'.$bg_repeat.'';
		}else{
			$bg = '';
		}
		echo ' <footer id="qodx_footer"';
		if(!empty($color) || !empty($bg)){
			echo' style="'.$color.''.$bg.'"';
		}
		echo ' class="clearfix">';
	}
	function focus_wp_footerTop($post_id = NULL) {
		if (focus_wp_is_blog()){
			$focus_wp_blog_page_id = focus_wp_get_option('blog','blog_page');
			$post_id = get_object_id($focus_wp_blog_page_id,'page');
		}
		$color = focus_wp_check_input(get_post_meta($post_id, '_footer_top_color', true));
		$bg = focus_wp_check_input(get_post_meta($post_id, '_footer_top_bg', true));
		$bg_position = get_post_meta($post_id, '_footer_top_position_x', true);
		$bg_repeat = get_post_meta($post_id, '_footer_top_repeat', true);
		
		if(!empty($color) && $color != "transparent"){
			$color = 'background-color:'.$color.';';
		}else{
			$color = '';
		}
		if(!empty($bg)){
			$bg = 'background-image:url('.$bg.');background-position:top '.$bg_position.';background-repeat:'.$bg_repeat.'';
		}else{
			$bg = '';
		}		
		echo '<footer id="qodx_footerTop"';
		if(!empty($color) || !empty($bg)){
			echo' style="'.$color.''.$bg.'"';
		}
		echo ' class="clearfix">';
		echo '<div class="container">';
	}
	function focus_wp_footerBottom($post_id = NULL) {
		if (focus_wp_is_blog()){
			$focus_wp_blog_page_id = focus_wp_get_option('blog','blog_page');
			$post_id = get_object_id($focus_wp_blog_page_id,'page');
		}
		$color = focus_wp_check_input(get_post_meta($post_id, '_footer_bottom_color', true));
		$bg = focus_wp_check_input(get_post_meta($post_id, '_footer_bottom_bg', true));
		$bg_position = get_post_meta($post_id, '_footer_bottom_position_x', true);
		$bg_repeat = get_post_meta($post_id, '_footer_bottom_repeat', true);
		if(!empty($color) && $color != "transparent"){
			$color = 'background-color:'.$color.';';
		}else{
			$color = '';
		}
		if(!empty($bg)){
			$bg = 'background-image:url('.$bg.');background-position:top '.$bg_position.';background-repeat:'.$bg_repeat.'';
		}else{
			$bg = '';
		}
		
		$sub_footer_center = focus_wp_get_option('footer','sub_footer_center') ? 'text-center ' : '';
		
		echo '<footer id="qodx_footerBottom"';
		if(!empty($color) || !empty($bg)){
			echo' style="'.$color.''.$bg.'"';
		}
		echo ' class="'.$sub_footer_center.'clearfix">';
		echo '<div class="container">';
	}
	function focus_wp_breadcrumbs($post_id = NULL) {
		
		$color = focus_wp_check_input(get_post_meta($post_id, '_breadcrumbs_bg_color', true));
		$textcolor = focus_wp_check_input(get_post_meta($post_id, '_breadcrumbs_text_color', true));
		$bg = focus_wp_check_input(get_post_meta($post_id, '_breadcrumbs_bg', true));
		$bg_position = get_post_meta($post_id, '_breadcrumbs_position_x', true);
		$bg_repeat = get_post_meta($post_id, '_breadcrumbs_repeat', true);
		if(!empty($color) && $color != "transparent"){
			$color = 'background-color:'.$color.';';
		}else{
			$color = '';
		}
		if(!empty($bg)){
			$bg = 'background-image:url('.$bg.');background-position:top '.$bg_position.';background-repeat:'.$bg_repeat.'';
		}else{
			$bg = '';
		}
		if(!empty($color) || !empty($bg)){
			$inline_style = ' style="'.$color.$bg.'"';
		} else {
			$inline_style = '';
		}		
		
		if(!empty($textcolor) && $textcolor != "transparent"){
			$textcolor_out = ' style="color:'.$textcolor.'"';
		}else{
			$textcolor_out = '';
			$textcolor = '';
		}
		
		if(!focus_wp_is_enabled(get_post_meta($post_id, '_disable_breadcrumb', true), focus_wp_get_option('general','disable_breadcrumb'))){
		breadcrumbs_plus(array(
				'prefix' => '<div id="qodx_breadcrumbs_wrapp" data-color="'.$textcolor.'"><div class="breadcrumb-section section-no-padding"'.$inline_style.'><div class="section-container"><div class="container"><div class="row"><div class="col-md-12"><ol class="breadcrumb"'.$textcolor_out.'>',
				'suffix' => '</ol></div></div></div></div></div></div>',
				'title' => false,
				'home' => esc_html__( 'Home', 'focus_wp' ),
				'sep' => false,
				'front_page' => false,
				'bold' => false,
				'blog' => esc_html__( 'Blog', 'focus_wp' ),
				'echo' => true
			));
		}
	}	
	function focus_wp_custom_header($post_id = NULL) {
		$type = get_post_meta($post_id, '_intro_type', true);
		$textcolor = focus_wp_check_input(get_post_meta($post_id, '_intro_text_color', true));
		if(!empty($textcolor) && $textcolor != "transparent"){
			$textcolor = 'color:'.$textcolor.';';
		}else{
			$textcolor = '';
		}
		if (focus_wp_is_blog()){
			$focus_wp_blog_page_id = focus_wp_get_option('blog','blog_page');
			$post_id = get_object_id($focus_wp_blog_page_id,'page');
		}
		if (is_single() || is_page() || (is_front_page() && $post_id != NULL) || (is_home() && $post_id != NULL)){
			$type = get_post_meta($post_id, '_intro_type', true);

			if (empty($type))
				$type = 'default';			
			if (focus_wp_get_option('introheader','slideshow_everywhere') && $type == 'default') {
				$type = 'slideshow';
			}		
			if (focus_wp_get_option('introheader','static_image_everywhere') && $type == 'default') {
				$type = 'static_image';
			}		
			if (is_front_page() && $type == 'default') {
				$type = 'slideshow';
			}
			if ($type == 'disable') {
				return;
			}
			if ($type == 'slideshow'){
				$stype = get_post_meta($post_id, '_slideshow_type', true);
				if(empty($stype) || $stype == 'default'){
					$stype= focus_wp_get_option('introheader','slideshow_type');
				}
			}
			if ($type == 'static_image'){
				return focus_wp_generator('qodx_staticImage',$type);
			}
			if ($type == 'static_video'){
				return focus_wp_generator('qodx_staticVideo',$type);
			}
			if (in_array($type, array('default', 'title', 'title_custom'))) {
				$custom_title = get_post_meta($post_id, '_custom_title', true);
				if(!empty($custom_title)){
					$title = $custom_title;
				}else{
					$title = get_the_title($post_id);
				}
			}
			$focus_wp_blog_page_id = focus_wp_get_option('blog','blog_page');
			if ($type == 'default' && is_singular('post') && $post_id!=$focus_wp_blog_page_id) {
					return $this->focus_wp_custom_header($focus_wp_blog_page_id);
			}
			if (in_array($type, array('custom', 'title_custom'))) {
				$text = trim(get_post_meta($post_id, '_custom_introduce_text', true));
			}
		}
		if (is_archive()){
			if ((focus_wp_get_option('general', 'woocommerce')) && function_exists('is_woocommerce') && (is_woocommerce() || is_cart() || is_checkout() || is_account_page())) {
				$custom_title = get_post_meta($post_id, '_custom_title', true);
				$text = trim(get_post_meta($post_id, '_custom_introduce_text', true));
				if(!empty($custom_title)){
					$title = $custom_title;
				}else{
					$title = get_the_title( get_option( 'woocommerce_shop_page_id' ) );
				}
			}
			else {
				$title = esc_html__( 'Archives', 'focus_wp' );
			}
			if(is_category()){
				$text = sprintf( esc_html__( 'Category Archive for: ', 'focus_wp' ) . '<strong>"%s"</strong>',single_cat_title('',false));
			}elseif(is_tag()){
				$text = sprintf( esc_html__( 'Tag Archives for: ', 'focus_wp' ) . '<strong>"%s"</strong>',single_tag_title('',false));
			}elseif(is_day()){
				$text = sprintf( esc_html__( 'Daily Archive for: ', 'focus_wp' ) . '<strong>"%s"</strong>',get_the_time('F jS, Y'));
			}elseif(is_month()){
				$text = sprintf( esc_html__( 'Monthly Archive for: ', 'focus_wp' ) . '<strong>"%s"</strong>',get_the_time('F, Y'));
			}elseif(is_year()){
				$text = sprintf( esc_html__( 'Yearly Archive for: ', 'focus_wp' ) . '<strong>"%s"</strong>',get_the_time('Y'));
			}elseif(is_author()){
				if(get_query_var('author_name')){
					$curauth = get_user_by('slug', get_query_var('author_name'));
				} else {
					$curauth = get_userdata(get_query_var('author'));
				}
				$text = sprintf( esc_html__( 'Author Archive for: ', 'focus_wp' ) . '<strong>"%s"</strong>',$curauth->nickname);
			}elseif(isset($_GET['paged']) && !empty($_GET['paged'])) {
				$text = esc_html__( 'Blog Archives', 'focus_wp' );
			}elseif(is_tax()){
				if ((focus_wp_get_option('general', 'woocommerce')) && (is_product_category())) {
					$term = get_term_by( 'slug', get_query_var( 'term' ), get_query_var( 'taxonomy' ) );
					$text = sprintf( esc_html__( 'Category: %s', 'focus_wp' ),$term->name);
				}
				else {
					$term = get_term_by( 'slug', get_query_var( 'term' ), get_query_var( 'taxonomy' ) );
					$text = sprintf( esc_html__( 'Archives for: ', 'focus_wp' ) . '<strong>"%s"</strong>',$term->name);
				}
			}					
		
		}	
		if (is_404()) {
			$title = esc_html__( "Sorry! We couldn't find it." , 'focus_wp' );
			$text = esc_html__( "You have requested a page or file which does not exists anymore. Below are a few options to find what you are looking for.", 'focus_wp' );
		}
		
		if (is_search()) {
			$title = esc_html__( 'Search', 'focus_wp' );
			$text = sprintf( esc_html__( 'Search Results for: "%s"', 'focus_wp' ),stripslashes( strip_tags( get_search_query() ) ));
		}
		if( function_exists('is_woocommerce') && is_woocommerce()){
			if(function_exists('is_shop') && is_shop()){
				$shop_id = woocommerce_get_page_id( 'shop' );
				if($shop_id != $post_id){
					$type = get_post_meta($shop_id, '_intro_type', true);
					
					if (empty($type)){
						$type = 'default';
					}
					if($type !== 'default'){
						return focus_wp_generator('focus_wp_custom_header', $shop_id, false, true);
					}
					
				}
			}
		}
		if( function_exists('is_woocommerce') && (is_product() || is_product_category())) {
			$shop_id = woocommerce_get_page_id( 'shop' );
			if($shop_id != $post_id){
				$type = get_post_meta($shop_id, '_intro_type', true);
				
				if($type !== 'default'){
					return focus_wp_generator('focus_wp_custom_header', $shop_id, false, true);
				}
				else {
					$title = get_the_title( get_option( 'woocommerce_shop_page_id' ) );
				}
			}
			
		}
		
		echo focus_wp_generator('focus_wp_intro',$post_id);	
			
		echo "\n\t\t".'<div class="container">'."\n";
				
		echo "\t\t\t".'<div id="introType" class="qodx_intro"><div class="intro_text">';
		if (isset($title)) {
			if(!empty($textcolor)){
				echo '<h1 style="'.$textcolor.'">' . balanceTags( $title ) . '</h1>';
			} else {
				echo '<h1>' . balanceTags( $title ) . '</h1>';
			}
		}
		if (isset($text)) {
			echo '<p class="custom_title">'.balanceTags( $text ).'</p>';
		}
		global $post;
		echo "</div></div>\n\t\t";
		if (class_exists( 'Qodux_Framework' )) {
			if (is_single() && ($post->post_type != 'portfolio')) {
				echo focus_wp_generator('focus_wp_blog_single_meta'); 
			}
		}
		echo "</div>\n\t";
		echo "</header>\n";
	}
	
	function focus_wp_custom_title($post_id = NULL) {
		$type = get_post_meta($post_id, '_intro_type', true);
		if (focus_wp_is_blog()){
			$focus_wp_blog_page_id = focus_wp_get_option('blog','blog_page');
			$post_id = get_object_id($focus_wp_blog_page_id,'page');
		}
		if (is_single() || is_page() || (is_front_page() && $post_id != NULL) || (is_home() && $post_id != NULL)){
			$type = get_post_meta($post_id, '_intro_type', true);
			
			if (in_array($type, array('default', 'title', 'title_custom'))) {
				$custom_title = get_post_meta($post_id, '_custom_title', true);
				if(!empty($custom_title)){
					$title = $custom_title;
				}else{
					$title = get_the_title($post_id);
				}
			}
			
			if (in_array($type, array('custom', 'title_custom'))) {
				$text = '<p class="custom_title">'.trim(get_post_meta($post_id, '_custom_introduce_text', true)).'</p>';
			}
		}	
			echo "\t\t\t".'<div class="qodx_intro"><div class="intro_text">';
			if (isset($title)) {
				echo '<h2 class="title">' . $title . '</h2>';
			}
			if (isset($text)) {
				echo balanceTags( $text );
			}
			echo '<div class="line-separator"></div>';
			echo "</div></div>\n\t";
	}
					
	function focus_wp_portfolio_featured_image($type='full',$focus_wp_layout='', $height=''){
		if($focus_wp_layout == 'full'){
			$width = 1140;
		}else{
			$width = 848;
		}
		if(focus_wp_get_option('portfolio', 'featured_image_lightbox') == 'true'){
			wp_enqueue_script( 'fancybox' ); }
		$image_src_array = wp_get_attachment_image_src(get_post_thumbnail_id(),'full', true);
		$adaptive_height = focus_wp_get_option('portfolio', 'adaptive_height');
		
		if($adaptive_height){
			$height = floor($width*($image_src_array[2]/$image_src_array[1]));
		}else{
			$height = focus_wp_get_option('portfolio', 'fixed_height');
		}
		$image_src = aq_resize( focus_wp_get_image_src($image_src_array[0]), $width, $height, true ); //resize & crop img
		if( class_exists('Dynamic_Featured_Image')) {
			global $dynamic_featured_image;
			$featured_images = $dynamic_featured_image->get_featured_images( $post->ID );
			if (has_post_thumbnail()) {
				$image_src_array = wp_get_attachment_image_src(get_post_thumbnail_id(),'full', true);
				$image_src = focus_wp_get_image_src($image_src_array[0]); 
			}
		   	if( !is_null($featured_images) ){
			wp_print_scripts('owlCarousel');
				if (has_post_thumbnail()) {
					
				$title = get_post(get_post_thumbnail_id())->post_title; //The Title
				$alt = get_post_meta(get_post_thumbnail_id(), '_wp_attachment_image_alt', true); //The Alt
				$caption = get_post(get_post_thumbnail_id())->post_excerpt; //The Caption
				$description = get_post(get_post_thumbnail_id())->post_content; // The Description
				
					if($focus_wp_layout=='left'){
						if(focus_wp_get_option('portfolio', 'featured_image_lightbox')){
							$content .= $li.'<a class="fancybox" href="'.$image_src.'" title="'.get_the_title().'"><img src="'. aq_resize( $image_src, $img_width, $height, true ).'" alt="'.get_the_title().'" /></a>'.$end_li;
						} else {
							$content .= $li.'<img src="'. aq_resize( $image_src, $img_width, $height, true ).'" alt="'.get_the_title().'" />'.$end_li;
						}
					} else {
						if(focus_wp_get_option('portfolio', 'featured_image_lightbox')){
							$content .= $li.'<a class="fancybox" href="'.$image_src.'" title="'.get_the_title().'"><img src="'. aq_resize( $image_src, $width, $height, true ).'" alt="'.get_the_title().'" /></a>'.$end_li;
						} else {
							$content .= $li.'<img src="'. aq_resize( $image_src, $width, $height, true ).'" alt="'.get_the_title().'" />'.$end_li;
						}
					}
				}
			    foreach($featured_images as $images) {
				      
					$image_url = $images['full'];
				
					$title = $dynamic_featured_image -> get_image_title( $image_url ); //The (dynamic image) Title
					$alt = $dynamic_featured_image -> get_image_alt( $image_url ); //The (dynamic image) Alt
					$caption = $dynamic_featured_image -> get_image_caption( $image_url ); //The (dynamic image) Caption
					$description = $dynamic_featured_image -> get_image_description( $image_url ); // The (dynamic image) Description
				
					if($focus_wp_layout=='left'){
						if(focus_wp_get_option('portfolio', 'featured_image_lightbox')){
							$content .= $li.'<a class="fancybox" href="'.$image_url.'" title="'.get_the_title().'"><img src="'. aq_resize( $image_url, $img_width, $height, true ).'"';
						} else {
							$content .= $li.'<img src="'. aq_resize( $image_url, $img_width, $height, true ).'"';
						}
					}else{
						if(focus_wp_get_option('portfolio', 'featured_image_lightbox')){
							$content .= $li.'<a class="fancybox" href="'.$image_url.'" title="'.get_the_title().'"><img src="'. aq_resize( $image_url, $width, $height, true ).'"';
						} else {
							$content .= $li.'<img src="'. aq_resize( $image_url, $width, $height, true ).'"';
						}
					}	
					if(focus_wp_get_option('portfolio', 'featured_image_lightbox')){
						$content .= ' alt="'.$title.'" /></a>'.$end_li;
					} else {
						$content .= ' alt="'.$title.'" />'.$end_li;
					}
				}
			if($type=='left'){
				$output .= ' style="width:'.$width.'px"';
			}
			if($featured_images) {
				$output .= '<div id="qodx_owl_rotator" class="qodx_owl_rotator" data-owl-autoPlay="3000" data-owl-stopOnHover="true" data-owl-navigation="false" data-owl-pagination="true" data-owl-pagSpeed="1000" data-owl-autoHeight="true">';
				$output .= $content;
				$output .= '</div>';	
			} else {
				if (has_post_thumbnail()) {
				$output .= '<div class="image-block">';
				$output .= '<div class="image-block-container">';
				if(is_single()){
					if(focus_wp_get_option('portfolio', 'featured_image_lightbox')){
						$output .= '<a class="fancybox" href="'.$image_src_array[0].'" title="'.get_the_title().'">';
						$output .= '<img src="'.aq_resize( $image_src, $width, $height, true ) .'" alt="'.get_the_title().'" />';
						$output .= '</a>';
						$output .= '</span>';
					} else {
						$output .= '<img src="'.aq_resize( $image_src, $width, $height, true ) .'" alt="'.get_the_title().'" /></span>'; 
					}
				} else {
					$output .= '<a class="overlay_zoom" href="'. $image_src_array[0].'" title="">';
					$output .= '<img src="'.aq_resize( $image_src, $width, $height, true ).'" alt="'.get_the_title().'" />';
					$output .= '</a>';
				}
					$output .= '</div>';
				$output .= '</div>';	
				}
			}	
		}else {
			if (has_post_thumbnail()) {
				$output .= '<div class="image-block">';
				$output .= '<div class="image-block-container">';
				if(is_single()){
					if(focus_wp_get_option('portfolio', 'featured_image_lightbox')){
						$output .= '<a class="fancybox" href="'.$image_src_array[0].'" title="'.get_the_title().'">';
						$output .= '<img src="'.$image_src .'" alt="'.get_the_title().'" />';
						$output .= '</a>';
						$output .= '</span>';
					} else {
						$output .= '<img src="'.$image_src .'" alt="'.get_the_title().'" /></span>'; 
					}
			} else {
				$output .= '<a class="overlay_zoom" href="'. $image_src_array[0].'" title="">';
				$output .= '<img src="'.$image_src.'" alt="'.get_the_title().'" />';
				$output .= '</a>';
				$output .= '</div>';
			}
			$output .= '</div>';
		} 
	}
	}
	else {
		if (has_post_thumbnail()) {
				$output .= '<div class="image-block">';
				$output .= '<div class="image-block-container">';
			if(is_single()){
				if(focus_wp_get_option('portfolio', 'featured_image_lightbox') == 'true'){
					$output .= '<a class="fancybox" href="'.$image_src_array[0].'" title="'.get_the_title().'">';
					$output .= '<img src="'.$image_src .'" alt="'.get_the_title().'" />';
					$output .= '</a>';
					$output .= '</span>';
				} else {
					$output .= '<img src="'.$image_src .'" alt="'.get_the_title().'" /></span>'; 
				}
		} else {
			$output .= '<a class="fancybox" href="'. $image_src_array[0].'" title="">';
			$output .= '<img src="'.$image_src.'" alt="'.get_the_title().'" />';
			$output .= '</a>';
		}
			$output .= '</div>';
			$output .= '</div>';
		} 
	}
		return $output;
}
		
	function focus_wp_blog_featured_image($type='full',$focus_wp_layout='',$set_width='',$set_height=''){
		$image_src_array = wp_get_attachment_image_src(get_post_thumbnail_id(),'full', true);
			
		if(focus_wp_get_option('blog', 'featured_image_lightbox') == 'true'){
			wp_enqueue_script( 'fancybox' ); }
		if($focus_wp_layout == 'full'){
			$width = 1140;
			$left_width = 720; // content width under 991px where the image is displayed at full size
		}elseif(is_numeric($focus_wp_layout)){
			$width = $focus_wp_layout;
			$left_width = $width;
		}else{
			$width = 850;
			$left_width = 720; // main content width under 991px where the image is displayed at full size
		}
		
		if($type=='left'){
			if($focus_wp_layout == 'full'){
				$inline_width = focus_wp_get_option('blog', 'left_width'); // Full Layout - left image inline width
				$height = focus_wp_get_option('blog', 'left_image_height');
			} else {
				$inline_width = focus_wp_get_option('blog', 'sidebar_left_width'); // Sidebar Layout - left image inline width
				$height = focus_wp_get_option('blog', 'sidebar_left_image_height');
			}
		}else{
			$adaptive_height = focus_wp_get_option('blog', 'adaptive_height');
			$single_adaptive_height = focus_wp_get_option('blog', 'single_adaptive_height');
			if($adaptive_height && focus_wp_is_blog()){
				$height = floor($width*($image_src_array[2]/$image_src_array[1]));
			}elseif($single_adaptive_height && is_single()){
				$height = floor($width*($image_src_array[2]/$image_src_array[1]));
			}else{
				if($focus_wp_layout == 'full'){
					$height = focus_wp_get_option('blog', 'image_height');
				} else {
					$height = focus_wp_get_option('blog', 'sidebar_image_height');
				}
			}
		}
		
		// If width / height are set by default when function is called
		if ($set_width != '') {
			$width = $set_width;
		}
		if ($set_height != '') {
			$height = $set_height;
		}
		
		if($type=='left'){
			$width = $left_width; // The full width of the image
		}
		
		$image_src = aq_resize( focus_wp_get_image_src($image_src_array[0]), $width, $height, true ); //resize & crop img
		
		$output = '';
		if (has_post_thumbnail()){
			$output .= '<div class="image-block entry_image">';
			$output .= '<div class="image-block-container"';
			if($type=='left'){
				$output .= ' style="width:'.$inline_width.'px"';
			}
			$output .= '>';
			if(is_single()){
				if(focus_wp_get_option('blog', 'featured_image_lightbox')){
					$output .= '<a class="overlay_zoom fancybox" href="'.$image_src_array[0].'" title="'.get_the_title().'">';
					$output .= '<img src="'.$image_src.'" alt="'.get_the_title().'" width="'.$width.'" height="'.$height.'" />';
					$output .= '</a>';
				} else {
					$output .= '<img src="'.$image_src.'" alt="'.get_the_title().'" width="'.$width.'" height="'.$height.'" />';
				}
			} else {
				$output .= '<a class="overlay_zoom" href="'.get_permalink().'" title="">';
				$output .= '<img src="'.$image_src.'" alt="'.get_the_title().'" width="'.$width.'" height="'.$height.'" />';
				$output .= '</a>';
			}
			$output .= '</div>';
			$output .= '</div>';
		}
		return $output;
	}
		
	function focus_wp_blog_meta() {
 		global $post;
		$output = '<div class="meta-block"><div class="meta-block-container">';
		
		if (focus_wp_get_option('blog','meta_date') || !class_exists( 'Qodux_Framework' ) ){
			$output .= '<span class="meta-block-date">';
				$output .= '<i class="fa fa-calendar-o"></i>'.get_the_date();
			$output .= '</span>';
		}
		if (focus_wp_get_option('blog','meta_author') || !class_exists( 'Qodux_Framework' ) ){
			$output .= '<span class="entry_author">';
				$output .= '<i class="fa fa-user"></i><a class="no_link" href="">'.get_the_author_link().'</a>';				
				switch(focus_wp_get_option('blog','author_link_type')){
					case 'website':
						$author = get_the_author_link();
						break;
					case 'archive':
						$author = get_the_author_posts_link();
						break;
					case 'none':
					default:
						$author = get_the_author();
				}				
				
			$output .= '</span>';
		}
		if (focus_wp_get_option('blog','meta_category') || !class_exists( 'Qodux_Framework' ) ){
			$output .= '<span class="meta-block-cat">';
				$output .= '<i class="fa fa-folder-o"></i>';
				$output .= get_the_category_list(' ');
			$output .= '</span>';
		}
		if (focus_wp_get_option('blog','meta_views') || !class_exists( 'Qodux_Framework' ) ){	
		
			$count_key = 'post_views_count';
			$count = get_post_meta($post->ID, $count_key, true);
			if($count==''){
        		$count = 0;
			}			
			$output .= '<span class="meta-block-view">';
				$output .= '<i class="fa fa-eye"></i>';
				$output .= $count;
			$output .= '</span>';
		}
		
		$output .= get_edit_post_link( esc_html__( 'Edit', 'focus_wp' ) );
		if ( comments_open() || get_comments_number() ) {
			if(focus_wp_get_option('blog','meta_comment') && ($post->comment_count > 0) || !class_exists( 'Qodux_Framework' ) ){
				
				ob_start();
				comments_popup_link( esc_html__( ' 0 ', 'focus_wp' ), esc_html__( ' 1 ', 'focus_wp' ), esc_html__( ' % ', 'focus_wp' ),'');
				$output .= '<span class="meta-block-comment"><i class="fa fa-comments-o"></i>';
					$output .= ob_get_clean() ;	
				$output .= '</span>';				
			}
		}
		
		$output .= '</div></div>';
		return $output;		
	}
	
	function focus_wp_blog_single_meta() {
 		global $post;
		$output = '<div class="meta-block"><div class="meta-block-container">';
		
		if (focus_wp_get_option('blog','single_meta_date') || !class_exists( 'Qodux_Framework' ) ){
			$output .= '<span class="meta-block-date">';
				$output .= '<i class="fa fa-calendar-o"></i>'.get_the_date();
			$output .= '</span>';
		}
		if (focus_wp_get_option('blog','single_meta_author') || !class_exists( 'Qodux_Framework' ) ){
			
			$output .= '<span class="entry_author">';
				$output .= '<i class="fa fa-user"></i><a class="no_link" href="">'.get_the_author_link().'</a>';				
				switch(focus_wp_get_option('blog','author_link_type')){
					case 'website':
						$author = get_the_author_link();
						break;
					case 'archive':
						$author = get_the_author_posts_link();
						break;
					case 'none':
					default:
						$author = get_the_author();
				}				
				
			$output .= '</span>';
		}
		if (focus_wp_get_option('blog','single_meta_category') || !class_exists( 'Qodux_Framework' ) ){			
			$output .= '<span class="meta-block-cat">';
				$output .= '<i class="fa fa-folder-o"></i>';
				$output .= get_the_category_list(' ');
			$output .= '</span>';
		}
		if (focus_wp_get_option('blog','single_meta_views') || !class_exists( 'Qodux_Framework' ) ){	
		
			$count_key = 'post_views_count';
			$count = get_post_meta($post->ID, $count_key, true);		
			if($count==''){
        		$count = 0;
			}	
			$output .= '<span class="meta-block-view">';
				$output .= '<i class="fa fa-eye"></i>';
				$output .= $count;
			$output .= '</span>';
		}
		$output .= get_edit_post_link( esc_html__( 'Edit', 'focus_wp' ), '<span class="edit-link">', '</span>' );
		if ( comments_open() || get_comments_number() ) {
			if(focus_wp_get_option('blog','single_meta_comment') && ($post->comment_count > 0) || !class_exists( 'Qodux_Framework' ) ){
				
				ob_start();
				comments_popup_link( esc_html__( ' 0 ', 'focus_wp' ), esc_html__( ' 1 ', 'focus_wp' ), esc_html__( ' % ', 'focus_wp' ),'');
				$output .= '<span class="meta-block-comment"><i class="fa fa-comments-o"></i>';
					$output .= ob_get_clean() ;	
				$output .= '</span>';				
			}
		}
		$output .= '</div></div>';
		return $output;
	}
		
	function focus_wp_blog_single_meta_footer() {
 		global $post;
		$output = '';		
		if (focus_wp_get_option('blog','single_meta_tags')){	
			$output .= get_the_tag_list('<span><strong>' . esc_html__( 'TAGS: ', 'focus_wp' ) . '</strong></span>');
		}
		return $output;		
	}
	
	function focus_wp_blog_author_info() {
		 $description = is_tag() ? tag_description() : category_description();
	
		 $author_id    = get_query_var( 'author' );
		 $gravatar     = get_avatar( get_the_author_meta('user_email', $author_id), '75' );
		 $name         = get_the_author_meta('display_name', $author_id);
		 $heading      = esc_html__( "About", 'focus_wp' ) ." ".$name;
		 $heading_s    = esc_html__( "Entries by", 'focus_wp' ) ." ".$name;
		 $description  = get_the_author_meta('description', $author_id);
	
		 if(empty($description)) {
		     $description  = esc_html__( "This author has not yet written his bio.", 'focus_wp' );
		     $description .= '</br>'.sprintf( esc_html__( 'Meanwhile let\'s just say that we are proud %s contributed with %s entries.', 'focus_wp' ), $name, count_user_posts( $author_id ) );
	
		     if(current_user_can('edit_users') || get_current_user_id() == $author_id) {
			     $description .= "</br><a href='".admin_url( 'profile.php?user_id=' . $author_id )."'>".esc_html__( 'Edit the profile description here.', 'focus_wp' )."</a>";
		     }
		 }
		?>
		<section id="aboutTheAuthor">
			<div class="aboutTheAuthor_wrapp clearfix">
				<div class="gravatar"><?php echo balanceTags( $gravatar ); ?></div>
				<div class="aboutTheAuthor_content">
					<h4><?php echo esc_attr( $heading ); ?></h4>
					<p class="author_desc"><?php echo balanceTags( $description ); ?></p>
				</div>
			</div>
		</section>
		<?php 
        echo "<h4 class='qodx_extra_author_title widgettitle'>{$heading_s}</h4>";
	}

	function focus_wp_blog_popular_posts(){
		$r = new WP_Query(array(
			'showposts' => 4, 
			'nopaging' => 0, 
			'orderby'=> 'comment_count', 
			'post_status' => 'publish', 
			'ignore_sticky_posts' => 1
		));
		$output = '';
		if ($r->have_posts()){
			$output .= '<ul class="posts qodx_postList">';
			while ($r->have_posts()){
				$r->the_post();
				$output .= '<li>';
				$output .= '<a class="thumb" href="'.get_permalink().'" title="'.get_the_title().'">';
				if (has_post_thumbnail() ){
					$output .= get_the_post_thumbnail(get_the_ID(),'focus_wp_thumb', array(70,45),array('title'=>get_the_title(),'alt'=>get_the_title()));
				}else{
					$output .= '<img src="'.get_template_directory_uri() . '/img/widget_posts_thumbnail.png" width="70" height="45" title="'.get_the_title().'" alt="'. get_the_title().'"/>';
				}
				$output .= '</a>';
				$output .= '<div class="qodx_postInfo">';
				$output .= '<a class="post_title" href="'.get_permalink().'" title="'.get_the_title().'" rel="bookmark">'.get_the_title().'</a>';
				$output .= '<span class="date">'.get_the_date().'</span>';
				$output .= '</div>';
				$output .= '<div class="qodx_clearboth"></div>';
				$output .= '</li>';
			}
			$output .= '</ul>';
		}

		wp_reset_postdata();
		echo balanceTags( $output );
	}

	function focus_wp_blog_related_posts(){
		global $post;
		$backup = $post;  
		$tags = wp_get_post_tags($post->ID);
        $tagIDs = array();
        $related_post_found = false;
        $output = '';
		if ($tags) {
			$tagcount = count($tags);
			for ($i = 0; $i < $tagcount; $i++) {
				$tagIDs[$i] = $tags[$i]->term_id;
			}
			$r = new WP_Query(array(
				'tag__in' => $tagIDs,
				'post__not_in' => array($post->ID),
				'showposts'=>4,
				'ignore_sticky_posts'=>1
			));
			if ($r->have_posts()){
				$related_post_found = true;
				$output .= '<ul class="posts qodx_postList">';
				while ($r->have_posts()){
					$r->the_post();
					$output .= '<li>';
					$output .= '<a class="thumb" href="'.get_permalink().'" title="'.get_the_title().'">';
					if (has_post_thumbnail() ){
						$output .= get_the_post_thumbnail(get_the_ID(),'focus_wp_thumb', array(70,45),array('title'=>get_the_title(),'alt'=>get_the_title()));
					}else{
						$output .= '<img src="'.get_template_directory_uri() . '/img/widget_posts_thumbnail.png" width="70" height="45" title="'.get_the_title().'" alt="'. get_the_title().'"/>';
					}
					$output .= '</a>';
					$output .= '<div class="qodx_postInfo">';
					$output .= '<a class="post_title" href="'.get_permalink().'" title="'.get_the_title().'" rel="bookmark">'.get_the_title().'</a>';
					$output .= '<span class="date">'.get_the_date().'</span>';
					$output .= '</div>';
					$output .= '<div class="qodx_clearboth"></div>';
					$output .= '</li>';
				}
				$output .= '</ul>';
			}
			$post = $backup;
		}
		if(!$related_post_found){
			$r = new WP_Query(array(
				'showposts' => 4, 
				'nopaging' => 0, 
				'post_status' => 'publish', 
				'ignore_sticky_posts' => 1
			));
			if ($r->have_posts()){
				$output .= '<ul class="posts qodx_postList">';
				while ($r->have_posts()){
					$r->the_post();
					$output .= '<li>';
					$output .= '<a class="thumb" href="'.get_permalink().'" title="'.get_the_title().'">';
					if (has_post_thumbnail() ){
						$output .= get_the_post_thumbnail(get_the_ID(),'focus_wp_thumb', array(70,45),array('title'=>get_the_title(),'alt'=>get_the_title()));
					}else{
						$output .= '<img src="'.get_template_directory_uri() . '/img/widget_posts_thumbnail.png" width="70" height="45" title="'.get_the_title().'" alt="'. get_the_title().'"/>';
					}
					$output .= '</a>';
					$output .= '<div class="qodx_postInfo">';
					$output .= '<a class="post_title" href="'.get_permalink().'" title="'.get_the_title().'" rel="bookmark">'.get_the_title().'</a>';
					$output .= '<span class="date">'.get_the_date().'</span>';
					$output .= '</div>';
					$output .= '<div class="qodx_clearboth"></div>';
					$output .= '</li>';
				}
				$output .= '</ul>';
			}
		}
		wp_reset_postdata();

		echo balanceTags( $output );
	}
	
	function focus_wp_portfolio_related_posts(){
		global $post;
		$backup = $post;  
		$tags = wp_get_post_tags($post->ID);
        $tagIDs = array();
        $related_post_found = false;
		wp_print_scripts('owlCarousel');
        $output = '';
		if ($tags) {
			$tagcount = count($tags);
			for ($i = 0; $i < $tagcount; $i++) {
				$tagIDs[$i] = $tags[$i]->term_id;
			}
			$r = new WP_Query(array(
				'post_type' => 'portfolio', 
				'tag__in' => $tagIDs,
				'post__not_in' => array($post->ID),
				//'showposts'=>3,
				'ignore_sticky_posts'=>1
			));
			if ($r->have_posts()){
				$related_post_found = true;
				$output .= '<div class="qodx_portfolio_wrapper_carousel">';
				$output .= '<ul class="qodx_owl_carousel posts portfList" data-owl-speed="600" data-owl-pagSpeed="1000" data-owl-autoplay="false" data-owl-navigation="true" data-owl-pagination="false" data-owl-items="4" data-owl-itemsDesktop="4" data-owl-itemsSmallDesktop="4" data-owl-itemsSmallDesktop="3" data-owl-itemsTablet="2" data-owl-itemsMobile="2" data-owl-itemsMobileSmall="1">';
				while ($r->have_posts()){
					$r->the_post();
					$output .= '<li class="item">';
					$output .= '<article class="portEntry qodx_portofolio_item  col-lg-12 col-md-12 col-sm-12"><div class="qodx_portofolio_container">';
					$output .= '<header class="qodx_image_frame">';
					$output .= '<span class="qodx_image_holder qodx_blackwhite">';
					//$output .= '<a href="'.get_permalink().'" title="'.get_the_title().'">';
					
					if (has_post_thumbnail() ){
						$image_src_array = wp_get_attachment_image_src(get_post_thumbnail_id(),'full', true);
						$portfimg = focus_wp_get_image_src($image_src_array[0]);
						$output .= '<img src="'. $portfimg .'" alt="'.get_the_title().'" />';	
					}else{
						$output .= '<img src="'.get_template_directory_uri() . '/img/widget_posts_thumbnail.png" width="265" height="170" title="'.get_the_title().'" alt="'. get_the_title().'"/>';
					}
					$output .= '<a class="qodx_hover_link mfp-image" href="' . get_permalink() . '" title="' . get_the_title() . '"><span><i class="fa fa-link"></i></span></a>';
					$output .= '<a class="qodx_hover_view mfp-image" href="#" title="' . get_the_title() . '"><span><i class="fa fa-search"></i></span></a>';
					$output .= '</span>';
					$output .= '</header>';
					$output .= '<div class="qodx_portofolio_details">';
					$output .= '<h4 class="qodx_portfolio_title"><a class="post_title" href="'.get_permalink().'" title="'.get_the_title().'" rel="bookmark">'.get_the_title().'</a></h4>';
					$output .= '<div class="qodx_portofolio_det"><p>'.get_the_date().'<p></div>';
					$output .= '</div>';
					$output .= '<div class="qodx_clearboth"></div>';
					$output .= '</div></article>';
					$output .= '</li>';
				}
				$output .= '</ul>';
				$output .= '</div>';
			}
			$post = $backup;
		}
		if(!$related_post_found){
			$r = new WP_Query(array(
				'post_type' => 'portfolio', 
				'nopaging' => 0, 
				'post_status' => 'publish', 
				'ignore_sticky_posts' => 1
			));
			if ($r->have_posts()){
				$output .= '<div class="qodx_portfolio_wrapper_carousel">';
				$output .= '<ul class="qodx_owl_carousel posts portfList" data-owl-speed="600" data-owl-pagSpeed="1000" data-owl-autoplay="false" data-owl-navigation="true" data-owl-pagination="false" data-owl-items="4" data-owl-itemsDesktop="4" data-owl-itemsSmallDesktop="4" data-owl-itemsSmallDesktop="3" data-owl-itemsTablet="2" data-owl-itemsMobile="2" data-owl-itemsMobileSmall="1">';
				while ($r->have_posts()){
					$r->the_post();
					$output .= '<li class="item">';
					$output .= '<article class="portEntry qodx_portofolio_item  col-lg-12 col-md-12 col-sm-12"><div class="qodx_portofolio_container">';
					$output .= '<header class="qodx_image_frame">';
					$output .= '<span class="qodx_image_holder qodx_blackwhite">';
					
					if (has_post_thumbnail() ){
						$image_src_array = wp_get_attachment_image_src(get_post_thumbnail_id(),'full', true);
						$portfimg = focus_wp_get_image_src($image_src_array[0]);
						$output .= '<img src="'. $portfimg .'" alt="'.get_the_title().'" />';
					}else{
						$output .= '<img src="'.get_template_directory_uri() . '/img/widget_posts_thumbnail.png" width="265" height="170" title="'.get_the_title().'" alt="'. get_the_title().'"/>';
					}
					$output .= '<a class="qodx_hover_link mfp-image" href="' . get_permalink() . '" title="' . get_the_title() . '"><span><i class="fa fa-link"></i></span></a>';
					$output .= '<a class="qodx_hover_view mfp-image" href="#" title="' . get_the_title() . '"><span><i class="fa fa-search"></i></span></a>';
					$output .= '</span>';
					$output .= '</header>';
					$output .= '<div class="qodx_portofolio_details">';
					$output .= '<h4 class="qodx_portfolio_title"><a class="post_title" href="'.get_permalink().'" title="'.get_the_title().'" rel="bookmark">'.get_the_title().'</a></h4>';
					$output .= '<div class="qodx_portofolio_det"><p>'.get_the_date().'<p></div>';
					$output .= '</div>';
					$output .= '<div class="qodx_clearboth"></div>';
					$output .= '</div></article>';
					$output .= '</li>';
				}
				$output .= '</ul>';
				$output .= '</div>';
			}
		}
		wp_reset_postdata();

		echo balanceTags( $output );
	}
	
	function focus_wp_staticImage($type) {
		if (has_post_thumbnail() ) {
			$image_src_array = wp_get_attachment_image_src(get_post_thumbnail_id(),'full', true);
			$featured_image = focus_wp_get_image_src($image_src_array[0]);		
		}
		if(!empty($featured_image) && $type == 'static_image'){
			$staticImg = $featured_image;
		} else {
			$staticImg= focus_wp_get_option('introheader','static_image');
		}
		$width = 980;
		
		$static_adaptive_height = focus_wp_get_option('introheader', 'static_adaptive_height');
		if($static_adaptive_height){
			$height = floor($width*($image_src_array[2]/$image_src_array[1]));
		}else{
			$height = focus_wp_get_option('introheader', 'static_image_height');
		}
		
		$lightbox = '<a href="'.$staticImg.'" data-rel="fancybox" title="'. get_the_title() .'">';
		$image_src = aq_resize( $staticImg, $width, $height, true ); //resize & crop img
					
?>
	<header id="qodx_intro">
		<div class="container">
        	<div class="intro_staticImage">
                <?php echo focus_wp_get_option('introheader', 'static_image_lightbox') ? $lightbox : ''; ?>
				<img src="<?php echo esc_url( $image_src ); ?>" alt="<?php the_title(); ?>" />
                <?php echo focus_wp_get_option('introheader', 'static_image_lightbox') ? '</a>' : ''; ?>
			</div>
		</div>
	</header>
<?php		
	}
	
	function focus_wp_staticVideo($type) {
		global $post;
		if($type == 'static_video'){
			if (get_post_meta($post->ID, '_featured_video', true)) {
				$featured_video = focus_wp_check_input(get_post_meta($post->ID, '_featured_video', true));	
			}	
		}
?>
	<header id="qodx_intro">
		<div class="container">
        	<div class="intro_staticVideo">
				<?php 
				echo focus_wp_video_featured($focus_wp_video_featured, '', '', 720, 1280);
				?>
			</div>
		</div>
	</header>
<?php		
	}		
}// End class themeFeatures

function focus_wp_generator($function){
	global $_focus_wp_themeFeatures;
	$_focus_wp_themeFeatures = new Focus_WP_themeFeatures;
	$args = array_slice( func_get_args(), 1 );
	return call_user_func_array(array( &$_focus_wp_themeFeatures, $function ), $args );
}