<?php

$config = array(
	'title' => esc_html__( 'Team Member Options', 'qodux_fw' ),
	'id' => 'team',
	'pages' => array('team'),
	'callback' => '',
	'context' => 'normal',
	'priority' => 'low',
);
function get_sidebar_team(){
	$sidebars = focus_wp_get_option('sidebar','sidebars');
	if(!empty($sidebars)){
		$sidebars_array = explode(',',$sidebars);
		
		$options = array();
		foreach ($sidebars_array as $sidebar){
			$options[$sidebar] = $sidebar;
		}
		return $options;
	}else{
		return array();
	}
}
$options = array(
	array(
		"class" => "nav-tab-wrapper",
		"default" => '',
		"options" => array(
			"general" => esc_html__( 'General', 'qodux_fw' ),
			"team_member" => esc_html__( 'Team Member', 'qodux_fw' ),
		),
		"type" => "qodx_navigation",
	),
	
	array(
		"type" => "qodx_option_group_start",
		"group_id" => "general",
	),
		array(
			"name" => esc_html__( "Disable Breadcrumbs", 'qodux_fw' ),
			"desc" => esc_html__( 'This option disables breadcrumbs on a page/post.', 'qodux_fw' ),
			"id" => "_disable_breadcrumb",
			"label" => "Check to disable breadcrumbs on this post",
			"default" => "",
			"type" => "qodx_tritoggle"
		),		
		array(
			"name" => esc_html__( "Team  Custom Css Class", 'qodux_fw' ),
			"desc" => esc_html__( "Custom css class that you can specify for this team item. Useful for team shortcode.", 'qodux_fw' ),
			"id" => "_item_css",
			"default" => '',
			"type" => "qodx_text"
		),
		array(
			"name" => esc_html__( "Custom Sidebar", 'qodux_fw' ),
			"desc" => esc_html__( "If there are any custum sidebars created in your theme option panel then you can choose one of them to be displayed on this.", 'qodux_fw' ),
			"id" => "_sidebar",
			"prompt" => esc_html__( "Choose one...", 'qodux_fw' ),
			"default" => '',
			"options" => get_sidebar_team(),
			"type" => "qodx_select",
		),
	array(
		"type" => "qodx_group_end",
	),
	
	array(
		"type" => "qodx_option_group_start",
		"group_id" => "team_member",
	),
		array(
			"name" => esc_html__( "Position", 'qodux_fw' ),
			"desc" => esc_html__( 'Enter the team member\'s position within the team.', 'qodux_fw' ),
			"id" => "_position",
			"icon" => "group",
			"default" => "",
			"type" => "qodx_text"
		),
		array(
			"name" => esc_html__( "Phone Number", 'qodux_fw' ),
			"desc" => esc_html__( 'Enter the team member\'s phone number.', 'qodux_fw' ),
			"id" => "_phone",
			"icon" => "phone",
			"default" => "",
			"type" => "qodx_text"
		),
		array(
			"name" => esc_html__( "Email Address", 'qodux_fw' ),
			"desc" => esc_html__( 'Enter the team member\'s email address.', 'qodux_fw' ),
			"id" => "_email",
			"icon" => "envelope",
			"default" => "",
			"type" => "qodx_text"
		),
		array(
			"name" => esc_html__( "Website", 'qodux_fw' ),
			"desc" => esc_html__( 'Enter the team member\'s website.', 'qodux_fw' ),
			"id" => "_website",
			"icon" => "external-link-square",
			"default" => "",
			"type" => "qodx_text"
		),
		array(
			"name" => esc_html__( "Facebook", 'qodux_fw' ),
			"desc" => esc_html__( 'Enter the team member\'s Facebook URL.', 'qodux_fw' ),
			"id" => "_facebook",
			"icon" => "facebook",
			"default" => "",
			"type" => "qodx_text"
		),
		array(
			"name" => esc_html__( "Twitter", 'qodux_fw' ),
			"desc" => esc_html__( 'Enter the team member\'s Twitter URL.', 'qodux_fw' ),
			"id" => "_twitter",
			"icon" => "twitter",
			"default" => "",
			"type" => "qodx_text"
		),
		array(
			"name" => esc_html__( "Behance", 'qodux_fw' ),
			"desc" => esc_html__( 'Enter the team member\'s Behance URL.', 'qodux_fw' ),
			"id" => "_behance",
			"icon" => "behance",
			"default" => "",
			"type" => "qodx_text"
		),
		array(
			"name" => esc_html__( "Dribbble", 'qodux_fw' ),
			"desc" => esc_html__( 'Enter the team member\'s Dribbble URL.', 'qodux_fw' ),
			"id" => "_dribbble",
			"icon" => "dribbble",
			"default" => "",
			"type" => "qodx_text"
		),
		array(
			"name" => esc_html__( "Github", 'qodux_fw' ),
			"desc" => esc_html__( 'Enter the team member\'s Github URL.', 'qodux_fw' ),
			"id" => "_github",
			"icon" => "github",
			"default" => "",
			"type" => "qodx_text"
		),
		array(
			"name" => esc_html__( "Instagram", 'qodux_fw' ),
			"desc" => esc_html__( 'Enter the team member\'s Instagram URL.', 'qodux_fw' ),
			"id" => "_instagram",
			"icon" => "instagram",
			"default" => "",
			"type" => "qodx_text"
		),
		array(
			"name" => esc_html__( "Google Plus", 'qodux_fw' ),
			"desc" => esc_html__( 'Enter the team member\'s Google Plus URL.', 'qodux_fw' ),
			"id" => "_google",
			"icon" => "google-plus",
			"default" => "",
			"type" => "qodx_text"
		),
		array(
			"name" => esc_html__( "Linkedin", 'qodux_fw' ),
			"desc" => esc_html__( 'Enter the team member\'s Linkedin URL.', 'qodux_fw' ),
			"id" => "_linkedin",
			"icon" => "linkedin",
			"default" => "",
			"type" => "qodx_text"
		),
		array(
			"name" => esc_html__( "Skype", 'qodux_fw' ),
			"desc" => esc_html__( 'Enter the team member\'s Skype URL.', 'qodux_fw' ),
			"id" => "_skype",
			"icon" => "skype",
			"default" => "",
			"type" => "qodx_text"
		),
		
	array(
		"type" => "qodx_group_end",
	),	
);
new focus_wp_metaboxes($config,$options);