<?php
$qodx_options = array(
	array(
		"class" => "nav-tab-wrapper",
		"default" => '',
		"options" => array(
			"single_portfolio_settings" => esc_html__( 'Single Portfolio', 'qodux_fw' ),
			"featured_entry_settings" => esc_html__( 'Featured Entry', 'qodux_fw' ),
		),
		"type" => "qodx_navigation",
	),
	array(
		"type" => "qodx_group_start",
		"group_id" => "single_portfolio_settings",
	),
		array(
			"name" => esc_html__( "Single Portfolio Item", 'qodux_fw' ),
			"type" => "qodx_open"
		),
			array(
				"name" => esc_html__( "Layout", 'qodux_fw' ),
				"desc" => "Choose the layout of the Single Portfolio Item.",
				"id" => "layout",
				"default" => 'full',
				"options" => array(
					"full" => esc_html__( 'Full Width', 'qodux_fw' ),
					"right" => esc_html__( 'Right Sidebar', 'qodux_fw' ),
					"left" => esc_html__( 'Left Sidebar', 'qodux_fw' ),
				),
				"type" => "qodx_select",
			),
			array(
				"name" => esc_html__( "Previous & Next Navigation", 'qodux_fw' ),
				"desc" => "Displays the Previous & Next Navigation.",
				"id" => "single_navigation",
				"default" => false,
				"type" => "qodx_toggle"
			),
			array(
				"name" => esc_html__( "Previous & Next Navigation Order", 'qodux_fw' ),
				"desc" => "The style you want to order Previous & Next Navigation.",
				"id" => "single_navigation_order",
				"default" => 'post_data',
				"options" => array(
					"post_data" => esc_html__( 'Post Data', 'qodux_fw' ),
					"menu_order" => esc_html__( 'Menu Order', 'qodux_fw' ),
				),
				"type" => "qodx_select",
			),
			array(
				"name" => esc_html__( "Document Type Navigation", 'qodux_fw' ),
				"desc" => "If the button is set to ON then Previous & Next Navigation will be applied just for Portfolio Document Type.",
				"id" => "single_doc_navigation",
				"default" => true,
				"type" => "qodx_toggle"
			),			
			array(
				"name" => esc_html__( "Enable Comments", 'qodux_fw' ),
				"desc" => "If the button is set to ON then you enable comments on the Single Portfolio Item.",
				"id" => "enable_comment",
				"default" => false,
				"type" => "qodx_toggle"
			),
		array(
			"type" => "qodx_close"
		),
		array(
			"type" => "qodx_reset"
		),
	array(
		"type" => "qodx_group_end",
	),
	array(
		"type" => "qodx_group_start",
		"group_id" => "featured_entry_settings",
	),
		array(
			"name" => esc_html__( "Featured Entry", 'qodux_fw' ),
			"type" => "qodx_open"
		),
			array(
				"name" => esc_html__( "Featured Image", 'qodux_fw' ),
				"desc" => esc_html__( "If the button is set to ON then the Featured Image will be diplayed in Portfolio Item page.", 'qodux_fw' ),
				"id" => "featured_image",
				"default" => true,
				"type" => "qodx_toggle"
			),
			array(
				"name" => esc_html__( "Featured Image for Lightbox", 'qodux_fw' ),
				"desc" => esc_html__( "If the button is set to ON then when you click on the Featured Image from Portfolio Item page, the full image will be opened in a lightbox.", 'qodux_fw' ),
				"id" => "featured_image_lightbox",
				"default" => false,
				"type" => "qodx_toggle"
			),
			array(
				"name" => esc_html__( "Adaptive Height", 'qodux_fw' ),
				"desc" => esc_html__( "If the button is set to ON then the Featured Image height depends on the original image.", 'qodux_fw' ),
				"id" => "adaptive_height",
				"default" => false,
				"type" => "qodx_toggle"
			),
			array(
				"name" => esc_html__( "Fixed Height", 'qodux_fw' ),
				"desc" => esc_html__( "You can set a fixed height for the Featured Image only if the option above is OFF.", 'qodux_fw' ),
				"id" => "fixed_height",
				"min" => "1",
				"max" => "1000",
				"step" => "1",
				"unit" => 'px',
				"default" => "530",
				"type" => "qodx_range"
			),
		array(
			"type" => "qodx_close"
		),
		array(
			"type" => "qodx_reset"
		),
	array(
		"type" => "qodx_group_end",
	),
);
return array(
	'auto' => true,
	'name' => 'portfolio',
	'options' => $qodx_options
);