jQuery(document).ready(function( $ ) {

    var qodx_marker = false;

	/* ----- Add New Marker Setting Panel ----- */
	
    $(document).on('click', '.new_marker', function(e) {
        e.preventDefault();
        var marker_data = {
                'm_address'   : '',
                'm_lat_lng'   : '',
                'm_link'      : '',
                'm_title'     : '',
                'm_desc'      : '',
                'm_image_id'  : '',
                'm_image_url' : '',
                'm_img_text'  : '',
                'm_icon_id'   : '',
                'm_icon_url'  : ''
            },
            marker = qodx_marker_item_panel(marker_data);
        $('.qodx_markers_wrapper').append(marker);
    });

	/* ----- Show / Hide Marker Settings Panel ----- */
	
    $(document).on('click', '.qodx_marker_settings', function(e) {
        e.preventDefault();
        var marker_settings = $(this).parent().next();
        $('.qodx_marker_info').not(marker_settings).hide();
		
		if(!marker_settings.is(':visible')) {
			marker_settings.parent().addClass("qodx_marker_info_opened");
		} else {
			marker_settings.parent().removeClass("qodx_marker_info_opened");
		}
		
        marker_settings.slideToggle(200);
    });
	
	/* ----- Save Marker Settings Fields on Blur ----- */

    $(document).on('blur', '.m_link, .m_title, .m_address, .m_desc, .m_img_text', function() {
        var $this = $(this);

        // Get lat & lng of marker
        if($this.hasClass('m_address')) {
            var geocoder = new google.maps.Geocoder();
            // Add loader while coordinates are retriving
            $this.parent().parent().append('<div class="get_coordinates">Get marker latitude & longitude</div>');
            geocoder.geocode({ 'address': $this.val() }, function(results, status) {
                if (status == google.maps.GeocoderStatus.OK) {
                    // Save coords in data-lat_lng attr
                    $this.attr('data-lat_lng', results[0].geometry.location);
                }
                $this.parent().parent().find('.get_coordinates').remove();
                // Update textarea with new json markers list
                qodx_save_markers_data();
            });
        } else {
            // Update textarea with new json markers list
            qodx_save_markers_data();
        }
		
		// Adding title val() to ".marker_title" span. This helps to easily recognize the marker when its info block is :hidden
        if($this.hasClass('m_title')) $this.parent().parent().parent().find('.marker_title').text($this.val());
    });	
	
	/* ----- Remove Marker Settings Panel ----- */
	
    $(document).on('click', '.remove_marker', function(e) {
        e.preventDefault();
        $(this).parent().parent().remove();
		
		// Update textarea with new json markers list
        qodx_save_markers_data();
    });	
	
	/* ----- WP Media Library - Upload Content Images & Custom Markers ----- */
	   
    $(document).on('click', '.qodx_uploader', function(e) {
        e.preventDefault();
        var $this = $(this),
			custom_uploader = false,
			$title;	
			
        qodx_marker = $this.parent().parent().parent();

        if (custom_uploader) {
            custom_uploader.open();
            return;
        }
		
		if ( $this.hasClass("qodx_content_img") ) {
			$title = 'Select content image';
		} else {
			$title = 'Select marker';
		}
		
        custom_uploader = wp.media.frames.file_frame = wp.media({
            title: $title,
            button: {
                text: 'Select'
            },
            multiple: false
        });
		
        custom_uploader.on('select', function() {
            attachment = custom_uploader.state().get('selection').first().toJSON();
            // console.log(attachment);

           	if ( $this.hasClass("qodx_content_img") ) {
				// Add content image preview
				qodx_marker.find('.m_image_prev').remove();
				qodx_marker.find('.remove_content_image').remove();
				qodx_marker.find('.qodx_content_img').after('<img class="m_image_prev" data-image_id="'+attachment.id+'" src="'+attachment.url+'">');
				qodx_marker.find('.m_image_prev').after('<a href="#" class="remove_content_image">Remove</a>');
			} else { 
				// Add marker icon preview
				qodx_marker.find('.m_icon_prev').remove();
				qodx_marker.find('.remove_marker_image').remove();
				qodx_marker.find('.qodx_marker_img').after('<img class="m_icon_prev" data-icon_id="'+attachment.id+'" src="'+attachment.url+'">');
				qodx_marker.find('.m_icon_prev').after('<a href="#" class="remove_marker_image">Remove</a>');
			}

            // Update textarea with new json markers list
            qodx_save_markers_data();

            qodx_marker = false;
        });
        custom_uploader.open();
    });
	
	/* ----- Remove Content Image ----- */
		   
    $(document).on('click', '.remove_content_image', function(e) {
        e.preventDefault();
        var $this = $(this);
        qodx_marker = $this.parent().parent().parent();
		
		// Remove marker icon preview
		qodx_marker.find('.m_image_prev').remove();
        qodx_marker.find('.qodx_content_img').after('<img class="m_image_prev" data-image_id="" src="">');
		$this.remove();

		// Update textarea with new json markers list
		qodx_save_markers_data();
    });
	
	/* ----- Remove Marker Image ----- */
		   
    $(document).on('click', '.remove_marker_image', function(e) {
        e.preventDefault();
        var $this = $(this);
        qodx_marker = $this.parent().parent().parent();
		
		// Remove marker icon preview
		qodx_marker.find('.m_icon_prev').remove();
        qodx_marker.find('.qodx_marker_img').after('<img class="m_icon_prev" data-icon_id="" src="">');
		$this.remove();

		// Update textarea with new json markers list
		qodx_save_markers_data();
    });

});

/* Saving Markers Data And Raturn Data As Json
   --------------------------------------------------------- */

function qodx_save_markers_data() {
    jQuery(document).ready(function($) {
        var marker_data_textarea = $('#vc_ui-panel-edit-element .marker_data');
        if($('#vc_ui-panel-edit-element .qodx_marker_item').length > 0) {
            var data = {},
                i = 0;
            $('#vc_ui-panel-edit-element .qodx_marker_item').each(function() {
                var $this = $(this),
                    row = {},
					
					// Get marker latitude & longitude values - on addresss field blur event
                    m_lat_lng = $this.find('.m_address').attr('data-lat_lng');

                if(m_lat_lng == undefined) m_lat_lng = '';

                row['m_address']   = $this.find('.m_address').val();
                row['m_lat_lng']   = m_lat_lng;
                row['m_link']      = $this.find('.m_link').val();
                row['m_title']     = $this.find('.m_title').val();
                row['m_desc']      = $this.find('.m_desc').val();
                row['m_image_id']  = $this.find('.m_image_prev').attr('data-image_id');
                row['m_image_url'] = $this.find('.m_image_prev').attr('src');
                row['m_img_text']  = $this.find('.m_img_text').val();
                row['m_icon_id']   = $this.find('.m_icon_prev').attr('data-icon_id');
                row['m_icon_url']  = $this.find('.m_icon_prev').attr('src');
				
                data[i] = row;
                i++;
            });
            marker_data_textarea.html(JSON.stringify(data));
            return true;
        }
        marker_data_textarea.html('');
        return false;
    });
}

/* Marker Item Panel
   --------------------------------------------------------- */
   	
function qodx_marker_item_panel(marker_data) {
    // Build marker icon preview
    var qodx_marker_icon = qodx_image_icon  = '';
		
    if(marker_data.m_image_id != undefined) {
        qodx_image_icon = '<img class="m_image_prev" data-image_id="" src="">';
    }
    if(marker_data.m_image_id != '') {
        qodx_image_icon = '<img class="m_image_prev" data-image_id="'+marker_data.m_image_id+'" src="'+marker_data.m_image_url+'">';
        qodx_image_icon += '<a href="#" class="remove_content_image">Remove</a>';
    }
	
    if(marker_data.m_icon_id != undefined) {
        qodx_marker_icon = '<img class="m_icon_prev" data-icon_id="" src="">';
    }
    if(marker_data.m_icon_id != '') {
        qodx_marker_icon = '<img class="m_icon_prev" data-icon_id="'+marker_data.m_icon_id+'" src="'+marker_data.m_icon_url+'">';
        qodx_marker_icon += '<a href="#" class="remove_marker_image">Remove</a>';
    }
    
    var m_lat_lng = (marker_data.m_lat_lng == undefined)? '' : marker_data.m_lat_lng;

    return '<div class="qodx_marker_item">'+
                '<div class="qodx_marker_events">'+
                    '<span class="marker_icon dashicons dashicons-location"></span>'+
                    '<a href="#" class="qodx_marker_settings">Marker settings</a>'+
                    '<span class="marker_title">'+marker_data.m_title+'</span>'+
                    '<a href="#" class="remove_marker">x</a>'+
                '</div>'+
                '<div class="qodx_marker_info">'+
                    '<div class="mi_section">'+
                        '<span>Marker address:</span>'+
                        '<input class="m_address" type="text" value="'+marker_data.m_address+'" data-lat_lng="'+m_lat_lng+'">'+
                    '</div>'+
                    '<div class="mi_section">'+
                        '<span>InfoWindow link:</span>'+
                        '<input class="m_link" type="text" value="'+marker_data.m_link+'">'+
                    '</div>'+
                    '<div class="mi_section">'+
                        '<span>InfoWindow title:</span>'+
                        '<input class="m_title" type="text" value="'+marker_data.m_title+'">'+
                    '</div>'+
                    '<div class="mi_section">'+
                        '<span>InfoWindow content:</span>'+
                        '<textarea class="m_desc">'+marker_data.m_desc+'</textarea>'+
                    '</div>'+
                    '<div class="mi_section">'+
                        '<a href="#" class="qodx_uploader qodx_content_img">Content image</a>'+
                        qodx_image_icon+
                    '</div>'+
                    '<div class="mi_section mi_last">'+
                        '<a href="#" class="qodx_uploader qodx_marker_img">Marker image</a>'+
                        qodx_marker_icon+
                    '</div>'+
                    '<div class="mi_section">'+
                        '<span>Content Image text overlay:</span>'+
                        '<textarea class="m_img_text">'+marker_data.m_img_text+'</textarea>'+
                    '</div>'+
                '</div>'+
            '</div>';
}