<?php

// File Security Check
if (!defined('ABSPATH')) die('-1');

/*
Register Qodux shortcode.
*/

class WPBakeryShortCode_QODX_bx_rotator extends WPBakeryShortCode {
	
	private $qodx_sc;
	
	public function __construct($settings) {
        parent::__construct($settings);
		$this->qodx_sc = new QODX_VCSC_SHORTCODE;
	}
						
	protected function content($atts, $content = null) {
		
		extract( shortcode_atts( array(
			'mode'           => 'horizontal',
			'effect'         => 'ease-in-out',
			"speed"          => '500',
			"pause"          => '3000',
			'autoplay'       => '',
			'controlnav'     => '',
			'pagernav'       => '',
			'slide_count'    => 1,
									
			'el_id'          => '',
			'el_class'       => '',
    		'css_animation'  => '',
    		'anim_type'      => '',
    		'anim_delay'     => '',			
			'css'            => ''		
		), $atts ) );
		
		$sc_class = 'qodx_bx_rotator_sc';
						
		$id = mt_rand(9999, 99999);
		if (trim($el_id) != false) {
			$el_id = esc_attr( trim($el_id) );
		} else {
			$el_id = $sc_class . '-' . $id;
		}
		
		wp_print_scripts('qodx-extend-bx-slider');
		wp_enqueue_style('qodx-extend-bx-slider');
		
		$output = '';		
		
		$autoplay   !== "true" ? $autoplay = 'false' : '';
		$controlnav !== "true" ? $controlnav = 'false' : '';
		$pagernav   !== "true" ? $pagernav = 'false' : '';		
		
		$el_class   = esc_attr( $this->getExtraClass($el_class) );
		$css_class  = apply_filters(VC_SHORTCODE_CUSTOM_CSS_FILTER_TAG, $sc_class.$el_class.vc_shortcode_custom_css_class($css, ' '), $this->settings['base']);	
		$css_class .= $this->qodx_sc->getWTCSSAnimationClass($css_animation,$anim_type);
		$anim_data  = $this->qodx_sc->getWTCSSAnimationData($css_animation,$anim_delay);
		
		$speed = (int)$speed;
		$pause = (int)$pause;
		
		$output .= '<div id="'.$el_id.'" class="'.$css_class.'"'.$anim_data.'>';
				
		$output .= "\n\t\t\t".'<ul class="qodx_bxslider" data-bx-mode="'.$mode.'" data-bx-effect="'.$effect.'" data-bx-speed="'.$speed.'" data-bx-pause="'.$pause.'" data-bx-autoPlay="'.$autoplay.'" data-bx-controlNav="'.$controlnav.'" data-bx-pagerNav="'.$pagernav.'">';
		
		for($i = 1; $i <= $slide_count; $i++) {
			$item_content = '';
								
			isset($atts["content_" . $i]) && $atts["content_" . $i] != "" ? $item_content = $atts["content_" . $i] : '';
			
			if ($item_content != '') {
				$item_content = rawurldecode(base64_decode(strip_tags($item_content)));
				//$item_content = rawurldecode(strip_tags($item_content));
			}	
							
			$output .= "\n\t\t\t\t".'<li class="item">';
													
				$output .= "\n\t\t\t\t\t" . do_shortcode($item_content);				
				
			$output .= "\t\t\t\t".'</li>';
			
		}
		
		$output .= "\n\t\t\t".'</ul>';
		$output .= "\n\t\t\t".'</div>';			
		
        return $output;
    }
	
}

/*
Register Qodux shortcode within Visual Composer interface.
*/

if (function_exists('vc_map')) {

	$add_qodx_sc_func             = new QODX_VCSC_SHORTCODE;
	$add_qodx_extra_id            = $add_qodx_sc_func->getWTExtraId();
	$add_qodx_extra_class         = $add_qodx_sc_func->getWTExtraClass();
	$add_qodx_css_animation       = $add_qodx_sc_func->getWTAnimations();
	$add_qodx_css_animation_type  = $add_qodx_sc_func->getWTAnimationsType();
	$add_qodx_css_animation_delay = $add_qodx_sc_func->getWTAnimationsDelay();
	
	vc_map( array(
		'name'          => esc_html__( 'Bx Rotator', 'qodux_fw' ),
		'base'          => 'qodx_bx_rotator',
		'icon'          => 'qodx-icon-bx_rotator fa fa-ellipsis-h',
		'class'         => 'qodx_vc_sc_bx_rotator',
		'category'      => esc_html__( 'by Qodux', 'qodux_fw' ),
		'description'   => esc_html__( 'Bx content rotator', 'qodux_fw' ),
		'params'        => array(
			array(
				'type'          => 'dropdown',
				'heading'       => esc_html__( 'Mode', 'qodux_fw' ),
				'param_name'    => 'mode',
				'value'         => array( 
					esc_html__( 'Horizontal', 'qodux_fw' ) => 'horizontal',
					esc_html__( "Vertical", 'qodux_fw' )   => 'vertical',
					esc_html__( 'Fade', 'qodux_fw' )       => 'fade'
				),
				'description'   => esc_html__( 'Type of transition between slides.', 'qodux_fw' )
			),
			array(
				'type'          => 'dropdown',
				'heading'       => esc_html__( 'Effect', 'qodux_fw' ),
				'param_name'    => 'effect',
				'value'         => array( 
					esc_html__( "EaseInOut", 'qodux_fw' ) => 'ease-in-out',
					esc_html__( 'EaseOut', 'qodux_fw' )   => 'ease-out',
					esc_html__( 'Ease', 'qodux_fw' )      => 'ease',
					esc_html__( 'easeIn', 'qodux_fw' )    => 'ease-in',
					esc_html__( 'Linear', 'qodux_fw' )    => 'linear'
				),
				'description'   => esc_html__( 'Here you can set the transition effect when the items are changing.', 'qodux_fw' )
			),
			array(
				'type'          => 'textfield',
				'heading'       => esc_html__( 'Speed', 'qodux_fw' ),
				'param_name'    => 'speed',
				'std'           => '500',
				'description'   => esc_html__( 'Here you can set the slide transition duration (in miliseconds). Example: \'100\', \'500\', \'1000\'.', 'qodux_fw' )
			),
			array(
				'type'          => 'textfield',
				'heading'       => esc_html__( 'Pause', 'qodux_fw' ),
				'param_name'    => 'pause',
				'std'           => '3000',
				'description'   => esc_html__( 'The amount of time between each auto transition. (in miliseconds). Example: \'100\', \'500\', \'1000\'.', 'qodux_fw' )
			),
			array(
				'type'          => 'checkbox',
				'heading'       => esc_html__( 'Auto Start', 'qodux_fw' ),
				'param_name'    => 'autoplay',
				'value'         => array( esc_html__( 'Yes, please', 'qodux_fw' ) => 'true' ),
				'description'   => esc_html__( 'If YES, slides will automatically transition.', 'qodux_fw' )
			),
			array(
				'type'          => 'checkbox',
				'heading'       => esc_html__( 'Control Navigation', 'qodux_fw' ),
				'param_name'    => 'controlnav',
				'value'         => array( esc_html__( 'Yes, please', 'qodux_fw' ) => 'true' ),
				'description'   => esc_html__( 'If YES, the Control Navigation (next & prev buttons) is displayed.', 'qodux_fw' )
			),
			array(
				'type'          => 'checkbox',
				'heading'       => esc_html__( 'Pager (Navigation)', 'qodux_fw' ),
				'param_name'    => 'pagernav',
				'value'         => array( esc_html__( 'Yes, please', 'qodux_fw' ) => 'true' ),
				'description'   => esc_html__( 'If YES, the Pager Navigation is displayed.', 'qodux_fw' )
			),
			array(
				'type'          => 'dropdown',
				'heading'       => esc_html__( 'Number Of Items.', 'qodux_fw' ),
				'param_name'    => 'slide_count',
				'value'         => array( 
					1  => '1', 
					2  => '2', 
					3  => '3', 
					4  => '4', 
					5  => '5', 
					6  => '6', 
					7  => '7', 
					8  => '8', 
					9  => '9',
					10 => '10', 
					11 => '11',
					12 => '12',
					13 => '13',
					14 => '14',
					15 => '15'
				),
				'description'   => esc_html__( 'Specify the number of slide items.', 'qodux_fw' ) .' <strong>' . esc_html__( 'Maximum allowed is \'15\' items', 'qodux_fw' ) .'</strong>.'
			),		
						
				array(
					'type'               => 'textarea_raw_html',
        			//'holder'             => 'div',
					'heading'            => sprintf( esc_html__( "Item Content %d", 'qodux_fw' ),1),
					'param_name'         => sprintf("content_%d",1),
					'value' 			 => '<p>I am test text block. Click edit button to change this text.</p>',
					'param_holder_class' => 'wtcode border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('1','2','3','4','5','6','7','8','9','10','11','12','13','14','15')
					)
				),
					
				array(
					'type'               => 'textarea_raw_html',
					'heading'            => sprintf( esc_html__( "Item Content %d", 'qodux_fw' ),2),
					'param_name'         => sprintf("content_%d",2),
        			'value'              => '',
					'param_holder_class' => 'wtcode border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('2','3','4','5','6','7','8','9','10','11','12','13','14','15')
					)
				),
					
				array(
					'type'               => 'textarea_raw_html',
					'heading'            => sprintf( esc_html__( "Item Content %d", 'qodux_fw' ),3),
					'param_name'         => sprintf("content_%d",3),
        			'value'              => '',
					'param_holder_class' => 'wtcode border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('3','4','5','6','7','8','9','10','11','12','13','14','15')
					)
				),
					
				array(
					'type'               => 'textarea_raw_html',
					'heading'            => sprintf( esc_html__( "Item Content %d", 'qodux_fw' ),4),
					'param_name'         => sprintf("content_%d",4),
        			'value'              => '',
					'param_holder_class' => 'wtcode border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('4','5','6','7','8','9','10','11','12','13','14','15')
					)
				),
					
				array(
					'type'               => 'textarea_raw_html',
					'heading'            => sprintf( esc_html__( "Item Content %d", 'qodux_fw' ),5),
					'param_name'         => sprintf("content_%d",5),
        			'value'              => '',
					'param_holder_class' => 'wtcode border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('5','6','7','8','9','10','11','12','13','14','15')
					)
				),
					
				array(
					'type'               => 'textarea_raw_html',
					'heading'            => sprintf( esc_html__( "Item Content %d", 'qodux_fw' ),6),
					'param_name'         => sprintf("content_%d",6),
        			'value'              => '',
					'param_holder_class' => 'wtcode border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('6','7','8','9','10','11','12','13','14','15')
					)
				),
					
				array(
					'type'               => 'textarea_raw_html',
					'heading'            => sprintf( esc_html__( "Item Content %d", 'qodux_fw' ),7),
					'param_name'         => sprintf("content_%d",7),
        			'value'              => '',
					'param_holder_class' => 'wtcode border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('7','8','9','10','11','12','13','14','15')
					)
				),
					
				array(
					'type'               => 'textarea_raw_html',
					'heading'            => sprintf( esc_html__( "Item Content %d", 'qodux_fw' ),8),
					'param_name'         => sprintf("content_%d",8),
        			'value'              => '',
					'param_holder_class' => 'wtcode border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('8','9','10','11','12','13','14','15')
					)
				),
				
				array(
					'type'               => 'textarea_raw_html',
					'heading'            => sprintf( esc_html__( "Item Content %d", 'qodux_fw' ),9),
					'param_name'         => sprintf("content_%d",9),
        			'value'              => '',
					'param_holder_class' => 'wtcode border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('9','10','11','12','13','14','15')
					)
				),
					
				array(
					'type'               => 'textarea_raw_html',
					'heading'            => sprintf( esc_html__( "Item Content %d", 'qodux_fw' ),10),
					'param_name'         => sprintf("content_%d",10),
        			'value'              => '',
					'param_holder_class' => 'wtcode border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('10','11','12','13','14','15')
					)
				),
					
				array(
					'type'               => 'textarea_raw_html',
					'heading'            => sprintf( esc_html__( "Item Content %d", 'qodux_fw' ),11),
					'param_name'         => sprintf("content_%d",11),
        			'value'              => '',
					'param_holder_class' => 'wtcode border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('11','12','13','14','15')
					)
				),
					
				array(
					'type'               => 'textarea_raw_html',
					'heading'            => sprintf( esc_html__( "Item Content %d", 'qodux_fw' ),12),
					'param_name'         => sprintf("content_%d",12),
        			'value'              => '',
					'param_holder_class' => 'wtcode border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('12','13','14','15')
					)
				),
				
				array(
					'type'               => 'textarea_raw_html',
					'heading'            => sprintf( esc_html__( "Item Content %d", 'qodux_fw' ),13),
					'param_name'         => sprintf("content_%d",13),
        			'value'              => '',
					'param_holder_class' => 'wtcode border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('13','14','15')
					)
				),
					
				array(
					'type'               => 'textarea_raw_html',
					'heading'            => sprintf( esc_html__( "Item Content %d", 'qodux_fw' ),14),
					'param_name'         => sprintf("content_%d",14),
        			'value'              => '',
					'param_holder_class' => 'wtcode border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('14','15')
					)
				),
					
				array(
					'type'               => 'textarea_raw_html',
					'heading'            => sprintf( esc_html__( "Item Content %d", 'qodux_fw' ),15),
					'param_name'         => sprintf("content_%d",15),
        			'value'              => '',
					'param_holder_class' => 'wtcode border_box qodx_dependency',
					'dependency'         => array(
						'element' => 'slide_count', 
						'value'   => array('15')
					)
				),
			
			$add_qodx_extra_id,
			$add_qodx_extra_class,
			$add_qodx_css_animation,
			$add_qodx_css_animation_type,
			$add_qodx_css_animation_delay,
			
			array(
				'type'          => 'css_editor',
				'heading'       => esc_html__( 'Css', 'qodux_fw' ),
				'param_name'    => 'css',
				'group'         => esc_html__( 'Design options', 'qodux_fw' )
			)
		)
	));
	
}