<?php

// File Security Check
if (!defined('ABSPATH')) die('-1');

/*
Register Qodux shortcode.
*/

class WPBakeryShortCode_QODX_service_box extends WPBakeryShortCode {
	
	private $qodx_sc;
	
	public function __construct($settings) {
        parent::__construct($settings);
		$this->qodx_sc = new QODX_VCSC_SHORTCODE;
	}
	
	public function singleParamHtmlHolder( $param, $value ) {
		$output = '';
		// Compatibility fixes
		$old_names = array(
			'yellow_message',
			'blue_message',
			'green_message',
			'button_green',
			'button_grey',
			'button_yellow',
			'button_blue',
			'button_red',
			'button_orange',
		);
		$new_names = array(
			'alert-block',
			'alert-info',
			'alert-success',
			'btn-success',
			'btn',
			'btn-info',
			'btn-primary',
			'btn-danger',
			'btn-warning',
		);
		$value = str_ireplace( $old_names, $new_names, $value );

		$param_name = isset( $param['param_name'] ) ? $param['param_name'] : '';
		$type = isset( $param['type'] ) ? $param['type'] : '';
		$class = isset( $param['class'] ) ? $param['class'] : '';

		if ( 'attach_image' === $param['type'] && 'image' === $param_name ) {
			$output .= '<input type="hidden" class="wpb_vc_param_value ' . $param_name . ' ' . $type . ' ' . $class . '" name="' . $param_name . '" value="' . $value . '" />';
			$element_icon = $this->settings( 'icon' );
			$img = wpb_getImageBySize( array(
				'attach_id' => (int) preg_replace( '/[^\d]/', '', $value ),
				'thumb_size' => 'thumbnail',
			) );
			$this->setSettings( 'logo', ( $img ? $img['thumbnail'] : '<img width="150" height="150" src="' . vc_asset_url( 'vc/blank.gif' ) . '" class="attachment-thumbnail vc_general vc_element-icon"  data-name="' . $param_name . '" alt="" title="" style="display: none;" />' ) . '<span class="no_image_image vc_element-icon' . ( ! empty( $element_icon ) ? ' ' . $element_icon : '' ) . ( $img && ! empty( $img['p_img_large'][0] ) ? ' image-exists' : '' ) . '" /><a href="#" class="column_edit_trigger' . ( $img && ! empty( $img['p_img_large'][0] ) ? ' image-exists' : '' ) . '">' . __( 'Add image', 'qodux_fw' ) . '</a>' );
			$output .= $this->outputTitleTrue( $this->settings['name'] );
		} elseif ( ! empty( $param['holder'] ) ) {
			if ( 'input' === $param['holder'] ) {
				$output .= '<' . $param['holder'] . ' readonly="true" class="wpb_vc_param_value ' . $param_name . ' ' . $type . ' ' . $class . '" name="' . $param_name . '" value="' . $value . '">';
			} elseif ( in_array( $param['holder'], array( 'img', 'iframe' ) ) ) {
				$output .= '<' . $param['holder'] . ' class="wpb_vc_param_value ' . $param_name . ' ' . $type . ' ' . $class . '" name="' . $param_name . '" src="' . $value . '">';
			} elseif ( 'hidden' !== $param['holder'] ) {
				$output .= '<' . $param['holder'] . ' class="wpb_vc_param_value ' . $param_name . ' ' . $type . ' ' . $class . '" name="' . $param_name . '">' . $value . '</' . $param['holder'] . '>';
			}
		}

		if ( ! empty( $param['admin_label'] ) && true === $param['admin_label'] ) {
			$output .= '<span class="vc_admin_label admin_label_' . $param['param_name'] . ( empty( $value ) ? ' hidden-label' : '' ) . '"><label>' . $param['heading'] . '</label>: ' . $value . '</span>';
		}

		return $output;
	}
	
	protected function outputTitle( $title ) {
		return '';
	}
	
	protected function outputTitleTrue( $title ) {
		return '<h4 class="wpb_element_title">' . $title . ' ' . $this->settings( 'logo' ) . '</h4>';
	}
				
	protected function content($atts, $content = null) {
		
		// Get and extract shortcode attributes
		$atts = vc_map_get_attributes( $this->getShortcode(), $atts );
		extract( $atts );
		
		$sc_class = 'qodx_service_box_sc';	
					
		$id = mt_rand(9999, 99999);
		if (trim($el_id) != false) {
			$el_id = esc_attr( trim($el_id) );
		} else {
			$el_id = $sc_class . '-' . $id;
		}		
		
		$style        = ($style!='') ? $style : '';		
		$el_style     = '';	
		$inline_style = '';
		$img_output   = '';
		$button_style_icon = '';
		$button_style = esc_html( $button_style );
		$button_text  = esc_html( $button_text );
		$slide_number = (int)$slide_number;
			
		$btn_start = $btn_end = '';
		if ($button_style == 'circle') {
			$button_style_cls = 'btn-qodx-circle btn-qodx-circle-md'; 
			$button_style_icon = '<i class="fa fa-angle-double-right"></i>'; 
		} elseif ($button_style == 'white') {
			$button_style_cls = 'btn btn-qodx-white'; 
			$button_style_icon = ' <i class="fa fa-angle-double-right"></i>'; 
			$btn_start = '<h5>';
			$btn_end = '</h5>';
		} else {
			$button_style_cls = 'btn btn-default btn-xs'; }
		// Service Image Output
		if ( $border_color != '' ) {
			if ($style == 'vc_box_border' || $style == 'vc_box_border_circle' ) {
				$el_style = 'background-color:' . esc_attr( $border_color ) . ';';
			}
			if ($style == 'vc_box_outline' || $style == 'vc_box_outline_circle' ) {
				$el_style = 'border-color:' . esc_attr( $border_color ) . ';';
			}
		}
		
		$img_id = preg_replace('/[^\d]/', '', $image);
		
		if ( $border_color != '' && ($style == 'vc_box_border' || $style == 'vc_box_border_circle' || $style == 'vc_box_outline' || $style == 'vc_box_outline_circle') ) {
			$img = qodx_wpb_getImageBySize(array( 'attach_id' => $img_id, 'thumb_size' => $img_size, 'class' => $style, 'style' => $el_style ));
		} else {
			$img = wpb_getImageBySize(array( 'attach_id' => $img_id, 'thumb_size' => $img_size, 'class' => $style ));
		}
				
		$img_output = ($style=='vc_box_shadow_3d') ? '<span class="vc_box_shadow_3d_wrap">' . $img['thumbnail'] . '</span>' : $img['thumbnail'];			
				
		// Service Icon Output
		if ( $default_icon == 'yes' ) {
			$icon_default = ' qodx_icon_default';
		} else {
			$icon_default = '';
		}
			
		if ( $icon_background != '' ) {
			$icon_background = 'background: ' . $icon_background . ';';
		}
			
		if ( $icon_color != '' ) {
			if ( $icon_type != 'qodx_icon_type_3' ) {
				$icon_color = 'color: ' . $icon_color . ';';
			} else {
				$icon_color = 'color: ' . $icon_color . ';' . 'border-color: ' . $icon_color . ';'; 
			}
		}
		
		if ( $icon_background != '' || $icon_color != '' ) {
			$inline_style = ' style="'. $icon_color . $icon_background .'"';
		}
		
		if ( $icon_type != 'qodx_icon_type_3' ) {
			$border_style = ''; // Add border style only for type_3 icons
		} else {
			$border_style = ' qodx_icon_border_' . $border_style;
		}
		
		$icon  = esc_html( $icon );
		$title = esc_html( $title );
		
		if ( $icon_type != 'qodx_icon_type_2' && $icon_type != 'qodx_icon_type_3' ) {
			$icon_style = ''; // Add icon style (rounded, squared and circle) ony for type2 and type3 icons
		} else {
			$icon_style = ' ' . $icon_style;
		}
		
		if ($icon_type == 'qodx_icon_type_1') {
			$title_type = ' qodx_title_type_1';
		} elseif ($icon_type == 'qodx_icon_type_2') {
			$title_type = ' qodx_title_type_2';
		} else {
			$title_type = ' qodx_title_type_3';
		}
		
		$icon_type  = ' ' . $icon_type;
		
		$title_size = ' qodx_title_' . $icon_size;
		$icon_size  = ' qodx_icon_' . $icon_size;
		
		if ( $icon != '' ) {
			$icon_out = '<i class="'.$icon.'"></i>';
		} else {
			$icon_out = ''; 
		}
		
		if ( $empty_space == 'yes' ) {
			$empty_space = ' qodx_overflow_hidden';
		} else {
			$empty_space = '';
		}
		
		if ( $alignment != 'center' && $title_content_new_row == 'yes' ) {
			$new_content_rows = ' qodx_title_content_new_row';
		} elseif ( $alignment != 'center' && $content_new_row == 'yes' ) {
			$new_content_rows = ' qodx_content_new_row';
		} else {
			$new_content_rows = '';			
		}
		
		if ( $title != '' ) {
			// parse button link	
			$title_title_out = '';
			$title_target_out = '';
			$title_link = ($title_link=='||') ? '' : $title_link;
			$title_link = vc_build_link($title_link);
			$title_url = esc_url($title_link['url']);
			if ( $title_url != '' ) {		
				$title_out = '<h4><a href="'.$title_url.'"' . $title_title_out . $title_target_out .'>'.$title.'</a></h4>';
			} else {
				$title_out = '<h4>'.$title.'</h4>';
			}
		} else {
			$title_out = ''; 
		}
		
		if ( $button_text != '' ) {
			
			// parse button link		
			$button_link = ($button_link=='||') ? '' : $button_link;
			$button_link = vc_build_link($button_link);
			$button_url = esc_url($button_link['url']);
			
			$button_title = $button_link['title'];
			$button_title_out = ($button_title!='') ? ' title="' . esc_attr( $button_title ) .'"' : '';	
			
			$button_target = $button_link['target'];
			$button_target_out = ($button_target!='') ? ' target="' . $button_target .'"' : '';	
			
			if ( $button_url != '' ) {
				$button_out = '<a class="'.$button_style_cls.' wave-effect" href="'.$button_url.'"' . $button_title_out . $button_target_out .'>'.$btn_start.$button_text.''.$button_style_icon.$btn_end.' <i class="fa fa-long-arrow-right"></i></a>';
			} else {
				$button_out = '<a class="'.$button_style_cls.' wave-effect" href="#">'.$button_text.''.$button_style_icon.' <i class="fa fa-long-arrow-right"></i></a>';
			}
		} else {
			$button_out = ''; 
		}
		
		if ( $img_output != '' ) {
			$service_with_img = ' qodx_service_with_img relative-image'; 
		} else {
			$service_with_img = ''; 
		}
		
		if ( $swiper_pag ) {
			$slide_to = $slide_number != '' ? ' data-qodx-swiper-slide-to="' . $slide_number . '"' : ' data-qodx-swiper-slide-to="1"'; 
		} else {
			$slide_to = ''; 
		}
				
		$el_class = esc_attr( $this->getExtraClass($el_class) );
		$el_css   = ' qodx_align_' . $alignment . $new_content_rows . $service_with_img . ' content-block';	
		$css_class = apply_filters(VC_SHORTCODE_CUSTOM_CSS_FILTER_TAG, $sc_class.$el_css.$el_class.vc_shortcode_custom_css_class($css, ' '), $this->settings['base']);	
		$css_class .= $this->qodx_sc->getWTCSSAnimationClass($css_animation,$anim_type);
		$anim_data = $this->qodx_sc->getWTCSSAnimationData($css_animation,$anim_delay);		
		
		$content = wpb_js_remove_wpautop($content, true); // fix unclosed/unwanted paragraph tags in $content		
			
		$output = '<div id="'.$el_id.'" class="'.$css_class.'"'.$anim_data.$slide_to.'>';
			$output .= '<div class="content-block-container">'; // it is needed for click event when 'swiper_pag' is true
			if ( $new_content_rows != '' ) { // if title, or content, or both of them are on new rows
			
				if ( $icon_out != '' ) {
					$output .= "\n\t" . '<div class="qodx_icon'.$icon_type.$icon_style.$border_style.$icon_size.$icon_default.'"'.$inline_style.'>'; 
						$output .= $icon_out;
					$output .= "\n\t" . '</div>';
				}
				
				if ( $img_output != '' ) {
					$output .= "\n\t" . '<div class="qodx_service_img image-block">';
					$output .= "\n\t" . '<div class="image-block-container">';  
						$output .= $img_output;
						if ($title_position == 'over') {
							$output .= '<div class="ribbon-block ribbon-block-style-1">'; 
								$output .= "\n\t" . $title_out;
							$output .= '</div>';
						}
						if ($button_position == 'over') {
							$output .= "\n\t" . $button_out;
						}
					$output .= "\n\t" . '</div>';
					$output .= "\n\t" . '</div>';
				}
				
				// if title and content are on new rows
				if ( trim($new_content_rows) == 'qodx_title_content_new_row' ) {
					$output .= '<div class="qodx_clearboth"></div>';
				}				
				
				// set title line height
				if ( trim($new_content_rows) == 'qodx_content_new_row' ) {
					$title_height = $title_size;
				} else {
					$title_height = '';
					$title_type   = '';
				}
					$output .= '<div class="qodx_service_details'.$empty_space.$title_type.$title_height.'">'; 
					if ($title_position == 'default') {
						$output .= "\n\t" . $title_out;
					}
					$output .= '</div>';
				// always new row for content
				$output .= '<div class="qodx_clearboth"></div>';
				
				$output .= '<div class="qodx_service_details qodx_new_content_row'.$empty_space.'">';
					$output .= "\n\t" . $content;
				$output .= '</div>';
				
				if ($button_position == 'default') {
					$output .= "\n\t" . $button_out;
				}
				
			} else {
				
				if ( $icon_out != '' ) {
					$output .= "\n\t" . '<div class="qodx_icon'.$icon_type.$icon_style.$border_style.$icon_size.$icon_default.'"'.$inline_style.'>'; 
						$output .= $icon_out;
					$output .= "\n\t" . '</div>';
				}
				
				if ( $img_output != '' ) {
					$output .= "\n\t" . '<div class="qodx_service_img image-block">'; 
					$output .= "\n\t" . '<div class="image-block-container">';  
						$output .= $img_output;
						if ($title_position == 'over') {
							$output .= '<div class="ribbon-block ribbon-block-style-1">'; 
								$output .= "\n\t" . $title_out;
							$output .= '</div>';
						}
						if ($button_position == 'over') {
							$output .= "\n\t" . $button_out;
						}
					$output .= "\n\t" . '</div>';
					$output .= "\n\t" . '</div>';
				}
				
				$output .= '<div class="qodx_service_details'.$empty_space.'">'; 
					if ($title_position == 'default') {
						$output .= "\n\t" . $title_out;
					}
					$output .= "\n\t" . $content;
					
					if ($button_position == 'default') {
						$output .= "\n\t\t" . $button_out;
					}	
				$output .= '</div>';
				
			}
			$output .= '</div>'; // End "content-block-container"
		$output .= '</div>';
		
        return $output;
								
    }
	
}
	
/*
Register Qodux shortcode within Visual Composer interface.
*/

if (function_exists('vc_map')) {

	$add_qodx_sc_func             = new QODX_VCSC_SHORTCODE;
	$add_qodx_extra_id            = $add_qodx_sc_func->getWTExtraId();
	$add_qodx_extra_class         = $add_qodx_sc_func->getWTExtraClass();
	$add_qodx_css_animation       = $add_qodx_sc_func->getWTAnimations();
	$add_qodx_css_animation_type  = $add_qodx_sc_func->getWTAnimationsType();
	$add_qodx_css_animation_delay = $add_qodx_sc_func->getWTAnimationsDelay();
	
	vc_map( array(
		'name'          => esc_html__( 'Service Box', 'qodux_fw' ),
		'base'          => 'qodx_service_box',
		'icon'          => 'qodx-icon-service_box fa fa-trophy',
		'class'         => 'qodx_vc_sc_service_box',
		'category'      => esc_html__( 'by Qodux', 'qodux_fw' ),
		'description'   => esc_html__( 'Build a service box', 'qodux_fw' ),
		'params'        => array(
			array(
				'type'		  => 'qodx_separator',
				'heading'	  => '',
				"param_name"  => 'separator',
				'value'	      => '',
				'separator'	  => 'Service Image & Styles'
			),
			array(
				'type'          => 'attach_image',
				'heading'       => esc_html__( 'Image', 'qodux_fw' ),
				'param_name'    => 'image',
				'value'         => '',
				'description'   => esc_html__( 'Select image from media library.', 'qodux_fw' )
			),
			array(
				'type'          => 'textfield',
				'heading'       => esc_html__( 'Image size', 'qodux_fw' ),
				'param_name'    => 'img_size',
				'description'   => esc_html__( 'Enter image size. Example: "thumbnail", "medium", "large", "full" or other sizes defined by current theme. Alternatively enter image size in pixels: 200x100 (Width x Height). Leave empty to use "thumbnail" size.', 'qodux_fw' )
			),
			array(
				'type'          => 'dropdown',
				'heading'       => esc_html__( 'Image style', 'qodux_fw' ),
				'param_name'    => 'style',
				'value'         => QODX_VCSC_getShared('single image styles')
			),
			array(
				'type'          => 'colorpicker',
				'heading'       => esc_html__( 'Border color', 'qodux_fw' ),
				'param_name'    => 'border_color',
				'dependency'    => Array('element' => 'style', 'value' => array('vc_box_border', 'vc_box_border_circle', 'vc_box_outline', 'vc_box_outline_circle')),
				'description'   => esc_html__( 'Select border color for your image.', 'qodux_fw' )
			),			
			array(
				'type'		  => 'qodx_separator',
				'heading'	  => '',
				"param_name"  => 'separator_2',
				'value'	      => '',
				'separator'	  => 'Service Icon & Styles'
			),
			array(
				'type'          => 'textfield',
				'heading'       => esc_html__( 'Icon', 'qodux_fw' ),
				'param_name'    => 'icon',
				'description'   => '<a href="http://fortawesome.github.io/Font-Awesome/icons/" target="_blank">Font Awesome</a>, <a href="http://entypo.com/" target="_blank">Entypo</a> or <a href="http://glyphicons.com/" target="_blank">Glyphicons</a> accepted. (use "fa fa-", "entypo-" or "glyphicon-" prefix - for example "<strong>fa fa-adjust, entypo-flag or glyphicon-leaf</strong>"'
			),
			array(
				'type'          => 'dropdown',
				'heading'       => esc_html__( 'Icon type', 'qodux_fw' ),
				'param_name'    => 'icon_type',
				'value'         => array( 
					esc_html__( 'Simple', 'qodux_fw' )             		 => 'qodx_icon_type_1',
					esc_html__( 'Background', 'qodux_fw' )         		 => 'qodx_icon_type_2', 
					esc_html__( 'Background hover & border', 'qodux_fw' )   => 'qodx_icon_type_3',
				),
				'description'   => esc_html__( 'Select service icon type.', 'qodux_fw' )
			),
			array(
				'type'          => 'dropdown',
				'heading'       => esc_html__( 'Icon style', 'qodux_fw' ),
				'param_name'    => 'icon_style',
				'value'         => array(
					esc_html__( 'Square', 'qodux_fw' )          => 'qodx_icon_square', 
					esc_html__( 'Rounded', 'qodux_fw' )         => 'qodx_icon_rounded',
					esc_html__( 'Circle', 'qodux_fw' )          => 'qodx_icon_circle',
					esc_html__( 'Diamond', 'qodux_fw' )   	     => 'qodx_icon_diamond',
					esc_html__( 'Diamond Rounded', 'qodux_fw' ) => 'qodx_icon_diamond qodx_icon_rounded',
				),
				'std'           => 'qodx_icon_circle',
				'dependency' 	=> array(
					'element' 	=> 'icon_type',
					'value' 	=> array('qodx_icon_type_2', 'qodx_icon_type_3')
				),
				'description'   => esc_html__( 'Select service icon style.', 'qodux_fw' )
			),
			array(
				'type'			=> 'checkbox',
				'heading'		=> esc_html__( 'Default Icon?', 'qodux_fw' ),
				'param_name'	=> 'default_icon',
				'value'			=> Array( esc_html__( 'Yes please.', 'qodux_fw' ) => 'yes'),
				'description'   => esc_html__( 'Check this option to add a default background / border color.', 'qodux_fw' )
			),
			array(
				'type'			=> 'dropdown',
				'class'			=> '',
				'heading'		=> esc_html__( 'Border Style', 'qodux_fw' ),
				'param_name'	=> 'border_style',
				'value'			=> array(
					esc_html__( 'Solid', 'qodux_fw' )	=> 'solid',
					esc_html__( 'Dotted', 'qodux_fw' )	=> 'dotted',
					esc_html__( 'Dashed', 'qodux_fw' )	=> 'dashed',
				),
				'dependency' 	=> array(
					'element' 	=> 'icon_type',
					'value' 	=> array('qodx_icon_type_3')
				),
				'description'   => esc_html__( 'Select border style.', 'qodux_fw' )
			),
			array(
				'type'          => 'colorpicker',
				'heading'       => esc_html__( 'Icon background', 'qodux_fw' ),
				'param_name'    => 'icon_background',
				'dependency' 	=> array(
					'element' 	=> 'icon_type',
					'value' 	=> array('qodx_icon_type_2', 'qodx_icon_type_3')
				),
				'description'   => esc_html__( 'Select icon background.', 'qodux_fw' )
			),
			array(
				'type'          => 'colorpicker',
				'heading'       => esc_html__( 'Icon color', 'qodux_fw' ),
				'param_name'    => 'icon_color',
				'description'   => esc_html__( 'Select icon color.', 'qodux_fw' )
			),
			array(
				'type'          => 'dropdown',
				'heading'       => esc_html__( 'Icon size', 'qodux_fw' ),
				'param_name'    => 'icon_size',
				'value'         => array( 
					'20' => '20',
					'24' => '24',
					'25' => '25',
					'26' => '26',
					'30' => '30', 
					'32' => '32',  
					'34' => '34', 
					'35' => '35',
					'36' => '36',
					'38' => '38',
					'40' => '40',
					'42' => '42',
					'44' => '44',
					'45' => '45',
					'50' => '50',
					'60' => '60',
				),
				'std'           => '30',
				'description'   => esc_html__( 'Select icon size.', 'qodux_fw' )
			),				
			array(
				'type'		  => 'qodx_separator',
				'heading'	  => '',
				"param_name"  => 'separator_3',
				'value'	      => '',
				'separator'	  => 'Service Title & Content'
			),
			array(
				'type'          => 'dropdown',
				'heading'       => esc_html__( 'Alignment', 'qodux_fw' ),
				'param_name'    => 'alignment',
				'value'         => array( esc_html__( 'Align left', 'qodux_fw' ) => 'left', esc_html__( 'Align right', 'qodux_fw' ) => 'right', esc_html__( 'Align center', 'qodux_fw' ) => 'center'),
				'std'           => 'left',
				'description'   => esc_html__( 'Select service box alignment.', 'qodux_fw' )
			),
				array(
					'type'			=> 'checkbox',
					'heading'		=> esc_html__( 'New row for title & content?', 'qodux_fw' ),
					'param_name'	=> 'title_content_new_row',
					'value'			=> Array( esc_html__( 'Yes please.', 'qodux_fw' ) => 'yes'),
					'param_holder_class' => 'qodx_dependency',
					'dependency' 	=> array(
						'element' 	=> 'alignment',
						'value' 	=> array('left', 'right')
					),
					'description'   => esc_html__( 'Check this option if you want a new row for service title & content.', 'qodux_fw' )
				),	
				array(
					'type'			=> 'checkbox',
					'heading'		=> esc_html__( 'New row for content?', 'qodux_fw' ),
					'param_name'	=> 'content_new_row',
					'value'			=> Array( esc_html__( 'Yes please.', 'qodux_fw' ) => 'yes'),
					'param_holder_class' => 'qodx_dependency',
					'dependency' 	=> array(
						'element' 	=> 'alignment',
						'value' 	=> array('left', 'right')
					),
					'description'   => esc_html__( 'Check this option if you want a new row only for service content.', 'qodux_fw' )
				),		
				array(
					'type'			=> 'checkbox',
					'heading'		=> esc_html__( 'Empty space below icon?', 'qodux_fw' ),
					'param_name'	=> 'empty_space',
					'value'			=> Array( esc_html__( 'Yes please.', 'qodux_fw' ) => 'yes'),
					'param_holder_class' => 'qodx_dependency',
					'dependency' 	=> array(
						'element' 	=> 'alignment',
						'value' 	=> array('left', 'right')
					),
					'description'   => esc_html__( 'Check this option if you don\'t want to fill the space below icon with text.', 'qodux_fw' )
				),	
			array(
				'type'        => 'dropdown',
				'heading'     => esc_html__( 'Service title position', 'qodux_fw' ),
				"param_name"  => "title_position",
				'value'       => array( esc_html__( 'Default', 'qodux_fw' ) => 'default', esc_html__( 'Across the image', 'qodux_fw' ) => 'over'),
				'std'         => 'default',
				"description" => esc_html__( "Choose position for service title.", 'qodux_fw' )
			),
			array(
				'type'          => 'textfield',
				'heading'       => esc_html__( 'Service title', 'qodux_fw' ),
				'param_name'    => 'title',
				"admin_label"   => true,
				'description'   => esc_html__( 'Add title for your service box.', 'qodux_fw' )
			),
			array(
				'type'        => 'vc_link',
				'heading'     => esc_html__( 'Service title Link', 'qodux_fw' ),
				'param_name'  => 'title_link',
				'value'       => '',
				'description' => esc_html__( 'Type Service title link here.', 'qodux_fw' )
			),
			array(
				"type"		  => "dropdown",
				"heading"	  => esc_html__( "Button Style", 'qodux_fw' ),
				"param_name"  => "button_style",
				'value'       => array( 
					esc_html__( 'Normal', 'qodux_fw' ) => 'normal', 
					esc_html__( 'White', 'qodux_fw' )  => 'white', 
					esc_html__( 'Circle', 'qodux_fw' ) => 'circle'
				),
				'std'         => 'normal',
				"description" => esc_html__( "Choose button style.", 'qodux_fw' )
			),
			array(
				'type'         => 'dropdown',
				'heading'      => esc_html__( 'Button position', 'qodux_fw' ),
				"param_name"   => "button_position",
				'value'        => array( esc_html__( 'Default', 'qodux_fw' ) => 'default', esc_html__( 'Across the image', 'qodux_fw' ) => 'over'),
				'std'          => 'default',
				"description" => esc_html__( "Choose position for service button.", 'qodux_fw' )
			),
			array(
				"type"		  => "textfield",
				"heading"	  => esc_html__( "Button: Text", 'qodux_fw' ),
				"param_name"  => "button_text",
				"value"		  => "",
				"description" => esc_html__( "Type button text here.", 'qodux_fw' )
			),
			array(
				'type'        => 'vc_link',
				'heading'     => esc_html__( 'Button: Link', 'qodux_fw' ),
				'param_name'  => 'button_link',
				'value'       => '',
				'description' => esc_html__( 'Type button link here.', 'qodux_fw' )
			),
			array(
				'type'			=> 'checkbox',
				'heading'		=> esc_html__( 'Slide item link?', 'qodux_fw' ),
				'param_name'	=> 'swiper_pag',
				'value'			=> Array( esc_html__( 'Yes please.', 'qodux_fw' ) => 'yes'),
				'description'   => esc_html__( 'Check this option if you need this service box to link to a slide item from a related custom slider.', 'qodux_fw' )
			),
			array(
				'type'          => 'textfield',
				'heading'       => esc_html__( 'Slide item number', 'qodux_fw' ),
				'param_name'    => 'slide_number',
				'value'		    => 1,
				'param_holder_class' => 'border_box qodx_dependency',
				'description'   => esc_html__( 'Link this service box to a specific slide item number from a related custom slider.', 'qodux_fw' ),
				'dependency'    => array( 'element' => 'swiper_pag', 'not_empty' => true ),
			),	
			array(
				'type'          => 'textarea_html',
				'heading'       => esc_html__( 'Service text', 'qodux_fw' ),
				'param_name'    => 'content',
				'value' 		=>  '<p>' . esc_html__( 'I am text block. Click edit button to change this text.', 'qodux_fw' ). '</p>',
				'description'   => esc_html__( 'Add text for your service box.', 'qodux_fw' )
			),
			
			$add_qodx_extra_id,
			$add_qodx_extra_class,
			$add_qodx_css_animation,
			$add_qodx_css_animation_type,
			$add_qodx_css_animation_delay,
			
			array(
				'type'          => 'css_editor',
				'heading'       => esc_html__( 'Css', 'qodux_fw' ),
				'param_name'    => 'css',
				'group'         => esc_html__( 'Design options', 'qodux_fw' )
			)
		)
	));	
	
}