<?php
/**
 * Social Icon Widget Class
 */
class Focus_WP_Widget_Social_Font_Awesome extends WP_Widget {

	var $sites = array(
		'Facebook','Google','Twitter','Youtube','Vimeo','Behance','Pinterest','Dribbble','Instagram','Linkedin','Rss','Github','Delicious','Flickr','Lastfm','Tumblr','Deviantart','Skype','Stumbleupon','Soundcloud'	
	);
	var $packages = array(
		'social' => array(
			'name'=>'Social',
			//'path'=>'{:name}.png',
			//'path_32'=>'{:name}_32.png',
			'class'=>'{:name}',
		),
	);
	
	
	function __construct() {
		$widget_ops = array('classname' => 'widget_social_font_awesome', 'description' => esc_html__( 'A list of Social Icons With Font', 'qodux_fw' ));
		parent::__construct('social_font_aw', QODUX_FRAME_NAME.' - '.esc_html__( 'Social Icon Font', 'qodux_fw' ), $widget_ops);
		
		if ('widgets.php' == basename($_SERVER['PHP_SELF'])) {
			add_action( 'admin_enqueue_scripts', array(&$this, 'add_admin_script') );
		}
	}
	
	function add_admin_script(){
		wp_enqueue_script( 'social-icon-widget', QODX_FW_URL . 'admin/assets/js/widget-social-fa.js', array('jquery'));
	}
	

	function widget( $args, $instance ) {
		extract( $args );
		$title = isset( $instance['title'] ) ? apply_filters( 'widget_title', $instance['title'] ) : '';
		
		$package           = $instance['package'];
		$custom_count      = $instance['custom_count'];
		$tooltip           = $instance['tooltip']           ? '1'                            : '0';
		$icons_type        = $instance['icons_type']        ? $instance['icons_type']        : 'type_0';
		$custom_icons_size = $instance['custom_icons_size'] ? $instance['custom_icons_size'] : 'sm';
		$icons_size        = $instance['icons_size']        ? $instance['icons_size']        : '34';
		$icons_style       = $instance['icons_style']       ? $instance['icons_style']       : 'simple';
		
		$output = '';
		
		$sites = array(
		'Facebook','Google','Twitter','Youtube','Vimeo','Behance','Pinterest','Dribbble','Instagram','Linkedin','Rss','Github','Delicious','Flickr','Lastfm','Tumblr','Deviantart','Skype','Stumbleupon','Soundcloud');
		
		if( !empty($instance['enable_sites']) ){
			foreach($instance['enable_sites'] as $site){
				$link = isset($instance[$site])?$instance[$site]:'#';
				$class = str_replace('{:name}',strtolower($site),$this->packages[$package]['class']);
				$output .= '<li data-alt="'.$site.'"><a href="'.$link.'" class="'.$class.'"';
				if ($tooltip == true) { 
					$output .= ' data-toggle="tooltip"';
				}
				switch( $class ) {
					case 'website'     : $icon_output = '<i class="fa fa-external-link"></i>';   break;
					case 'email'       : $icon_output = '<i class="fa fa-envelope"></i>';        break;
					case 'facebook'    : $icon_output = '<i class="fa fa-'.$class.'"></i>';      break;
					case 'twitter'     : $icon_output = '<i class="fa fa-'.$class.'"></i>';      break;
					case 'pinterest'   : $icon_output = '<i class="fa fa-'.$class.'"></i>';      break;
					case 'google' 	   : $icon_output = '<i class="fa fa-'.$class.'-plus"></i>'; break;
					case 'linkedin'    : $icon_output = '<i class="fa fa-'.$class.'"></i>';      break;
					case 'behance'     : $icon_output = '<i class="fa fa-'.$class.'"></i>';      break;
					case 'dribbble'    : $icon_output = '<i class="fa fa-'.$class.'"></i>';      break;
					case 'youtube'     : $icon_output = '<i class="fa fa-'.$class.'-play"></i>'; break;
					case 'vimeo'       : $icon_output = '<i class="fa fa-'.$class.'"></i>';      break;
					case 'rss'         : $icon_output = '<i class="fa fa-'.$class.'"></i>';      break;
					case 'github'      : $icon_output = '<i class="fa fa-'.$class.'-alt"></i>';  break;
					case 'delicious'   : $icon_output = '<i class="fa fa-'.$class.'"></i>';      break;
					case 'flickr'      : $icon_output = '<i class="fa fa-'.$class.'"></i>';      break;
					case 'lastfm'      : $icon_output = '<i class="fa fa-'.$class.'"></i>';      break;
					case 'tumblr'      : $icon_output = '<i class="fa fa-'.$class.'"></i>';      break;
					case 'deviantart'  : $icon_output = '<i class="fa fa-'.$class.'"></i>';      break;
					case 'skype'       : $icon_output = '<i class="fa fa-'.$class.'"></i>';      break;
					case 'instagram'   : $icon_output = '<i class="fa fa-'.$class.'"></i>';      break;
					case 'stumbleupon' : $icon_output = '<i class="fa fa-'.$class.'"></i>';      break;
					case 'soundcloud'  : $icon_output = '<i class="fa fa-'.$class.'"></i>';      break;
				}
				$output .= ' rel="nofollow" title="'.$site.'" target="_blank">'.$icon_output;
				$output .= '</a></li>';
			}
		}
		if( $custom_count > 0){
			for($i=1; $i<= $custom_count; $i++){
				$name = isset($instance['custom_'.$i.'_name'])?$instance['custom_'.$i.'_name']:'';
				$icon = isset($instance['custom_'.$i.'_icon'])?$instance['custom_'.$i.'_icon']:'';
				$link = isset($instance['custom_'.$i.'_url'])?$instance['custom_'.$i.'_url']:'#';
				if(!empty($icon)){
					$output .= '<a href="'.$link.'" rel="nofollow" target="_blank"><img src="'.$icon.'" alt="'.$name.'" title="'.$name.'"/></a>';
				}
			}
		}
		if ( !empty( $output ) ) {
			echo  balanceTags( $before_widget );
			if ( $title)
				echo  balanceTags( $before_title . $title . $after_title );
		?>
	
    	<?php if ( $icons_type == 'type_0' ): ?>
        <div class="social-icons-block social-icons-block-<?php echo $custom_icons_size; ?> social-icons-block-style-1">
            <ul class="wt_icon_<?php echo esc_attr( $icons_type ); ?>">
                <?php echo  balanceTags( $output ); ?>
            </ul>
        </div>
        
   		<?php else: ?>        
        <div class="wt_social_networks_sc">
            <ul class="wt_icon_<?php echo (int)$icons_size; ?> wt_icon_<?php echo esc_attr( $icons_type ); ?> wt_<?php echo esc_attr( $icons_style ); ?>">
                <?php echo  balanceTags( $output ); ?>
            </ul>
        </div>
        
   		<?php endif; ?>
        
		<?php
			echo  balanceTags( $after_widget );
		}
	}

	function update( $new_instance, $old_instance ) {

		$instance = $old_instance;
		$instance['title']             = strip_tags($new_instance['title']);
		$instance['tooltip']           = !empty($new_instance['tooltip']) ? 1 : 0;
		$instance['icons_type']        = $new_instance['icons_type'];
		$instance['custom_icons_size'] = $new_instance['custom_icons_size'];
		$instance['icons_size']        = $new_instance['icons_size'];
		$instance['icons_style']       = $new_instance['icons_style'];
		$instance['package']           = strip_tags($new_instance['package']);
		$instance['enable_sites']      = $new_instance['enable_sites'];
		$instance['custom_count']      = (int) $new_instance['custom_count'];

		if(!empty($instance['enable_sites'])){
			foreach($instance['enable_sites'] as $site){
				$instance[$site] = isset($new_instance[$site])?strip_tags($new_instance[$site]):'';
			}
		}
		for($i=1;$i<=$instance['custom_count'];$i++){
			$instance['custom_'.$i.'_name'] = strip_tags($new_instance['custom_'.$i.'_name']);
			$instance['custom_'.$i.'_url'] = strip_tags($new_instance['custom_'.$i.'_url']);
			$instance['custom_'.$i.'_icon'] = strip_tags($new_instance['custom_'.$i.'_icon']);
		}
		return $instance;
	}

	function form( $instance ) {
		//Defaults
		$title             = isset($instance['title'])               ? esc_attr($instance['title'])   : '';
		$tooltip           = isset( $instance['tooltip'] )           ? (bool) $instance['tooltip']    : false;
		$package           = isset($instance['package'])             ? $instance['package']           : '';
		$icons_type        = isset( $instance['icons_type'] )        ? $instance['icons_type']        : 'type_0';
		$custom_icons_size = isset( $instance['custom_icons_size'] ) ? $instance['custom_icons_size'] : 'sm';
		$icons_size        = isset( $instance['icons_size'] )        ? $instance['icons_size']        : '34';
		$icons_style       = isset( $instance['icons_style'] )       ? $instance['icons_style']       : 'simple';
		$enable_sites      = isset($instance['enable_sites'])        ? $instance['enable_sites']      : array();
		
		foreach($this->sites as $site){
			$$site = isset($instance[$site]) ? esc_attr($instance[$site]) : '';
		}

		$custom_count = isset($instance['custom_count']) ? absint($instance['custom_count']) : 0;
		for($i=1;$i<=10;$i++){
			$custom_name = 'custom_'.$i.'_name';
			$$custom_name = isset($instance[$custom_name]) ? $instance[$custom_name] : '';
			$custom_url = 'custom_'.$i.'_url';
			$$custom_url = isset($instance[$custom_url]) ? $instance[$custom_url] : '';
			$custom_icon = 'custom_'.$i.'_icon';
			$$custom_icon = isset($instance[$custom_icon]) ? $instance[$custom_icon] : '';
		}
	?>
        <p><label for="<?php echo esc_attr( $this->get_field_id('title') ); ?>"><?php esc_html_e( 'Title:', 'qodux_fw' ); ?></label> <input class="widefat" id="<?php echo esc_attr( $this->get_field_id('title') ); ?>" name="<?php echo esc_attr( $this->get_field_name('title') ); ?>" type="text" value="<?php echo esc_attr( $title ); ?>" /></p>
        
        <p><input type="checkbox" class="checkbox" id="<?php echo esc_attr( $this->get_field_id('tooltip') ); ?>" name="<?php echo esc_attr( $this->get_field_name('tooltip') ); ?>"<?php checked( $tooltip ); ?> />
		<label for="<?php echo esc_attr( $this->get_field_id('tooltip') ); ?>"><?php esc_html_e( 'Use Tooltip?', 'qodux_fw' ); ?></label></p>
        
        <p>
			<label for="<?php echo esc_attr( $this->get_field_id('icons_type') ); ?>"><?php esc_html_e( 'Choose icon type:', 'qodux_fw' ); ?></label>
			<select name="<?php echo esc_attr( $this->get_field_name('icons_type') ); ?>" id="<?php echo esc_attr( $this->get_field_id('icons_type') ); ?>" class="widefat">
				<option value="type_0"<?php selected($icons_type,'type_0');?>><?php esc_html_e( 'Theme - custom', 'qodux_fw' ); ?></option>
				<option value="type_1"<?php selected($icons_type,'type_1');?>><?php esc_html_e( 'Type #1', 'qodux_fw' ); ?></option>
				<option value="type_2"<?php selected($icons_type,'type_2');?>><?php esc_html_e( 'Type #2', 'qodux_fw' ); ?></option>
				<option value="type_3"<?php selected($icons_type,'type_3');?>><?php esc_html_e( 'Type #3', 'qodux_fw' ); ?></option>
				<option value="type_4"<?php selected($icons_type,'type_4');?>><?php esc_html_e( 'Type #4', 'qodux_fw' ); ?></option>
			</select>
		</p>        
		<p><strong><?php esc_html_e( 'Theme - custom', 'qodux_fw' ); ?></strong> <?php esc_html_e( 'style is a theme specific style and the other options like', 'qodux_fw' ); ?> <em><?php esc_html_e( '\'Icon size / style\'', 'qodux_fw' ); ?></em> <?php esc_html_e( 'doesn\'t work.', 'qodux_fw' ); ?></p>
        <p>
			<label for="<?php echo esc_attr( $this->get_field_id('custom_icons_size') ); ?>"><?php esc_html_e( 'Choose', 'qodux_fw' ); ?> <strong><?php esc_html_e( 'theme-custom', 'qodux_fw' ); ?></strong> <?php esc_html_e( 'icon size:', 'qodux_fw' ); ?></label>
			<select name="<?php echo esc_attr( $this->get_field_name('custom_icons_size') ); ?>" id="<?php echo esc_attr( $this->get_field_id('custom_icons_size') ); ?>" class="widefat">
				<option value="sm"<?php selected($custom_icons_size,'sm');?>><?php esc_html_e( 'Small', 'qodux_fw' ); ?></option>
				<option value="md"<?php selected($custom_icons_size,'md');?>><?php esc_html_e( 'Medium', 'qodux_fw' ); ?></option>
				<option value="lg"<?php selected($custom_icons_size,'lg');?>><?php esc_html_e( 'Large', 'qodux_fw' ); ?></option>
			</select>
		</p>
        
        <p>
			<label for="<?php echo esc_attr( $this->get_field_id('icons_size') ); ?>"><?php esc_html_e( 'Choose icon size:', 'qodux_fw' ); ?></label>
			<select name="<?php echo esc_attr( $this->get_field_name('icons_size') ); ?>" id="<?php echo esc_attr( $this->get_field_id('icons_size') ); ?>" class="widefat">
				<option value="26"<?php selected($icons_size,'26');?>><?php esc_html_e( '26', 'qodux_fw' ); ?></option>
				<option value="32"<?php selected($icons_size,'32');?>><?php esc_html_e( '32', 'qodux_fw' ); ?></option>
				<option value="34"<?php selected($icons_size,'34');?>><?php esc_html_e( '34', 'qodux_fw' ); ?></option>
				<option value="38"<?php selected($icons_size,'38');?>><?php esc_html_e( '38', 'qodux_fw' ); ?></option>
				<option value="40"<?php selected($icons_size,'40');?>><?php esc_html_e( '40', 'qodux_fw' ); ?></option>
				<option value="42"<?php selected($icons_size,'42');?>><?php esc_html_e( '42', 'qodux_fw' ); ?></option>
				<option value="44"<?php selected($icons_size,'44');?>><?php esc_html_e( '44', 'qodux_fw' ); ?></option>
				<option value="50"<?php selected($icons_size,'50');?>><?php esc_html_e( '50', 'qodux_fw' ); ?></option>
			</select>
		</p>
        
        <p>
			<label for="<?php echo esc_attr( $this->get_field_id('icons_style') ); ?>"><?php esc_html_e( 'Choose icon style:', 'qodux_fw' ); ?></label>
			<select name="<?php echo esc_attr( $this->get_field_name('icons_style') ); ?>" id="<?php echo esc_attr( $this->get_field_id('icons_style') ); ?>" class="widefat">
				<option value="simple"<?php selected($icons_style,'simple');?>><?php esc_html_e( 'Simple', 'qodux_fw' ); ?></option>
				<option value="square"<?php selected($icons_style,'square');?>><?php esc_html_e( 'Square', 'qodux_fw' ); ?></option>
				<option value="rounded"<?php selected($icons_style,'rounded');?>><?php esc_html_e( 'Rounded', 'qodux_fw' ); ?></option>
				<option value="circle"<?php selected($icons_style,'circle');?>><?php esc_html_e( 'Circle', 'qodux_fw' ); ?></option>
			</select>
		</p>
		<p style="display:none;">
			<label for="<?php echo esc_attr( $this->get_field_id('package') ); ?>"><?php esc_html_e( 'Icon Package:' , 'qodux_fw' ); ?></label>
			<select name="<?php echo esc_attr( $this->get_field_name('package') ); ?>" id="<?php echo esc_attr( $this->get_field_id('package') ); ?>" class="widefat">
				<?php foreach($this->packages as $name => $value):?>
				<option value="<?php echo esc_attr( $name );?>"<?php selected($package,$name);?>><?php echo esc_attr( $value['name'] );?></option>
				<?php endforeach;?>
			</select>
		</p>
		<p>
			<label for="<?php echo esc_attr( $this->get_field_id('enable_sites') ); ?>"><?php esc_html_e( 'Enable Social Icon: (CTRL + Click)', 'qodux_fw' ); ?></label>
			<select name="<?php echo esc_attr( $this->get_field_name('enable_sites') ); ?>[]" style="height:10em" id="<?php echo esc_attr( $this->get_field_id('enable_sites') ); ?>" class="social_icon_select_sites widefat" multiple="multiple">
				<?php foreach($this->sites as $site):?>
				<option value="<?php echo esc_attr( $site );?>"<?php echo in_array($site, $enable_sites)? 'selected="selected"':'';?>><?php echo esc_attr( $site );?></option>
				<?php endforeach;?>
			</select>
		</p>
		
		<p>
			<em><?php esc_html_e("Note: Please input FULL URL <br/>(e.g. <code>http://www.example.com</code>)", 'qodux_fw' );?></em>
		</p>
		<div class="social_icon_wrap_2">
		<?php foreach($this->sites as $site):?>
		<p class="social_icon_<?php echo esc_attr( $site );?>" <?php if(!in_array($site, $enable_sites)):?>style="display:none"<?php endif;?>>
			<label for="<?php echo esc_attr( $this->get_field_id( $site ) ); ?>"><?php echo esc_attr( $site ).' '.esc_html__( 'URL:', 'qodux_fw' )?></label>
			<input class="widefat" id="<?php echo esc_attr( $this->get_field_id( $site ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( $site ) ); ?>" type="text" value="<?php echo esc_attr( $$site ); ?>" />
		</p>
		<?php endforeach;?>
		</div>

		<p><label for="<?php echo esc_attr( $this->get_field_id('custom_count') ); ?>"><?php esc_html_e( 'How many custom icons to add?', 'qodux_fw' ); ?></label>
		<input id="<?php echo esc_attr( $this->get_field_id('custom_count') ); ?>" class="social_icon_custom_count" name="<?php echo esc_attr( $this->get_field_name('custom_count') ); ?>" type="text" value="<?php echo esc_attr( $custom_count ); ?>" size="3" /></p>

		<div class="social_custom_icon_wrap_2">
		<?php for($i=1;$i<=10;$i++): $custom_name='custom_'.$i.'_name';$custom_url='custom_'.$i.'_url'; $custom_icon='custom_'.$i.'_icon'; ?>
			<div class="social_icon_custom_<?php echo (int)$i;?>" <?php if($i>$custom_count):?>style="display:none"<?php endif;?>>
				<p><label for="<?php echo esc_attr( $this->get_field_id( $custom_name ) ); ?>"><?php printf(esc_html__( 'Custom %s Name:', 'qodux_fw' ),$i);?></label>
				<input class="widefat" id="<?php echo esc_attr( $this->get_field_id( $custom_name ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( $custom_name ) ); ?>" type="text" value="<?php echo esc_attr( $$custom_name ); ?>" /></p>
				<p><label for="<?php echo esc_attr( $this->get_field_id( $custom_url ) ); ?>"><?php printf(esc_html__( 'Custom %s URL:', 'qodux_fw' ),$i);?></label>
				<input class="widefat" id="<?php echo esc_attr( $this->get_field_id( $custom_url ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( $custom_url ) ); ?>" type="text" value="<?php echo esc_attr( $$custom_url ); ?>" /></p>
				<p><label for="<?php echo esc_attr( $this->get_field_id( $custom_icon ) ); ?>"><?php printf(esc_html__( 'Custom %s Icon:', 'qodux_fw' ),$i);?></label>
				<input class="widefat" id="<?php echo esc_attr( $this->get_field_id( $custom_icon ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( $custom_icon ) ); ?>" type="text" value="<?php echo esc_attr( $$custom_icon ); ?>" /></p>
			</div>

		<?php endfor;?>
		</div>
		
<?php
	}
}