<?php
/**
 * The loop that displays posts.
 *
 * The loop displays the posts and the post content.  See
 * http://codex.wordpress.org/The_Loop to understand it and
 * http://codex.wordpress.org/Template_Tags to understand
 * the tags used in it.
 */
$featured_image_type = focus_wp_get_option('blog', 'featured_image_type');
$focus_wp_layout = focus_wp_get_option('blog','layout');
$author_id   = get_query_var( 'author' );

?>
<?php if ( have_posts() ) while ( have_posts() ) : the_post(); ?>
    <article id="post-<?php the_ID(); ?>" class="blogEntry qodx_blog_entry qodx_entry_<?php echo esc_attr( $featured_image_type );?>">
        <div <?php post_class(); ?>>
            <div class="post-block-container">
            <?php    
                $thumbnail_type = get_post_meta($post->ID, '_thumbnail_type', true);
                    switch($thumbnail_type){					
                        case "timage" : 
                        if ( has_post_thumbnail() ) {
                            echo '<div class="post-media"><header class="blogEntry_frame"><div class="image-block"><div class="image-block-container">';
                            echo focus_wp_generator('focus_wp_blog_featured_image',$featured_image_type,$focus_wp_layout); 
                            echo '</div></div></header></div>';	
                            }
                            break;
                        case "tvideo" : 
                            $video_link = get_post_meta($post->ID, '_featured_video', true);
                            echo '<div class="post-media"><header class="blogEntry_frame">';
                            echo '<div class="blog-thumbnail-video">';
                            echo focus_wp_video_featured($video_link,$featured_image_type,$focus_wp_layout,$height='',$width='');
                            echo '</div>';	
                            echo '</header></div>';													
                            break;
                        case "tplayer" : 
                            $player_link = get_post_meta($post->ID,'_thumbnail_player', true);
                            echo '<div class="post-media"><header class="blogEntry_frame">';
                            echo '<div class="blog-thumbnail-player">';
                            echo focus_wp_media_player($featured_image_type,$focus_wp_layout,$player_link);
                            echo '</div>';	
                            echo '</header></div>';													
                            break;
                        case "tslide" : 
                            echo '<div class="post-media"><header class="blogEntry_frame">';
                            echo '<div class="blog-thumbnail-slide">';
                            echo focus_wp_get_slide($featured_image_type,$focus_wp_layout);
                            echo '</div>';	
                            echo '</header></div>';													
                            break;
                    }
                 ?>
                <div class="post-header">

                    <!-- Title -->
                    
                    <h4><a href="<?php echo get_permalink() ?>" rel="bookmark" title="<?php printf( esc_html__( "Permanent Link to %s", 'focus_wp' ), get_the_title() ); ?>"><?php the_title(); ?></a></h4>

                    <!-- Meta Block -->
                    
                    <?php if (!is_search()): ?>
                        <?php echo focus_wp_generator('focus_wp_blog_meta'); ?>
                    <?php endif; ?>
                </div>
            <div class="post-footer">
            <?php 
                if(focus_wp_get_option('blog','display_full')):
                    global $more;
                    $more = 0;
                    the_content(esc_html__( 'Read more &raquo;', 'focus_wp' ),false);
                else:
                    the_excerpt();
            ?>
            <?php wp_link_pages( array( 'before' => '<div class="wp-pagenavi post_navi"><span class="page-links-title">' . esc_html__( 'Pages:', 'focus_wp' ) . '</span>', 'after' => '</div>', 'link_before' => '<span>', 'link_after' => '</span>' ) ); ?>
            <a class="btn btn-md btn-qodx wave-effect" href="<?php the_permalink(); ?>"><?php echo esc_html__('Read more &raquo;', 'focus_wp' )?></a>
            <?php endif; ?>
            </div>
            <?php if ($featured_image_type == 'left') { echo '<div class="qodx_clearboth"></div>'; } ?>        
            </div>
           </div>	  
        </article>
<?php 
endwhile;
wp_reset_postdata(); 

if (function_exists("focus_wp_pagination")) {
	focus_wp_pagination();
} 
?>