<?php 
/**
 * Header aside content
 *
 * @package Focus_WP WordPress Theme
 * @subpackage Template Parts
 * @version 1.0.0
 */

// Exit if accessed directly
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}
$focus_wp_homeContent    = focus_wp_get_option('general', 'one_page_home');
$focus_wp_enable_retina  = focus_wp_get_option('general', 'enable_retina');
$focus_wp_style 		    = focus_wp_get_option('general', 'qodx_style');
$focus_wp_retinaLogo     = focus_wp_get_option('general', 'logo_retina');
$focus_wp_retinaLogoAlt  = focus_wp_get_option('general', 'logo_home_retina');
$focus_wp_enable_retina  = focus_wp_get_option('general', 'enable_retina');
$focus_wp_stickyHeader   = focus_wp_get_option('general', 'sticky_header');
$focus_wp_menu_style     = focus_wp_get_option('general', 'qodx_menu_style');

if ($focus_wp_stickyHeader) {
	$navbar = ' navbar-fixed-top';
	$headerStuck = ' header-menu-stuck';
} else {
	$navbar = '';
	$headerStuck = ''; }

if ($focus_wp_menu_style == 'black') {
	$nav_color   = ' header-dark';
} else {
	$nav_color = ''; }
?>
<!-- Header 2
==================================================================== -->

<?php focus_wp_generator('focus_wp_header',$post->ID); ?>
    <!-- Header Section Container -->
    <div class="header-section-container">

        <!-- Header Menu -->
        <div class="header-menu<?php echo esc_attr( $navbar ); ?>">
            <!-- Header Menu Container -->
            <div class="header-menu-container<?php echo esc_attr( $headerStuck ); ?>">

                <!-- Navbar -->
                <nav class="navbar<?php echo esc_attr( $nav_color ); ?>">
                    <!-- container -->
                    <div class="container">
                        <!-- row -->
                        <div class="row">
                            <!-- col-md-12 -->
                            <div class="col-md-12">

                                <!-- Navbar Header -->
                                <div class="navbar-header">

                                <!-- Logo -->
                                <?php if(!focus_wp_get_option('general','display_logo') && $custom_logo = focus_wp_get_option('general','logo')): ?>		
                                    <?php if($focus_wp_enable_retina): ?>
                                    	<a class="navbar-brand logo-white" href="<?php echo esc_url( home_url( '/' ) ); ?>"><img src="<?php echo focus_wp_get_option('general','logo'); ?>" data-at2x="<?php echo esc_attr( $focus_wp_retinaLogo ); ?>" alt="" /></a>
                            			<a class="navbar-brand logo-black" href="<?php echo esc_url( home_url( '/' ) ); ?>"><img src="<?php echo focus_wp_get_option('general','logo_home'); ?>" data-at2x="<?php echo focus_wp_get_option('general','logo_home_retina') ?>" alt="" /></a>
                                    <?php else: ?>
                                    	<a class="navbar-brand logo-white" href="<?php echo esc_url( home_url( '/' ) ); ?>"><img src="<?php echo focus_wp_get_option('general','logo'); ?>" alt="" /></a>
                            			<a class="navbar-brand logo-black" href="<?php echo esc_url( home_url( '/' ) ); ?>"><img src="<?php echo focus_wp_get_option('general','logo_home'); ?>" alt="" /></a>
                                    <?php endif; ?> 
                                <?php else: ?>
                                	<div id="logo" class="logo_text navbar-header">
                                    	<a class="navbar-brand" href="<?php echo esc_url( home_url( '/' ) ); ?>">
                                        	<?php bloginfo( 'name' ); ?>
                                        </a>
										<?php if(focus_wp_get_option('general','display_site_desc')){
                                            $focus_wp_site_desc = get_bloginfo( 'description' );
                                            if(!empty($focus_wp_site_desc)): ?>
                                            <div id="siteDescription"><?php bloginfo( 'description' ); ?></div>
                                        <?php endif;}?>
                                    </div>
                                <?php endif; ?>
                                <!-- Toggle Menu Button -->
                                <button type="button" class="navbar-toggle collapsed" data-toggle="collapse" data-target=".navbar-collapse"><span><i class="ti-menu"></i></span>
                                </button><!-- /End Toggle Menu Button -->

                                </div><!-- /End Navbar Header -->

                                <!-- Navbar Collapse ( Menu ) -->
                                <div class="collapse navbar-collapse" role="navigation"> 
                                	
                                    <div id="qodx-navigation" class="pull-right"> 
										<?php 
                                        if ( has_nav_menu( 'primary-menu' ) ) {
                                            if (empty($focus_wp_homeContent)|| ($focus_wp_style == 'multipage') ) {
                                                focus_wp_generator('focus_wp_menu');
                                            } else {
                                                focus_wp_generator('focus_wp_menu_one_page');
                                            }
                                        } else {
                                            echo '<span class="qodx_no_custom_nav">No custom menu created! Go to Appearance - Menus and create one!<span>';
                                        } ?>
                                        
                                        <!-- Header Widget -->
                                        <div id="headerWidget">
                                            <?php 
                                            if(is_active_sidebar('sidebar-header-area')){
                                                dynamic_sidebar( 'sidebar-header-area' ); 
                                            } 
                                            ?>
                                        </div><!-- Header Widget --> 
                                    </div><!-- qodx-navigation --> 
                                                                       
                                </div><!-- /End Navbar Collapse ( Menu ) -->

                            </div><!-- /End col-md-12 -->
                        </div><!-- /End row -->
                    </div><!-- /End container -->
                </nav><!-- /End Navbar -->

            </div><!-- /End Header Menu Container -->
        </div><!-- /End Header Menu -->

    </div><!-- /End Header Section Container -->